unit ArduinoCfg;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons, shellApi, constreg,
  vcl.htmlHelpViewer,
  OOmisc, adport, lnswin32, awuser,
  regutil, Vcl.Samples.Spin, Vcl.Grids;

type
  TArduinoDlg = class(TForm)
    Comports: TRadioGroup;
    Okbtn: TBitBtn;
    Memo1: TMemo;
    ExPointBtn: TBitBtn;
    BaudRG: TRadioGroup;
    ModeRG: TRadioGroup;
    DureeGB: TGroupBox;
    dureeMaxSE: TSpinEdit;
    arduinoExeBtn: TBitBtn;
    GroupBox3: TGroupBox;
    SendGrid: TStringGrid;
    ExTempsBtn: TBitBtn;
    EtalonBtn: TBitBtn;
    ModeTempsRG: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    StartEdit: TEdit;
    HelpBtn: TBitBtn;
    TriggerRG: TRadioGroup;
    monocoupCB: TCheckBox;
    procedure FormActivate(Sender: TObject);
    procedure ExPointBtnClick(Sender: TObject);
    procedure arduinoExeBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OkbtnClick(Sender: TObject);
    procedure ModeRGClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure ModeTempsRGClick(Sender: TObject);
  private
    NumeroCom : array[-1..MaxComHandles] of integer;
  public
  end;

var
  ArduinoDlg: TArduinoDlg;

implementation

{$R *.dfm}

uses arduinoU, arduinoGraphe, aidekey;

procedure TArduinoDlg.ExPointBtnClick(Sender: TObject);
var chemin : string;
begin
   chemin := application.ExeName;
   chemin := extractFilePath(chemin)+'Arduino\';
   if sender=ExPointBtn then chemin := chemin+'simplePoint\simplePoint.ino';
   if sender=EtalonBtn then begin
       chemin := chemin+'etalon\etalon.ino';
       sendGrid.Cells[1,1] := 'Set';
       sendGrid.Cells[1,2] := 'Zro';
       modeRG.ItemIndex := 0;
   end;
   if sender=ExTempsBtn then begin
       chemin := chemin+'simpleTemps\simpleTemps.ino';
       modeRG.ItemIndex := 1;
       ModeTempsRG.ItemIndex := 2;
       startEdit.text := '';
   end;
   if ShellExecute(Handle, 'open', PChar(chemin), nil, nil, SW_SHOW) <= 32 then
      ShowMessage(stNoAccesInstall+chemin);
end;

procedure TArduinoDlg.arduinoExeBtnClick(Sender: TObject);
begin
 if ShellExecute(Handle, 'open', PChar(arduinoExe), nil, nil, SW_SHOW) <= 32 then
     ShowMessage(stNoAcces+arduinoExe);
end;

procedure TArduinoDlg.FormActivate(Sender: TObject);
var j : integer;
    chemin : string;
begin
     Comports.items.clear;
     for j := 1 to MaxComHandles do
        if IsPortAvailable(j) then begin
           Comports.Items.Add('COM'+IntToStr(j));
           NumeroCom[Comports.items.count-1] := j;
           if j=arduinoForm.voieSerie.comNumber then
              Comports.ItemIndex := Comports.items.count-1;
        end;
     for j := 0 to pred(baudRG.Items.count) do
         if arduinoForm.voieSerie.baud=StrToInt(baudRG.items[j]) then
            baudRG.ItemIndex := j;
     if (Comports.ItemIndex<0) and (comports.Items.Count>0) then
        Comports.itemIndex := 0;
     if comports.Items.count=0 then showMessage('Pas de voie srie');
     chemin := application.ExeName;
     chemin := extractFilePath(chemin)+'Arduino\';
     ExPointBtn.Visible := fileExists(chemin+'simplePoint\simplePoint.ino');
     exTempsBtn.Visible := fileExists(chemin+'simpleTemps\simpleTemps.ino');
     etalonBtn.Visible := fileExists(chemin+'etalon\etalon.ino');
     ArduinoExeBtn.Visible := fileExists(arduinoExe);
     if arduinoForm.pointParPoint then modeRG.ItemIndex := 0 else modeRG.ItemIndex := 1;
     triggerRG.ItemIndex := ord(arduinoForm.trigger);
     modeTempsRG.ItemIndex := ord(arduinoForm.modeTemps);
     modeTempsRG.Visible := modeRG.ItemIndex>0;
     triggerRG.Visible := modeTempsRG.visible and (modeTempsRG.ItemIndex=0);
     monocoupCB.Checked := arduinoForm.monocoup;
     for j := 1 to 3 do begin
         sendGrid.Cells[j,1] := arduinoForm.sendCommand[j];
         sendGrid.Cells[j,2] := arduinoForm.sendBtn[j].caption;
     end;
end;

procedure TArduinoDlg.FormCreate(Sender: TObject);
var i : integer;
begin
      for i := 1 to 3 do
          sendGrid.Cells[i,0] := intToStr(i);
      sendGrid.Cells[0,1] := 'Commande';
      sendGrid.Cells[0,2] := 'Texte';
end;

procedure TArduinoDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(Help_Arduino);
end;

procedure TArduinoDlg.ModeRGClick(Sender: TObject);
begin
    modeTempsRG.Visible := modeRG.itemIndex=1;
    triggerRG.visible := (modeRG.itemIndex=1) and (modeTempsRG.itemIndex=0);
    dureeGB.Visible := modeRG.itemIndex=1;
end;

procedure TArduinoDlg.ModeTempsRGClick(Sender: TObject);
begin
    monocoupCB.visible := (ModeTempsRG.ItemIndex=0) and (triggerRG.ItemIndex<2);
    triggerRG.Visible := ModeTempsRG.ItemIndex=0;
end;

procedure TArduinoDlg.OkbtnClick(Sender: TObject);
var j : integer;
begin
     for j := 1 to 3 do begin
         arduinoForm.sendCommand[j] := sendGrid.Cells[j,1];
         arduinoForm.sendBtn[j].caption := sendGrid.Cells[j,2];
     end;
     arduinoForm.pointparpoint := modeRG.ItemIndex=0;
     arduinoForm.modeTemps := TModeTemporel(modeTempsRG.ItemIndex);
     arduinoForm.voieSerie.comNumber := NumeroCom[Comports.ItemIndex];
     arduinoForm.voieSerie.baud := strToInt(baudRG.items[BaudRG.ItemIndex]);
     arduinoForm.monocoup := monocoupCB.checked;
end;

end.
