unit ArduinoOscilloCfg;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Buttons,
  vcl.htmlHelpViewer,
  OOmisc, adport, lnswin32, awuser, shellApi,
  regutil, constreg, Vcl.Samples.Spin;

type
  TArduinoOscilloDlg = class(TForm)
    Comports: TRadioGroup;
    OKBtn: TBitBtn;
    Memo1: TMemo;
    UnoBtn: TBitBtn;
    BaudRG: TRadioGroup;
    NbreRG: TRadioGroup;
    CurieBtn: TBitBtn;
    DueBtn: TBitBtn;
    arduinoExeBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ResolutionCB: TCheckBox;
    sincGB: TGroupBox;
    sincCB: TCheckBox;
    ordreSincSE: TSpinEdit;
    procedure FormActivate(Sender: TObject);
    procedure ComportsClick(Sender: TObject);
    procedure UnoBtnClick(Sender: TObject);
    procedure BaudRGClick(Sender: TObject);
    procedure arduinoExeBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    NumeroCom : array[-1..MaxComHandles] of integer;
  public
  end;

var
  ArduinoOscilloDlg: TArduinoOscilloDlg;

implementation

{$R *.dfm}

uses arduinoOscillo, arduinoGraphe, aidekey;

procedure TArduinoOscilloDlg.UnoBtnClick(Sender: TObject);
var chemin : string;
begin
   chemin := application.ExeName;
   chemin := extractFilePath(chemin)+'Arduino\';
   if sender=UnoBtn then chemin := chemin+'oscillo\oscillo.ino';
   if sender=DueBtn then chemin := chemin+'oscilloDue\oscilloDue.ino';
   if sender=CurieBtn then chemin := chemin+'oscilloCurie101\oscilloCurie101.ino';
   if ShellExecute(Handle, 'open', PChar(chemin), nil, nil, SW_SHOW) <= 32 then
      ShowMessage(stNoAccesInstall+chemin);
end;

procedure TArduinoOscilloDlg.arduinoExeBtnClick(Sender: TObject);
begin
 if ShellExecute(Handle, 'open', PChar(arduinoExe), nil, nil, SW_SHOW) <= 32 then
     ShowMessage(stNoAcces+arduinoExe);
end;

procedure TArduinoOscilloDlg.BaudRGClick(Sender: TObject);
begin
   arduinoOscilloForm.voieSerie.baud := StrToInt(baudRG.items[BaudRG.ItemIndex]);
end;

procedure TArduinoOscilloDlg.ComportsClick(Sender: TObject);
begin
   arduinoOscilloForm.voieSerie.comNumber := NumeroCom[Comports.ItemIndex];
end;

procedure TArduinoOscilloDlg.FormActivate(Sender: TObject);
var j : integer;
    chemin : string;
begin
     Comports.items.clear;
     for j := 1 to MaxComHandles do
        if IsPortAvailable(j) then begin
           Comports.Items.Add('COM'+IntToStr(j));
           NumeroCom[Comports.items.count-1] := j;
           if j=arduinoOscilloForm.voieSerie.comNumber then
              Comports.ItemIndex := Comports.items.count-1;
        end;
     if (Comports.ItemIndex<0) and (comports.Items.Count>0) then
        Comports.itemIndex := 0;
     for j := 0 to pred(baudRG.Items.Count) do
         if arduinoOscilloForm.voieSerie.baud=StrToInt(baudRG.items[j]) then
            baudRG.ItemIndex := j;
     if comports.Items.count=0 then showMessage('Pas de voie srie');
     chemin := application.ExeName;
     chemin := extractFilePath(chemin)+'Arduino';
     UnoBtn.visible := directoryExists(chemin);
     DueBtn.visible := UnoBtn.visible;
     CurieBtn.visible := UnoBtn.visible;
     ArduinoExeBtn.Visible := fileExists(arduinoExe);
end;

procedure TArduinoOscilloDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(Help_Arduino);
end;

end.
