unit ChronoBitmap;

interface

uses
  Windows,
  SysUtils, Messages,  Classes,  Graphics, Controls,  Forms,  Dialogs,
  StdCtrls,  ExtCtrls,  Buttons,  Printers,  Math, ComCtrls, clipbrd, inifiles,
  grapheU, jpeg, Menus, Spin, compile, vidgrabconst, gifImg, pngimage, registry,
  Grids, ToolWin, ImgList, regutil,system.Types, System.ImageList;

const
   maxObjet = 5;
   rayonAngle = 25;

type
  Taxe = (aVertical,aHorizontal,aOblique,aVertHoriz);
  indiceObjet = 1..maxObjet;
  TstyleDrag = (bsNone,bsMesure,bsSuppr,bsOrigine,bsEchelle1,bsEchelle2);

  TChronoForm = class(TForm)
    StatusBar: TStatusBar;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Panel2: TPanel;
    ImagePaintBox: TPaintBox;
    Panel3: TPanel;
    ZoomArriereBtn: TSpeedButton;
    ZoomEdit: TEdit;
    ZoomAvantBtn: TSpeedButton;
    ContrasteCB: TCheckBox;
    SerieLabel: TLabel;
    SerieSE: TSpinEdit;
    Panel4: TPanel;
    PaintBox: TPaintBox;
    Splitter2: TSplitter;
    Grid: TStringGrid;
    ScrollBarGamma: TUpDown;
    GammaPaintBox: TPaintBox;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    FileBtn: TToolButton;
    StopBtn: TToolButton;
    RazBtn: TToolButton;
    UndoBtn: TToolButton;
    SupprBtn: TToolButton;
    ExiBtn: TToolButton;
    RegressiBtn: TToolButton;
    MesureBtn: TToolButton;
    EchelleBtn: TToolButton;
    EditBidon: TEdit;
    OpenDialog: TOpenDialog;
    ProgressBar: TProgressBar;
    angleCB: TCheckBox;
    HelpBtn: TToolButton;
    GroupBox2: TGroupBox;
    CouleurPointsCB: TColorBox;
    GroupBox3: TGroupBox;
    CouleurAxeCB: TColorBox;
    GrilleCB: TCheckBox;
    EtiquetteCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImagePaint(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditBidonKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EchelleBtnClick(Sender: TObject);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure MesureBtnClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure CouleurPointsCBChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure SupprBtnClick(Sender: TObject);
    procedure ZoomMenuPopup(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GammaPaintBoxPaint(Sender: TObject);
    procedure GammaPaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GammaPaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GammaPaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure ContrasteCBClick(Sender: TObject);
    procedure ZoomAvantBtnClick(Sender: TObject);
    procedure ZoomArriereBtnClick(Sender: TObject);
    procedure ZoomArriere(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SerieSEChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ScrollBarGammaChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure FormResize(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FileBtnClick(Sender: TObject);
    procedure GrilleCBClick(Sender: TObject);
    procedure angleCBClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure CouleurAxeCBChange(Sender: TObject);
  private
    e_PointRepere : array[TstyleDrag] of Tpoint;
    BorneSelect,oldBorne : TstyleDrag;
    PosMenu : Tpoint;
    pointCourant,objetCourant : integer;
    oldStatus : String;
// Vignette
    pasZoomEntier : double;
    PointDnZoom,PointDnModele : Tpoint;
    RectZoom,RectMove,RectVisible,RectLecture : Trect;
    ZoomEnCours : boolean;
    MilieuGamma,e_MilieuGamma,ValeurGamma : integer;
    CaptureMilieu : boolean;
    decaleX,decaleY : integer;
    objetSelect : integer;
    NbreObjet : integer;
    rectCourant : Trect;
    arrondi : double;
    oldX,oldY : integer;
    CouleurGrid : array[0..maxObjet*2] of Tcolor;
    function GetCouleurGrid(Acol : integer) : Tcolor;
    Procedure envoieDonnees;
    Function GetBorne(x,y : integer) : TstyleDrag;
    Function PointProche(x,y : Integer) : integer;
    Procedure AffecteBorne(x,y : integer);
    procedure ImageVersEcran;
    procedure EcranVersImage;
    procedure EffectuerZoom(NewZoom : double);
    Function PointInZoom(x,y : integer) : boolean;
    Procedure AjoutePoint(x,y : integer);
    Procedure SupprimePoint(x,y : integer);
    procedure OuvreFichier(Nom: String);
    Procedure setEchelle;
    function valeurAngle(i: integer): double;
    function StrAngle(i: integer): string;
    Function StrX(j : indiceObjet;i : integer) : String;
    Function StrY(j : indiceObjet;i : integer) : String;
    procedure MajContraste;
    procedure TraceGrid;
  public
      XY : array[indiceObjet,0..maxPixel] of Tpoint;
      angle: array[0..MaxPixel] of double;
      Longueur : double;
      deltaT : double;
      Echelle : double;
      signeY : double;
      NbrePoints : array[indiceObjet] of integer;
      OrigineX,OrigineY : integer;
      NomFichier : String;
      axe : Taxe;
      Couleur : array[0..maxObjet] of Tcolor;
      Abitmap,bitmapOriginal,bitmapGamma : Tbitmap;
      Largeur,Hauteur : integer;
      pasZoom : double;
      PointRepere : array[TstyleDrag] of Tpoint;
      AvecT : boolean;
  end;

var
  ChronoForm: TChronoForm;

implementation

uses chronoEch, regdde, regmain, graphvar, AideBmpMeca;

const Magnet = 8;
      Rayon = 5;
      SizeData = 4;
      ValeurGammaMax = 25;
      crTab = #9;
      NomRepere : array[TstyleDrag] of string =
        ('None','Mesure','Suppr','Origine','Echelle1','Echelle2');
      Titre = 'Chronophoto';

{$R *.DFM}

procedure TChronoForm.FormCreate(Sender: TObject);
var i : tstyleDrag;
    j : integer;
    Fichier : TRegIniFile;
begin
    AvecT := true;
    NbreObjet := 1;
    SigneY := -1;
    NomFichier := '';
    for i := low(TstyleDrag) to high(TstyleDrag) do
        PointRepere[i] := point(0,0);
    Longueur := 1;
    Deltat := 1;
    MilieuGamma := 128;
    ValeurGamma := 8;
    ScrollBarGamma.max := ValeurGammaMax;
    ScrollBarGamma.position := ValeurGamma;
    bitmapGamma := Tbitmap.create;
    bitmapGamma.width := 256;
    bitmapGamma.height := 2;
    Abitmap := Tbitmap.create;
    bitmapOriginal := Tbitmap.create;
    Fichier := TRegIniFile.create(registreReg);
    GrilleCB.checked := Fichier.readBool(Titre,'Grille',false);
    OpenDialog.filterIndex := Fichier.readInteger(Titre,'Filtre',0);
    CouleurGrid[0] := clBlack;
    for j := 0 to maxObjet do
        Couleur[j] := Fichier.readInteger(Titre,'Couleur'+intToStr(j),clRed);
    for j := 1 to maxObjet do begin
        CouleurGrid[2*j-1] := getCouleurGrid(2*j-1);
        CouleurGrid[2*j] := CouleurGrid[2*j-1];
    end;
    CouleurPointsCB.selected := Couleur[1];
    CouleurAxeCB.selected := Couleur[0];
    Application.CreateForm(TechelleMecaBmpDlg,echelleMecaBmpDlg);
    echelleMecaBmpDlg.uniteEdit.text := Fichier.readString(Titre,'UniteX','m');
    echelleMecaBmpDlg.SigneYCB.checked := Fichier.readBool(Titre,'SigneY',false);
    Fichier.free;
end;

procedure TChronoForm.RegressiBtnClick(Sender: TObject);
begin
   StopBtnClick(nil);
   setEchelle;
   EnvoieDonnees;
end;

procedure TChronoForm.EnvoieDonnees;
var tampon : TstringList;
    avecX,avecY : boolean;

Procedure AjouteOptionGrXY;
var j : integer;
begin
     tampon.add('&'+intToStr(NbreObjet)+' NOMX');
     if NbreObjet=1
        then tampon.add(EchelleMecaBmpDlg.nomX.text)
        else for j := 1 to NbreObjet do
             tampon.add(EchelleMecaBmpDlg.nomX.text+intToStr(j));
     tampon.add('&'+intToStr(NbreObjet)+' NOMY');
     if NbreObjet=1
        then tampon.add(EchelleMecaBmpDlg.nomY.text)
        else for j := 1 to NbreObjet do
             tampon.add(EchelleMecaBmpDlg.nomY.text+intToStr(j));
     tampon.add('&'+intToStr(NbreObjet)+' ORTHO');
     for j := 1 to NbreObjet do tampon.add('1');
     tampon.add('&1 FICHIER');
     tampon.add(NomFichier);
end;

Procedure AjouteOptionGrAngle;
begin
     tampon.add('&1 NOMX');
     tampon.add(EchelleMecaBmpDlg.nomT.text);
     tampon.add('&1 NOMY');
     tampon.add(EchelleMecaBmpDlg.nomX.text);
     tampon.add('&1 ORTHO');
     tampon.add('1');
     tampon.add('&1 FICHIER');
     tampon.add(NomFichier);
end;

Procedure AjouteOptionGrX;
var j : integer;
begin
     tampon.add('&'+intToStr(NbreObjet)+' NOMX');
     for j := 1 to NbreObjet do
         tampon.add(EchelleMecaBmpDlg.nomT.text);
     tampon.add('&'+intToStr(NbreObjet)+' NOMY');
     if NbreObjet=1
        then tampon.add(EchelleMecaBmpDlg.nomX.text)
        else for j := 1 to NbreObjet do
             tampon.add(EchelleMecaBmpDlg.nomX.text+intToStr(j));
     tampon.add('&1 FICHIER');
     tampon.add(NomFichier);
end;

Procedure AjouteOptionGrY;
var j : integer;
begin
     tampon.add('&'+intToStr(NbreObjet)+' NOMX');
     for j := 1 to NbreObjet do
         tampon.add(EchelleMecaBmpDlg.nomT.text);
     tampon.add('&'+intToStr(NbreObjet)+' NOMY');
     if NbreObjet=1
        then tampon.add(EchelleMecaBmpDlg.nomY.text)
        else for j := 1 to NbreObjet do
             tampon.add(EchelleMecaBmpDlg.nomY.text+intToStr(j));
     tampon.add('&1 FICHIER');
     tampon.add(NomFichier);
end;

var ligne : String;
    i,j : integer;
    minY,maxY,minX,maxX : integer;
    P : Tpoint;
    compteur : integer;
begin
     minY := hauteur;maxY := 0;
     minX := largeur;maxX := 0;
     for i := 0 to pred(NbrePoints[1]) do begin
         for j := 1 to NbreObjet do begin
             P := xy[j,i];
             if P.x>maxX then maxX := P.x;
             if P.x<minX then minX := P.x;
             if P.y>maxY then maxY := P.y;
             if P.y<minY then minY := P.y;
         end;
     end;

     avecY := (maxY-minY)>hauteur div 32;
     avecX := (maxX-minX)>largeur div 32;
     compteur := 0;
     if avecX then inc(compteur);
     if avecY then inc(compteur);
     if avecT then inc(compteur);
     if compteur<2 then begin
        showMessage('Mesures sur zone trop troite !');
        exit;
     end;

     tampon := TstringList.create;
     Screen.Cursor := crHourGlass;
     tampon.add('Chronophotographie');
     tampon.add('');
     if avecT or angleCB.checked
        then ligne := EchelleMecaBmpDlg.nomT.text+crTab
        else ligne := '';
     if angleCB.checked
     then ligne := ligne+alpha+crTab
     else if NbreObjet=1
        then begin
            ligne := ligne+EchelleMecaBmpDlg.nomX.text+crTab;
            ligne := ligne+EchelleMecaBmpDlg.nomY.text+crTab;
        end
        else for j := 1 to NbreObjet do begin
           ligne := ligne+EchelleMecaBmpDlg.nomX.text+intToStr(j)+crTab;
           ligne := ligne+EchelleMecaBmpDlg.nomY.text+intToStr(j)+crTab;
        end;
     tampon.add(ligne);
     if avecT or angleCB.checked
        then ligne := EchelleMecaBmpDlg.uniteT.text+crTab
        else ligne := '';
     if angleCB.checked
     then ligne := ligne+''+crTab
     else for j := 1 to NbreObjet do begin
         ligne := ligne+EchelleMecaBmpDlg.uniteEdit.text+crTab;
         ligne := ligne+EchelleMecaBmpDlg.uniteEdit.text+crTab;
     end;
     tampon.add(ligne);
     for i := 0 to pred(NbrePoints[1]) do begin
         if avecT or angleCB.checked
            then ligne := FloatToStrPoint(i*deltaT)+crTab
            else ligne := '';
         if angleCB.checked
         then ligne := ligne+strAngle(i)+crTab
         else for j := 1 to NbreObjet do begin
             ligne := ligne+strX(j,i)+crTab;
             ligne := ligne+strY(j,i)+crTab;
         end;
         tampon.add(ligne);
     end;
     if pageCourante=0 then begin
           if angleCB.checked
           then AjouteOptionGrAngle
           else if avecX and avecY
              then AjouteOptionGrXY
              else if avecX
                 then AjouteOptionGrX
                 else AjouteOptionGrY;
     end;
     ClipBoard.asText := tampon.text;
     if pageCourante=0
         then with FregressiMain do begin
             grandeursOpen;
             grapheOpen;
             if FormDDE.ImportePressePapier then begin
                ModifConfigAcq := SaveConfigAcq;
                FocusAcquisitionBtn.visible := true;
             end
         end
         else FormDDE.AjoutePressePapier;
     tampon.free;
     Screen.Cursor := crDefault;
     modeAcquisition := acqChrono;
     MesureBtn.Down := False;
     Close;
end;

Procedure TChronoForm.SetEchelle;
var PixelX : double;
begin
       if e_PointRepere[bsEchelle2].y<0 then
              e_PointRepere[bsEchelle2].y := 0;
       if e_PointRepere[bsEchelle2].x>largeur then
              e_PointRepere[bsEchelle2].x := largeur;
       PixelX := sqrt(
          sqr(PointRepere[bsEchelle2].x-PointRepere[bsEchelle1].x)+
          sqr(PointRepere[bsEchelle2].y-PointRepere[bsEchelle1].y)
          );
       Echelle := Longueur/PixelX;
       Arrondi := power(10,floor(log10(abs(Echelle))));
       OrigineX := PointRepere[bsOrigine].X;
       OrigineY := PointRepere[bsOrigine].Y;
       traceGrid;
end;

Function TChronoForm.GetBorne(x,y : integer) : TstyleDrag;
var i : TstyleDrag;
begin
      result := bsNone;
      x := x - decaleX;
      y := y - decaleY;
      for i := bsOrigine to high(TstyleDrag) do
          if (abs(x-e_PointRepere[i].x)+abs(y-e_PointRepere[i].y) < Magnet) 
                  then begin
                       result := i;
                       break;
                  end;
end;

Procedure TChronoForm.AffecteBorne(x,y : integer);
const marge = 1;
begin
    if x<marge then x := marge;
    if y<marge then y := marge;
    if y>(rectLecture.bottom-marge) then y := rectLecture.bottom-marge;
    if x>(rectLecture.right-marge) then x := rectLecture.right-marge;
    e_PointRepere[BorneSelect] := point(x-decaleX,y-decaleY);
    BorneSelect := bsNone;
    EcranVersImage;
    ImagePaintBox.cursor := crDefault;
    setEchelle;
    ImagePaintBox.refresh;
    PaintBox.refresh;
end; // AffecteBorne 

procedure TChronoForm.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if BorneSelect=bsMesure then begin
      pointCourant := pointProche(x,y);
      if pointCourant>=0
          then begin
             ImagePaintBox.cursor := crCibleMove;
             hint := hDeplacerPoint;
          end
          else begin
             ImagePaintBox.cursor := crCible;
             hint := hRepererPoint;
             pointDnModele := point(x,y);
          end;
      exit;
   end;
   if BorneSelect=bsSuppr then exit;
   BorneSelect := GetBorne(x,y);
   if borneSelect=bsNone
      then begin
         ImagePaintBox.cursor := crCible;
         e_PointRepere[bsNone] := point(x,y);
         pointRepere[bsNone].x := round(e_pointRepere[bsNone].x/pasZoom);
         pointRepere[bsNone].y := round(e_pointRepere[bsNone].y/pasZoom);
         RectCourant := rect(x,y,x,y);
      end
      else ImagePaintBox.cursor := crDrag;
   oldX := x;
   oldY := y;
end;

procedure TChronoForm.ImageMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var BS : tstyleDrag;
    xr,yr,p : double;
    objetPrec,deltaX,nmes : integer;
begin
   statusBar.panels[0].Text := '';
   case BorneSelect of
        bsMesure : if ssLeft in shift
          then begin
             if angleCB.checked and (objetCourant>1) and (PointCourant<0) then begin
                objetPrec := objetCourant-1;
                nmes := nbrePoints[ObjetPrec];
                if (ssShift in shift) then begin // horizontal ou vertical
                   deltaX := x-XY[objetPrec,nmes].x;
                   if deltaX<>0 then begin
                      p := abs((y-XY[objetPrec,nmes].y)/deltaX);
                      if p>1
                        then x := XY[objetPrec,nmes].x
                        else y := XY[objetPrec,nmes].y;
                   end;
                end; // Horiz
// ssShift   La touche Maj est enfonce.
// ssAlt     La touche Alt est enfonce.
// ssCtrl    La touche Ctrl est enfonce.
// ssLeft    Le bouton gauche de la souris est enfonc.
// ssRight   Le bouton droit de la souris est enfonc.
// ssMiddle  Le bouton central de la souris est enfonc.
// ssDouble  On a double-cliqu sur la souris.
                imagePaintBox.Canvas.Pen.Mode := pmNot;
                imagePaintBox.Canvas.moveTo(XY[objetPrec,nmes].x, XY[objetPrec,nmes].y);
                imagePaintBox.Canvas.lineTo(oldX, oldY); { efface }
                imagePaintBox.Canvas.moveTo(XY[objetPrec,nmes].x, XY[objetPrec,nmes].y);
                imagePaintBox.Canvas.lineTo(x, y);
                oldX := x;
                oldY := y;
          end; // mesure angulaire
          end
          else begin
            if pointProche(x,y)>=0
               then begin
                  ImagePaintBox.cursor := crCibleMove;
                  hint := hDeplacerPoint;
               end
               else begin
                  ImagePaintBox.cursor := crCible;
                  hint := hRepererPoint;
               end;
        end;
        bsSuppr : ;
        bsNone : begin
           BS := GetBorne(x,y);
           if BS=bsNone
             then ImagePaintBox.cursor := crDefault
             else ImagePaintBox.cursor := crCibleMove;
           case BS of
               bsOrigine : hint := hOrigineBmp;
               bsEchelle1 : hint := hDebutX;
               bsEchelle2 : hint := hFinX;
               else hint := hClicDroit;
           end;
           ImagePaintBox.hint := hint;
           if ssLeft in shift then with ImagePaintBox.canvas do begin
               pen.mode := pmNot;
               moveto(rectCourant.left,rectCourant.top);
               lineto(rectCourant.right,rectCourant.bottom);
               rectCourant.right := x;
               rectCourant.bottom := y;
               moveTo(rectCourant.left,rectCourant.top);
               lineTo(rectCourant.right,rectCourant.bottom);
               pen.mode := pmCopy;
               xr := echelle*(((x/pasZoom-1/2) - PointRepere[bsNone].x));
               yr := echelle*(((y/pasZoom-1/2) - PointRepere[bsNone].y));
               statusBar.panels[0].Text := trDistance+
                  FloatToStrF(sqrt(xr*xr+yr*yr),ffGeneral,4,2)+
                  EchelleMecaBmpDlg.uniteEdit.text
           end;
        end;
        else ;
   end; // case borne select
end;

procedure TChronoForm.ImagePaint(Sender: TObject);

Procedure TraceLigne(P1,P2 : Tpoint);
begin with imagePaintBox.canvas do begin
         with P1 do moveto(x+decaleX,y+decaleY);
         with P2 do lineto(x+decaleX,y+decaleY);
end end;

Procedure TraceCercle(Apoint : Tpoint);
begin with Apoint do
      imagePaintBox.canvas.ellipse(x-rayon+decaleX,y-rayon+decaleY,
                                   x+rayon+decaleX+1,y+rayon+decaleY+1)
end;

Procedure TraceCroix(Apoint : Tpoint);
begin with Apoint do begin
         TraceLigne(Point(x-sizeData,y),point(x+sizeData,y));
         TraceLigne(point(x,y-sizeData),point(x,y+sizeData));
end end;

   procedure TraceAngle(i : integer);
   var texte: string;
   begin
       TraceCroix(XY[2, i]); // sommet de l'angle
       imagePaintBox.Canvas.Arc(OrigineX-rayonAngle,OrigineY-rayonAngle,
                        OrigineX+rayonAngle,OrigineY+rayonAngle,
                        XY[1,i].x,XY[1,i].y,
                        XY[2,i].x,XY[2,i].y);
       imagePaintBox.canvas.moveTo(OrigineX,OrigineY);
       imagePaintBox.canvas.lineTo(XY[1,i].x,XY[1,i].y);
       imagePaintBox.canvas.moveTo(OrigineX,OrigineY);
       imagePaintBox.canvas.lineTo(XY[2,i].x,XY[2,i].y);
       texte := IntToStr(succ(i));
       imagePaintBox.Canvas.TextOut(XY[2, i].x + 2, XY[2, i].y + 2,texte);
// L'arc traverse le primtre de l'ellipse circonscrite par les points (X1,Y1) et (X2,Y2).
// L'arc est dessin en suivant le primtre de l'ellipse, dans le sens contraire des aiguilles d'une montre
// jusqu'au point d'arrive. Le point de dpart est dfini par l'intersection de l'ellipse et d'une ligne dfinie
// par le centre de l'ellipse et (X3,Y3). Le point d'arrive est dfini par l'intersection de l'ellipse et d'une ligne
// dfinie par le centre de l'ellipse et (X4,Y4).
   end;

Procedure TraceReticule(Apoint : Tpoint);
begin with imagePaintBox.canvas do begin
        moveto(Apoint.x+decaleX,0);
        lineto(Apoint.x+decaleX,imagePaintBox.Height);
        moveto(0,Apoint.y+decaleY);
        lineto(imagePaintBox.width,Apoint.y+decaleY);
end end;

Procedure TraceCroixData(i : integer;j : indiceObjet);
var Apoint : Tpoint;
    texte : string;
begin
     imagePaintBox.canvas.pen.color := couleur[j];
     imagePaintBox.canvas.font.color := couleur[j];
     Apoint.x := round(xy[j,i].x*pasZoom);
     Apoint.y := round(xy[j,i].y*pasZoom);
     if grilleCB.checked
        then TraceReticule(APoint)
        else TraceCroix(APoint);
     if etiquetteCB.checked then begin
        texte := intToStr(i);
        if NbreObjet>1 then texte := texte+'('+intToStr(j)+')';
        imagePaintBox.canvas.textOut(Apoint.x+SizeData+decaleX,
                                  Apoint.y+SizeData+decaleY,
                                  texte);
     end;
     Grid.cells[j*2-1,i+1] := strX(j,i);
     Grid.cells[j*2,i+1] := strY(j,i);
end;

Procedure TraceBorne;

Procedure TraceFleche(P1i,P2i : Tpoint);
var delta,zz : Tpoint;
    norme : integer;
begin
            delta.X := P1i.x-P2i.x;
            delta.Y := P1i.y-P2i.y;
            norme := round(sqrt(sqr(delta.X)+sqr(delta.Y)));
            delta.X := round(2*Magnet*delta.X/norme);
            delta.Y := round(2*Magnet*delta.Y/norme);
// zz = centre de la base de la flche 
            zz.y := P2i.y+delta.Y;          
            zz.x := P2i.x+delta.X;
            delta.x := round(delta.x/3);
            delta.y := round(delta.y/3);
            TraceLigne(P1i,P2i);
            TraceLigne(P2i,point(zz.x-delta.Y,zz.y+delta.X));
            TraceLigne(P2i,point(zz.x+delta.Y,zz.y-delta.X));
            TraceLigne(point(P1i.x-delta.Y,P1i.y+delta.X),
                       point(P1i.x+delta.Y,P1i.y-delta.X));
end;

var apoint : Tpoint;
begin
if NomFichier='' then exit;
with imagePaintBox.canvas do begin
       decaleX := round(-rectVisible.left*pasZoom+pasZoom/2);
       decaleY := round(-rectVisible.top*pasZoom+pasZoom/2);
       pen.color := couleur[0];
       ImageVersEcran;
       TraceFleche(e_PointRepere[bsEchelle1],e_PointRepere[bsEchelle2]);
       TraceCercle(e_PointRepere[bsOrigine]);
// axe vertical
       aPoint := e_PointRepere[bsOrigine];
       if signeY>0
          then inc(aPoint.y,150)
          else dec(aPoint.y,150);
       if aPoint.y<0 then aPoint.y := 8;
       if aPoint.y>hauteur then aPoint.y := hauteur;
       TraceFleche(e_PointRepere[bsOrigine],aPoint);
// axe horizontal
       aPoint := e_PointRepere[bsOrigine];
       inc(aPoint.x,150);
       if aPoint.x>largeur then aPoint.x := largeur;
       TraceFleche(e_PointRepere[bsOrigine],aPoint);
end end; // TraceBorne

var i : integer;
    j : indiceObjet;
begin
    if NomFichier='' then exit;
    rectLecture := rect(0,0,
       round((rectVisible.right-rectVisible.left)*pasZoom),
       round((rectVisible.bottom-rectVisible.top)*pasZoom));
    ImagePaintBox.canvas.CopyRect(rectLecture,Abitmap.canvas,rectVisible);
    with imagePaintBox.canvas do begin
       if (NbrePoints[1]+2)>grid.rowCount then
          grid.rowCount := NbrePoints[1]+5;
       brush.style := bsClear;
       for i := 0 to pred(NbrePoints[1]) do
           grid.cells[0,i+1] := FloatToStrPoint(i*deltaT);
       if angleCB.Checked
       then begin
            for i := 0 to pred(NbrePoints[1]) do
                traceAngle(i)
       end
       else for j := 1 to NbreObjet do
           for i := 0 to pred(NbrePoints[j]) do
               traceCroixData(i,j);
       for i := NbrePoints[1] to (grid.rowCount-2) do
           for j := 1 to pred(grid.colCount) do
              grid.cells[j,i+1] := '';
       grid.Row := NbrePoints[1]+1;
    end;
    TraceBorne;
    EditBidon.setFocus;
end; // imagePaint

procedure TChronoForm.ExitBtnClick(Sender: TObject);
begin
    Close
end;

procedure TChronoForm.ImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if Button<>mbLeft then exit;
     case BorneSelect of
          bsMesure : ajoutePoint(x,y);
          bsSuppr : supprimePoint(x,y);
          bsNone : with ImagePaintBox.canvas do begin
              pen.mode := pmNot;
              moveTo(rectCourant.left,rectCourant.top);
              lineTo(rectCourant.right,rectCourant.bottom);
              pen.mode := pmCopy;              
              ImagePaintBox.cursor := crDefault;              
          end;
          else affecteBorne(x,y);
     end;
end;

Function TChronoForm.PointProche(X,Y : Integer) : integer;
var distance, newDistance : double;
    i,j : integer;
begin
         result := -1;
         ObjetSelect := 1;
         Distance := 10;
         for j := 1 to NbreObjet do
         for i := 0 to pred(NbrePoints[j]) do begin
             newDistance := abs(xy[j,i].x*pasZoom-x+decaleX)+
                            abs(xy[j,i].y*pasZoom-y+decaleY);
             if (newDistance<distance) then begin
                distance := newDistance;
                result := i;
                ObjetSelect := j;
             end;
         end;
end;

procedure TChronoForm.EditBidonKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var P : Tpoint;
begin
     GetCursorPos(P);
     case key of
          vk_left,vk_numpad4 : dec(P.X);
          vk_right,vk_numpad6 : inc(P.X);
          vk_down,vk_numpad2 : inc(P.Y);
          vk_up,vk_numpad8 : dec(P.Y);
          vk_prior :  if ssShift in shift
             then dec(P.X,10)
             else dec(P.Y,10);
          vk_next : if ssShift in shift
              then inc(P.X,10)
              else inc(P.Y,10);
          vk_delete : ;
          vk_space,vk_return : case BorneSelect of
             bsMesure : begin
                P := ImagePaintBox.ScreenToClient(P);
                ajoutePoint(P.x,P.y);
                exit;
             end;
             bsSuppr : begin
                P := ImagePaintBox.ScreenToClient(P);
                supprimePoint(P.x,P.y);
                exit;
             end;
          end;
          else exit;
     end;
     setCursorPos(P.X,P.Y);
end;

procedure TChronoForm.EchelleBtnClick(Sender: TObject);
begin
    if EchelleMecaBmpDlg.showModal=mrOK then begin
       NbreObjet := round(EchelleMecaBmpDlg.NbreSE.value);
       SerieSE.maxValue := NbreObjet;
       if serieSE.Value > NbreObjet then SerieSE.maxValue := 1;
       SerieSE.visible := NbreObjet > 1;
       SerieLabel.visible := SerieSE.visible;
       if EchelleMecaBmpDlg.signeYCB.checked
          then signeY := +1
          else signeY := -1;
    end;
    ImagePaintBox.refresh;
    PaintBox.refresh;
    BorneSelect := bsNone;
    ImagePaintBox.Cursor := crCible;
    statusBar.Panels[1].text := hRepererPoint;
    hint := '';
    StopBtn.visible := false;
    MesureBtn.visible := true;
    EchelleBtn.enabled := true;
    PointCourant := -1;
    setEchelle;
    traceGrid;
end;

procedure TChronoForm.OpenFileBtnClick(Sender: TObject);
begin
    if OpenDialog.execute then
       ouvreFichier(openDialog.fileName)
end;

procedure ConvertitGifBmp(var nomFichier: string);
var
  GIF		 : TGIFImage;
  Bitmap : TBitmap;
begin
    GIF := TGIFImage.Create;
    try
      GIF.OnProgress := Nil;
      // Load the GIF that will be converted
      nomFichier := ChangeFileExt(nomFichier,'.gif');
      GIF.LoadFromFile(nomFichier);
      Bitmap := TBitmap.Create;
      try
        // Convert the GIF to a BMP
        Bitmap.Assign(GIF);
        // Save the BMP
        nomFichier := ChangeFileExt(nomFichier,'.bmp');
        Bitmap.SaveToFile(nomFichier);
      finally
        Bitmap.Free;
      end;
    finally
      GIF.Free;
    end;
end;

procedure TChronoForm.OuvreFichier(Nom: String);

procedure MajBitmap;
var i : integer;
    j : indiceObjet;
begin
     Largeur := Abitmap.width;
     Hauteur := Abitmap.height;
     for j := 1 to maxObjet do begin
         NbrePoints[j] := 0;
         for i := 0 to maxPixel do
             XY[j,i] := point(0,0);
     end;
     PointRepere[bsOrigine] := point(Largeur div 5,4*Hauteur div 5);
     PointRepere[bsEchelle1] := PointRepere[bsOrigine];
     PointRepere[bsEchelle2] := PointRepere[bsOrigine];
     PointRepere[bsEchelle2].y := Largeur div 5;
     PointRepere[bsEchelle1].x := 4*Largeur div 5;
     ImageVersEcran;
     BorneSelect := bsNone;
     StopBtn.visible := false;
     MesureBtn.visible := false;
     EchelleBtn.enabled := true;
     UndoBtn.enabled := false;
     RegressiBtn.enabled := false;
     pasZoom := 1;
     objetCourant := 1;
     NbreObjet := 1;
     ZoomEdit.text := hNoZoom;
     ImageVersEcran;
     rectVisible := rect(0,0,panel1.width,panel1.height);
     ImagePaintBox.refresh;
     Caption := 'Lecture de chronophotographie ['+ExtractFileName(NomFichier)+']';
     statusBar.Panels[1].text := hRepereBmp;
     setEchelle;
     PaintBox.refresh;
end; // MajBitmap

var extension : String;
    Ajpeg : TjpegImage;
    Apng : TpngImage;
begin
     screen.cursor := crHourGlass;
     NomFichier := AnsiUpperCase(Nom);
     extension := AnsiUpperCase(extractFileExt(NomFichier));
     if (extension='.GIF') then begin
          ProgressBar.visible := true;
          ConvertitGifBmp(nomFichier);
          extension := '.BMP';
          ProgressBar.visible := false;
     end;
     if (extension='.PNG') then begin
           Apng := TpngImage.create;
           Apng.LoadFromFile(Nom);
           with bitmapOriginal do begin
                pixelFormat := pf24bit;
                height := Apng.Height;
                width := Apng.Width;
                assign(Apng);
                nomFichier := changeFileExt(nom,'.BMP');
                saveToFile(nomFichier);
           end;
           Apng.free;
           extension := '.BMP';
     end;
     if (extension='.BMP') then
        BitmapOriginal.LoadFromFile(NomFichier);
        // supprt TIFF wincodec twicimage dans delphi 2010
     if (extension='.JPG') or (extension='.JPEG') then begin
         Ajpeg := TjpegImage.create;
         Ajpeg.LoadFromFile(NomFichier);
         with bitmapOriginal do begin
              pixelFormat := pf24bit;
              height := hauteur; // ??
              width := largeur;
         end;
         bitmapOriginal.assign(Ajpeg);
         Ajpeg.free;
     end;
     Abitmap.assign(bitmapOriginal);
     MajBitMap;
     screen.cursor := crDefault;
     EchelleBtnClick(nil);
     statusBar.Panels[1].text := hparamBtn;
end;

    procedure TChronoForm.ImageVersEcran;
    var i : TstyleDrag;
    begin
       for i := low(TstyleDrag) to High(TstyleDrag) do begin
           e_pointRepere[i].x := round(pointRepere[i].x*pasZoom);
           e_pointRepere[i].y := round(pointRepere[i].y*pasZoom);
       end;
    end;

    procedure TChronoForm.EcranVersImage;
    var i : TstyleDrag;
    begin
       for i := low(TstyleDrag) to High(TstyleDrag) do begin
           pointRepere[i].x := round(e_pointRepere[i].x/pasZoom);
           pointRepere[i].y := round(e_pointRepere[i].y/pasZoom);
       end;
    end;

procedure TChronoForm.StopBtnClick(Sender: TObject);
begin
     BorneSelect := bsNone;
     MesureBtn.visible := true;
     UndoBtn.enabled := false;
     StopBtn.visible := false;
     EchelleBtn.enabled := true;
     Screen.cursor := crDefault;
     statusBar.Panels[1].text := hTransfertRegressi;
end;

procedure TChronoForm.MesureBtnClick(Sender: TObject);
var i,j,N : integer;
begin
     BorneSelect := bsMesure;
     ImagePaintBox.Cursor := crCible;
     statusBar.Panels[1].text := hRepererPoint;
     hint := '';
     StopBtn.visible := true;
     MesureBtn.visible := false;
     EchelleBtn.enabled := false;
     N := NbrePoints[1];
     ObjetCourant := 1;
     for j := maxObjet downto 1 do
        if NbrePoints[j]<=N then begin
           ObjetCourant := j;
           N := NbrePoints[j];
        end;
     PointCourant := -1;
     if angleCB.checked
        then Grid.ColCount := 2
        else Grid.ColCount := EchelleMecaBmpDlg.NbreSE.value*2+1;
     Grid.cells[0,0] := EchelleMecaBmpDlg.nomT.text+'('+EchelleMecaBmpDlg.uniteT.text+')';
     if angleCB.checked then
           Grid.cells[1,0] := 'angle()'
     else for j := 1 to EchelleMecaBmpDlg.NbreSE.value do begin
           Grid.cells[j*2-1,0] := EchelleMecaBmpDlg.nomX.text+intToStr(j)+
                                 '('+EchelleMecaBmpDlg.uniteEdit.text+')';
           Grid.cells[j*2,0] := EchelleMecaBmpDlg.nomY.text+intToStr(j)+
                                '('+EchelleMecaBmpDlg.uniteEdit.text+')';
     end;
     if angleCB.checked then ObjetCourant := 1;
     for i := 1 to pred(grid.rowCount) do
          for j := 0 to pred(grid.colCount) do
              Grid.cells[j,i] := '';
     grid.Col := 0;
     grid.Row := 1;
     imagePaintBox.refresh;
     paintBox.refresh;
end;

procedure TChronoForm.UndoBtnClick(Sender: TObject);
begin
     if NbrePoints[objetCourant]>0 then dec(nbrePoints[ObjetCourant]);
     UndoBtn.enabled := nbrePoints[ObjetCourant]>0;
     ImagePaintBox.refresh;
     PaintBox.refresh;
end;

procedure TChronoForm.CouleurAxeCBChange(Sender: TObject);
begin
      couleur[0] := couleurAxeCB.selected;
      ImagePaintBox.refresh;
      PaintBox.refresh;
end;

procedure TChronoForm.CouleurPointsCBChange(Sender: TObject);
var j : integer;
begin
      if nomFichier='' then exit;
      couleur[objetCourant] := couleurPointsCB.selected;
      j := 1+2*objetCourant;
      couleurGrid[j] := getCouleurGrid(j);
      couleurGrid[j+1] := CouleurGrid[j];
      ImagePaintBox.refresh;
      PaintBox.refresh;
end;

procedure TChronoForm.FormDestroy(Sender: TObject);
begin
    AbitMap.free;
    bitMapGamma.free;
    bitMapOriginal.free;
    chronoForm := nil;
end;

procedure TChronoForm.RazBtnClick(Sender: TObject);
var i,j : integer;
begin
     for j := 1 to maxObjet do NbrePoints[j] := 0;
     for i := 1 to pred(grid.rowCount) do
         for j := 0 to pred(grid.colCount) do
             grid.cells[j,i] := '';
     ObjetCourant := 1;
     NbreObjet := 1;
     RazBtn.enabled := false;
     UndoBtn.enabled := false;
     SupprBtn.enabled := false;
     RegressiBtn.enabled := false;
     MesureBtn.visible := true;
     EchelleBtn.enabled := true;
     imagePaintBox.refresh;
     PaintBox.refresh;
end;

procedure TChronoForm.SupprBtnClick(Sender: TObject);
begin
      OldBorne := BorneSelect;
      BorneSelect := bsSuppr;
      ImagePaintBox.cursor := crDefault;
      oldStatus := statusBar.Panels[1].text;
      statusBar.Panels[1].text := hSupprPoint;
      hint := '';
end;

procedure TChronoForm.EffectuerZoom(newZoom : double);
var P1,P : Tpoint;
    ecart : integer;
begin
    if newZoom>1 then newZoom := round(newZoom);
    if newZoom<1 then newZoom := 1/round(1/newZoom);
    if nomFichier='' then exit;
    imagePaintBox.visible := false;
    P := ImagePaintBox.ScreenToClient(PosMenu);
// position souris sur l'image
    P1.x := round(P.x/pasZoom) + rectVisible.left;
    P1.y := round(P.y/pasZoom) + rectVisible.top;
// position sur l'image de taille 1
    pasZoom := newZoom;
    rectVisible.left := round(P1.x-P.x/pasZoom);
    rectVisible.top := round(P1.y-P.y/pasZoom);
// position sur l'image de la nouvelle taille doit concider avec l'ancienne position
    if rectVisible.left<0 then rectVisible.left := 0;
    rectVisible.Right := rectVisible.left+round(panel1.width/pasZoom);
    if rectVisible.right>largeur then rectVisible.right := largeur;
    ecart := panel1.width-round(pasZoom*(rectVisible.right-rectVisible.left));
    if ecart>0 then begin { il reste de la plece }
       rectVisible.left := rectVisible.left-round(ecart/pasZoom);
       if rectVisible.left<0 then rectVisible.left := 0;
       rectVisible.Right := rectVisible.left+round(panel1.width/pasZoom);
       if rectVisible.right>largeur then rectVisible.right := largeur;
    end;
    if rectVisible.top<0 then rectVisible.top := 0;
    rectVisible.bottom := rectVisible.top+round(panel1.height/pasZoom);
    if rectVisible.bottom>hauteur then rectVisible.bottom := hauteur;
    ecart := panel1.height-round(pasZoom*(rectVisible.bottom-rectVisible.top));
    if ecart>0 then begin { il reste de la plece }
       rectVisible.top := rectVisible.top-round(ecart/pasZoom);
       if rectVisible.top<0 then rectVisible.top := 0;
       rectVisible.bottom := rectVisible.top+round(panel1.height/pasZoom);
       if rectVisible.bottom>hauteur then rectVisible.bottom := hauteur;
    end;
    ImageVersEcran;
    ImagePaintBox.visible := true;
    ImagePaintBox.refresh;
    PaintBox.refresh;
    EditBidon.setFocus;
    ZoomEdit.text := hNoZoom;
    if pasZoom>1.1 then ZoomEdit.text := 'Zoom X '+IntToStr(round(pasZoom));
    if pasZoom<0.9 then ZoomEdit.text := 'Zoom / '+IntToStr(round(1/pasZoom));
end;

procedure TChronoForm.ZoomMenuPopup(Sender: TObject);
begin
    GetCursorPos(PosMenu)
// position souris sur l'cran  l'appel du menu 
end;

procedure TChronoForm.PaintBoxPaint(Sender: TObject);
var TailleLoc : integer;

Procedure TracePoints;

Procedure TraceLigne(P1,P2 : Tpoint);
begin with PaintBox.canvas do begin
         with P1 do moveto(round(pasZoomEntier*x),
                           round(pasZoomEntier*y));
         with P2 do lineto(round(pasZoomEntier*x),
                           round(pasZoomEntier*y));
end end;

Procedure TraceCroix(Apoint : Tpoint);
begin with Apoint do begin
      TraceLigne(point(x-TailleLoc,y),Point(x+TailleLoc,y));
      TraceLigne(point(x,y-TailleLoc),Point(x,y+TailleLoc));
end end;

Procedure TraceCercle(Apoint : Tpoint);
begin
      with Apoint do PaintBox.canvas.ellipse(
                              round(pasZoomEntier*x)-rayon,
                              round(pasZoomEntier*y)-rayon,
                              round(pasZoomEntier*x)+rayon+1,
                              round(pasZoomEntier*y)+rayon+1)
end;

Procedure TraceFleche(P1i,P2i : Tpoint);
var delta,zz : Tpoint;
    norme : integer;
begin
            delta.X := P1i.x-P2i.x;
            delta.Y := P1i.y-P2i.y;
            norme := round(sqrt(sqr(delta.X)+sqr(delta.Y)));
            delta.X := round(2*TailleLoc*delta.X/norme);
            delta.Y := round(2*TailleLoc*delta.Y/norme);
          { x,y = centre de la base de la flche }
            zz.y := P2i.y+delta.Y;
            zz.x := P2i.x+delta.X;
            delta.x := round(delta.x/3);
            delta.y := round(delta.y/3);
            TraceLigne(P1i,P2i);
            TraceLigne(P2i,point(zz.x-delta.Y,zz.y+delta.X));
            TraceLigne(P2i,point(zz.x+delta.Y,zz.y-delta.X));
end;

var i,j : integer;
    texte : String;
begin with PaintBox.canvas do begin
       TailleLoc := round(SizeData/pasZoomEntier);
       if TailleLoc<1 then TailleLoc := 1;
       for j := 1 to NbreObjet do begin
           pen.color := couleur[j];
           font.color := couleur[j];
           for i := 0 to pred(NbrePoints[j]) do begin
               traceCroix(xy[j,i]);
               texte := intToStr(i);
               if NbreObjet>1 then texte := texte+'('+intToStr(j)+')';
               textOut(round(pasZoomEntier*(xy[j,i].x+tailleLoc)),
                       round(pasZoomEntier*(xy[j,i].y+tailleLoc)),texte);
           end;
       end;
       pen.color := couleur[0];
       TailleLoc := round(Magnet/pasZoomEntier);
       if TailleLoc<1 then TailleLoc := 1;
       TraceFleche(PointRepere[bsEchelle1],PointRepere[bsEchelle2]);
       TraceCercle(PointRepere[bsOrigine]);
end end; // TracePoints 

procedure traceZoom;

function Conversion(x : integer) : integer;
begin
     result := round(x*pasZoomEntier)
end;

begin with PaintBox.canvas do begin
     pen.color := couleur[0];
     brush.style := bsClear;
     rectZoom := rect(conversion(rectVisible.left),
          conversion(rectVisible.top),
          conversion(rectVisible.right),
          conversion(rectVisible.bottom));
     rectangle(rectZoom.left,rectZoom.top,
          rectZoom.right,rectZoom.bottom)
end end;

var zoomH,zoomV : double;
begin
    if NomFichier='' then exit;
    ZoomH := Panel4.Height/hauteur;
    ZoomV := Panel4.Width/largeur;
    if zoomV<zoomH
       then pasZoomEntier := ZoomV
       else pasZoomEntier := ZoomH;
    PaintBox.height := round(hauteur*pasZoomEntier);
    PaintBox.width := round(largeur*pasZoomEntier);
    PaintBox.canvas.StretchDraw(
             rect(0,0,
                  PaintBox.width,
                  PaintBox.height),Abitmap);
    TraceZoom;
    TracePoints;
    ImagePaint(nil);
    EditBidon.setFocus;
end;

procedure TChronoForm.PaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var dx,dy : integer;
begin
     if (ssLeft in shift) and ZoomEnCours
        then begin
          dx := x-pointDnZoom.x;
          dy := y-pointDnZoom.y;
          with PaintBox.canvas do begin
            pen.color := couleur[0];
            pen.mode := pmXOR;
            brush.style := bsClear;
            if dx<-rectMove.left then dx := -rectMove.left;
            if dy<-rectMove.top then dy := -rectMove.top;
            rectangle(rectMove.left,rectMove.top,
                      rectMove.right,rectMove.bottom); { efface }
            rectMove := rect(rectZoom.left+dx,rectZoom.top+dy,
               rectZoom.right+dx,rectZoom.bottom+dy);
            rectangle(rectMove.left,rectMove.top,
                     rectMove.right,rectMove.bottom); { trace }
            pen.mode := pmCopy;         
          end;
        end
        else begin
            if pointInZoom(x,y)
               then begin
                  PaintBox.cursor := crHandPoint;
                  hint := hReglerZoom;
               end
               else begin
                  PaintBox.cursor := crDefault;
                  hint := '';
               end;
        end
end;

procedure TChronoForm.PaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    PointDnZoom := point(x,y);
    ZoomEnCours := pointInZoom(x,y);
    if zoomEnCours
       then begin
          PaintBox.cursor := crHandPoint;
          rectMove := rectZoom
       end
       else PaintBox.cursor := crDefault;
end;

Function TChronoForm.PointInZoom(X,Y : Integer) : boolean;
begin with rectZoom do
     result := (x>left) and (x<right) and (y>top) and (y<bottom)
end;

procedure TChronoForm.PaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

function Conversion(x : integer) : integer;
begin
     result := round(x/pasZoomEntier)
end;

begin
     if ZoomEnCours then with rectVisible do begin
        left := left+conversion(x-pointDnZoom.x);
        if left<0 then left := 0;
        top := top+conversion(y-pointDnZoom.y);
        if top<0 then top := 0;
        right := left + round(panel1.width/pasZoom);
        if right>largeur
           then if largeur>(panel1.width/pasZoom)
              then begin
                 right := largeur;
                 left := right-round(panel1.width/pasZoom);
              end
              else begin
                 left := 0;
                 right := largeur;
              end;
        bottom := top + round(panel1.height/pasZoom);
        if bottom>hauteur
           then if hauteur>(panel1.height/pasZoom)
              then begin
                bottom := hauteur;
                top := bottom-round(panel1.height/pasZoom);
              end
              else begin
                bottom := hauteur;
                top := 0;
              end;
        PaintBox.cursor := crDefault;
        PaintBox.refresh;
        zoomEnCours := false;
        ImagePaintBox.refresh;
     end;
end;

procedure TChronoForm.MajContraste;

function Gamma(v : integer) : integer;
begin
    result := 128+round((v-milieuGamma)*exp(valeurGamma*3/valeurGammaMax));
    if result<0
       then result := 0
       else if result>255
            then result := 255;
end;

var zz : Tcolor;
    i,j : integer;
    rouge,vert,bleu : integer;
begin
if NomFichier='' then exit;
with bitmapOriginal.canvas do begin
     Screen.cursor := crHourGlass;
     ValeurGamma :=  ScrollBarGamma.position;
     for i := 0 to pred(width) do
         for j := 0 to pred(height) do begin
             zz := pixels[i,j];
             if zz>0 then begin
               rouge := gamma(GetRvalue(zz));
               vert :=  gamma(GetGvalue(zz));
               bleu :=  gamma(GetBvalue(zz));
               Abitmap.canvas.pixels[i,j] := rgb(rouge,bleu,vert);
             end;
         end;
    ImagePaintBox.refresh;
    PaintBox.refresh;
    Screen.cursor := crDefault;
    EditBidon.setFocus;
end end;

procedure TChronoForm.GammaPaintBoxPaint(Sender: TObject);
begin
if NomFichier='' then exit;
with GammaPaintBox.canvas do begin
     StretchDraw(rect(0,0,width,height),bitmapGamma);
     e_MilieuGamma := milieuGamma*width div 255;
     pen.color := clRed;
     pen.mode := pmCopy;
     moveTo(e_MilieuGamma,0);
     lineTo(e_MilieuGamma,height);
end end;

procedure TChronoForm.GammaPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     captureMilieu := abs(x-e_milieuGamma) < Magnet;
     if captureMilieu then with GammaPaintBox.canvas do begin
        pen.color := clBlack;
        pen.mode := pmXor;
        moveTo(e_MilieuGamma,0);
        lineTo(e_MilieuGamma,height);
     end;
end;

procedure TChronoForm.GammaPaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
     if captureMilieu then begin
        milieuGamma := x*255 div GammaPaintBox.width;
        captureMilieu := false;
        GammaPaintBox.Refresh;
        MajContraste
     end;
end;

procedure TChronoForm.GammaPaintBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin if captureMilieu then
with gammaPaintBox.canvas do begin
     moveTo(e_MilieuGamma,0);
     lineTo(e_MilieuGamma,height);
     moveTo(x,0);
     lineTo(x,height);
     e_MilieuGamma := x;
end end;

Procedure TChronoForm.AjoutePoint(x,y : integer);
begin
    if pointCourant>=0
       then XY[ObjetSelect,PointCourant] :=
                point(round(x/pasZoom-1/2)+rectVisible.left,
                      round(y/pasZoom-1/2)+rectVisible.top)
       else begin
               XY[ObjetCourant,NbrePoints[ObjetCourant]] :=
                        point(round(x/pasZoom)+rectVisible.left,
                              round(y/pasZoom)+rectVisible.top);
               inc(NbrePoints[ObjetCourant]);
               if angleCB.Checked then begin
                  if objetCourant=3
                     then objetCourant := 1 // prochain angle
                     else inc(objetCourant); // prochain point de dfinition de l'angle
               end
               else if (ObjetCourant>1) and
                  (NbrePoints[1]=NbrePoints[ObjetCourant]) then
                      stopBtnClick(nil);
       end;
    pointCourant := -1;
    imagePaintBox.cursor := crCible;
    imagePaintBox.refresh;
    UndoBtn.enabled := NbrePoints[ObjetCourant]>0;
    SupprBtn.enabled := NbrePoints[ObjetCourant]>0;
    RazBtn.enabled := NbrePoints[1]>0;
    RegressiBtn.enabled := NbrePoints[1]>2;
    PaintBox.refresh;
end;

procedure TChronoForm.angleCBClick(Sender: TObject);
begin
  inherited;
  SerieLabel.Visible := not angleCB.checked;
  SerieSE.Visible := not angleCB.checked;
end;

Procedure TChronoForm.SupprimePoint(x,y : integer);
var i,num : integer;
begin
      Num := PointProche(x,y);
      if num>=0 then begin
         dec(NbrePoints[objetSelect]);
         for i := num to pred(NbrePoints[ObjetSelect]) do
             xy[ObjetSelect,i] := xy[ObjetSelect,succ(i)];
         imagePaintBox.refresh;
         PaintBox.refresh;
         UndoBtn.enabled := NbrePoints[ObjetCourant]>0;
         SupprBtn.enabled := NbrePoints[ObjetCourant]>0;
         RazBtn.enabled := NbrePoints[1]>0;
         RegressiBtn.enabled := NbrePoints[1]>2;
      end;
      BorneSelect := oldBorne;
      statusBar.Panels[1].text := oldStatus;
end;

procedure TChronoForm.ContrasteCBClick(Sender: TObject);
begin
    ScrollBarGamma.visible := contrasteCB.checked;
    GammaPaintBox.visible := contrasteCB.checked;
    GammaPaintBox.Width := panel3.width - ScrollBarGamma.Left - 20
end;

procedure TChronoForm.ZoomAvantBtnClick(Sender: TObject);
begin
     if pasZoom<8 then effectuerZoom(2*pasZoom)
end;

procedure TChronoForm.ZoomArriereBtnClick(Sender: TObject);
begin
     if pasZoom>1/8 then EffectuerZoom(pasZoom/2)
end;

procedure TChronoForm.ZoomArriere(Sender: TObject);
begin
     effectuerZoom(1/((sender as TmenuItem).tag))
end;

procedure TChronoForm.Splitter1Moved(Sender: TObject);
begin
     effectuerZoom(pasZoom)
end;

procedure TChronoForm.FormClose(Sender: TObject; var Action: TCloseAction);
var Fichier : TRegIniFile;
    j : integer;
begin
     try
     Fichier := TRegIniFile.create(RegistreReg);
     try
     for j := 0 to maxObjet do
         Fichier.writeInteger(Titre,'Couleur'+intToStr(j),Couleur[j]);
     Fichier.writeBool(Titre,'Grille',grilleCB.checked);
     Fichier.writeBool(Titre,'SigneY',echelleMecaBmpDlg.SigneYCB.checked);
     Fichier.writeString(Titre,'UniteX',echelleMecaBmpDlg.uniteEdit.text);
     Fichier.writeInteger(Titre,'Filtre',OpenDialog.filterIndex);
     finally
     Fichier.free;
     end;
     except
     end;
     inherited;
end;

procedure TChronoForm.SerieSEChange(Sender: TObject);
begin
   ObjetCourant := round(SerieSE.Value);
   CouleurPointsCB.selected := couleur[objetCourant];
end;

Function TChronoForm.StrX(j : indiceObjet;i : integer) : String;
begin
    result := FloatToStrPoint(Arrondi*round((
               echelle*((xy[j,i].x-origineX)))/Arrondi))
end;

Function TChronoForm.StrY(j : indiceObjet;i : integer) : String;
begin
    result := FloatToStrPoint(Arrondi*round((
        signeY*echelle*((xy[j,i].y-origineY)))/Arrondi))
end;

function TChronoForm.StrAngle(i: integer): string;
begin
   Result := FloatToStrPoint(Arrondi * round(valeurAngle(i) / Arrondi));
end;

procedure TChronoForm.GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var s : String;
begin
   TstringGrid(sender).canvas.Font.Color := couleurGrid[Acol];
   S := TstringGrid(sender).cells[Acol,Arow];
   with TstringGrid(sender).canvas do
        TextOut(Rect.Left + 2, Rect.Top + 2,S);
end;

procedure TChronoForm.GrilleCBClick(Sender: TObject);
begin
	imagePaintBox.refresh;
end;

procedure TChronoForm.HelpBtnClick(Sender: TObject);
begin
    if aideBmpMecaForm=nil then
       Application.CreateForm(TAideBmpMecaForm,aideBmpMecaForm);
    aideBmpMecaForm.show;
end;

procedure TChronoForm.FormActivate(Sender: TObject);
begin
   windowState := wsMaximized;
end;

procedure TChronoForm.ScrollBarGammaChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
    ValeurGamma := ScrollBarGamma.Position;
    MajContraste
end;

procedure TChronoForm.FormResize(Sender: TObject);
begin
  inherited;
  GammaPaintBox.Width := panel3.width - ScrollBarGamma.Left - 20
end;

procedure TChronoForm.FileBtnClick(Sender: TObject);
begin
    if OpenDialog.execute then
       ouvreFichier(openDialog.fileName)
end;

Procedure TChronoForm.TraceGrid;
var i,j : integer;
begin
   if angleCB.checked then begin
      for i := 0 to pred(NbrePoints[1]) do
          Grid.cells[1, i + 1] := strAngle(i);
   end
   else begin
         for j := 1 to NbreObjet do begin
             for i := 0 to pred(NbrePoints[j]) do begin
                 Grid.cells[j*2-1,i+1] := strX(j,i);
                 Grid.cells[j*2,i+1] := strY(j,i);
             end;
             for i := NbrePoints[j] to pred(grid.rowCount) do begin
                 grid.cells[j*2-1,i] := '';
                 grid.cells[j*2,i] := '';
             end;
          end;
   end;
end;

function TChronoForm.valeurAngle(i : integer) : double;
var CA,CB : Tpoint;
    PS,PV : integer;
begin
    CA.x := xy[1, i].x-OrigineX;
    CA.y := xy[1, i].y-OrigineY;
    CB.x := xy[2, i].x-OrigineX;
    CB.y := xy[3, i].y-OrigineY;
    PS := CA.X*CB.X+CA.Y*CB.Y;
    PV := -CA.X*CB.Y+CA.Y*CB.X;
    result := radToDeg(arcTan2(PV,PS));
end;

function TChronoForm.GetCouleurGrid(Acol : integer) : TColor;
begin
     if Acol=0
        then result := clBlack
        else result := couleur[(Acol+1) div 2];
case result of
    clBlack: ;
    clMaroon: ;
    clGreen: ;
    clOlive: ;
    clNavy: ;
    clPurple: ;
    clTeal: ;
    clGray: ;
    clSilver: Result := clBlack;
    clRed: ;
    clLime: Result := clGreen;
    clYellow: Result := clBlack;
    clBlue: ;
    clFuchsia: ;
    clAqua: Result := clBlue;
    clWhite: Result := clBlack;
    clMoneyGreen: Result := clGreen;
    clSkyBlue: Result := clBlue;
    clCream: Result := clBlack;
    clMedGray: Result := clGray;
    else Result := clBlack;
end;
end;

(*
Aprs import activex du scanner

if ImgScan1.ScannerAvailable then
  try
    ImgScan1.OpenScanner;
    ImgScan1.ScanTo := 2;
    ImgScan1.Image:='c:\MyPicture.gif';
    ImgScan1.StartScan ;
    Application.ProcessMessages;
  finally
    ImgScan1.CloseScanner ;
  end;
*)

end.

