// SpectraLibrary
// Copyright (C) 1998, 2001, Earl F. Glynn, Overland Park, KS.
// Updated June 2001 for "FrequencyToRGB" and conversion routines.
// May be copied freely for non-commercial use.
// E-Mail:  EarlGlynn@att.net

UNIT Couleur;

INTERFACE

  PROCEDURE WavelengthToRGB(CONST Wavelength:  byte;
                            VAR R,G,B:  BYTE);

IMPLEMENTATION

  USES
    SysUtils, // IntToStr
    Math;     // Power


 // Adapted from www.isc.tamu.edu/~astro/color.html
 PROCEDURE WavelengthToRGB(CONST Wavelength:  byte;
                            VAR R,G,B:  BYTE);
 BEGIN
   CASE Wavelength OF
     0..50: BEGIN
         R  := 255*Wavelength div 51;
         G  := 0;
         B  := 255;
       END;
     51..101: BEGIN
         R  := 0;
         G  := 255*(Wavelength - 51) div 51;
         B  := 255;
       END;
     102..152:  BEGIN
         R  := 0;
         G  := 255;
         B  := 255*(Wavelength - 102) div 51
       END;
     153..203: BEGIN
         R  := 255*(Wavelength - 153) div 51;
         G  := 255;
         B  := 0
     END;
     204..255: BEGIN
         R  := 255;
         G  := 255*(Wavelength - 204) div 51;
         B  := 255
     END;
   END;
 END {WavelengthToRGB};


END.
