unit VLC_3D;

interface

uses
  System.Types, System.UITypes, System.ImageList,
  Vcl.Imaging.pngimage,
  Windows, SysUtils, Messages,  Classes, Graphics, Controls,
  Forms,  Dialogs, StdCtrls,  ExtCtrls,  Buttons, math,
  Menus, ImgList, Spin, ComCtrls, ToolWin,  inifiles,
  regutil, compile, constreg, grapheU, shellApi, clipBrd, stayontop_3D,
  PasLibVlcUnit, PasLibVlcClassUnit, PasLibVlcPlayerUnit;


const
   maxVecteurVideo = 1024;

type
  TstyleDrag = (bsNone,bsMesure,bsOrigine,bsEchelle1,bsEchelle2,
                bsEchelle1Move,bsEchelle2Move);
  TVLC_3DForm = class(TForm)
    OpenDialog: TOpenDialog;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    UndoBtn: TToolButton;
    RegressiBtn: TToolButton;
    ExitBtn: TToolButton;
    MesureBtn: TToolButton;
    ImageMenu: TPopupMenu;
    CurseurCroix: TMenuItem;
    CurseurNoir: TMenuItem;
    CurseurBlanc: TMenuItem;
    CurseurCible: TMenuItem;
    CouleurPointsCB: TColorBox;
    TraceEchCB: TCheckBox;
    CouleurAxeCB: TColorBox;
    TracePointsCB: TCheckBox;
    OrigineTempsBtn: TToolButton;
    Status: TStatusBar;
    RazBtn: TToolButton;
    EtiquetteCB: TCheckBox;
    Image1: TImage;
    PanelYZ: TPanel;
    PanelXZ: TPanel;
    ToolBarXZ: TToolBar;
    OpenXZBtn: TToolButton;
    OrigineXZBtn: TToolButton;
    EchelleXZBtn: TToolButton;
    ToolBarYZ: TToolBar;
    OpenYZBtn: TToolButton;
    OrigineYZBtn: TToolButton;
    EchelleYZBtn: TToolButton;
    SuivantXZBtn: TSpeedButton;
    SuivantYZBtn: TSpeedButton;
    PlayXZBtn: TSpeedButton;
    PlayYZBtn: TSpeedButton;
    StopXZBtn: TSpeedButton;
    StopYZBtn: TSpeedButton;
    RewindXZBtn: TSpeedButton;
    RewindYZBtn: TSpeedButton;
    GroupBox1: TGroupBox;
    distanceXZEdit: TEdit;
    GroupBox2: TGroupBox;
    distanceYZEdit: TEdit;
    GroupBox3: TGroupBox;
    EchelleEdit: TEdit;
    PanelVideoYZ: TPanel;
    PanelVideoXZ: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EchelleBtnClick(Sender: TObject);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure OrigineBtnClick(Sender: TObject);
    procedure MesureBtnClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure EchelleEditKeyPress(Sender: TObject; var Key: Char);
    procedure EchelleEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EchelleEditExit(Sender: TObject);
    procedure CurseurClick(Sender: TObject);
    procedure CouleurPointsCBChange(Sender: TObject);
    procedure CouleurAxeCBChange(Sender: TObject);
    procedure OrigineTempsBtnClick(Sender: TObject);
    procedure AxeClick(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure SuivantBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MediaPlayerPlaying(Sender: TObject);
    procedure MediaPlayerStopped(Sender: TObject);
    procedure MediaPlayerPaused(Sender: TObject);
    procedure MediaPlayerEndReached(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure RewindBtnClick(Sender: TObject);
    procedure OpenYZBtnClick(Sender: TObject);
    procedure distanceXZEditChange(Sender: TObject);
  private
    mediaPlayer : array[Tplan] of TPasLibVlcPlayer;
    panelVideo : array[Tplan] of TPanel;
    BorneSelect : TstyleDrag;
    LargeurAff,HauteurAff : integer;
    dureeSec : array[Tplan] of double;
    dureeSecMax : double;
    LongueurEchelle : double;
    distance : array[TPlan] of double;
    dragEch : boolean;
    NbreImagesParSec : array[Tplan] of integer;
    DureeImage : double;
    OrigineT : double;
    crCibleAvi : integer;
    MajVideo : boolean;
    MiseAJourEchelleAfaire : boolean;
    DrawForm3D : array[TPlan] of Tdraw_3DForm;
    SuivantBtn : array[TPlan] of TSpeedButton;
    procedure setBoutons;
    procedure EnregistrePoint(plan : Tplan);
    procedure SetCurseur(Acursor : Tcursor);
    procedure Dessine;
    Function valeurX(i : integer) : double;
    Function valeurY(i : integer) : double;
    Function valeurZ(i : integer) : double;
    procedure SauveData;
    Function GetBorne(plan : Tplan;x,y : integer) : TstyleDrag;
  public
      Temps : array[0..MaxVecteurVideo] of double;
      XY : array[Tplan,0..MaxVecteurVideo] of Tpoint;
      Echelle,Arrondi : array[Tplan] of double;
      Nmes : integer;
      PointAcquis : array[Tplan] of boolean;
      Largeur,Hauteur : integer;
      OrigineX,OrigineY : integer;
      OrigineZ : array[Tplan] of integer;
      pasZoom : single;
      PointRepere : array[Tplan,TstyleDrag] of Tpoint;
      nomFichier : array[Tplan] of string;
      couleurAxe,couleurPoint : Tcolor;
      procedure calcEchelle;
      procedure OuvreFichier(plan : Tplan;Anom: string);
  protected
      procedure WMSuivant(var Msg: TWMRegMessage); message wm_avi_suivant;
      procedure WMMAJAVI(var Msg: TWMRegMessage); message wm_maj_avi;
  end;

var
  VLC_3DForm: TVLC_3DForm;

implementation

uses regmain, regdde, graphvar, valeurs;

const  Titre = 'VLC';

{$R *.DFM}

procedure TVLC_3DForm.FormCreate(Sender: TObject);
var Fichier : TMemIniFile;
    plan : TPlan;
begin
    pasZoom := 1;
    nomFichier[Oxz] := '';  nomFichier[Oyz] := '';
    panelVideo[Oxz] := panelVideoXZ;  panelVideo[Oyz] := panelVideoYZ;
    LongueurEchelle := 1;
    distance[OXZ] := 1; distance[OYZ] := 1;
    EchelleEdit.text := '1';
    distanceXZEdit.text := '1';
    distanceYZEdit.text := '1';
    suivantBtn[Oxz] := suivantXZBtn;
    suivantBtn[Oyz] := suivantYZBtn;
    Fichier := TMemIniFile.create(NomFichierIni);
    OpenDialog.filterIndex := Fichier.readInteger(Titre,'FilterIndex',1);
    TraceEchCB.checked := Fichier.readBool(Titre,'TraceEchelle',true);
    TracePointsCB.checked := Fichier.readBool(Titre,'TracePoints',true);
    EtiquetteCB.checked := Fichier.readBool(Titre,'Etiquette',true);    
    couleurAxeCB.selected := Fichier.readInteger(Titre,'CouleurEchelle',clBlack);
    CouleurAxe := Fichier.readInteger(Titre,'CouleurA',clBlack);
    CouleurPoint := Fichier.readInteger(Titre,'CouleurP',clBlack);
    CouleurPointsCB.selected := CouleurPoint;
    crCibleAvi := Fichier.readInteger(Titre,'Cible',crCibleNormale);
    case crCibleAvi of
        crCibleNormale : curseurCible.checked := true;
        crCibleNoire : curseurNoir.checked := true;
        crCibleBlanche : curseurBlanc.checked := true;
        else curseurCroix.checked := true;
    end;
    Fichier.free;
    for plan := Oxz to Oyz do begin
        DrawForm3D[plan] := TDraw_3DForm.Create(self);
        DrawForm3D[plan].Tag := ord(plan);
        DrawForm3D[plan].plan := plan;
        DrawForm3D[plan].PaintBox.tag := ord(plan);
        mediaPlayer[plan] := nil;
    end;
    setBoutons;
end; // FormCreate

procedure TVLC_3DForm.RegressiBtnClick(Sender: TObject);
begin
    BorneSelect := bsNone;
    setCurseur(crDefault);
    setBoutons;
    SauveData
end;

procedure TVLC_3DForm.RewindBtnClick(Sender: TObject);
begin
    postMessage(handle,wm_maj_avi,0,0);
end;

procedure TVLC_3DForm.wmmajavi(var Msg: TWMRegMessage);
begin
    if nomFichier[Oxz]<>'' then ouvreFichier(Oxz,nomFichier[Oxz]);
    if nomFichier[Oyz]<>'' then ouvreFichier(Oyz,nomFichier[Oyz]);
end;

procedure TVLC_3DForm.SauveData;
var tampon : TstringList;

Procedure AjouteOptionGr;
var ligne : string;
begin
     tampon.Add('');
     Ligne := 'Dxz'+crTab+'Dyz';
     tampon.Add(Ligne);
     Ligne := 'm'+crTab+'m';
     tampon.Add(Ligne);
     ligne := FloatToStrPoint(distance[oXZ])+crTab+FloatToStrPoint(distance[OYZ]);
     tampon.Add(Ligne);
     tampon.add(SymbReg2+'1 NOMX');
     tampon.add('xe');
     tampon.add(SymbReg2+'1 NOMY');
     tampon.add('ye');
     tampon.add(SymbReg2+'1 ORTHO');
     tampon.add('1');
end;

var i : integer;
    ligne : String;
begin // SauveData
       tampon := TstringList.create;
       calcEchelle;
       Screen.Cursor := crHourGlass;
       tampon.add('');
       Ligne := 't'+crTab+'xe'+crTab+'ye'+crTab+'ze';
       tampon.add(Ligne);
       Ligne := 's'+crTab+'m'+crTab+'m'+crTab+'m';
       tampon.add(Ligne);
       for i := 0 to pred(Nmes) do begin
           ligne := floatToStrPoint(temps[i]-origineT);
               ligne := ligne+
                  crTab+floatToStrPoint(valeurX(i))+
                  crTab+floatToStrPoint(valeurY(i))+
                  crTab+floatToStrPoint(valeurZ(i));
           tampon.add(ligne);
        end;
        AjouteOptionGr;
        ClipBoard.asText := tampon.text;
        if pageCourante=0
        then with FregressiMain do begin
             grandeursOpen;
             grapheOpen;
             if FormDDE.ImportePressePapier then begin
                ModifConfigAcq := SaveConfigAcq;
                FocusAcquisitionBtn.visible := true;
                Fvaleurs.memo.lines.Add('''Dxz=Distance camra plan Oxz');
                Fvaleurs.memo.lines.Add('''Dyz=Distance camra plan Oyz');
                Fvaleurs.memo.lines.Add('x=Dyz*ye/(Dyz+ye)');
                Fvaleurs.memo.lines.Add('y=Dxz-Dxz*Dyz*ye/xe/(Dyz+ye)');
                Fvaleurs.memo.lines.Add('z=Dyz*ye*ze/(Dyz+ye)/xe');
             end
        end
        else FormDDE.AjoutePressePapier;
        tampon.free;
        Screen.Cursor := crDefault;
        modeAcquisition := acqVideo;
        setBoutons;
        Close;
end; // SauveData

procedure TVLC_3DForm.ExitBtnClick(Sender: TObject);
begin
    Close
end;

procedure TVLC_3DForm.PaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var echelleLoc : String;
    plan,p : Tplan;
begin
    plan := Oxz;
    if sender is TpaintBox then plan := Tplan((sender as TPaintBox).Tag);
    if sender is TPasLibVLCPlayer then begin
       for p := Oxz to Oyz do
           if sender = mediaPlayer[p] then plan := p;
    end;
if (Button<>mbLeft) or (NomFichier[plan]='') then exit;
pointRepere[plan,BorneSelect].x := round(x/pasZoom);
pointRepere[plan,BorneSelect].y := round(y/pasZoom);
case BorneSelect of
     bsEchelle1 : begin
         BorneSelect := bsEchelle2;
         hint := hEchelle2;
     end;
     bsEchelle1Move : begin
         BorneSelect := bsNone;
         pointRepere[plan,bsEchelle1] := pointRepere[plan,bsEchelle1Move];
         calcEchelle;
         Application.processMessages;
         setCurseur(crDefault);
         hint := hClicDroitAvi;
     end;
     bsEchelle2 : begin
         BorneSelect := bsNone;
         hint := hClicDroitAvi;
         setCurseur(crDefault);
         echelleLoc := inputBox(trEchelle,trLmetre,EchelleEdit.text);
         try
         LongueurEchelle := StrToFloatWin(echelleLoc);
         echelleEdit.text := echelleLoc;
         calcEchelle;
         except
             LongueurEchelle := StrToFloatWin(echelleEdit.text);
         end;
         Application.processMessages;
     end;
     bsEchelle2Move : begin
         pointRepere[plan,bsEchelle2] := pointRepere[plan,bsEchelle2Move];
         BorneSelect := bsNone;
         hint := hClicDroitAvi;
         setCurseur(crDefault);
         calcEchelle;
         Application.processMessages;
     end;
     bsOrigine : begin
         BorneSelect := bsNone;
         setCurseur(crDefault);
         hint := hClicDroitAvi;
         calcEchelle;
     end;
     bsMesure : EnregistrePoint(plan);
  end;
  DrawForm3D[plan].PaintBox.Refresh;
end; // MouseUp

procedure TVLC_3DForm.EnregistrePoint(plan : Tplan);
var PointSuivant : boolean;
begin
         XY[plan,Nmes] := pointRepere[plan,bsMesure];
         PointAcquis[plan] := true;
         if plan=Oxz
            then begin
              Temps[Nmes] := MediaPlayer[plan].GetVideoPosInMs()/1000;
              if nmes=0 then OrigineT := temps[nmes];
              PointSuivant := PointAcquis[Oyz]
            end
            else PointSuivant := PointAcquis[Oxz];
         if not PointSuivant then exit;
         UndoBtn.enabled := true;
         inc(Nmes);
         hint := Format(hMesureAvi1,[succ(nmes)]);
         RegressiBtn.enabled := nmes>3;
         PointAcquis[Oxz] := false; PointAcquis[Oyz] := false;
         if temps[nmes-1]<dureeSecMax-dureeImage
            then begin
                postMessage(handle,wm_avi_suivant,0,0); // Oxz
                postMessage(handle,wm_avi_suivant,1,0); // Oyz
            end
            else begin // c'est fini
                   BorneSelect := bsNone;
                   hint := hClicDroitAvi;
                   setBoutons;
                   Dessine;
            end;
end;

procedure TVLC_3DForm.EchelleBtnClick(Sender: TObject);
begin
   BorneSelect := bsEchelle1;
   Hint := hEchelle1;
   PointRepere[Oxz,bsEchelle1].x := 0;
   PointRepere[Oxz,bsEchelle1].y := 0;
   setCurseur(crCibleAvi);
end;

procedure TVLC_3DForm.OuvreFichier(plan : Tplan;Anom : string);
begin
     if mediaPlayer[plan]<>nil then mediaPlayer[plan].Free;
     mediaPlayer[plan] := TPasLibVlcPlayer.Create(panelVideo[plan]);
     mediaPlayer[plan].tag := ord(plan);
     mediaPlayer[plan].OnMediaPlayerEndReached := MediaPlayerEndReached;
     mediaPlayer[plan].OnMediaPlayerPaused := MediaPlayerPaused;
     mediaPlayer[plan].OnMediaPlayerPlaying := MediaPlayerPlaying;
     mediaPlayer[plan].OnMediaPlayerStopped := MediaPlayerStopped;
     mediaPlayer[plan].OnMouseDown := PaintBoxMouseDown;
     mediaPlayer[plan].OnMouseMove := PaintBoxMouseMove;
     mediaPlayer[plan].OnMouseUp := PaintBoxMouseUp;
     mediaPlayer[plan].PopupMenu := ImageMenu;
     mediaPlayer[plan].AudioOutput := aoDummy;
     mediaPlayer[plan].DeinterlaceMode := dmLinear;
     NomFichier[plan] := ANom;
     NbreImagesParSec[plan] := 30; // par dfaut
     DureeImage := 1/30;
     drawForm3D[plan].Visible := false;
     try
     Nmes := 0;
     pasZoom := 1;
     BorneSelect := bsNone;
     Caption := CaptionAvi+
         ' ['+ExtractFileName(NomFichier[Oxz])+
         ';'+ExtractFileName(NomFichier[Oyz])+']';
     suivantBtn[plan].Enabled := true;
     MajVideo := true;
     MediaPlayer[plan].Play(NomFichier[plan]);
     if libvlc_dynamic_dll_error <>'' then begin
        afficheErreur(libvlc_dynamic_dll_error,0);
        {$IFDEF WIN64}
        afficheErreur('Soit VLC non install, soit VLC 32 bits',0);
        {$ENDIF}
        {$IFDEF WIN32}
        afficheErreur('Soit VLC non install, soit VLC 64 bits',0);
        {$ENDIF}
     end;
     except
        NomFichier[plan] := '';
     end;
end;

procedure TVLC_3DForm.OpenFileBtnClick(Sender: TObject);
begin
   if OpenDialog.execute then
      ouvreFichier(Oxz,openDialog.fileName)
end;

procedure TVLC_3DForm.OpenYZBtnClick(Sender: TObject);
begin
   if OpenDialog.execute then
      ouvreFichier(Oyz,openDialog.fileName)
end;

procedure TVLC_3DForm.setBoutons;
var OK : array[TPlan] of boolean;
    OKglb : boolean;
    plan : Tplan;
begin
    for plan := Oxz to Oyz do begin
        OK[plan] := (NomFichier[plan]<>'');
        if mediaPlayer[plan]<>nil then MediaPlayer[plan].visible := OK[plan];
        DrawForm3D[plan].Visible := OK[plan];
        if OK[plan] then drawForm3D[plan].PaintBox.Refresh;
    end;
    OKglb := OK[Oxz] and OK[Oyz];
    MesureBtn.enabled := OKglb;
    RegressiBtn.enabled := nmes>3;
    EchelleXZBtn.enabled := OKglb;
    EchelleYZBtn.enabled := OKglb;
    OrigineXZBtn.enabled := OKglb;
    OrigineYZBtn.enabled := OKglb;
    RazBtn.enabled := OKglb and (borneSelect<>bsMesure) and (nmes>3);
    origineXZBtn.hint := hOrigineMouse;
    origineYZBtn.hint := hOrigineMouse;
    if borneSelect=bsMesure
       then begin
          MesureBtn.Hint := hStopMes;
          MesureBtn.Caption := 'STOP';
       end
       else begin
          MesureBtn.Hint := hStartMes;
          MesureBtn.Caption := 'Mesures';
       end;
    UndoBtn.enabled := OKglb and (borneSelect<>bsMesure) and (Nmes>0);
    calcEchelle;
end; // setBoutons

procedure TVLC_3DForm.OrigineBtnClick(Sender: TObject);
begin
     BorneSelect := bsOrigine;
     hint := hOrigineMove;
     setCurseur(crOrigine);
end;

procedure TVLC_3DForm.MesureBtnClick(Sender: TObject);
begin
if (borneSelect<>bsMesure)
  then begin
     BorneSelect := bsMesure;
     setCurseur(crCibleAvi);
     hint := Format(hMesureAvi1,[1]);
     Nmes := 0;
     PointAcquis[Oxz] := false; PointAcquis[Oyz] := false;
     if dureeSec[Oxz]>dureeSec[Oyz]
        then dureeSecMax := dureeSec[Oyz]
        else dureeSecMax := dureeSec[Oxz];
  end
  else begin
     BorneSelect := bsNone;
     hint := hClicDroitAvi;
     setCurseur(crDefault);
  end;
  setBoutons;
end;

procedure TVLC_3DForm.MediaPlayerEndReached(Sender: TObject);
var plan : integer;
begin
    plan := (sender as Tcontrol).Tag;
    postMessage(handle,WM_MAJ_AVI,plan,0);
end;

procedure TVLC_3DForm.MediaPlayerPaused(Sender: TObject);
var plan : TPlan;
begin
   plan := Tplan((sender as Tcontrol).Tag);
   suivantBtn[plan].Enabled := true
end;

procedure TVLC_3DForm.MediaPlayerPlaying(Sender: TObject);
var plan : Tplan;

procedure EffectuerZoom;
var zoomX,zoomY : single;
begin
    largeur := MediaPlayer[plan].GetVideoWidth();
    hauteur := MediaPlayer[plan].GetVideoHeight();
    zoomX := 0.98*(PanelVideo[plan].width / largeur);
    zoomY := 0.98*(PanelVideo[plan].height / hauteur);
    if zoomX>zoomY then pasZoom := zoomY else pasZoom := zoomX;
    if pasZoom<0.1 then pasZoom := 1;
    hauteurAff := round(hauteur*pasZoom)+1;
    largeurAff := round(largeur*pasZoom)+1;
    DrawForm3D[plan].width := largeurAff;
    DrawForm3D[plan].height := hauteurAff;
    MediaPlayer[plan].width := largeurAff;
    MediaPlayer[plan].height := hauteurAff;
end;

var apoint : Tpoint;
    longueur : int64;
begin
     plan := Tplan((sender as Tcontrol).Tag);
     if MajVideo then begin
     try
          Longueur := MediaPlayer[plan].GetVideoLenInMs();
          if (longueur=0) then longueur := 1000;
          // dbordement int64 ? si moins d'une seconde donc une seconde !
          DureeSec[plan] := longueur div 1000;
          MediaPlayer[plan].SetVideoScaleInPercent(0); // autoscale
          MediaPlayer[plan].SetAudioVolume(0);
          EffectuerZoom;
          apoint.Y := MediaPlayer[plan].top;
          apoint.x := MediaPlayer[plan].left;
          apoint := PanelVideo[plan].ClientToScreen(apoint);
          DrawForm3D[plan].left := apoint.x;
          DrawForm3D[plan].top := apoint.y;
          PointRepere[plan,bsOrigine] := point(Largeur div 2,Hauteur div 2);
          PointRepere[plan,bsEchelle1] := point(Largeur div 4,Hauteur div 4);
          PointRepere[plan,bsEchelle2] := point(Largeur div 2,Hauteur div 4);
          NbreImagesParSec[plan] := round(MediaPlayer[plan].GetVideoFPS());
          if NbreImagesParSec[plan]=0 then NbreImagesParSec[plan] := 30;
          status.panels[0].text := intToStr(NbreImagesParSec[plan])+'/s';
          DureeImage := 1/NbreImagesParSec[plan];
          OrigineT := 0;
          MajVideo := false;
          sleep(100);
          MediaPlayer[plan].Pause();
          sleep(100);
          if (((plan=Oxz) and (nomFichier[oyz]<>'')) or
              ((plan=Oyz) and (nomFichier[oxz]<>''))) and
             (NbreImagesParSec[Oxz]<>NbreImagesParSec[Oyz]) then
               ShowMessage('Les deux films doivent avoir la mme base de temps');
          borneSelect := bsNone;
          postMessage(handle,wm_avi_suivant,ord(plan),0);
          postMessage(handle,wm_avi_suivant,ord(plan),0);
          // pour avoir le troisime point sinon doublon au dmarrage ?
     except
        NomFichier[plan] := '';
     end;
        setBoutons;
     end; // Maj video au chargement
end;

procedure TVLC_3DForm.MediaPlayerStopped(Sender: TObject);
var plan : TPlan;
begin
  plan := Tplan((sender as Tcontrol).Tag);
  suivantBtn[plan].Enabled := true
end;

procedure TVLC_3DForm.UndoBtnClick(Sender: TObject);
begin
     if Nmes>0 then dec(nmes);
     UndoBtn.enabled := nmes>0;
               hint := Format(hMesureAvi1,[succ(nmes)]);
               setCurseur(crCibleAvi);
      //MediaPlayer[Oxz].PreviousFrame();  // n'existe pas !
      MediaPlayer[Oxz].setVideoPosInMs(round(temps[nmes]*1000));
      MediaPlayer[Oyz].setVideoPosInMs(round(temps[nmes]*1000));
      DrawForm3D[Oxz].PaintBox.Refresh;
end;

procedure TVLC_3DForm.EchelleEditKeyPress(Sender: TObject; var Key: Char);
begin
    if not CharInSet(key,['0'..'9','.',',','s','m',
                    crSupprArr,crCR,crTab,crGauche,crDroite]) then key := #0
end;

procedure TVLC_3DForm.EchelleEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=ord(crCR) then EchelleEditExit(sender)
end;

procedure TVLC_3DForm.PaintBoxPaint(Sender: TObject);
var plan : Tplan;
begin
    plan := Tplan((sender as Tcontrol).tag);
    if nomFichier[plan]<>'' then DrawForm3D[plan].Dessine;
end;

procedure TVLC_3DForm.PlayBtnClick(Sender: TObject);
var plan : Tplan;
begin
     plan := Tplan((sender as Tcontrol).tag);
     if (NomFichier[plan]<>'') then begin
         suivantBtn[plan].Enabled := false;
         mediaPlayer[plan].play(NomFichier[plan]);
     end;
end;

procedure TVLC_3DForm.Dessine;
begin
    if (NomFichier[Oxz]='') and (NomFichier[Oyz]='') then exit;
    DrawForm3D[Oxz].dessine;
    DrawForm3D[Oyz].dessine;
end;

procedure TVLC_3DForm.distanceXZEditChange(Sender: TObject);
begin
     MiseAJourEchelleAfaire := true
end;

procedure TVLC_3DForm.FormClose(Sender: TObject; var Action: TCloseAction);
var Fichier : TMemIniFile;
    plan : Tplan;
begin
     try
     Fichier := TMemIniFile.create(NomFichierIni);
     try
     Fichier.WriteBool(Titre,'Etiquette',EtiquetteCB.checked);
     Fichier.writeInteger(Titre,'FilterIndex',OpenDialog.filterIndex);
     Fichier.writeBool(Titre,'TraceEchelle',traceEchCB.checked);
     Fichier.writeBool(Titre,'TracePoints',tracePointsCB.checked);
     Fichier.writeInteger(Titre,'CouleurEchelle',couleurAxeCB.selected);
     Fichier.writeInteger(Titre,'CouleurP',CouleurPoint);
     Fichier.writeInteger(Titre,'Cible',crCible);
     Fichier.UpdateFile;
     finally
     Fichier.free;
     end;
     except
     end;
     for plan := Oxz to Oyz do begin
     if NomFichier[plan]<>'' then begin
        try
        MediaPlayer[plan].Stop;
        NomFichier[plan] := '';
        except
        end;
     end;
     drawForm3D[plan].Visible := false;
     end;
     inherited;
end;

procedure TVLC_3DForm.FormDestroy(Sender: TObject);
begin
     DrawForm3D[Oxz].free;
     DrawForm3D[Oyz].free;
     VLC_3DForm := nil
end;

procedure TVLC_3DForm.FormHide(Sender: TObject);
begin
  setCurseur(crDefault);
end;

procedure TVLC_3DForm.FormResize(Sender: TObject);
var zoomX,zoomY : single;
    plan : Tplan;
begin
    panelYZ.Width := ToolBar1.width div 2;
    if (NomFichier[Oxz]='') or
       (mediaPlayer[Oxz]=nil) or
       not MediaPlayer[Oxz].isPlay then exit;
    largeur := MediaPlayer[Oxz].GetVideoWidth();
    hauteur := MediaPlayer[Oxz].GetVideoHeight();
    zoomX := panelVideoYZ.width/largeur;
    zoomY := panelVideoYZ.height/hauteur;
    if zoomX>zoomY then pasZoom := zoomY else pasZoom := zoomX;
    if pasZoom<0.1 then pasZoom := 0.1;
    hauteurAff := round(hauteur*pasZoom);
    largeurAff := round(largeur*pasZoom);
    for plan := Oxz to Oyz do begin
      DrawForm3D[plan].width := largeurAff;
      DrawForm3D[plan].height := hauteurAff;
      if MediaPlayer[plan]<>nil then begin
         MediaPlayer[plan].width := largeurAff;
         MediaPlayer[plan].height := hauteurAff;
      end;
    end;
end;

procedure TVLC_3DForm.SetCurseur(Acursor : Tcursor);
var plan : Tplan;
begin
    if drawForm3D[Oxz].Cursor<>Acursor then begin
    for plan := Oxz to Oyz do begin
       DrawForm3D[plan].PaintBox.cursor := Acursor;
       DrawForm3D[plan].cursor := Acursor;
       PanelVideo[plan].cursor := Acursor;
       if mediaPlayer[plan]<>nil then mediaPlayer[plan].cursor := Acursor;
    end;
      screen.Cursor := Acursor;
    end;
end;

procedure TVLC_3DForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var BS : TstyleDrag;
    Plan,p : Tplan;
begin
plan := Oxz;
if sender is TpaintBox then plan := Tplan((sender as TpaintBox).tag);
if sender is TPasLibVlcPlayer then begin
  for p := Oxz to Oyz do
      if sender = mediaPlayer[p] then plan := p;
end;
if (NomFichier[plan]='') then exit;
if plan=Oxz
  then Status.Panels[1].text := 'x='+FormatReg((round(x/pasZoom)-origineX)*Echelle[plan])+'m'
  else Status.Panels[2].text := 'y='+FormatReg((round(y/pasZoom)-origineY)*Echelle[plan])+'m';
Status.Panels[3].text := 'z='+FormatReg((round(y/pasZoom)-origineZ[plan])*Echelle[plan])+'m';
if borneSelect=bsNone then begin
           hint := '';
           BS := GetBorne(plan,x,y);
           case BS of
              bsOrigine :  setCurseur(crOrigine);
              bsNone : setCurseur(crDefault)
              else setCurseur(crCibleMove);
           end;
           case BS of
               bsOrigine : hint := hOrigineMove;
               bsEchelle2 : hint := hEchelle2;
               bsEchelle1 : hint := hEchelle1;
               bsEchelle2Move : hint := hEchelle2Move;
               bsEchelle1Move : hint := hEchelle1Move;
               else hint := hClicDroitAvi;
           end;
           DrawForm3D[plan].PaintBox.hint := hint;
           Status.panels[4].Text := hint;
           exit;
   end;
if (BorneSelect=bsEchelle1) and
   (PointRepere[plan,bsEchelle1].x>0) and
   (PointRepere[plan,bsEchelle1].y>0) and
   ((abs(PointRepere[plan,bsEchelle1].x-x)+
     abs(PointRepere[plan,bsEchelle1].y-y))>4) then begin
          BorneSelect := bsEchelle2;
          hint := hGlisserEchelle;
          DragEch := true;
end;
if (BorneSelect=bsEchelle2) and DragEch then begin
       PointRepere[plan,bsEchelle2].x := round(x/pasZoom);
       PointRepere[plan,bsEchelle2].y := round(y/pasZoom);
       DrawForm3D[plan].PaintBox.Refresh;
end;
case borneSelect of
     bsNone : setCurseur(crDefault);
     bsMesure : setCurseur(crCibleAvi);
     bsOrigine : setCurseur(crSizeAll);
     bsEchelle1 : setCurseur(crSizeAll);
     bsEchelle2 : setCurseur(crSizeAll);
end;
end;  // mouseMove

procedure TVLC_3DForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var plan,p : Tplan;
begin
    plan := Oxz;
    if sender is TpaintBox then plan := Tplan((sender as TPaintBox).Tag);
    if sender is TPasLibVLCPlayer then begin
       for p := Oxz to Oyz do
           if sender = mediaPlayer[p] then plan := p;
    end;
    if (Button<>mbLeft) or (NomFichier[plan]='') then exit;
    if borneSelect=bsNone then begin
      BorneSelect := GetBorne(plan,x,y);
      if BorneSelect<bsNone then else setCurseur(crCibleMove);
      case BorneSelect of
           bsNone : setCurseur(crDefault);
           bsOrigine : setCurseur(crOrigine);
           else setCurseur(crCibleMove);
      end;
      case BorneSelect of
           bsOrigine : hint := hOrigineMove;
           bsEchelle2 : hint := hEchelle2;
           bsEchelle1 : hint := hEchelle1;
           bsEchelle2Move : hint := hEchelle2Move;
           bsEchelle1Move : hint := hEchelle1Move;
           else hint := hClicDroitAvi;
      end;
      DrawForm3D[plan].PaintBox.hint := hint;
      Status.Panels[4].Text := hint;
    end;
    pointRepere[plan,BorneSelect].x := round(x/pasZoom);
    pointRepere[plan,BorneSelect].y := round(y/pasZoom);
    if BorneSelect=bsEchelle1 then dragEch := false;
end;

procedure TVLC_3DForm.calcEchelle;
var EchelleEnPixel : double;
    plan : Tplan;
begin
     if (NomFichier[Oxz]='') or (NomFichier[Oyz]='') then exit;
     if miseAjourEchelleAfaire then begin
       try
       distance[OXZ] := StrToFloatWin(distanceXZEdit.text);
       distance[OYZ] := StrToFloatWin(distanceYZEdit.text);
       LongueurEchelle := StrToFloatWin(EchelleEdit.text);
       miseAjourEchelleAfaire := false;
       except
       end;
     end;
     for plan := Oxz to Oyz do begin
     echelleEnPixel := sqrt(sqr(PointRepere[plan,bsEchelle1].x-PointRepere[plan,bsechelle2].x)+
                            sqr(PointRepere[plan,bsEchelle1].y-PointRepere[plan,bsechelle2].y));
     Echelle[plan] := LongueurEchelle/EchelleEnPixel;
     OrigineX := PointRepere[plan,bsOrigine].x;
     OrigineY := PointRepere[plan,bsOrigine].y;
     Arrondi[plan] := power(10,floor(log10(abs(Echelle[plan]))));
     end;
end;

procedure TVLC_3DForm.EchelleEditExit(Sender: TObject);
var valeur,oldValeur : double;
begin
  try
     valeur := StrToFloatWin((sender as Tedit).text);
     case (sender as Tedit).tag of
          2 : LongueurEchelle := valeur;
          0 : distance[OXZ] := valeur;
          1 : distance[OYZ] := valeur;
     end;
  miseAjourEchelleAfaire := false;
  except
     showMessage(erEchelle);
     case (sender as Tedit).tag of
          2 : oldValeur := LongueurEchelle;
          0 : oldValeur := distance[OXZ];
          1 : oldValeur := distance[OYZ];
          else oldValeur := 1;
     end;
    (sender as TEdit).text := FormatReg(oldValeur);
  end;
end;

procedure TVLC_3DForm.SuivantBtnClick(Sender: TObject);
begin
     postMessage(handle,wm_avi_suivant,(sender as Tcontrol).tag,0);
end;

procedure TVLC_3DForm.WMSuivant(var Msg: TWMRegMessage);
var plan : Tplan;
begin
     plan := Tplan(Msg.WParam);
     if MediaPlayer[plan]<>nil then MediaPlayer[plan].NextFrame();
     sleep(100);
end;

procedure TVLC_3DForm.CurseurClick(Sender: TObject);
var Amenu : TmenuItem;
begin
      Amenu := TmenuItem(sender);
     if Amenu.tag=0
        then crCibleAvi := crCross
        else crCibleAvi := Amenu.tag;
     Amenu.checked := true;
     if (BorneSelect = bsMesure) then setCurseur(crCibleAVI);
end;

procedure TVLC_3DForm.StopBtnClick(Sender: TObject);
var plan : TPlan;
begin
     plan := Tplan((sender as Tcontrol).tag);
     if (NomFichier[plan]<>'') then begin
        MediaPlayer[plan].Pause();
        suivantBtn[plan].Enabled := true
     end;
end;


procedure TVLC_3DForm.CouleurPointsCBChange(Sender: TObject);
begin
   couleurPoint := couleurPointsCB.selected;
   dessine;
end;

procedure TVLC_3DForm.CouleurAxeCBChange(Sender: TObject);
begin
    couleurAxe := couleurAxeCB.Selected;
    dessine
end;

procedure TVLC_3DForm.OrigineTempsBtnClick(Sender: TObject);
var valeurInt : longInt;
begin
   if (NomFichier[Oxz]='') or (mediaPlayer[Oxz]<>nil) then exit;
   valeurInt := mediaPlayer[Oxz].GetVideoPosInMs();
   OrigineT := valeurInt/1000; // millisecondes
end;

procedure TVLC_3DForm.AxeClick(Sender: TObject);
begin
   (sender as TMenuItem).checked := true;
   setBoutons;
end;

function TVLC_3DForm.valeurX(i : integer) : double;
begin
     result := (xy[Oxz,i].x-OrigineX)*Echelle[Oxz]
end;

function TVLC_3DForm.valeurY(i : integer) : double;
begin
     result := (xy[Oyz,i].y-OrigineY)*Echelle[Oyz]
end;

function TVLC_3DForm.valeurZ(i : integer) : double;
 begin
     result := (xy[Oxz,i].y-OrigineZ[Oxz])*Echelle[Oxz];
end;

procedure TVLC_3DForm.RazBtnClick(Sender: TObject);
begin
     if MessageDlg('Suppression des donnes',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
         Nmes := 0;
         DrawForm3D[Oxz].PaintBox.Refresh;
         setBoutons;
     end;
end;

Function TVLC_3DForm.GetBorne(plan : Tplan;x,y : integer) : TstyleDrag;
var i : TstyleDrag;
begin
      result := bsNone;
      x := round(x/pasZoom);
      y := round(y/pasZoom);
      for i := succ(low(TstyleDrag)) to high(TstyleDrag) do
          if (abs(x-PointRepere[plan,i].x)+abs(y-PointRepere[plan,i].y) < Magnet)
              then begin
                   if i=bsEchelle1
                      then result := bsEchelle1Move
                      else if i=bsEchelle2
                         then result := bsEchelle2Move
                         else result := i;
                   break;
              end;
end;

end.

