﻿unit VLCbitmap;

interface

uses
  System.Types, System.UITypes, System.ImageList,
  Windows, SysUtils, Messages,  Classes, Graphics, Controls,
  Forms,  Dialogs, StdCtrls,  ExtCtrls,  Buttons,  registry, math,
  Menus, ImgList, Spin, ComCtrls, ToolWin, grids, inifiles,
  jpeg, gifImg, system.IOUtils,
  vcl.htmlHelpViewer,
  regutil, compile, constreg, grapheU, shellApi, clipBrd,
  Vcl.Imaging.pngimage,
  rollingShutterCalc;

type
  TstyleDrag = (bsNone,bsMesure,bsOrigine,bsEchelle1,bsEchelle2,
                bsChronoInit,bsChrono,bsAxeX,bsAxeY);
  TVLCBitmapForm = class(TForm)
    PanelMediaPlayer: TPanel;
    TempsLabel: TLabel;
    OpenDialog: TOpenDialog;
    CodecLabel: TLabel;
    ToolBarBoutons: TToolBar;
    OpenBtn: TToolButton;
    ImageList1: TImageList;
    UndoBtn: TToolButton;
    RegressiBtn: TToolButton;
    ExitBtn: TToolButton;
    MesureBtn: TToolButton;
    ToolBarParam: TToolBar;
    LabelNbreSE: TLabel;
    NbreSE: TSpinEdit;
    LabelIncertitude: TLabel;
    EchelleEdit: TEdit;
    ImageMenu: TPopupMenu;
    CurseurCroix: TMenuItem;
    CurseurNoir: TMenuItem;
    CurseurBlanc: TMenuItem;
    CurseurDouble: TMenuItem;
    IncertitudeSE: TSpinEdit;
    LabelEchelle: TLabel;
    GridSplitter: TSplitter;
    Status: TStatusBar;
    RazBtn: TToolButton;
    PanelVideo: TPanel;

    PlayBtn: TSpeedButton;
    StopBtn: TSpeedButton;
    SuivantBtn: TSpeedButton;
    Grid: TStringGrid;
    Image1: TImage;
    RewindBtn: TSpeedButton;
    LabelFPS: TLabel;
    PrecedentBtn: TSpeedButton;
    Timer: TTimer;
    LabelAttente: TLabel;
    ImagePaintBox: TPaintBox;
    SaveDialog: TSaveDialog;
    ChronoPhotoBtn: TToolButton;
    RalentiTB: TTrackBar;
    NimagesSE: TSpinEdit;
    Label1: TLabel;
    Panel1: TPanel;
    TrackBar: TTrackBar;
    FinBtn: TSpeedButton;
    DebutBtn: TSpeedButton;
    NchronoSE: TSpinEdit;
    GroupBox1: TGroupBox;
    TraceEchCB: TCheckBox;
    CouleurAxeCB: TColorBox;
    GroupBox2: TGroupBox;
    TracePointsCB: TCheckBox;
    CouleurPointsCB: TColorBox;
    MesureAutoCB: TCheckBox;
    EtiquetteCB: TCheckBox;
    VitesseLabel: TLabel;
    GridPanel: TPanel;
    altitudeCB: TCheckBox;
    TimerMove: TTimer;
    zoomUD: TSpinEdit;
    origineMobileCB: TCheckBox;
    RazAxes: TToolButton;
    Label2: TLabel;
    Label6: TLabel;
    RollingShutterBtn: TSpeedButton;
    RollingShutterSE: TSpinEdit;
    procedure FormCreate(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure MesureBtnClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure EchelleEditKeyPress(Sender: TObject; var Key: Char);
    procedure EchelleEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EchelleEditExit(Sender: TObject);
    procedure CurseurClick(Sender: TObject);
    procedure OrigineItemClick(Sender: TObject);
    procedure CouleurPointsCBChange(Sender: TObject);
    procedure CouleurAxeCBChange(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure SuivantBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure RewindBtnClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure PrecedentBtnClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure ImagePaintBoxPaint(Sender: TObject);
    procedure PanelVideoResize(Sender: TObject);
    procedure ChronoPhotoBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure PaintBoxClick(Sender: TObject);
    procedure DebutBtnClick(Sender: TObject);
    procedure FinBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure altitudeCBClick(Sender: TObject);
    procedure TimerMoveTimer(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure FormResize(Sender: TObject);
    procedure RazAxesClick(Sender: TObject);
    procedure zoomUDChange(Sender: TObject);
    procedure RollingShutterBtnClick(Sender: TObject);
  private
    complementaire : boolean;
    BorneSelect : TstyleDrag;
    dureeSec : double;
    LongueurEchelle : double;
    DureeImage : double;
    pasImage : integer;
    crCibleAvi : integer;
    indexImage : integer;
    bitmapC : Tbitmap;
    signeY : integer;
    Nmes : integer;
    Largeur,Hauteur : integer;
    LargeurAff,HauteurAff,longueurAxe : integer;
    PointRepere : array[TstyleDrag] of Tpoint;
    e_PointRepere : array[TstyleDrag] of Tpoint;
    PointCourant : integer;
    Couleur : array[0..maxPoints] of Tcolor;
    CouleurGrid : array[0..2*maxPoints+1] of Tcolor;
    nomFichier : string;
    NbreFichierImages : integer;
    rectAffichage : Trect;
    pasZoom : double;
    BlueCibleChrono,RedCibleChrono,GreenCibleChrono : integer;
    bitmapFin,bitmapInit : TBitmap;
    nomFichierChrono : string;
    arretForce : boolean;
    extension,extensionMaj : string;
    FichierVideoRecopie : boolean;
    angleX : double;
    bitmapLoupe : Tbitmap;
    lectureCouleur : boolean;
    hinTredim : boolean;
    nomffmpeg : string;
    rotation : integer;
    procedure setBoutons;
    procedure EnregistrePoint;
    procedure SetCurseur(Acursor : Tcursor);
    procedure traceGrid;
    procedure SauveData;
    procedure Precedent;
    Function GetBorne(x,y : integer;Deplace : boolean) : TstyleDrag;
    procedure getImage(index : integer);
    procedure videRepertoire;
    procedure dessineImage;
    procedure calcEchelle;
    procedure SaveChronoPhoto;
    procedure CreationImages;
    procedure ConvertitXY(Sender: TObject;var X, Y: Integer);
    procedure CacheLoupe;
    procedure EcranVersImage;
    procedure CorrigeAxes;
    procedure AVICHRONO;
  public
    procedure OuvreFichier(Anom: string);
  protected
    procedure WMAVICHRONOINIT(var Msg: TWMRegMessage); message wm_avi_chrono_init;
    procedure WMAVISUIVANT(var Msg: TWMRegMessage); message wm_avi_suivant;
  end;

var
  VLCBitmapForm: TVLCBitmapForm;

implementation

uses regmain, regdde, graphvar, chronoU, ChronoBitmap, loupeU, rollingShutterU,
  maths;

{$R *.DFM}

procedure TVLCBitmapForm.FormCreate(Sender: TObject);
var Fichier : TMemIniFile;
    j : integer;
begin
    nomFichier := '';
    LongueurEchelle := 1;
    EchelleEdit.text := '1';
 //   EchelleEdit.Height := 29;
    extension := '.jpg';
    hintRedim := false;
    Fichier := TMemIniFile.create(NomFichierIni);
    OpenDialog.filterIndex := Fichier.readInteger(stAVI,'FilterIndexMpeg',1);
    RollingShutterSE.value := Fichier.readInteger(stAVI,'RollingShutter',0);
    TraceEchCB.checked := Fichier.readBool(stAVI,'TraceEchelle',true);
    TracePointsCB.checked := Fichier.readBool(stAVI,'TracePoints',true);
    EtiquetteCB.checked := Fichier.readBool(stAVI,'Etiquette',true);
    couleurAxeCB.selected := Fichier.readInteger(stAVI,'CouleurEchelle',clBlack);
    bitmapC := Tbitmap.create;
    bitmapC.pixelFormat := pf24bit;
    couleur[0] := clBlack;
    for j := 1 to maxPoints do
        Couleur[j] := Fichier.readInteger(stAVI,'Couleur'+intToStr(j),clBlack);
    CouleurPointsCB.selected := Couleur[1];
    crCibleAvi := Fichier.readInteger(stAVI,'Cible',crCibleNormale);
    case crCibleAvi of
        crCibleDouble : curseurDouble.checked := true;
        crCibleNoire : curseurNoir.checked := true;
        crCibleBlanche : curseurBlanc.checked := true;
        else curseurCroix.checked := true;
    end;
    if LoupeForm=nil then
       Application.CreateForm(TLoupeForm, LoupeForm);
    altitudeCB.checked := Fichier.readBool(stAVI,'Altitude',true);
    if altitudeCB.checked
        then SigneY := -1
        else SigneY := +1;
    IncertitudeSE.value := Fichier.readInteger(stAVI,'PixelIncert',0);
    ZoomUD.value := Fichier.readInteger(stAVI,'Loupe',1);
    Fichier.free;
    Grid.cells[0,0] := 't(s)';
    nbreSE.MaxValue := maxPoints;
    bitmapLoupe := Tbitmap.create;
    bitmapLoupe.pixelFormat := pf24bit;
    LoupeForm.paintBox.onMouseUp := paintBoxMouseUp;
    LoupeForm.paintBox.onMouseDown := paintBoxMouseDown;
    LoupeForm.paintBox.onMouseMove := paintBoxMouseMove;
    LoupeForm.onKeyDown := formKeyDown;
    LoupeForm.Hide;
    setBoutons;
end; // FormCreate

procedure TVLCBitmapForm.RegressiBtnClick(Sender: TObject);
begin
    BorneSelect := bsNone;
    setCurseur(crDefault);
    setBoutons;
    SauveData
end;

procedure TVLCBitmapForm.RewindBtnClick(Sender: TObject);
begin
    getImage(pasImage)
end;

procedure TVLCBitmapForm.RollingShutterBtnClick(Sender: TObject);
begin
    RollingShutterForm := TRollingShutterForm.create(self);
    RollingShutterForm.showModal;
    RollingShutterForm.free;
end;

procedure TVLCBitmapForm.SauveData;
begin
       Screen.Cursor := crHourGlass;
       calcEchelle;
       correctionRS.withOrigine := OrigineMobileCB.Checked;
       correctionRS.RSvalue := RollingShutterSE.value;
       correctionRS.Nbre := nmes;
       correctionRS.NPoints := NbreSE.value;
       correctionRS.hauteur := hauteur;
       correctionRS.angleX := angleX;
       correctionRS.signeY := signeY;
       correctionRS.incertXY := IncertitudeSE.value;
       correctionRS.nomFichierVideo := nomFichier;
       correctionRS.sauveData;
       Screen.Cursor := crDefault;
       setBoutons;
       Close;
end; // SauveData

procedure TVLCBitmapForm.ExitBtnClick(Sender: TObject);
begin
    Close
end;

procedure TVLCBitmapForm.PaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if (Button<>mbLeft) or (NomFichier='') then exit;
convertitXY(sender,x,y);
e_pointRepere[BorneSelect].x := x;
e_pointRepere[BorneSelect].y := y;
corrigeAxes;
ecranVersImage;
case BorneSelect of
     bsEchelle1 : begin
         BorneSelect := bsNone;
         ecranVersImage;
         Application.processMessages;
         setCurseur(crDefault);
         hint := hClicDroitAvi;
     end;
     bsEchelle2 : begin
         ecranVersImage;
         BorneSelect := bsNone;
         hint := hClicDroitAvi;
         setCurseur(crDefault);
         Application.processMessages;
     end;
     bsOrigine,bsAxeX,bsAxeY : begin
         BorneSelect := bsNone;
         setCurseur(crDefault);
         hint := hClicDroitAvi;
     end;
     bsMesure : EnregistrePoint;
     bsChronoInit : begin
         correctionRS.XY[1,Nmes] := pointRepere[bsChronoInit];
         calcEchelle;
         postMessage(handle,wm_avi_chrono_init,0,0);
     end;
  end;
  ImagePaintBox.Refresh;
end; // MouseUp

procedure TVLCBitmapForm.EnregistrePoint;
begin
         correctionRS.XY[pointCourant,Nmes] := pointRepere[bsMesure];
         correctionRS.Temps[Nmes] := indexImage*dureeImage*pasImage;
         if (Nmes + 2) > grid.rowCount then
             grid.rowCount := Nmes + 5;
         Grid.cells[0,Nmes+1] := correctionRS.strT(Nmes);
         if pointCourant>0 then begin
            Grid.cells[pointCourant*2-1,Nmes+1] := correctionRS.strX(pointCourant,Nmes);
            Grid.cells[pointCourant*2,Nmes+1] := correctionRS.strY(pointCourant,Nmes);
         end;
         inc(PointCourant);
         if OrigineMobileCB.checked then begin
            if (PointCourant=1)
            then begin
               if NbreSE.value>1
                  then hint := Format(hMesureAvi1N,[succ(nmes)])
                  else hint := Format(hMesureAvi1,[succ(nmes)]);
               setCurseur(crCibleAvi);
            end
            else if NbreSE.value>1 then
                hint := Format(hMesureAviN,[PointCourant,succ(nmes)]);
         end
         else if NbreSE.value>1 then
                hint := Format(hMesureAviN,[PointCourant,succ(nmes)]);
         UndoBtn.enabled := true;
         if PointCourant>NbreSe.value then begin
             inc(Nmes);
             if OrigineMobileCB.checked
                then begin
                   PointCourant := 0;
                   hint := hOrigineI+intToStr(succ(nmes));
                   setCurseur(crOrigine);
                end
                else begin
                    PointCourant := 1;
                    if NbreSE.value>1
                      then hint := Format(hMesureAvi1N,[succ(nmes)])
                      else hint := Format(hMesureAvi1,[succ(nmes)]);
                    setCurseur(crCibleAvi);
                end;
             RegressiBtn.enabled := nmes>3;
             if indexImage<trackBar.max*pasImage
                then postMessage(handle,wm_avi_suivant,0,0)
                else begin
                   BorneSelect := bsNone;
                   hint := hClicDroitAvi;
                   setBoutons;
                   DessineImage;
                end;
         end;
end;

procedure TVLCBitmapForm.OuvreFichier(Anom : string);

procedure ConvertitGifBmp(var nomFichier: string);
var
  GIF		 : TGIFImage;
  Bitmap : TBitmap;
begin
    GIF := TGIFImage.Create;
    try
      GIF.OnProgress := Nil;
      // Load the GIF that will be converted
      nomFichier := ChangeFileExt(nomFichier,'.gif');
      GIF.LoadFromFile(nomFichier);
      Bitmap := TBitmap.Create;
      try
        // Convert the GIF to a BMP
        Bitmap.Assign(GIF);
        // Save the BMP
        nomFichier := ChangeFileExt(nomFichier,'.bmp');
        Bitmap.SaveToFile(nomFichier);
      finally
        Bitmap.Free;
      end;
    finally
      GIF.Free;
    end;
end;

procedure OuvreFichierImage;
var Ajpeg : TjpegImage;
    Apng : TpngImage;
    Abitmap : Tbitmap;
begin
       if (extensionMaj='.GIF') then begin
          ConvertitGifBmp(Anom);
          extension := '.bmp';
          extensionMaj := '.BMP';
       end;
       if (extensionMaj='.JPG') or (extensionMaj='.JPEG') then begin
           Ajpeg := TjpegImage.create;
           Ajpeg.LoadFromFile(ANom);
           hauteur := Ajpeg.Height;
           largeur := Ajpeg.Width;
           Ajpeg.free;
       end;
       if (extensionMaj='.PNG') then begin
           Apng := TpngImage.create;
           Apng.LoadFromFile(ANom);
           hauteur := Apng.Height;
           largeur := Apng.Width;
           Apng.free;
       end;
       if (extensionMaj='.BMP') then begin
           Abitmap := Tbitmap.Create;
           abitmap.LoadFromFile(ANom);
           largeur := abitmap.width;
           hauteur := abitmap.height;
           abitmap.free;
       end;
end; // OuvreFichierImage

Procedure RecopieLocal;
var nomCourt : string;
    src,dest : Pchar;
begin
     if Anom[1]<>'C' then begin
        nomCourt := extractFileName(Anom);
        nomFichier := Tpath.combine(tempDirReg,nomCourt);
        src := strAlloc(length(Anom)+1);
        dest := strAlloc(length(nomFichier)+1);
        strPCopy(src,anom);
        strPCopy(dest,nomFichier);
        copyFile(src,dest,true);
        strDispose(src);
        strDispose(dest);
        FichierVideoRecopie := true;
     end
     else NomFichier := ANom;
end;

procedure recopieImages;
var info : TSearchRec;
    numero : integer;
    numeroStr : string;
    nomFic : string;
    posCarac : integer;
    repertoire : string;
begin
     numero := 0;
     repertoire := extractFilePath(Anom);
     posCarac := pos(extension,Anom);
     Anom := copy(Anom,1,posCarac-1);
     posCarac := length(Anom);
     while charInSet(Anom[posCarac],['0'..'9']) do begin
           delete(Anom,posCarac,1);
           dec(posCarac);
     end;
     Anom := Anom+'*'+extension;
     if findFirst(Anom,faAnyFile,Info)=0 then begin
     repeat
         if (Info.attr and faDirectory)<>faDirectory then
            deleteFile(Tpath.combine(tempDirReg,Info.Name));
         inc(numero);
         numeroStr := intToStr(numero);
         while length(numeroStr)<3 do
               numeroStr := '0'+numeroStr;
         nomFic := Tpath.combine(tempDirReg,'test'+numeroStr+extension);
         copyFile(Pchar(repertoire+info.name),PChar(nomFic),false);
     until FindNext(Info)<>0;
     FindClose(info);
     end;
     NbreFichierImages := numero;
     trackBar.OnChange := nil;
     DureeImage := 1;
     pasImage := 1;
     if numero>2 then begin
        DureeSec := numero;
        PointRepere[bsOrigine] := point(Largeur div 2,Hauteur div 2);
        PointRepere[bsAxeX] := point(3*Largeur div 4,Hauteur div 2);
        PointRepere[bsAxeY] := point(Largeur div 2,Hauteur div 4);
        PointRepere[bsEchelle1] := point(Largeur div 4,Hauteur div 4);
        PointRepere[bsEchelle2] := point(Largeur div 2,Hauteur div 4);
        LabelFPS.Caption := '';
        indexImage := 1;
        borneSelect := bsNone;
        nomFichier := nomFic;
        getImage(pasImage);
        trackBar.max := numero;
        trackBar.Position := 1;
        trackBar.OnChange := TrackBarChange;
     end;
     setBoutons;
end; // recopieImages

var i,j : integer;
begin // ouvreFichier
     cacheLoupe;
     videRepertoire;
     trackBar.SelEnd := 0;
     trackBar.SelStart := 0;
     traceEchCB.visible := true;
     lectureCouleur := true;
     extension := extractFileExt(ANom);
     extensionMaj := UpperCase(extension);
     FichierVideoRecopie := false;
     if (extensionMaj='.JPG') or
        (extensionMaj='.JPEG') or
        (extensionMaj='.PNG') or
        (extensionMaj='.BMP') then begin
        ouvreFichierImage; // dimensions
        recopieImages;
        exit;
     end;
     videoDir := extractFilePath(Anom);
     recopieLocal;
     cursor := crHourGlass;
     labelAttente.Visible := true;
     labelAttente.Caption := ' Initialisation de ffmpeg, patientez … ';
     labelAttente.update;
     cursor := crHourGlass;
     DureeImage := 1/25;
     Nmes := 0;
     BorneSelect := bsNone;
     cacheLoupe;
     Caption := Captionffmpeg+' ['+ExtractFileName(NomFichier)+']';
     for i := 2 to pred(Grid.rowCount) do
         for j := 0 to pred(grid.colCount) do
             Grid.cells[j,i] := '';
     try
     creationImages;
     if (ImagePaintBox.Width>(largeurAff+32)) then
         gridPanel.Width := ClientWidth-largeurAff-gridSplitter.Width-32;
     except
         nomFichier := '';
     end;
end; // ouvreFichier

procedure TVLCBitmapForm.OpenFileBtnClick(Sender: TObject);
begin
   if OpenDialog.InitialDir='' then
      OpenDialog.InitialDir := VideoDir;
   if OpenDialog.execute then
      ouvreFichier(openDialog.fileName)
end;

procedure TVLCBitmapForm.setBoutons;
var OK : boolean;
begin
    OK := (NomFichier<>'') and (NbreFichierImages>3);
    EchelleEdit.enabled := OK;
    MesureBtn.enabled := OK and not ChronoPhotoBtn.down;
    ChronoPhotoBtn.enabled := OK and (borneSelect<>bsMesure);
    RegressiBtn.enabled := nmes>3;
    EchelleEdit.enabled := OK;
    RazAxes.enabled := OK and (angleX<>0);
    NbreSE.enabled := OK  and (borneSelect<>bsMesure);
    RazBtn.enabled := OK and (borneSelect<>bsMesure) and (nmes>0);
        (*
    if axeVersLeHautGauche.checked then
           EchelleBtn.ImageIndex := axeVersLeHautGauche.imageIndex;
    if axeVersLeHautDroite.checked then
           EchelleBtn.ImageIndex := axeVersLeHautDroite.imageIndex;
    if axeVersLeBasDroite.checked then
           EchelleBtn.ImageIndex := axeVersLeBasDroite.imageIndex;
    if axeVersLeBasGauche.checked then
           EchelleBtn.ImageIndex := axeVersLeBasGauche.imageIndex;
           *)
    if borneSelect=bsMesure
       then begin
          MesureBtn.Hint := hStopMes;
          MesureBtn.Caption := 'STOP';
          MesureBtn.imageIndex := 1;
       end
       else begin
          MesureBtn.Hint := hStartMes;
          MesureBtn.Caption := 'Mesurer';
          MesureBtn.imageIndex := 8;
       end;
    if ChronoPhotoBtn.down
       then ChronoPhotoBtn.Hint := hStopChrono
       else ChronoPhotoBtn.Hint := hChrono;
    UndoBtn.enabled := OK and (borneSelect<>bsMesure) and (Nmes>0);
    EchelleEdit.Height := 22;
    cursor := crDefault;
    if (borneSelect=bsNone) then cacheLoupe;
end; // setBoutons


procedure TVLCBitmapForm.MesureBtnClick(Sender: TObject);
var i,j : integer;
    P : TPoint;
begin
calcEchelle;
correctionRS.withOrigine := OrigineMobileCB.Checked;
correctionRS.RSvalue := RollingShutterSE.value;
correctionRS.NPoints := NbreSE.value;
correctionRS.hauteur := hauteur;
correctionRS.angleX := angleX;
correctionRS.signeY := signeY;
correctionRS.incertXY := IncertitudeSE.value;
if MesureBtn.down
  then begin
  if MesureAutoCB.checked
    then begin
         nomFichierChrono := Tpath.combine(tempDirReg,'regavi.bmp');
         Nmes := 0;
         BorneSelect := bsChronoInit;
         if NbreSE.value>1 then showMessage('Un seul mobile possible');
         NbreSE.value := 1;
         setCurseur(crCible);
         P := TPoint.create(ImagePaintBox.Width div 4,ImagePaintBox.Height div 3);
         P := ImagePaintBox.ClientToScreen(P);
         MessageDlgPos(trCibleAuto,mtConfirmation,[mbOK],0,P.x,P.y);
         hint := hCibleAuto;
         imagePaintBox.repaint;
    end
    else begin
     BorneSelect := bsMesure;
     Nmes := 0;
     if OrigineMobileCB.checked
        then begin
           PointCourant := 0;
           setCurseur(crOrigine);
           hint := hOrigine1
        end
        else begin
           PointCourant := 1;
           setCurseur(crCibleAvi);
           if NbreSE.value>1
              then hint := Format(hMesureAvi1N,[1])
              else hint := Format(hMesureAvi1,[1]);
        end;
    end;
    for i := Nmes+2 to pred(Grid.rowCount) do
        for j := 0 to pred(grid.colCount) do
            Grid.cells[j,i] := '';
    MesureBtn.Hint := hStopMes;
    MesureBtn.imageIndex := 1;
    MesureBtn.Caption := 'Stop';
  end
  else begin
     BorneSelect := bsNone;
     hint := hClicDroitAvi;
     setCurseur(crDefault);
     MesureBtn.Hint := hStartMes;
     MesureBtn.imageIndex := 8;
     MesureBtn.Caption := 'Mesurer';
  end;
  Grid.ColCount := NbreSE.value*2+1;
  if NbreSE.value=1
     then begin
        Grid.cells[1,0] := 'x(m)';
        Grid.cells[2,0] := 'y(m)';
     end
     else for j := 1 to NbreSE.value do begin
        Grid.cells[2*j-1,0] := 'x'+intToStr(j)+'(m)';
        Grid.cells[2*j,0] := 'y'+intToStr(j)+'(m)';
     end;
  setBoutons;
end;

procedure TVLCBitmapForm.UndoBtnClick(Sender: TObject);
var j : integer;
begin
     if Nmes>0 then dec(nmes);
     UndoBtn.enabled := nmes>0;
     if OrigineMobileCB.checked
          then begin
               PointCourant := 0;
               hint := hOrigineI+intToStr(succ(nmes));
               setCurseur(crOrigine);
          end
          else begin
               PointCourant := 1;
               if NbreSE.value>1
                   then hint := Format(hMesureAvi1N,[succ(nmes)])
                   else hint := Format(hMesureAvi1,[succ(nmes)]);
               setCurseur(crCibleAvi);
          end;
      for j := 0 to pred(grid.colCount) do
          Grid.cells[j,nmes+1] := '';
      Precedent;
      ImagePaintBox.Refresh;
end;

procedure TVLCBitmapForm.EchelleEditKeyPress(Sender: TObject; var Key: Char);
begin
    if not CharInSet(key,['0'..'9','.',',','s','m',
                    crSupprArr,crCR,crTab,crGauche,crDroite]) then key := #0
end;

procedure TVLCBitmapForm.EchelleEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=ord(crCR) then EchelleEditExit(sender)
end;

procedure TVLCBitmapForm.PanelVideoResize(Sender: TObject);
begin
     if NomFichier<>'' then getImage(indexImage);
end;

procedure TVLCBitmapForm.PlayBtnClick(Sender: TObject);
begin
     if (NomFichier<>'') then timer.Enabled := true;
end;

procedure TVLCBitmapForm.DebutBtnClick(Sender: TObject);
begin
  TrackBar.SelStart := Trackbar.position
end;

procedure TVLCBitmapForm.TraceGrid;

function GetCouleurGrid(Acol : integer) : TColor;
begin
if Acol=0
     then result := clBlack
     else result := couleur[(Acol+1) div 2];
case result of
    clMaroon: ;
    clGreen: ;
    clOlive: ;
    clNavy: ;
    clPurple: ;
    clTeal: ;
    clGray: ;
    clBlue: ;
    clFuchsia: ;
    clRed: ;
    clLime,clMoneyGreen: Result := clGreen;
    clAqua,clSkyBlue: Result := clBlue;
    clMedGray: Result := clGray;
    else Result := clBlack;
end; // case
end;

var i,j : integer;
begin
    if NomFichier='' then exit;
    for j := 0 to pred(grid.ColCount) do
        couleurGrid[j] := getCouleurGrid(j);
    if (Nmes+2)>grid.rowCount then grid.rowCount := Nmes+5;
    if NbreSE.value=1
       then begin
          Grid.cells[1,0] := 'x(m)';
          Grid.cells[2,0] := 'y(m)';
       end
       else for j := 1 to NbreSE.value do begin
          Grid.cells[2*j-1,0] := 'x'+intToStr(j)+'(m)';
          Grid.cells[2*j,0] := 'y'+intToStr(j)+'(m)';
       end;
    for i := 0 to pred(nmes) do begin
           Grid.cells[0,i+1] := correctionRS.strT(i);
           for j := 1 to NbreSE.value do begin
               Grid.cells[j*2-1,i+1] := correctionRS.strX(j,i);
               Grid.cells[j*2,i+1] := correctionRS.strY(j,i);
           end;{j}
    end;
    for i := nmes+1 to pred(grid.rowCount) do
        for j := 0 to pred(grid.colCount) do
            Grid.cells[j,i] := '';
end; // TraceGrid

procedure TVLCBitmapForm.FinBtnClick(Sender: TObject);
begin
    TrackBar.SelEnd := Trackbar.position
end;

procedure TVLCBitmapForm.FormActivate(Sender: TObject);
begin
    cacheLoupe;
    if (pos('ffmpeg',nomDecodeur)>0)
       then nomffmpeg := nomDecodeur
       else nomffmpeg := ffmpegExe
end;

procedure TVLCBitmapForm.FormClose(Sender: TObject; var Action: TCloseAction);
var Fichier : TMemIniFile;
    j : integer;
begin
     try
     Fichier := TMemIniFile.create(NomFichierIni);
     try
     Fichier.writeInteger(stAVI,'RollingShutter',RollingShutterSE.value);
     Fichier.WriteBool(stAVI,'Etiquette',EtiquetteCB.checked);
     Fichier.writeInteger(stAVI,'FilterIndexMpeg',OpenDialog.filterIndex);
     Fichier.writeBool(stAVI,'TraceEchelle',traceEchCB.checked);
     Fichier.writeBool(stAVI,'TracePoints',tracePointsCB.checked);
     Fichier.writeInteger(stAVI,'CouleurEchelle',couleurAxeCB.selected);
     for j := 1 to maxPoints do
         Fichier.writeInteger(stAVI,'Couleur'+intToStr(j),Couleur[j]);
     Fichier.writeInteger(stAVI,'Cible',crCibleAvi);
     Fichier.writeBool(stAVI,'Altitude',altitudeCB.checked);
     Fichier.writeInteger(stAVI,'PixelIncert',IncertitudeSE.value);
     Fichier.writeInteger(stAVI,'Loupe',zoomUD.value);
     Fichier.UpdateFile;
     finally
     Fichier.free;
     end;
     except
     end;
     timer.Enabled := false;
     loupeForm.Hide;
     inherited;
end;

procedure TVLCBitmapForm.FormDestroy(Sender: TObject);
begin
     VLCBitmapForm := nil;
     if LoupeForm<>nil then begin
        LoupeForm.close;
        LoupeForm.free;
        LoupeForm := nil;
     end;
     bitmapC.free;
     videRepertoire;
     bitmapLoupe.Free;
end;

procedure TVLCBitmapForm.FormHide(Sender: TObject);
begin
     setCurseur(crDefault);
end;

procedure TVLCBitmapForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var P : Tpoint;
    incr : integer;
begin
     if not key in [vk_left,vk_numpad4,vk_right,vk_numpad6,
                    vk_down,vk_numpad2,vk_up,vk_numpad8,vk_prior,
                    vk_next,vk_space,vk_return]
        then exit;
     try
     P := Mouse.CursorPos;
     except
       exit;
     end;
     if ssShift in shift then incr := 8 else incr := 1;
     case key of
          vk_left,vk_numpad4 : dec(P.X,incr);
          vk_right,vk_numpad6 : inc(P.X,incr);
          vk_down,vk_numpad2 : inc(P.Y,incr);
          vk_up,vk_numpad8 : dec(P.Y,incr);
          vk_prior : if ssShift in shift
              then dec(P.X,8)
              else dec(P.Y,8);
          vk_next : if ssShift in shift
              then inc(P.X,8)
              else inc(P.Y,8);
          vk_space,vk_return : if BorneSelect=bsMesure then begin
              P := ImagePaintBox.ScreenToClient(P);
              pointRepere[bsMesure].x := round(P.x/pasZoom);
              pointRepere[bsMesure].y := round(P.y/pasZoom);
              enregistrePoint;
              exit;
          end;
          else exit;
     end;
     key := 0;
     Mouse.CursorPos := P;
end;

procedure TVLCBitmapForm.FormResize(Sender: TObject);
begin
    if gridPanel.Width>clientWidth div 3 then
       gridPanel.Width := clientWidth div 3;
    if (nomFichier<>'') and not HintRedim then begin
        showMessage('Rouvrez le fichier video en cas de redimensionnement');
        HintRedim := true;
    end;
end;

procedure TVLCBitmapForm.SetCurseur(Acursor : Tcursor);
begin
    if ImagePaintBox.Cursor<>Acursor then begin
       imagePaintBox.cursor := Acursor;
       if (aCursor=crDefault) then cacheLoupe;
    end;
end;

procedure TVLCBitmapForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);

procedure Loupe;
var gainLoupe,largeurLoupe,hauteurLoupe : integer;
    Xleft,Xright,Ytop,Ybottom : integer;

procedure reperage;
begin
    LoupeForm.PaintBox.canvas.pen.color := couleurAxeCB.selected;
    LoupeForm.PaintBox.canvas.brush.Color := couleurAxeCB.selected;
    LoupeForm.PaintBox.canvas.brush.style := bsSolid;

    LoupeForm.PaintBox.canvas.moveto(0,LoupeForm.height div 2);
    LoupeForm.PaintBox.canvas.lineto(LoupeForm.width div 3,LoupeForm.height div 2);
    LoupeForm.PaintBox.canvas.moveto(2*LoupeForm.width div 3,LoupeForm.height div 2);
    LoupeForm.PaintBox.canvas.lineto(LoupeForm.width,LoupeForm.height div 2);

    LoupeForm.PaintBox.canvas.moveto(LoupeForm.width div 2,0);
    LoupeForm.PaintBox.canvas.lineto(LoupeForm.width div 2,LoupeForm.height div 3);
    LoupeForm.PaintBox.canvas.moveto(LoupeForm.width div 2,2*LoupeForm.height div 3);
    LoupeForm.PaintBox.canvas.lineto(LoupeForm.width div 2,LoupeForm.height);

    LoupeForm.PaintBox.canvas.FillRect(rect(
       (LoupeForm.width div 2)-1,(LoupeForm.height div 2)-1,
       (LoupeForm.width div 2)+1,(LoupeForm.height div 2)+1));
end;

procedure Efface;
begin
     if (Ybottom>0) or (Ytop>0) or  (Xleft>0) or (Xright>0) then begin
        LoupeForm.PaintBox.canvas.brush.Color := LoupeForm.transparentColorValue;
        LoupeForm.PaintBox.canvas.brush.style := bsSolid;
     end;
     if (Ytop>0) or (ybottom>0) then
        LoupeForm.PaintBox.canvas.FillRect(rect(0,ytop,LoupeForm.width,ybottom));
     if (xleft>0) or (xright>0) then
        LoupeForm.PaintBox.canvas.FillRect(rect(xleft,0,xright,LoupeForm.height));
end;

var
   X1,Y1,X2,Y2 : integer;
   decaleX,decaleY : integer;
   aPoint : TPoint;
begin
   imagePaintBox.OnMouseMove := nil;
   loupeForm.paintBox.OnMouseMove := nil; // mise à jour longue ...
   gainLoupe := zoomUD.value;
   largeurLoupe := LoupeForm.width div (gainLoupe);
   hauteurLoupe := LoupeForm.height div (gainLoupe);
   X1 := X-largeurLoupe div 2;
   Y1 := Y-hauteurLoupe div 2;
   X2 := X+largeurLoupe div 2;
   Y2 := Y+hauteurLoupe div 2;
   Xleft := 0;Xright := 0;
   Ytop := 0;Ybottom := 0;
   decaleX := 0;decaleY := 0;
   if Y1<0 then begin
      Ybottom := -Y1*gainLoupe;
      Y1 := 0;
      decaleY := Ybottom;
   end;
   if X1<0 then begin
      Xright := -X1*gainLoupe;
      X1 := 0;
      decaleX := Xright;
   end;
   if Y2>hauteurAff then begin
      Ybottom := loupeForm.Height;
      Ytop := loupeForm.Height-(Y2-hauteurAff)*gainLoupe;
      Y2 := hauteurAff;
   end;
   if X2>largeurAff then begin
      Xright := loupeForm.width;
      Xleft := loupeForm.width-(X2-largeurAff)*gainLoupe;
      X2 := largeurAff;
   end;
   bitmapLoupe.Width := (X2-X1);
   bitmapLoupe.Height := (Y2-Y1);
   bitmapLoupe.canvas.CopyRect(rect(0,0,X2-X1,Y2-Y1),
            bitmapC.canvas,
            rect(round(X1/pasZoom),round(Y1/pasZoom),round(X2/pasZoom),round(Y2/pasZoom)));
   aPoint := imagePaintBox.clientToScreen(Point(x,y));
   LoupeForm.Left := aPoint.X-LoupeForm.width div 2;
   LoupeForm.Top := aPoint.Y-LoupeForm.height div 2;
   LoupeForm.paintBox.canvas.StretchDraw(
             rect(decaleX,decaleY,
                  decaleX+(X2-X1)*gainLoupe,
                  decaleY+(Y2-Y1)*gainLoupe),bitmapLoupe);
   Reperage;
   Efface;
   imagePaintBox.OnMouseMove := paintBoxMouseMove;
   loupeForm.paintBox.OnMouseMove := paintBoxMouseMove;
   if not loupeForm.visible then begin
      loupeForm.Cursor := crNone;
      loupeForm.paintBox.Cursor := crNone;
      loupeForm.show;
   end;
end; // loupe

var BS : TstyleDrag;
begin
if (NomFichier='') then exit;
if chronoPhotoBtn.Down then exit;
ConvertitXY(Sender,X,Y);
if (x<=0) or (y<=0) or (x>=largeurAff) or (y>=hauteurAff) then begin
   cacheLoupe;
   exit;
end;
if borneSelect=bsNone then begin
           hint := '';
           BS := GetBorne(x,y,false);
           case BS of
              bsOrigine : setCurseur(crOrigine);
              bsNone : setCurseur(crDefault)
              else setCurseur(crCibleMove);
           end;
           case BS of
               bsOrigine : hint := hOrigineMove;
               bsAxeX : hint := hAxeX;
               bsAxeY : hint := hAxeY;
               bsEchelle2 : hint := hEchelle2Move;
               bsEchelle1 : hint := hEchelle1Move;
               else hint := hClicDroitAvi;
           end;
           ImagePaintBox.hint := hint;
           Status.panels[2].Text := hint;
           exit;
   end
   else if (BorneSelect in[bsEchelle1,bsEchelle2,bsOrigine,bsAxeX,bsAxeY]) and
           not timerMove.enabled then begin
      e_pointRepere[BorneSelect].x := x;
      e_pointRepere[BorneSelect].y := y;
      corrigeAxes;
      ecranVersImage;
      ImagePaintBox.Refresh;
      timerMove.Enabled := true;
   end;
if (zoomUD.value>1) and (borneSelect in [bsMesure,bsOrigine,bsEchelle1,bsEchelle2,bsAxeX,bsAxeY,bsChronoInit])
      then Loupe
      else cacheLoupe;
end;  // mouseMove

procedure TVLCBitmapForm.PaintBoxClick(Sender: TObject);
begin
  complementaire := not complementaire
end;

procedure TVLCBitmapForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Button<>mbLeft) or (NomFichier='') then exit;
    ConvertitXY(Sender,X,Y);
    if borneSelect=bsNone then begin
      BorneSelect := GetBorne(x,y,true);
      case BorneSelect of
           bsNone : setCurseur(crDefault);
           bsOrigine : setCurseur(crOrigine);
           else setCurseur(crCibleMove);
      end;
      case BorneSelect of
           bsOrigine : hint := hOrigineMove;
           bsEchelle2 : hint := hEchelle2Move;
           bsEchelle1 : hint := hEchelle1Move;
           bsAxeX : hint := hAxeX;
           bsAxeY : hint := hAxeY;
           else hint := hClicDroitAvi;
      end;
      setBoutons;
      ImagePaintBox.hint := hint;
      Status.Panels[2].Text := hint;
    end;
end;

procedure TVLCBitmapForm.calcEchelle;
var EchelleEnPixel : double;
    i : integer;
begin
     if NomFichier='' then exit;
     if not OrigineMobileCB.checked then
          for i := 0 to MaxVecteurVideo do begin
                correctionRS.xy[0,i].x := PointRepere[bsOrigine].x;
                correctionRS.xy[0,i].y := PointRepere[bsOrigine].y;
          end;
          try
     LongueurEchelle := StrToFloatWin(EchelleEdit.text);
     except
         showMessage(erEchelle);
         EchelleEdit.text := FormatReg(LongueurEchelle);
     end;
     echelleEnPixel := sqrt(sqr(PointRepere[bsEchelle1].x-PointRepere[bsechelle2].x)+
                            sqr(PointRepere[bsEchelle1].y-PointRepere[bsechelle2].y));
     correctionRS.Echelle := LongueurEchelle/EchelleEnPixel;
     if altitudeCB.checked
        then SigneY := -1
        else SigneY := +1
end;

procedure TVLCBitmapForm.EchelleEditExit(Sender: TObject);
begin
     calcEchelle
end;

procedure TVLCBitmapForm.WMAVISuivant(var Msg: TWMRegMessage);
begin
   if borneSelect=bsChrono
      then GetImage(indexImage+pasImage*NchronoSE.value)
      else GetImage(indexImage+pasImage);
end;

procedure TVLCBitmapForm.zoomUDChange(Sender: TObject);
begin
    if zoomUD.Value=1 then cacheLoupe;
end;

procedure TVLCBitmapForm.Precedent;
begin
   GetImage(indexImage-pasImage);
end;

procedure TVLCBitmapForm.PrecedentBtnClick(Sender: TObject);
begin
   Precedent;
end;

procedure TVLCBitmapForm.SuivantBtnClick(Sender: TObject);
begin
    postMessage(handle,wm_avi_suivant,0,0);
end;

procedure TVLCBitmapForm.TimerMoveTimer(Sender: TObject);
begin
    TimerMove.Enabled := false;
end;

procedure TVLCBitmapForm.TimerTimer(Sender: TObject);
begin
   postMessage(handle,wm_avi_suivant,0,0);
   timer.Interval := 1000 div RalentiTB.Position;
end;

procedure TVLCBitmapForm.TrackBarChange(Sender: TObject);
begin
   getImage(TrackBar.Position*pasImage);
end;

procedure TVLCBitmapForm.CurseurClick(Sender: TObject);
var Amenu : TmenuItem;
begin
     Amenu := TmenuItem(sender);
     if Amenu.tag=0
        then crCibleAvi := crCross
        else crCibleAvi := Amenu.tag;
     Amenu.checked := true;
     if (BorneSelect = bsMesure) then if pointCourant=0
        then setCurseur(crOrigine)
        else setCurseur(crCibleAVI);
end;

procedure TVLCBitmapForm.OrigineItemClick(Sender: TObject);
begin
  correctionRS.withOrigine := origineMobileCB.checked;
  setBoutons;
end;

procedure TVLCBitmapForm.StopBtnClick(Sender: TObject);
begin
     if (NomFichier<>'') then begin
        timer.enabled := false;
        arretForce := true;
     end;
end;

procedure TVLCBitmapForm.CouleurPointsCBChange(Sender: TObject);
begin
   if pointCourant=0
     then couleur[1] := couleurPointsCB.selected
     else couleur[pointCourant] := couleurPointsCB.selected;
   imagePaintBox.Repaint;
end;

procedure TVLCBitmapForm.CouleurAxeCBChange(Sender: TObject);
begin
    getImage(TrackBar.Position*pasImage);
    imagePaintBox.Repaint;
end;

procedure TVLCBitmapForm.altitudeCBClick(Sender: TObject);
begin
   if nomFichier<>'' then begin
      if altitudeCB.checked
         then SigneY := -1
         else SigneY := +1;
      traceGrid;
      e_pointRepere[bsAxeY].x := 2*e_pointRepere[bsOrigine].x-e_pointRepere[bsAxeY].x;
      e_pointRepere[bsAxeY].y := 2*e_pointRepere[bsOrigine].y-e_pointRepere[bsAxeY].y;
      ImagePaintBox.repaint;
   end;
end;

procedure TVLCBitmapForm.RazAxesClick(Sender: TObject);
var longueur : integer;
begin
     longueur := largeur div 4;
     angleX := 0;
     e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+longueur;
     e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y;
     e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x;
     e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*longueur;
     ecranVersImage;
     ImagePaintBox.Refresh;
end;

procedure TVLCBitmapForm.RazBtnClick(Sender: TObject);
var i,j : integer;
begin
     if MessageDlg('Suppression des données',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
         for i := 0 to nmes do
           for j := 0 to pred(grid.ColCount) do
               Grid.cells[j,i+1] := '';
         Nmes := 0;
         ImagePaintBox.Refresh;
         setBoutons;
     end;
end;

Function TVLCBitmapForm.GetBorne(x,y : integer;deplace : boolean) : TstyleDrag;
var i : TstyleDrag;
    aPoint : TPoint;
    a,d : double;
begin
      result := bsNone;
      aPoint := Point(x,y);
      for i in [bsOrigine,bsEchelle1,bsEchelle2,bsAxeX,bsAxeY] do
          if (e_PointRepere[i].distance(aPoint) < Magnet)
              then begin
                   result := i;
                   break;
              end;
      if result=bsNone then begin
         d := e_PointRepere[bsOrigine].distance(aPoint);
         if d<100 then exit;
         a := arcTan2(aPoint.y-e_PointRepere[bsOrigine].y,
                      aPoint.x-e_PointRepere[bsOrigine].x);
         if (abs(angleX-a)<0.02)
         then begin
             if deplace then begin
                e_PointRepere[bsAxeX] := aPoint;
                ecranVersImage;
             end;
             result := bsAxeX;
         end
         else if (abs(angleX+signeY*pi/2-a)<0.02) then begin
             if deplace then begin
                e_PointRepere[bsAxeY] := aPoint;
                ecranVersImage;
             end;
             result := bsAxeY;
         end;
      end;
end;

procedure TVLCBitmapForm.CreationImages;
var Nbre : integer;
    scaleStr : string;

procedure GetNbre;
var info : TSearchRec;
begin
  nbre := 0;
  removeBackSlash(tempDirReg);
  if findFirst(tempDirReg+'\*'+extension,faAnyFile,Info)=0 then begin
     repeat
         inc(nbre)
     until FindNext(Info)<>0;
     FindClose(info);
  end;
end;

function GetDosOutput(CommandLine: string): string;
// Run a DOS program and retrieve its output dynamically while it is running.
var
  SecAtrrs: TSecurityAttributes;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  StdOutPipeRead, StdOutPipeWrite: THandle;
  WasOK: Boolean;
  pCommandLine: array[0..255] of AnsiChar;
  BytesRead: Cardinal;
  WorkDir: string;
  Handle: Boolean;
begin
  Result := '';
  with SecAtrrs do begin
    nLength := SizeOf(SecAtrrs);
    bInheritHandle := True;
    lpSecurityDescriptor := nil;
  end;
  CreatePipe(StdOutPipeRead, StdOutPipeWrite, @SecAtrrs, 0);
  try
    with StartupInfo do begin
      FillChar(StartupInfo, SizeOf(StartupInfo), 0);
      cb := SizeOf(StartupInfo);
      dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
      wShowWindow := SW_HIDE;
      hStdInput := GetStdHandle(STD_INPUT_HANDLE); // don't redirect stdin
      hStdOutput := StdOutPipeWrite;
      hStdError := StdOutPipeWrite;
    end;
    WorkDir := extractFilePath(application.exeName);
    Handle := CreateProcess(nil, PChar(CommandLine),
                            nil, nil, True, 0, nil,
                            PChar(WorkDir), StartupInfo, ProcessInfo);
    CloseHandle(StdOutPipeWrite);
    if Handle then
      try
        repeat
          WasOK := windows.ReadFile(StdOutPipeRead, pCommandLine, 255, BytesRead, nil);
          if BytesRead > 0 then begin
            pCommandLine[BytesRead] := #0;
            Result := Result + string(pCommandLine);
          end;
        until not WasOK or (BytesRead = 0);
        WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
      finally
        CloseHandle(ProcessInfo.hThread);
        CloseHandle(ProcessInfo.hProcess);
      end;
  finally
    CloseHandle(StdOutPipeRead);
  end;
end;

procedure Info;
var cars : TStringList;

(*
$ffmpeg_path = “/usr/bin/ffmpeg”; //Path to your FFMPEG
$video_path = “/vidoes/myvideo.mov”; // Path to your Video

$command = $ffmpeg_path . ‘ -i “‘ . $video_path . ‘” -vstats 2>&1’;

$output = shell_exec($command);

$out_arr = explode(“\n”, $output);
foreach($out_arr as $line) {
if( preg_match(‘/^Stream.*Video:/’, trim($line)) ) {
/* match line: Stream #0.0(und): Video: h264 (High), yuv420p, 640×360 [PAR 1:1 DAR 16:9], 597 kb/s, 25 fps, 25 tbr, 25k tbn, 50 tbc */
$line_arr = explode(‘,’, $line);
// get field: 640×360 [PAR 1:1 DAR 16:9]
$target_arr = explode(‘ ‘, $line_arr[3]);
// get parts: 640×360
$dims = explode(‘x’, $target_arr[1]);
$res_x = $dims[0];
$res_y = $dims[1];
*)

procedure LireInfo;
var zut : string;

function chercheHauteurLargeur(posC : integer) : boolean;
var posA,posB : integer;
    aConvertir : string;
begin
(*
ffmpeg -i inputfile -vf "rotate=-2" outputfile
This uses mplayer's rotate filter, so the options are the same:
rotate[=<0−7>]
Rotates the image by 90 degrees and optionally flips it.
For values between 4−7 rotation is only done if the movie geometry is portrait and not landscape.
0
Rotate by 90 degrees clockwise and flip (default).
1
Rotate by 90 degrees clockwise.
2
Rotate by 90 degrees counterclockwise.
3
Rotate by 90 degrees counterclockwise and flip.
*)
    result := false;
    if (posC>1) and (posC<length(zut)) and
       charInSet(zut[posC-1],['0'..'9']) and
       charInSet(zut[posC+1],['0'..'9']) then begin
                posA := posC-1;
                repeat
                    dec(posA)
                until not CharInSet(zut[posA],['0'..'9']);
                aconvertir := copy(zut,posA+1,posC-posA-1);
                largeur := strToInt(aconvertir);
                result := (largeur>100) and (largeur<4000);
                if not result then largeur := 640;
                posB := posC+1;
                repeat
                    inc(posB)
                until not CharInSet(zut[posB],['0'..'9']);
                aconvertir := copy(zut,posC+1,posB-posC-1);
                hauteur := strToInt(aconvertir);
                if (hauteur<100) or (hauteur>4000) then begin
                    hauteur := 480;
                    result := false;
                end;
                if not result then delete(zut,posA,posB-posA);
    end
    else delete(zut,posC,1);
end;

procedure ChercheFPS(posC : integer);
var aconvertir : string;
    posB : integer;
    fps : integer;
begin // , 25 fps,
               repeat
                    dec(posC)
               until CharInSet(zut[posC],['0'..'9']);
               posB := posC-1;
               repeat
                    dec(posB)
               until not CharInSet(zut[posB],['0'..'9']);
               aconvertir := copy(zut,posB+1,posC-posB);
               fps := strToInt(aconvertir);
               DureeImage := 1/FPS;
               LabelFPS.Caption := '  '+ intToStr(FPS)+' img/s ';
end;

procedure SetHauteurLargeurImages;
var zoomX,zoomY,zoom : single;
    coeff : single;
begin
    if abs(rotation)=1 then maths.swap(largeur,hauteur);
    zoomX := (ImagePaintBox.Width / largeur);
    zoomY := (ImagePaintBox.Height / hauteur);
    scaleStr := '';
    if zoomX>zoomY then Zoom := zoomY else Zoom := zoomX;
  //  if Zoom>1 then begin
       coeff := hauteur/largeur;
       largeur := round(zoom*largeur);
       hauteur := round(coeff*largeur);
       scaleStr := ' -vf scale='+intToStr(largeur)+':-1 ';
 //   end;
end;

procedure ChercheDuree(posC : integer);
var  Hour, Min, Sec, MSec,centiSec: Word;
     aformat : TFormatSettings;
     posB,posA : integer;
     aconvertir : string;
     longueur : TTime;
begin // Duration: 00:00:01.52,  centiSec := 100;
               centiSec := 100;
               aformat := TFormatSettings.create;
               aformat.TimeSeparator := ':';
               aformat.LongTimeFormat := 'hh:nn:ss';
               posC := posC+length('Duration');
               repeat
                    inc(posC)
               until charInSet(zut[posC],['0'..'9']);
               posB := posC+1;
               repeat
                    inc(posB)
               until not charInSet(zut[posB],['0'..'9',':']);
               if zut[posB]='.' then begin
                  posA := posB;
                  repeat
                     inc(posA)
                  until not charInSet(zut[posA],['0'..'9']);
                  aconvertir := copy(zut,succ(posB),posA-posB-1);
                  centiSec := strToInt(aconvertir);
               end;
               aconvertir := copy(zut,posC,posB-posC);
               longueur := strToTime(aconvertir,aformat);
               DecodeTime(longueur,Hour, Min, Sec, MSec);
               DureeSec := centiSec/100+(Sec+60*(Min+60*Hour));
         end;

var i,posC,posV,posS,posD : integer;
begin
     largeur := 640;
     hauteur := 480;
     scaleStr := '';
     dureeSec := 5;
     DureeImage := 1/25;
     LabelFPS.Caption := '  25 img/s ';
     for i := 0 to pred(cars.Count) do begin
         zut := cars[i];
      //   posC := pos('libav',zut); if posC>0 then continue;
      //   posC := pos('ffmpeg',zut); if posC>0 then continue;
      //   posC := pos('configuration',zut); if posC>0 then continue;
      //   posC := pos('libs',zut); if posC>0 then continue;
         posD := pos('Duration',zut);
         if posD>0 then chercheDuree(posD);
         posV := pos('Video',zut);
         posS := pos('Stream',zut);
//  Stream #0:0[0x1e0]: Video: mpeg1video                 , yuv420p(tv), 1280x720 [SAR 1:1 DAR 16:9],
// 104857 kb/s, 25 fps, 25 tbr, 90k tbn, 25 tbc
//  Stream #0:0:        Video: cinepak (cvid / 0x64697663), rgb24      , 320x240,
// 3048 kb/s  , 15 fps, 15 tbr, 15 tbn , 15 tbc
         if (posV>0) and (posS>0) then begin
            delete(zut,1,posV+length('video'));
            posV := pos(',',zut);
            delete(zut,1,posV);
            posC := pos('fps',zut);
            if posC>0 then chercheFPS(posC);
            posC := pos('x',zut);
            while (posC>0) and not CherchehauteurLargeur(posC) do posC := pos('x',zut);
         end;
     end;
     setHauteurLargeurImages;
     PointRepere[bsOrigine] := point(Largeur div 2,Hauteur div 2);
     PointRepere[bsAxeX] := point(3*Largeur div 4,Hauteur div 2);
     PointRepere[bsaxeY] := point(Largeur div 2,Hauteur div 4);
     PointRepere[bsEchelle1] := point(Largeur div 4,Hauteur div 4);
     PointRepere[bsEchelle2] := point(Largeur div 2,Hauteur div 4);
     TrackBar.OnChange := nil;
     TrackBar.Max := trunc(dureeSec/dureeImage);
     TrackBar.position := 1;
     indexImage := 1;
     TrackBar.OnChange := TrackBarChange;
     labelAttente.Caption := ' Récupération des paramètres de la vidéo : OK';
     labelAttente.update;
     setBoutons;
end;

procedure getOrientation;
var info,param, nomffProbe : string;
begin
// ffprobe -loglevel error -select_streams v:0 -show_entries stream_tags=rotate -of default=nw=1:nk=1 input.mp4
   nomffProbe := '"'+extractFilePath(application.exeName)+'ffprobe.exe"';
   param := ' -loglevel error -select_streams v:0 -show_entries stream_tags=rotate -of default=nw=1:nk=1 "'+nomFichier+'"';
   info := GetDosOutput(nomffProbe+param);
   rotation := 0;
   if pos('90',info)>0 then rotation := 1;
   if pos('270',info)>0 then rotation := -1;
   if pos('180',info)>0 then rotation := 2;
end;

var
    param : string;
    nomffProbe,info : string;
    posCR : integer;
begin
  labelAttente.Caption := ' Récupération des paramètres de la vidéo … ';
  labelAttente.update;
  getOrientation;
  param := ' -i "'+nomFichier+'"';
  nomffProbe := '"'+nomffmpeg+'"';
  info := GetDosOutput(nomffProbe+param);
  cars := TStringList.Create;
  posCR := pos(crCR,info);
  while posCR>0 do begin
        cars.Add(copy(info,1,pred(posCR)));
        delete(info,1,succ(posCR));
        posCR := pos(crCR,info);
  end;
  LireInfo;
  cars.Free;

(* How do I run ffmpeg as a background task?
ffmpeg normally checks the console input, for entries like "q" to stop and "?" to give help,
while performing operations. ffmpeg does not have a way of detecting when it is running as a background task.
When it checks the console input, that can cause the process running ffmpeg in the background to suspend.
to prevent those input checks, allowing ffmpeg to run as a background task, use the -nostdin option in the ffmpeg invocation.
This is effective whether you run ffmpeg in a shell or invoke ffmpeg in its own process via an operating system API.
For example: ffmpeg -nostdin -i INPUT OUTPUT
*)

end;

var param : string;
    StartInfo : TStartupInfo;
    ProcessInfo : TProcessInformation;
    Termine : boolean;
    qualityStr : string;
    rotateStr : string;
begin
  cursor := crHourGlass;
  labelAttente.Visible := true;
  labelAttente.Caption := ' Lancement de ffmpeg, patientez … ';
  labelAttente.update;
  rotateStr := '';
//  rotateStr := ' -noautorotate ';
// ffmpeg -vfilters "rotate=90" -i input.mp4 output.mp4
// ffmpeg -vf "transpose=1" -i input.mov output.mp4
// ffmpeg -noautorotate -i input.mp4
  Info;
  pasImage := NimagesSE.value;
  trackBar.Max := trackbar.Max div pasImage;
// -q:v 1 quality  v=video valeur de 2 (better) to 31
  qualitystr := ' -q:v 2 ';
  param :=  rotateStr+
     ' -i '+
     '"'+nomFichier+'"'+
     qualityStr+
     scaleStr+
     '"'+TPath.Combine(tempDirReg,'test%03d.jpg')+'"';
  extension := '.jpg';
  extensionMaj := '.JPG';
// Mise à zéro de la structure StartInfo
  ZeroMemory(@StartInfo, SizeOf(StartInfo));
  StartInfo.cb  := SizeOf(StartInfo);
  if CreateProcess(Nil, Pchar('"'+nomffmpeg+'" '+param),
              Nil, Nil, False, 0, Nil, Nil, StartInfo,ProcessInfo)
  then begin
       stopBtn.enabled := true;
       nbre := 0;
       arretForce := false;
       labelAttente.Caption := ' Création des images, patientez … ';
       labelAttente.update;
       repeat
       termine := WaitForSingleObject(ProcessInfo.hProcess, 500)=WAIT_OBJECT_0;
       if not termine then
          Application.processMessages;
          // pour que StopBtn puisse mettre arretForce à true
       until termine or arretForce;
       if termine then begin
          getNbre;
          NbreFichierImages := nbre;
          trackBar.OnChange := nil;
          trackBar.max := nbre;
          trackBar.Position := 1;
          trackBar.OnChange := TrackBarChange;
          GetImage(1);
       end;
       labelAttente.Visible := false;
  end
  else showMessage('Impossible de créer les images');
  setBoutons;
end;

procedure TVLCBitmapForm.VideRepertoire;
var info : TSearchRec;
begin
  removeBackSlash(tempDirReg);
  if findFirst(tempDirReg+'\*'+extension,faAnyFile,Info)=0 then begin
     repeat
         if (Info.attr and faDirectory)<>faDirectory then
            deleteFile(Tpath.combine(tempDirReg,Info.Name));
     until FindNext(Info)<>0;
     FindClose(info);
  end;
  if FichierVideoRecopie then deleteFile(nomFichier);
  if (NomFichierChrono<>'') and
     fileExists(NomFichierChrono) and
     (extractFilePath(NomFichierChrono)=tempDirReg+'\') then deleteFile(nomFichierChrono);
  NbreFichierImages := 0;
end;

procedure TVLCBitmapForm.GetImage(index : integer);
var nomImage : string;

procedure EffectuerZoom;
var zoomX,zoomY : single;
    i : TStyleDrag;
begin
    zoomX := (ImagePaintBox.Width / largeur);
    zoomY := (ImagePaintBox.Height / hauteur);
    if zoomX>zoomY then pasZoom := zoomY else pasZoom := zoomX;
    if (pasZoom>1) and (pasZoom<1.25) then pasZoom := 1; // pour éviter déformation
    hauteurAff := round(hauteur*pasZoom);
    largeurAff := round(largeur*pasZoom);
    longueurAxe := hauteurAff div 2;
    rectAffichage := rect(0,0,largeurAff,hauteurAff);
    for i := low(TstyleDrag) to High(TstyleDrag) do begin
           e_pointRepere[i].x := round(pointRepere[i].x*pasZoom);
           e_pointRepere[i].y := round(pointRepere[i].y*pasZoom);
    end;
end;

procedure getNomImage;
var numero : string;
begin
     nomImage := '';
     numero := intToStr(index);
     while length(numero)<3 do
           numero := '0'+numero;
     nomImage := Tpath.combine(tempDirReg,'test'+numero+extension);
     if not FileExists(nomImage) then begin
         showMessage(nomImage+' non trouvée');
         nomImage := '';
     end;
end;

procedure ConvertitJPEGBitmap;
var Ajpeg : TjpegImage;
//    h,l : integer;
begin
         Ajpeg := TjpegImage.create;
         Ajpeg.LoadFromFile(nomImage);
         (*
         h := Ajpeg.Height;
         l := Ajpeg.Width;
         if (l<>largeur) or (h>hauteur) or ((l=hauteur) and (h=largeur)) then begin // portrait iphone
             largeur := l;
             hauteur := h;
             EffectuerZoom;
             PointRepere[bsOrigine] := point(Largeur div 2,Hauteur div 2);
             PointRepere[bsAxeX] := point(3*Largeur div 4,Hauteur div 2);
             PointRepere[bsaxeY] := point(Largeur div 2,Hauteur div 4);
             PointRepere[bsEchelle1] := point(Largeur div 4,Hauteur div 4);
             PointRepere[bsEchelle2] := point(Largeur div 2,Hauteur div 4);
         end;
         *)
         (*
         with bitmapC do begin
              pixelFormat := pf24bit;
              height := hauteur;
              width := largeur;
         end;
         *)
         bitmapC.assign(Ajpeg);
         Ajpeg.free;
end;

procedure ConvertitPNGBitmap;
var Apng : TpngImage;
begin
         Apng := TpngImage.create;
         Apng.loadFromFile(nomImage);
         with bitmapC do begin
              pixelFormat := pf24bit;
              height := hauteur;
              width := largeur;
         end;
         bitmapC.assign(Apng);
         Apng.free;
end;

procedure ConvertitBitmap;
begin
     bitmapC.loadFromFile(nomImage);
end;

var P : TPoint;
begin // GetImage
    if nomFichier='' then begin
       imagePaintBox.canvas.brush.Color := clWindow;
       imagePaintBox.canvas.brush.style := bsSolid;
       exit;
    end;
    if (index<TrackBar.Min) or (index>TrackBar.max*pasImage) then begin
       timer.Enabled := false;
       exit;
    end;
    EffectuerZoom;
    getNomImage;
    if nomImage='' then exit;
    try
    if (extensionMaj='.JPG') or (extensionMaj='.JPEG') then ConvertitJPEGBitmap;
    if (extensionMaj='.PNG') then ConvertitPNGBitmap;
    if (extensionMaj='.BMP') then ConvertitBitmap;
    if lectureCouleur then begin
       couleur[0] := couleurComplementaire(bitmapC);
       couleur[1] := couleur[0];
       CouleurPointsCB.selected := couleur[1];
       CouleurAxeCB.selected := couleur[0];
       lectureCouleur := false;
    end;
    IndexImage := index;
    TrackBar.OnChange := nil;
    TrackBar.Position := index div pasImage;
    TrackBar.OnChange := trackBarChange;
    tempsLabel.Caption := FloatToStrF(index*DureeImage*pasImage,ffFixed,5,3)+'/'+IntToStr(round(DureeSec))+' s ';
    ImagePaintBox.refresh;
    if (zoomUD.Value>1) and (borneSelect in [bsMesure,bsOrigine,bsEchelle1,bsEchelle2,bsAxeX,bsAxeX,bsChronoInit]) then begin
       P := Mouse.CursorPos;
       P := ImagePaintBox.ScreenToClient(P);
       PaintBoxMouseMove(nil,[],P.x,P.y);
    end;
    if BorneSelect=bsChrono then aviChrono;
    except
    timer.Enabled := false;
    end;
end; // GetImage

procedure TVLCBitmapForm.GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var s : String;
begin
    TstringGrid(sender).canvas.Font.Color := CouleurGrid[Acol];
    S := TstringGrid(sender).cells[Acol,Arow];
    with TstringGrid(sender).canvas do
         TextOut(Rect.Left + 2, Rect.Top + 2,S);
end;

procedure TVLCBitmapForm.ImagePaintBoxPaint(Sender: TObject);
var rectOrigine : Trect;
begin
    if nomFichier='' then exit;
    rectOrigine := rect(0,0,bitmapC.width,bitmapC.height);
    ImagePaintBox.canvas.copyMode := cmSrcCopy;
    ImagePaintBox.canvas.CopyRect(rectAffichage,bitmapC.canvas,rectOrigine);
    if not (borneSelect in [bsChrono,bsChronoInit]) then DessineImage;
end;

Procedure TVLCBitmapForm.DessineImage;

Procedure TraceLigne(x1,y1,x2,y2 : integer);
begin
      ImagePaintBox.canvas.moveto(x1,y1);
      ImagePaintBox.canvas.lineto(x2,y2);
end;

Procedure TraceLigneP(P1,P2 : TPoint);
begin
      ImagePaintBox.canvas.moveto(P1.x,P1.y);
      ImagePaintBox.canvas.lineto(P2.x,P2.y);
end;

Procedure TraceRect(P : Tpoint);
begin
      ImagePaintBox.Canvas.Rectangle(P.X-(magnet div 2),P.Y-(magnet div 2),
                                     P.X+(magnet div 2),P.Y+(magnet div 2));
end;

Procedure TraceRepere(i : integer);
var Apoint : TPoint;
begin
Apoint := correctionRS.XY[0,i];
with Apoint do begin
         ImagePaintBox.canvas.pen.Color := couleurAxeCB.selected;
         X := round(X*pasZoom);
         Y := round(X*pasZoom);
         TraceLigne(x-4*Magnet,y,x+4*Magnet,y);  // axe X
// flèche X
         TraceLigne(x+4*Magnet,y,x+2*Magnet,y-2);
         TraceLigne(x+4*Magnet,y,x+2*Magnet,y+2);
         TraceLigne(x,y-4*Magnet,x,y+4*Magnet); // axe Y

// flèche Y
         TraceLigne(x,y+4*signeY*Magnet,x-2,y+2*signeY*Magnet);
         traceLigne(x,y+4*signeY*Magnet,x+2,y+2*signeY*Magnet);
end end;

Procedure TraceCroix(Apoint : Tpoint);
begin
      traceLigne(Apoint.x-Magnet,Apoint.y,Apoint.x+Magnet,Apoint.y);
      traceLigne(Apoint.x,Apoint.y-Magnet,Apoint.x,Apoint.y+Magnet);
end;

Procedure TraceCroixData(i,j : integer);
var apoint : TPoint;
begin
      apoint.X := round(correctionRS.xy[i,j].X*pasZoom);
      apoint.Y := round(correctionRS.xy[i,j].Y*pasZoom);
      traceCroix(Apoint);
end;

Procedure TraceOrigine;

procedure TraceFleche(angle : double);
    var
      PE: TPoint; // centre puis extrémité de la base de la flèche
      deltaX, deltaY: integer;
      Points:  array[0..2] of Tpoint; // Flèche
      hauteur,rayon : integer;
begin
       rayon := hauteurAff div 2;
       hauteur := screen.Width div 128;
       PE := e_PointRepere[bsOrigine];
       deltaY := round(sin(angle)*rayon);
       deltaX := round(rayon*cos(angle));
       PE.offset(deltaX,deltaY);
       TraceLigneP(e_PointRepere[bsOrigine],PE);
       deltaX := round(hauteur*cos(angle));
       deltaY := round(hauteur*sin(angle));
       Points[0] := PE;
       PE.offset(-deltaX,-deltaY); // base de la flèche
       deltaX := deltaX div 3;
       deltaY := deltaY div 3;
       PE.offset(-deltaY,+deltaX);
       Points[1] := PE;
       PE.offset(+2*deltaY,-2*deltaX);
       Points[2] := PE;
       ImagePaintBox.Canvas.Polygon(Points);
end;

begin with e_PointRepere[bsOrigine] do begin
         ImagePaintBox.canvas.pen.Color := couleurAxeCB.selected;
         angleX := arcTan2(e_PointRepere[bsAxeX].y-e_PointRepere[bsOrigine].y,
                           e_PointRepere[bsAxeX].x-e_PointRepere[bsOrigine].x);
// axe X
     //    TraceLigneP(e_PointRepere[bsOrigine],e_PointRepere[bsAxeX]);
         TraceRect(e_PointRepere[bsAxeX]);
         TraceFleche(angleX);
         if EtiquetteCB.checked then
         ImagePaintBox.Canvas.TextOut(e_PointRepere[bsAxeX].X+magnet,
                                      e_PointRepere[bsAxeX].Y,
                                      'X');
// axe Y
     //    TraceLigneP(e_PointRepere[bsOrigine],e_PointRepere[bsAxeY]);
         TraceRect(e_PointRepere[bsAxeY]);
         TraceFleche(angleX+signeY*pi/2);
         if EtiquetteCB.checked then
         ImagePaintBox.Canvas.TextOut(e_PointRepere[bsAxeY].X+magnet,
                                      e_PointRepere[bsAxeY].Y,
                                      'Y');
end end;

Procedure TraceEchelle;
var angleLoc : integer;
begin
      TraceLigneP(e_PointRepere[bsEchelle1],e_PointRepere[bsechelle2]);
      TraceCroix(e_PointRepere[bsEchelle1]);
      TraceCroix(e_PointRepere[bsechelle2]);
      angleLoc := round(arcTan2(PointRepere[bsEchelle2].Y-PointRepere[bsEchelle1].Y,
                                PointRepere[bsEchelle1].X-PointRepere[bsEchelle2].X)*180/system.pi);
      if angleLoc>90 then angleLoc := angleLoc-180;
      if angleLoc<-90 then angleLoc := angleLoc+180;
      ImagePaintBox.Canvas.font.orientation := angleLoc*10;
      ImagePaintBox.Canvas.TextOut((e_PointRepere[bsEchelle1].X+e_PointRepere[bsEchelle2].X) div 2,
                     (e_PointRepere[bsEchelle1].Y+e_PointRepere[bsEchelle2].Y) div 2,
                      echelleEDit.text+' m');
      ImagePaintBox.Canvas.font.orientation := 0;
      ImagePaintBox.canvas.font.size := 8;
end;

var i,j : integer;
    texte : string;
begin // DessineImage
    if NomFichier='' then exit;
    calcEchelle;
    couleurAxeCB.Visible := traceEchCB.checked;
    couleurPointsCB.Visible := tracePointsCB.checked;
    ImagePaintBox.canvas.font.color := couleur[0];
    ImagePaintBox.canvas.font.size := 12;
    ImagePaintBox.Canvas.Brush.Style := bsClear; // Set the brush style to transparent.
    if traceEchCB.checked then begin
       ImagePaintBox.canvas.pen.color := couleur[0];
       if OrigineMobileCB.checked
          then begin
              for i := 0 to pred(nmes) do TraceRepere(i);
              if PointCourant>0 then TraceRepere(nmes);
          end
          else TraceOrigine;
       TraceEchelle;
    end;
    if tracePointsCB.checked then begin
    for j := 1 to NbreSE.value do begin
        ImagePaintBox.canvas.pen.color := couleur[j];
        ImagePaintBox.canvas.Font.Color := couleur[j];
        ImagePaintBox.canvas.font.size := 10;
        for i := 0 to pred(nmes) do begin
                 TraceCroixData(j,i);
                 if EtiquetteCB.checked then begin
                    texte := intToStr(succ(i));
                    if NbreSE.value>1 then texte := intToStr(j)+'-'+texte;
                    ImagePaintBox.canvas.TextOut(round(correctionRS.XY[j,i].x*pasZoom)+2,
                                                 round(correctionRS.XY[j,i].y*pasZoom)+2,
                                                 texte);
                 end;
           end;{j}
    end; // for i
       for j := 1 to pred(PointCourant) do begin
           ImagePaintBox.canvas.pen.color := couleur[j];
           TraceCroixData(j,nmes);
           if etiquetteCB.checked then begin
              ImagePaintBox.canvas.Font.Color := couleur[j];
              texte := intToStr(succ(VLCBitmapForm.nmes));
              if NbreSE.value>1 then texte := intToStr(j)+'-'+texte;
              ImagePaintBox.canvas.TextOut(round(correctionRS.XY[j,nmes].x*pasZoom)+2,
                                           round(correctionRS.XY[j,nmes].y*pasZoom)+2,
                                           texte);
           end;
       end; // for j
    end;
end; // DessineImage

procedure TVLCBitmapForm.AVICHRONO;
var couleur0,couleurInit : TRGBtriple;
    scanLineC,scanLineInit,scanLineFin : pRGBTripleArray;
    xPrec,yPrec : integer;
    xAttendu,yAttendu : integer;
    DeltaX,DeltaY : integer;
    x0,y0 : integer;
    ecartMin : integer;

procedure EnregistrePointChrono;
// on affine autour de i0, j0
var xMin,xMax : integer;
    yMin,yMax : integer;
    xb,yb,x1,y1,x2,y2 : integer;
    ecartCible,ecart : integer;
    largeurCible,hauteurCible : integer;
begin
    largeurCible := largeur div 24; // zone de recherche
    hauteurCible := hauteur div 24;
    correctionRS.XY[1,Nmes].x := x0;
    correctionRS.XY[1,Nmes].y := y0;
    yMin := y0+hauteurCible;
    yMax := y0-hauteurCible;
    xMin := x0+largeurCible;
    xMax := x0-largeurCible;
    y1 := yMax;y2 := yMin;
    if y1<0 then y1 := 0;
    if y2>=hauteur then y2 := pred(hauteur);
    x1 := xMax;x2 := xMin;
    if x1<0 then x1 := 0;
    if x2>=largeur then x2 := pred(largeur);
    for yb := y1 to y2 do begin
        scanLineC := bitmapC.scanLine[yb];
        scanLineInit := bitmapInit.scanLine[yb];
        scanLineFin := bitmapFin.scanLine[yb];
        for xb := x1 to x2 do begin
            couleur0 := scanLineC[xb];
            couleurInit := scanLineInit[xb];
            ecart := abs(integer(couleurInit.rgbtBlue)-integer(couleur0.rgbtBlue))+
                     abs(integer(couleurInit.rgbtGreen)-integer(couleur0.rgbtGreen))+
                     abs(integer(couleurInit.rgbtRed)-integer(couleur0.rgbtRed));
            ecartCible := abs(BlueCibleChrono-integer(couleur0.rgbtBlue))+
                     abs(GreenCibleChrono-integer(couleur0.rgbtGreen))+
                     abs(RedCibleChrono-integer(couleur0.rgbtRed));
            if ecartCible<resolutionAcceptee then
                  scanLineFin[xb] := couleur0;
            if (ecart>resolutionAcceptee) and (ecartCible<ecartMin) then begin
            // différent de l'état initial et proche couleur cible
               if xb<xMin then xMin := xb;
               if yb<yMin then yMin := yb;
               if xb>xMax then xMax := xb;
               if yb>yMax then yMax := yb;
            end;
        end;// for  x
    end;// for y
    correctionRS.Temps[Nmes] := indexImage*dureeImage*pasImage;
    correctionRS.XY[1,Nmes].x := (xMin+xMax) div 2;
    correctionRS.XY[1,Nmes].y := (yMin+yMax) div 2;
    if (Nmes + 2) > grid.rowCount then grid.rowCount := Nmes + 5;
    Grid.cells[0,Nmes+1] := correctionRS.strT(Nmes);
    Grid.cells[1,Nmes+1] := correctionRS.strX(1,Nmes);
    Grid.cells[2,Nmes+1] := correctionRS.strY(1,Nmes);
    inc(Nmes);
end; // EnregistrePointChrono

function chercheMobile : boolean;
var resolutionCible : integer;
    ecart,ecartCible : integer;
    xb,yb : integer;
    procheAttendu,prochePrec : boolean;
begin
resolutionCible := resolutionCibleMin;
repeat
    EcartMin := resolutionCible;
    for yb := 0 to pred(hauteur) do begin
        scanLineC := bitmapC.scanLine[yb];
        scanLineInit := bitmapInit.scanLine[yb];
        for xb := 0 to pred(largeur) do begin
            couleur0 := scanLineC[xb];
            couleurInit := scanLineInit[xb];
            ecart := abs(integer(couleurInit.rgbtBlue)-integer(couleur0.rgbtBlue))+
                     abs(integer(couleurInit.rgbtGreen)-integer(couleur0.rgbtGreen))+
                     abs(integer(couleurInit.rgbtRed)-integer(couleur0.rgbtRed));
            if (ecart>resolutionAcceptee)  then begin
                 // On cherche là où il y eu changement
                 procheAttendu := (abs(xb-xAttendu)<deltaX) and (abs(yb-yAttendu)<deltaY);
                 prochePrec := (abs(xb-xPrec)<deltaX) and (abs(yb-yPrec)<deltaY);
                 if (procheAttendu or prochePrec) and mesureAutoCB.Checked then begin
                    ecartCible := abs(BlueCibleChrono-integer(couleur0.rgbtBlue))+
                                  abs(GreenCibleChrono-integer(couleur0.rgbtGreen))+
                                  abs(RedCibleChrono-integer(couleur0.rgbtRed));
                    if ecartCible<ecartMin then begin // couleur=couleurCible
                       ecartMin := ecartCible;
                       x0 := xb;y0 := yb;
                    end;
                 end;
            end;
        end;// for x
    end;// for y
    result := (x0>0) and (y0>0);
    inc(resolutionCible,pasCouleur);
until result or (resolutionCible>resolutionCibleMax);
end;

function chercheFixe : boolean;
var ecartCible : integer;
    xb,yb : integer;
    resolutionCible : integer;
begin
    resolutionCible := resolutionCibleMin;
    repeat
    EcartMin := resolutionCible;
    for yb := 0 to pred(hauteur) do begin
        scanLineC := bitmapC.scanLine[yb];
        for xb := 0 to pred(largeur) do
            if (abs(xb-xPrec)<deltaX) and (abs(yb-yPrec)<deltaY) then begin
            couleur0 := scanLineC[xb];
            ecartCible := abs(BlueCibleChrono-integer(couleur0.rgbtBlue))+
                          abs(GreenCibleChrono-integer(couleur0.rgbtGreen))+
                          abs(RedCibleChrono-integer(couleur0.rgbtRed));
            if ecartCible<ecartMin then begin // couleur=couleurCible
               ecartMin := ecartCible;
               x0 := xb;y0 := yb;
            end;
        end;// for x
    end;// for y
    result := (x0>0) and (y0>0);
    inc(resolutionCible,pasCouleur);
until result or (resolutionCible>resolutionCibleMax);
end;

var
    trouve : boolean;
    fin : integer;
begin // WMaviChrono
    DeltaX := largeur div 16; // zone de recherche
    DeltaY := hauteur div 16;
    x0 := 0; y0 := 0;
    xPrec := correctionRS.XY[1,pred(nmes)].x;
    yPrec := correctionRS.XY[1,pred(nmes)].y;
    if nmes>1 then begin // Nouvelle position en supposant la vitesse constante
       yAttendu := 2*yPrec-correctionRS.XY[1,nmes-2].y;
       xAttendu := 2*xPrec-correctionRS.XY[1,nmes-2].x;
    end
    else begin
       yAttendu := yPrec;
       xAttendu := xPrec;
    end;
    trouve := chercheMobile;
    if not trouve then trouve := chercheFixe;
    if trouve then begin
       inc(ecartMin,pasCouleur);
       enregistrePointChrono;
    end;
    if trackBar.SelEnd>0
       then fin := trackBar.SelEnd
       else fin := pred(trackBar.max);
    if trackBar.position<fin
          then if trouve
             then postMessage(handle,wm_avi_suivant,0,0)
             else begin
                  BorneSelect := bsNone;
                  saveChronoPhoto;
                  setBoutons;
             end
          else saveChronoPhoto;
end; // WMAviChrono

procedure TVLCBitmapForm.ChronoPhotoBtnClick(Sender: TObject);
begin
if ChronoPhotoBtn.Down
    then begin
    saveDialog.filter := 'bitmap|*.bmp';
    saveDialog.defaultExt := 'BMP';
    if saveDialog.Execute
       then begin
         nomFichierChrono := saveDialog.FileName;
         if trackBar.SelStart>0 then begin
            trackBar.OnChange := nil;
            trackbar.Position := trackBar.SelStart;
            indexImage := TrackBar.Position*pasImage;
            trackBar.OnChange := trackBarChange;
         end;
         if (NbreSE.value>1) then begin
               showMessage('Un seul mobile');
               NbreSE.value := 1;
         end;
         hint := hCibleAuto;
         setCurseur(crCible);
         showMessage(trCibleAuto);
         BorneSelect := bsChronoInit;
         imagePaintBox.repaint;
       end
       else ChronoPhotoBtn.Down := false
    end // début chrono
    else case borneSelect of
         bsChronoInit : borneSelect := bsNone;
         bsChrono : if IndexImage>10
            then saveChronoPhoto
            else borneSelect := bsNone;
         else
    end; // fin chrono
end;

procedure TVLCBitmapForm.SaveChronoPhoto;
begin
       BorneSelect := bsNone;
       mesureBtn.Down := false;
       bitmapFin.saveToFile(nomFichierChrono);
       bitmapFin.free;
       bitmapInit.free;
       hint := hClicDroitAvi;
       DessineImage;
       if chronoPhotoBtn.Down then begin
           chronoPhotoBtn.Down := false;
           if VLCChronoForm=nil then
              Application.createForm(TVLCChronoForm,VLCChronoForm);
           VLCChronoForm.image1.picture.loadFromFile(NomFichierChrono);
           VLCChronoForm.showModal;
       end;
       setBoutons;
end;

procedure TVLCBitmapForm.WMAVICHRONOINIT(var Msg: TWMRegMessage);

procedure InitMesure;
var
    xb,yb : integer;
    couleur : TRGBtriple;
    scanLine : pRGBTripleArray;
    xCibleChrono, yCibleChrono  : integer;
begin
     PointCourant := 1;
     correctionRS.Temps[0] := indexImage*dureeImage*pasImage;
     Nmes := 1;
     Grid.ColCount := 3;
     Grid.cells[1,0] := 'x(m)';
     Grid.cells[2,0] := 'y(m)';
     RedCibleChrono := 0;
     BlueCibleChrono := 0;
     GreenCibleChrono := 0;
     bitmapInit.saveToFile('azerty.bmp');
     xCibleChrono := pointRepere[bsChronoInit].x;
     yCibleChrono := pointRepere[bsChronoInit].y;
     for yb := yCibleChrono-1 to yCibleChrono+1 do begin
          scanLine := bitmapInit.scanLine[yb];
          for xb := xCibleChrono-1 to xCibleChrono+1 do begin
            couleur := scanLine[xb];
            RedCibleChrono := RedCibleChrono+integer(couleur.rgbtRed);
            BlueCibleChrono := BlueCibleChrono+integer(couleur.rgbtBlue);
            GreenCibleChrono := GreenCibleChrono+integer(couleur.rgbtGreen);
          end;
     end;
     RedCibleChrono := RedCibleChrono div 9;
     BlueCibleChrono := BlueCibleChrono div 9;
     GreenCibleChrono := GreenCibleChrono div 9;
     setBoutons;
end;

begin
     bitmapInit := Tbitmap.create;
     bitmapInit.pixelFormat := pf24bit;
     bitmapFin := Tbitmap.create;
     bitmapFin.pixelFormat := pf24bit;
     bitmapInit.assign(bitmapC);
     bitmapFin.assign(BitmapC);
     BorneSelect := bsChrono;
     setCurseur(crDefault);
     imagePaintBox.hint := hChronoEnCours;
     initMesure;
     postMessage(handle,wm_avi_suivant,0,0);
end;

procedure TVLCBitmapForm.ConvertitXY(Sender: TObject;var X, Y: Integer);
var PointImage,PointLoupe : TPoint;
begin
    if (sender=LoupeForm.paintBox) then begin
       PointImage := imagePaintBox.ClientToScreen(Point(0,0));
       PointLoupe := LoupeForm.ClientToScreen(Point(0,0));
       x := (LoupeForm.width div 2)+pointLoupe.X-PointImage.X;
       y := (LoupeForm.height div 2)+pointLoupe.Y-PointImage.Y;
    end;
end;

procedure TVLCBitmapForm.CacheLoupe;
begin
     if loupeForm.visible then begin
        loupeForm.hide;
        setFocus;
     end;
end;

 procedure TVLCBitmapForm.EcranVersImage;
    var i : TstyleDrag;
    begin
       for i := low(TstyleDrag) to High(TstyleDrag) do begin
           pointRepere[i].x := round(e_pointRepere[i].x/pasZoom);
           pointRepere[i].y := round(e_pointRepere[i].y/pasZoom);
       end;
    end;

  procedure TVLCBitmapForm.CorrigeAxes;
  var angleLoc : double;
      longueur : integer;
  begin  // Angle est l'angle informatique Y vers le bas donc positif=sens horaire
     if borneSelect=bsAxeX then begin // rendre les axes perpendiculaires
           angleLoc := arcTan2(e_pointRepere[bsAxeX].y-e_pointRepere[bsOrigine].y,
                               e_pointRepere[bsAxeX].x-e_pointRepere[bsOrigine].x);
           longueur := round(e_pointRepere[bsAxeY].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x-signeY*round(longueur*sin(angleLoc));
           e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*round(longueur*cos(angleLoc));
      end;
      if borneSelect=bsAxeY then begin // rendre les axes perpendiculaires
           angleLoc := arcTan2(signeY*(-e_pointRepere[bsAxeY].x+e_pointRepere[bsOrigine].x),
                               signeY*(e_pointRepere[bsAxeY].y-e_pointRepere[bsOrigine].y));
           longueur := round(e_pointRepere[bsAxeX].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+round(longueur*cos(angleLoc));
           e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y+round(longueur*sin(angleLoc));
      end;
      if borneSelect=bsOrigine then begin // ne pas changer l'angle
           longueur := round(e_pointRepere[bsAxeX].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+round(longueur*cos(angleX));
           e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y+round(longueur*sin(angleX));
           longueur := round(e_pointRepere[bsAxeY].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x-signeY*round(longueur*sin(angleX));
           e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*round(longueur*cos(angleX));
      end;
  end;

end.

(*
procedure RotateBitmap90CW(b1,b2:TBitmap);
var
  x,y:integer;
  p:array[0..2] of TPoint;
begin
  x:=b1.Width;
  y:=b1.Height;
  b2.Width:=y;
  b2.Height:=x;
  p[0].X:=y;
  p[0].Y:=0;
  p[1].X:=y;
  p[1].Y:=x;
  p[2].X:=0;
  p[2].Y:=0;
  PlgBlt(b2.Canvas.Handle,p,b1.Canvas.Handle,0,0,x,y,0,0,0);
end;
*)

(*
procedure RotateBitmap(var hBitmapDC : Longint; var lWidth : Longint;
            var lHeight : Longint; lRadians : real);
   var
            I : Longint;               // loop counter
            J : Longint;               // loop counter
            hNewBitmapDC : Longint;    // DC of the new bitmap
            hNewBitmap : Longint;      // handle to the new bitmap
            lSine : extended;          // sine used in rotation
            lCosine : extended;        // cosine used in rotation
           X1 : Longint;              // used in calculating new
                                      //   bitmap dimensions
           X2 : Longint;              // used in calculating new
                                      //     bitmap dimensions
           X3 : Longint;              // used in calculating new
                                      //     bitmap dimensions
           Y1 : Longint;              // used in calculating new
                                      // bitmap dimensions
           Y2 : Longint;              // used in calculating new
                                      // bitmap dimensions
           Y3 : Longint;              // used in calculating new
                                      // bitmap dimensions
           lMinX : Longint;           // used in calculating new
                                      // bitmap dimensions
           lMaxX : Longint;           // used in calculating new
                                      // bitmap dimensions
           lMinY : Longint;           // used in calculating new
                                      // bitmap dimensions
           lMaxY : Longint;           // used in calculating new
                                      // bitmap dimensions
           lNewWidth : Longint;       // width of new bitmap
           lNewHeight : Longint;      // height of new bitmap
           lSourceX : Longint;        // x pixel coord we are blitting
                                      // from the source  image
           lSourceY : Longint;        // y pixel coord we are blitting
                                      // from the source image

  begin
           // create a compatible DC from the one just brought
           // into this function
           hNewBitmapDC := CreateCompatibleDC(hBitmapDC);

           // compute the sine/cosinse of the radians used to
           // rotate this image
           lSine := Sin(lRadians);
           lCosine := Cos(lRadians);

           // compute the size of the new bitmap being created
           X1 := Round(-lHeight * lSine);
           Y1 := Round(lHeight * lCosine);
           X2 := Round(lWidth * lCosine - lHeight * lSine);
          Y2 := Round(lHeight * lCosine + lWidth * lSine);
          X3 := Round(lWidth * lCosine);
           Y3 := Round(lWidth * lSine);

           // figure out the max/min size of the new bitmap
           lMinX := Min(0, Min(X1, Min(X2, X3)));
           lMinY := Min(0, Min(Y1, Min(Y2, Y3)));
           lMaxX := Max(X1, Max(X2, X3));
           lMaxY := Max(Y1, Max(Y2, Y3));

           // set the new bitmap width/height
           lNewWidth := lMaxX - lMinX;
           lNewHeight := lMaxY - lMinY;

           // create a new bitmap based upon the new width/height of the
           // rotated bitmap
           hNewBitmap := CreateCompatibleBitmap(hBitmapDC, lNewWidth, lNewHeight);

           //attach the new bitmap to the new device context created
           //above before constructing the rotated bitmap
           SelectObject(hNewBitmapDC, hNewBitmap);

           // loop through and translate each pixel to its new location.
           // this is using a standard rotation algorithm
           for I := 0 to lNewHeight do begin
              for J := 0 to lNewWidth do begin
                 lSourceX := Round((J + lMinX) * lCosine + (I + lMinY) * lSine);
                 lSourceY := Round((I + lMinY) * lCosine - (J + lMinX) * lSine);
                 if (lSourceX >= 0) and (lSourceX <= lWidth) and
                 (lSourceY >= 0) and (lSourceY <= lHeight) then
                     BitBlt(hNewBitmapDC, J, I, 1, 1, hBitmapDC,
                                lSourceX, lSourceY, SRCCOPY);
              end;
           end;

           // reset the new bitmap width and height
           lWidth := lNewWidth;
           lHeight := lNewHeight;

           // return the DC to the new bitmap
           hBitmapDC := hNewBitmapDC;

           // destroy the bitmap created
           DeleteObject(hNewBitmap);

        end;
*)

//The following is an example of how the RotateBitmap function might be called:
(*
 procedure TForm1.RotateTest(Sender: TObject);
 var
  lRadians : real;
  DC  : longint;
  H, W : integer;
  Degrees : integer;
 begin
   Degrees := 45;
   lRadians := PI * Degrees / 180;
   DC := Image1.Picture.Bitmap.Canvas.Handle;
   H := Image1.Picture.Bitmap.Height;
   W := Image1.Picture.Bitmap.Width;
   RotateBitmap(DC, W, H, lRadians);
   Image1.Width := W;
   Image1.Height := H;
   Image1.Picture.Bitmap.Width := W;
   Image1.Picture.Bitmap.Height := H;
   BitBlt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0, W, H, DC, 0, 0, SRCCopy);
   Image1.Refresh;
 end;
 *)

 (*
 procedure RotateBitmap(Bmp: TBitmap; Rads: Single; AdjustSize: Boolean;
  BkColor: TColor = clNone);
var
  C: Single;
  S: Single;
  Tmp: TBitmap;
  OffsetX: Single;
  OffsetY: Single;
  Points: array[0..2] of TPoint;
begin
  C := Cos(Rads);
  S := Sin(Rads);
  Tmp := TBitmap.Create;
  try
    Tmp.TransparentColor := Bmp.TransparentColor;
    Tmp.TransparentMode := Bmp.TransparentMode;
    Tmp.Transparent := Bmp.Transparent;
    Tmp.Canvas.Brush.Color := BkColor;
    if AdjustSize then
    begin
      Tmp.Width := Round(Bmp.Width * Abs(C) + Bmp.Height * Abs(S));
      Tmp.Height := Round(Bmp.Width * Abs(S) + Bmp.Height * Abs(C));
      OffsetX := (Tmp.Width - Bmp.Width * C + Bmp.Height * S) / 2;
      OffsetY := (Tmp.Height - Bmp.Width * S - Bmp.Height * C) / 2;
    end
    else
    begin
      Tmp.Width := Bmp.Width;
      Tmp.Height := Bmp.Height;
      OffsetX := (Bmp.Width - Bmp.Width * C + Bmp.Height * S) / 2;
      OffsetY := (Bmp.Height - Bmp.Width * S - Bmp.Height * C) / 2;
    end;
    Points[0].X := Round(OffsetX);
    Points[0].Y := Round(OffsetY);
    Points[1].X := Round(OffsetX + Bmp.Width * C);
    Points[1].Y := Round(OffsetY + Bmp.Width * S);
    Points[2].X := Round(OffsetX - Bmp.Height * S);
    Points[2].Y := Round(OffsetY + Bmp.Height * C);
    PlgBlt(Tmp.Canvas.Handle, Points, Bmp.Canvas.Handle, 0, 0, Bmp.Width,
      Bmp.Height, 0, 0, 0);
    Bmp.Assign(Tmp);
  finally
    Tmp.Free;
  end;
end;
*)

