unit VclMain;

interface

uses
  System.Types, System.UITypes, System.ImageList, system.IOUtils,

  Vcl.Imaging.pngimage, Vcl.Controls, Vcl.ComCtrls, vcl.htmlHelpViewer,

  Windows, SysUtils, Messages,  Classes, Graphics,
  Forms,  Dialogs, StdCtrls,  ExtCtrls,  Buttons, math,
  Menus, ImgList, Spin, ToolWin, grids, inifiles,
  regutil, compile, constreg, grapheU, shellApi, clipBrd,

  PasLibVlcUnit, PasLibVlcClassUnit, PasLibVlcPlayerUnit,
  rollingShutterCalc;

const
   timeOutSuivant = 75;
   timeOutPrecedent = 150;

type
  TVclForm = class(TForm)
    PanelMediaPlayer: TPanel;
    TempsLabel: TLabel;
    OpenDialog: TOpenDialog;
    EditBidon: TEdit;
    CodecLabel: TLabel;
    ToolBar1: TToolBar;
    OpenBtn: TToolButton;
    ImageList1: TImageList;
    UndoBtn: TToolButton;
    RegressiBtn: TToolButton;
    ExitBtn: TToolButton;
    MesureBtn: TToolButton;
    ToolBar2: TToolBar;
    LabelNbreSE: TLabel;
    NbreSE: TSpinEdit;
    LabelIncertitude: TLabel;
    EchelleEdit: TEdit;
    ImageMenu: TPopupMenu;
    CurseurCroix: TMenuItem;
    CurseurNoir: TMenuItem;
    CurseurBlanc: TMenuItem;
    CurseurDouble: TMenuItem;
    IncertitudeSE: TSpinEdit;
    LabelEchelle: TLabel;
    Splitter1: TSplitter;
    Status: TStatusBar;
    RazBtn: TToolButton;
    PanelVideo: TPanel;
    PlayBtn: TSpeedButton;
    StopBtn: TSpeedButton;
    SuivantBtn: TSpeedButton;
    Grid: TStringGrid;
    Image1: TImage;
    RewindBtn: TSpeedButton;
    LabelFPS: TLabel;
    PrecedentBtn: TSpeedButton;
    TrackBar: TTrackBar;
    ScrollBox: TScrollBox;
    TimerScroll: TTimer;
    MediaPlayer: TPasLibVlcPlayer;
    MainMenu1: TMainMenu;
    TimerMaj: TTimer;
    TimerSuivant: TTimer;
    GroupBox1: TGroupBox;
    TraceEchCB: TCheckBox;
    CouleurAxeCB: TColorBox;
    GroupBox2: TGroupBox;
    TracePointsCB: TCheckBox;
    CouleurPointsCB: TColorBox;
    EtiquetteCB: TCheckBox;
    altitudeCB: TCheckBox;
    TimerMove: TTimer;
    origineMobileCB: TCheckBox;
    RazaxesBtn: TToolButton;
    Label6: TLabel;
    RollingShutterBtn: TSpeedButton;
    RollingShutterSE: TSpinEdit;
    AttenteLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditBidonKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure OrigineBtnClick(Sender: TObject);
    procedure MesureBtnClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure EchelleEditKeyPress(Sender: TObject; var Key: Char);
    procedure EchelleEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EchelleEditExit(Sender: TObject);
    procedure CurseurClick(Sender: TObject);
    procedure OrigineItemClick(Sender: TObject);
    procedure CouleurPointsCBChange(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure CouleurAxeCBChange(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure RazAxesBtnClick(Sender: TObject);
    procedure SuivantBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MediaPlayerPlaying(Sender: TObject);
    procedure MediaPlayerStopped(Sender: TObject);
    procedure MediaPlayerPaused(Sender: TObject);
    procedure MediaPlayerEndReached(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure RewindBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PrecedentBtnClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure TimerScrollTimer(Sender: TObject);
    procedure ZoomTBChange(Sender: TObject);
    procedure TimerMajTimer(Sender: TObject);
    procedure TimerSuivantTimer(Sender: TObject);
    procedure AxesCBChange(Sender: TObject);
    procedure altitudeCBClick(Sender: TObject);
    procedure TimerMoveTimer(Sender: TObject);
    procedure RollingShutterBtnClick(Sender: TObject);
  private
    BorneSelect : TstyleDrag;
    vlcfps : int64; // intervalle entre deux trames en ms
    LargeurAff,HauteurAff : integer; // Affiche
    dureeSec : double;
    LongueurEchelle : double;
    NbreImagesParSec : integer;
    DureeImage : double;
    DureeImageMs : int64;
    crCibleAvi : integer;
    MajVideo : boolean;
    timeEnregistre : TTime;
    PositionV,PositionH : integer;
    compteurMaj : integer;
    tPrecedent : int64;
 //   aspectRationum, aspectRatioDen : longword;
    procedure setBoutons;
    procedure EnregistrePoint;
    procedure SetCurseur(Acursor : Tcursor);
    procedure Dessine;
    procedure SauveData;
    Function GetBorne(x,y : integer;deplace : boolean) : TstyleDrag;
    procedure VideRepertoire;
    procedure EffectuerZoom;
    function GetCouleurGrid(Acol : integer) : TColor;
    procedure CorrigeAxes;
  public
      Nmes : integer;
      Largeur,Hauteur : longWord; // de la video originale
      OrigineX,OrigineY : integer;
      pasZoom : double; // conversion xy(video) vers xy(cran)
      PointRepere : TarrayPoint;
      e_PointRepere : TarrayPoint;
      old_PointRepere : TarrayPoint;
      PointCourant : integer;
      Couleur : array[0..maxPoints] of Tcolor;
      nomFichierVLC : string;
      signeY : integer;
      angleX : double;
      vlcTrouve : boolean;
      procedure calcEchelle;
      procedure OuvreFichier(Anom: string);
      procedure TraceData;
      procedure ImageVersEcran;
      procedure EcranVersImage;
      procedure TraceGrid;
  protected
      procedure WMSuivant(var Msg: TWMRegMessage); message wm_avi_suivant;
      procedure WMPrecedent(var Msg: TWMRegMessage); message wm_avi_precedent;
  end;

var
  VclForm: TVclForm;

implementation

uses regmain, regdde, graphvar, stayontopVcl, rollingShutterU;

const  Titre = 'AVI';

{$R *.DFM}

  procedure TVclForm.ImageVersEcran;
    var i : TstyleDrag;
    begin
       for i := low(TstyleDrag) to High(TstyleDrag) do begin
           e_pointRepere[i].x := round(pointRepere[i].x*pasZoom);
           e_pointRepere[i].y := round(pointRepere[i].y*pasZoom);
       end;
    end;

    procedure TVclForm.EcranVersImage;
    var i : TstyleDrag;
    begin
       for i := low(TstyleDrag) to High(TstyleDrag) do begin
           pointRepere[i].x := round(e_pointRepere[i].x/pasZoom);
           pointRepere[i].y := round(e_pointRepere[i].y/pasZoom);
       end;
    end;

procedure TVclForm.FormCreate(Sender: TObject);
var Fichier : TMemIniFile;
    j : integer;
begin
{$IFDEF Debug}
    if ecritVLCcreate then ecritDebug('Entre VCL.create') else exit;
    ecritVLCcreate := false;
{$ENDIF}
    pasZoom := 1;
    nomFichierVLC := '';
    LongueurEchelle := 1;
    EchelleEdit.text := '1';
    ToolBar2.ButtonHeight := 22;
    EchelleEdit.Height := 22;
    angleX := 0;signeY := 1;
{$IFDEF Debug}
    ecritDebug('Ouverture fichier INI');
{$ENDIF}
try
    Fichier := TMemIniFile.create(NomFichierIni);
    try
    OpenDialog.filterIndex := Fichier.readInteger(Titre,'FilterIndexVLC',1);
    TraceEchCB.checked := Fichier.readBool(Titre,'TraceEchelle',true);
    TracePointsCB.checked := Fichier.readBool(Titre,'TracePoints',true);
    EtiquetteCB.checked := Fichier.readBool(Titre,'Etiquette',true);
    RollingShutterSE.value := Fichier.readInteger(Titre,'RollingShutter',0);
    couleurAxeCB.selected := Fichier.readInteger(Titre,'CouleurEchelle',clBlack);
    couleur[0] := clBlack;
    for j := 1 to maxPoints do
        Couleur[j] := Fichier.readInteger(Titre,'Couleur'+intToStr(j),clBlack);
    CouleurPointsCB.selected := Couleur[1];
    crCibleAvi := Fichier.readInteger(Titre,'Cible',crCibleNormale);
    case crCibleAvi of
        crCibleDouble : curseurDouble.checked := true;
        crCibleNoire : curseurNoir.checked := true;
        crCibleBlanche : curseurBlanc.checked := true;
        else curseurCroix.checked := true;
    end;
    altitudeCB.checked := Fichier.readBool(Titre,'Altitude',true);
    IncertitudeSE.value := Fichier.readInteger(Titre,'PixelIncert',0);
    finally
    Fichier.free;
    end;
except
    // on oublie le fichier ini
end;
{$IFDEF Debug}
    ecritDebug('Fermeture fichier INI');
{$ENDIF}
    Grid.cells[0,0] := 't(s)';
    if magnet<5 then magnet := 5;
{$IFDEF Debug}
       ecritDebug('DrawForm.create');
{$ENDIF}
    VcldrawForm := TVclDrawForm.create(self);
    VcldrawForm.paintBox.onMouseUp := paintBoxMouseUp;
    VcldrawForm.paintBox.onMouseDown := paintBoxMouseDown;
    VcldrawForm.paintBox.onMouseMove := paintBoxMouseMove;
    VcldrawForm.onKeyDown := editBidonKeyDown;
    timeEnregistre := now;
{$IFDEF Debug}
    ecritDebug('Appel setBoutons');
{$ENDIF}
    setBoutons;
{$IFDEF Debug}
     ecritDebug('Sortie VCL.create');
{$ENDIF}
end; // FormCreate

procedure TVclForm.RegressiBtnClick(Sender: TObject);
begin
    BorneSelect := bsNone;
    setCurseur(crDefault);
    setBoutons;
    SauveData
end;

procedure TVclForm.RewindBtnClick(Sender: TObject);
begin
    if nomFichierVLC<>'' then ouvreFichier(nomFichierVLC);
end;

procedure TVclForm.RollingShutterBtnClick(Sender: TObject);
begin
    RollingShutterForm := TRollingShutterForm.create(self);
    RollingShutterForm.showModal;
    RollingShutterForm.free;
end;

procedure TVclForm.SauveData;
begin
       Screen.Cursor := crHourGlass;
       calcEchelle;
       correctionRS.withOrigine := OrigineMobileCB.Checked;
       correctionRS.RSvalue := RollingShutterSE.value;
       correctionRS.Nbre := nmes;
       correctionRS.NPoints := NbreSE.value;
       correctionRS.hauteur := hauteur;
       correctionRS.angleX := angleX;
       correctionRS.nomFichierVideo := nomFichierVLC;
       correctionRS.signeY := signeY;
       correctionRS.sauveData;
       Screen.Cursor := crDefault;
       setBoutons;
       Close;
end; // SauveData

procedure TVclForm.ExitBtnClick(Sender: TObject);
begin
    Close
end;

procedure TVclForm.PaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if (Button<>mbLeft) or (NomFichierVLC='') then exit;
e_pointRepere[BorneSelect].x := x;
e_pointRepere[BorneSelect].y := y;
ecranVersImage;
case BorneSelect of
     bsNone : ;
     bsMesure : EnregistrePoint;
     else begin
         BorneSelect := bsNone;
         calcEchelle;
         traceGrid;
         Application.processMessages;
         setCurseur(crDefault);
         hint := hClicDroitAvi;
     end;
  end;
  traceData;
end; // MouseUp

procedure TVclForm.EnregistrePoint;
var t : TTime;
    duree : double;
begin
         t := now;
         duree := t-timeEnregistre;
         if duree*3600*24<3*timeOutPrecedent/1000 then exit;
         correctionRS.XY[pointCourant,Nmes] := pointRepere[bsMesure];
         correctionRS.Temps[Nmes] := MediaPlayer.GetVideoPosInMs()/1000;
         trackBar.onChange := nil;
         trackBar.Position := round(correctionRS.Temps[Nmes]/dureeImage);
         trackBar.onChange := trackBarChange;
         if (Nmes + 2) > grid.rowCount then
             grid.rowCount := Nmes + 5;
         Grid.cells[0,Nmes+1] := floatToStrF(correctionRS.valeurT(Nmes),ffFixed,5,2);
         if pointCourant>0 then begin
            Grid.cells[pointCourant*2-1,Nmes+1] := correctionRS.strX(pointCourant,Nmes);
            Grid.cells[pointCourant*2,Nmes+1] := correctionRS.strY(pointCourant,Nmes);
         end;
         inc(PointCourant);
         if OrigineMobileCB.checked then begin
            if (PointCourant=1)
            then begin
               if NbreSE.value>1
                  then hint := Format(hMesureAvi1N,[succ(nmes)])
                  else hint := Format(hMesureAvi1,[succ(nmes)]);
               setCurseur(crCibleAvi);
            end
            else if NbreSE.value>1 then
                hint := Format(hMesureAviN,[PointCourant,succ(nmes)]);
         end
         else if NbreSE.value>1 then
                hint := Format(hMesureAviN,[PointCourant,succ(nmes)]);
         UndoBtn.enabled := true;
         if PointCourant>NbreSe.value then begin
             inc(Nmes);
             if OrigineMobileCB.checked
                then begin
                   PointCourant := 0;
                   hint := hOrigineI+intToStr(succ(nmes));
                   setCurseur(crOrigine);
                end
                else begin
                    PointCourant := 1;
                    if NbreSE.value>1
                      then hint := Format(hMesureAvi1N,[succ(nmes)])
                      else hint := Format(hMesureAvi1,[succ(nmes)]);
                    setCurseur(crCibleAvi);
                end;
             RegressiBtn.enabled := nmes>3;
             if correctionRS.temps[nmes-1]<dureeSec-dureeImage
                then postMessage(handle,wm_avi_suivant,0,0)
                else begin
                   BorneSelect := bsNone;
                   hint := hClicDroitAvi;
                   setBoutons;
                   Dessine;
                end;
         end;
         timeEnregistre := t;
end;

procedure TVclForm.EditBidonKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var P : Tpoint;
    incr : integer;
begin
     if not key in [vk_left,vk_numpad4,vk_right,vk_numpad6,
                    vk_down,vk_numpad2,vk_up,vk_numpad8,vk_prior,
                    vk_next,vk_space,vk_return]
        then exit;
     try
     P := Mouse.CursorPos;
     except
        exit;
     end;
     if ssShift in shift then incr := 8 else incr := 1;
     case key of
          vk_left,vk_numpad4 : dec(P.X,incr);
          vk_right,vk_numpad6 : inc(P.X,incr);
          vk_down,vk_numpad2 : inc(P.Y,incr);
          vk_up,vk_numpad8 : dec(P.Y,incr);
          vk_prior : if ssShift in shift
              then dec(P.X,8)
              else dec(P.Y,8);
          vk_next : if ssShift in shift
              then inc(P.X,8)
              else inc(P.Y,8);
          vk_space,vk_return : if BorneSelect=bsMesure then begin
              e_pointRepere[bsMesure] := VclDrawForm.ScreenToClient(P);
              ecranVersImage;
              enregistrePoint;
              exit;
          end;
          else exit;
     end;
     key := 0;
     Mouse.CursorPos := P;
end;

procedure TVclForm.OuvreFichier(Anom : string);

Procedure RecopieLocal;
var src,dest : Pchar;
    nomLoc : string;
begin
     if Anom[1]<>'C' then begin
        videRepertoire;
        nomLoc := extractFileName(Anom);
        nomFichierVLC := TPath.combine(tempDirReg,nomLoc);
        src := strAlloc(length(Anom)+1);
        dest := strAlloc(length(nomFichierVLC)+1);
        strPCopy(src,anom);
        strPCopy(dest,nomFichierVLC);
        copyFile(src,dest,true);
        strDispose(src);
        strDispose(dest);
     end
     else nomFichierVLC := Anom;
end;

procedure Erreur;
const
{$IFDEF Win32}
   erreurVLC = '32 bits ; VLC64 install ?';
   erreurVLCBis = '32 bits ; VLC non install ?';
{$ELSE}
   erreurVLC = '64 bits ; VLC32 install ?';
   erreurVLCBis = '64 bits ; VLC non install ?';
{$ENDIF}
begin
     if vlcTrouve
        then afficheErreur('Regressi utilise VLC '+erreurVLC+crCR+crLF+libvlc_dynamic_dll_error,0)
        else afficheErreur('Regressi utilise VLC '+erreurVLCBis+crCR+crLF+libvlc_dynamic_dll_error,0);
     NomFichierVLC := '';
     cursor := crDefault;
     attenteLabel.Visible := false;
end;

var i,j : integer;
begin // ouvreFichier
     attenteLabel.Visible := true;
     attenteLabel.update;
     cursor := crHourGlass;
     videoDir := extractFilePath(Anom);
     recopieLocal;
     try
     NbreImagesParSec := 30; // par dfaut
     DureeImage := 1/NbreImagesParSec;
     DureeImageMS := round(100*DureeImage);
     VcldrawForm.Visible := false;
     Nmes := 0;
     pasZoom := 1;
     BorneSelect := bsNone;
     Caption := CaptionVLC+' ['+extractFileName(NomFichierVLC)+']';
     EditBidon.setFocus;
     angleX := 0;
     suivantBtn.Enabled := true;
     MajVideo := true;
     for i := 2 to pred(Grid.rowCount) do
         for j := 0 to pred(grid.colCount) do
             Grid.cells[j,i] := '';
     MediaPlayer.Play(NomFichierVLC);
     if libvlc_dynamic_dll_error<>'' then Erreur;
     except
        Erreur;
     end;
end;  // ouvreFichier

procedure TVclForm.OpenFileBtnClick(Sender: TObject);
begin
   if OpenDialog.InitialDir='' then
      OpenDialog.InitialDir := VideoDir;
   if mediaPlayer.isPlay then mediaPlayer.Stop;
   if OpenDialog.execute then
      ouvreFichier(openDialog.fileName)
end;

procedure TVclForm.setBoutons;
var OK : boolean;
begin
    OK := NomFichierVLC<>'';
    VclDrawForm.Visible := OK;
    if OK then traceData;
    EchelleEdit.enabled := OK;
    MesureBtn.enabled := OK;
    RegressiBtn.enabled := nmes>3;
    EchelleEdit.enabled := OK;
    NbreSE.enabled := OK;
    RazBtn.enabled := OK and (borneSelect<>bsMesure) and (nmes>3);
    if borneSelect=bsMesure
       then begin
          MesureBtn.Hint := hStopMes;
          MesureBtn.Caption := 'STOP';
       end
       else begin
          MesureBtn.Hint := hStartMes;
          MesureBtn.Caption := 'Mesurer';
       end;
    RazAxesBtn.enabled := OK and (angleX<>0);
    UndoBtn.enabled := OK and (borneSelect<>bsMesure) and (Nmes>0);
    ToolBar2.ButtonHeight := 22;
    EchelleEdit.Height := 22;
    calcEchelle;
end; // setBoutons

procedure TVclForm.OrigineBtnClick(Sender: TObject);
begin
     if OrigineMobileCB.checked then exit;
     BorneSelect := bsOrigine;
     hint := hOrigineMove;
     setCurseur(crOrigine);
     EditBidon.setFocus;
end;

procedure TVclForm.MesureBtnClick(Sender: TObject);
var i,j : integer;
begin
if MesureBtn.down
  then begin
     BorneSelect := bsMesure;
     if OrigineMobileCB.checked
        then begin
           PointCourant := 0;
           setCurseur(crOrigine);
           hint := hOrigine1
        end
        else begin
           PointCourant := 1;
           setCurseur(crCibleAvi);
           if NbreSE.value>1
              then hint := Format(hMesureAvi1N,[1])
              else hint := Format(hMesureAvi1,[1]);
        end;
     Nmes := 0;
     MesureBtn.Hint := hStopMes;
     MesureBtn.imageIndex := 1;
     MesureBtn.Caption := 'Stop';
     for i := 2 to pred(Grid.rowCount) do
         for j := 0 to pred(grid.colCount) do
             Grid.cells[j,i] := '';
  end
  else begin
     BorneSelect := bsNone;
     hint := hClicDroitAvi;
     setCurseur(crDefault);
     MesureBtn.Hint := hStartMes;
     MesureBtn.imageIndex := 8;
     MesureBtn.Caption := 'Mesurer';
  end;
  Grid.ColCount := NbreSE.value*2+1;
  if NbreSE.value=1
     then begin
        Grid.cells[1,0] := 'x(m)';
        Grid.cells[2,0] := 'y(m)';
     end
     else for j := 1 to NbreSE.value do begin
        Grid.cells[2*j-1,0] := 'x'+intToStr(j)+'(m)';
        Grid.cells[2*j,0] := 'y'+intToStr(j)+'(m)';
     end;
  setBoutons;
end;

procedure TVclForm.MediaPlayerEndReached(Sender: TObject);
begin
    if nomFichierVLC<>'' then ouvreFichier(nomFichierVLC); // VLC a dcharg la video => RZ
end;

procedure TVclForm.MediaPlayerPaused(Sender: TObject);
begin
   suivantBtn.Enabled := true;
end;

procedure TVclForm.MediaPlayerPlaying(Sender: TObject);
var apoint : Tpoint;
    longueur : int64;
    fps : single;
begin
     if MajVideo then begin
          MajVideo := false;
          suivantBtn.Enabled := false;
          borneSelect := bsNone;
     try
          Longueur := MediaPlayer.GetVideoLenInMs();
          // +1 : pb si moins d'une seconde donc plus une seconde !
          DureeSec := 1+(longueur div 1000);
          MediaPlayer.SetVideoScaleInPercent(0); // autoscale
       //   mediaPlayer.GetVideoSampleAspectRatio(aspectRatioNum, aspectRatioDen);
          MediaPlayer.GetVideoDimension(largeur,hauteur);
          EffectuerZoom;
          apoint.y := PanelVideo.top+scrollBox.top;
          apoint.x := PanelVideo.left+scrollBox.left;
          apoint := ClientToScreen(apoint);
          VclDrawForm.left := apoint.x;
          VclDrawForm.top := apoint.y;
          PointRepere[bsOrigine] := point(Largeur div 2,Hauteur div 2);
          PointRepere[bsEchelle1] := point(Largeur div 4,Hauteur div 4);
          PointRepere[bsEchelle2] := point(Largeur div 2,Hauteur div 4);
          PointRepere[bsAxeX] := point(3*Largeur div 4,Hauteur div 2);
          if altitudeCB.Checked
             then PointRepere[bsAxeY] := point(Largeur div 2,Hauteur div 4)
             else PointRepere[bsAxeY] := point(Largeur div 2,3*Hauteur div 4);
          imageVersEcran;
          fps := MediaPlayer.GetVideoFPS;
          NbreImagesParSec := round(fps);
          vlcfps := round(1000/fps);
          trackBar.onChange := nil;
          TrackBar.Max := round(Longueur*fps/1000);
          trackBar.onChange := trackBarChange;
          if NbreImagesParSec=0 then NbreImagesParSec := 30;
          LabelFPS.Caption := '  '+intToStr(NbreImagesParSec)+' /s ';
          DureeImage := 1/NbreImagesParSec;
          compteurMaj := 0;
          TimerMaj.Enabled := true;
     except
        NomFichierVLC := '';
        cursor := crDefault;
        attenteLabel.Visible := false;
     end;
     end; // Maj video au chargement
end;

procedure TVclForm.MediaPlayerStopped(Sender: TObject);
begin
   suivantBtn.Enabled := true;
end;

procedure TVclForm.UndoBtnClick(Sender: TObject);
var j : integer;
begin
     if Nmes>0 then dec(nmes);
     UndoBtn.enabled := nmes>0;
     if OrigineMobileCB.checked
          then begin
               PointCourant := 0;
               hint := hOrigineI+intToStr(succ(nmes));
               setCurseur(crOrigine);
          end
          else begin
               PointCourant := 1;
               if NbreSE.value>1
                   then hint := Format(hMesureAvi1N,[succ(nmes)])
                   else hint := Format(hMesureAvi1,[succ(nmes)]);
               setCurseur(crCibleAvi);
          end;
      for j := 0 to 2*NbreSE.value-1 do
          Grid.cells[j,nmes+1] := '';
      MediaPlayer.setVideoPosInMs(round(correctionRS.temps[nmes]*1000));
      traceData;
end;

procedure TVclForm.EchelleEditKeyPress(Sender: TObject; var Key: Char);
begin
    if not CharInSet(key,['0'..'9','.',',','s','m',
                    crSupprArr,crCR,crTab,crGauche,crDroite]) then key := #0
end;

procedure TVclForm.EchelleEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=ord(crCR) then EchelleEditExit(sender)
end;

procedure TVclForm.PaintBoxPaint(Sender: TObject);
begin
     if nomFichierVLC<>'' then Dessine;
end;

procedure TVclForm.PlayBtnClick(Sender: TObject);
begin
     if (NomFichierVLC<>'') then begin
         suivantBtn.Enabled := false;
 //        mediaPlayer.setPlayRate(NbreImagesParSec div RalentiTB.position);
         mediaPlayer.play(NomFichierVLC);
     end;
end;

procedure TVclForm.PrecedentBtnClick(Sender: TObject);
begin
    postMessage(handle,wm_avi_precedent,0,0);
end;

procedure TVclForm.Dessine;
begin // Dessine
    if NomFichierVLC='' then exit;
    couleurAxeCB.Visible := traceEchCB.checked;
    couleurPointsCB.Visible := tracePointsCB.checked;
    traceGrid;
    VclDrawForm.Dessine;
    EditBidon.setFocus;
end; // Dessine

procedure TVclForm.TraceGrid;
var i,j : integer;
begin // Dessine
    if NomFichierVLC='' then exit;
    if (Nmes+2)>grid.rowCount then grid.rowCount := Nmes+5;
    if NbreSE.value=1
       then begin
          Grid.cells[1,0] := 'x(m)';
          Grid.cells[2,0] := 'y(m)';
       end
       else for j := 1 to NbreSE.value do begin
          Grid.cells[2*j-1,0] := 'x'+intToStr(j)+'(m)';
          Grid.cells[2*j,0] := 'y'+intToStr(j)+'(m)';
       end;
    for i := 0 to pred(nmes) do begin
           Grid.cells[0,i+1] := floatToStrF(correctionRS.valeurT(i),ffFixed,5,3);
           for j := 1 to NbreSE.value do begin
               Grid.cells[j*2-1,i+1] := correctionRS.strX(j,i);
               Grid.cells[j*2,i+1] := correctionRS.strY(j,i);
           end;{j}
    end;
    for i := nmes+1 to pred(grid.rowCount) do
        for j := 0 to pred(grid.colCount) do
            Grid.cells[j,i] := '';
end; // TraceGrid

procedure TVclForm.FormClose(Sender: TObject; var Action: TCloseAction);
var Fichier : TMemIniFile;
    j : integer;
begin
     Fichier := TMemIniFile.create(NomFichierIni);
     Fichier.writeInteger(Titre,'RollingShutter',RollingShutterSE.value);
     Fichier.WriteBool(Titre,'Etiquette',EtiquetteCB.checked);
     Fichier.writeInteger(Titre,'FilterIndexVLC',OpenDialog.filterIndex);
     Fichier.writeBool(Titre,'TraceEchelle',traceEchCB.checked);
     Fichier.writeBool(Titre,'TracePoints',tracePointsCB.checked);
     Fichier.writeInteger(Titre,'CouleurEchelle',couleurAxeCB.selected);
     for j := 1 to maxPoints do
         Fichier.writeInteger(Titre,'Couleur'+intToStr(j),Couleur[j]);
     Fichier.writeInteger(Titre,'Cible',crCibleAvi);
     Fichier.writeBool(Titre,'Altitude',altitudeCB.checked);
     Fichier.writeInteger(Titre,'PixelIncert',IncertitudeSE.value);
     Fichier.UpdateFile;
     Fichier.free;
     VcldrawForm.Visible := false;
     if mediaPlayer.isPlay then MediaPlayer.Stop;
     inherited;
end;

procedure TVclForm.FormDestroy(Sender: TObject);
begin
     if mediaPlayer.isPlay then MediaPlayer.Stop;
     videRepertoire;
     VcldrawForm.free;
     //bitmapSource.Free;
     VclForm := nil;
end;

procedure TVclForm.FormHide(Sender: TObject);
begin
  setCurseur(crDefault);
  VcldrawForm.Visible := false;
end;

procedure TVclForm.FormResize(Sender: TObject);
begin
    if (NomFichierVLC<>'') then begin
       effectuerZoom;
       traceData;
    end;
end;

procedure TVclForm.FormShow(Sender: TObject);
begin
{$IFDEF Debug}
    if compteurvlcshow<3 then ecritDebug('Entre VCL.show') else exit;
    inc(compteurvlcshow);
{$ENDIF}
    VclDrawForm.Visible := NomFichierVLC<>'';
    if (nomFichierVLC<>'') then begin
        suivantBtn.Enabled := true;
        MajVideo := true;
        MediaPlayer.Play(NomFichierVLC);
    end;
{$IFDEF Debug}
    ecritDebug('Sortie VCL.show');
{$ENDIF}
end;

procedure TVclForm.SetCurseur(Acursor : Tcursor);
begin
    if VcldrawForm.Cursor<>Acursor then begin
      VclDrawForm.PaintBox.cursor := Acursor;
      VclDrawForm.cursor := Acursor;
      PanelVideo.cursor := Acursor;
      mediaPlayer.cursor := Acursor;
      screen.Cursor := Acursor;
    end;
end;

procedure TVclForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var BS : TstyleDrag;
begin
if (NomFichierVLC='') then exit;
old_pointRepere := e_pointRepere;
e_pointRepere[BorneSelect].x := x;
e_pointRepere[BorneSelect].y := y;
corrigeAxes;
ecranVersImage;
if origineMobileCB.checked
    then begin
        Status.Panels[0].text := ' ';
        Status.Panels[1].text := ' ';
    end
    else begin
       // Status.Panels[0].text := 'x='+FormatReg((x-origineX)*correctionRS.Echelle)+'m';
       // Status.Panels[1].text := 'y='+FormatReg((y-origineY)*correctionRS.Echelle*signeY)+'m';
    end;
case borneSelect of
    bsNone : begin
           hint := '';
           BS := GetBorne(x,y,false);
           case BS of
              bsOrigine : setCurseur(crOrigine);
              bsNone : setCurseur(crDefault)
              else setCurseur(crCibleMove);
           end;
           case BS of
               bsOrigine : hint := hOrigineMove;
               bsEchelle2 : hint := hEchelle2Move;
               bsEchelle1 : hint := hEchelle1Move;
               bsAxeX : hint := hAxeX;
               bsAxeY : hint := hAxeY;
               else hint := hClicDroitAvi;
           end;
           VclDrawForm.PaintBox.hint := hint;
           Status.panels[2].Text := hint;
           exit;
    end;
    bsMesure : ;
    else if not timerMove.enabled then begin
        timerMove.Enabled := true;
        VcldrawForm.PaintBox.Repaint;
    end;
end;
case borneSelect of
     bsNone : setCurseur(crDefault);
     bsMesure : if pointCourant=0
         then setCurseur(crOrigine)
         else setCurseur(crCibleAvi);
     bsOrigine : setCurseur(crOrigine);
     bsEchelle1 : setCurseur(crSizeAll);
     bsEchelle2 : setCurseur(crSizeAll);
end;
end;  // mouseMove

procedure TVclForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Button<>mbLeft) or (NomFichierVLC='') then exit;
    e_pointRepere[BorneSelect].x := x;
    e_pointRepere[BorneSelect].y := y;
    if borneSelect=bsNone then begin
      BorneSelect := GetBorne(x,y,true);
      if BorneSelect<bsNone then else setCurseur(crCibleMove);
      case BorneSelect of
           bsNone : setCurseur(crDefault);
           bsOrigine : setCurseur(crOrigine);
           else setCurseur(crCibleMove);
      end;
      case BorneSelect of
           bsOrigine : hint := hOrigineMove;
           bsEchelle2 : hint := hEchelle2Move;
           bsEchelle1 : hint := hEchelle1Move;
           else hint := hClicDroitAvi;
      end;
      VclDrawForm.PaintBox.hint := hint;
      Status.Panels[2].Text := hint;
    end;
    ecranVersImage;
end;

procedure TVclForm.calcEchelle;
var EchelleEnPixel : double;
    i : integer;
begin
     if NomFichierVLC='' then exit;
     try
         LongueurEchelle := StrToFloatWin(EchelleEdit.text);
     except
         EchelleEdit.text := FormatReg(LongueurEchelle);
     end;
     if not OrigineMobileCB.checked then
          for i := 0 to MaxVecteurVideo do begin
                correctionRS.xy[0,i].x := origineX;
                correctionRS.xy[0,i].y := origineY;
          end;
     echelleEnPixel := sqrt(sqr(PointRepere[bsEchelle1].x-PointRepere[bsechelle2].x)+
                            sqr(PointRepere[bsEchelle1].y-PointRepere[bsechelle2].y));
     correctionRS.Echelle := LongueurEchelle/EchelleEnPixel;
     OrigineX := PointRepere[bsOrigine].x;
     OrigineY := PointRepere[bsOrigine].y;
     if altitudeCB.checked
        then signeY := -1
        else signeY := +1
end;

procedure TVclForm.EchelleEditExit(Sender: TObject);
begin
   calcEchelle;
end;

procedure TVclForm.SuivantBtnClick(Sender: TObject);
begin
      postMessage(handle,wm_avi_suivant,0,0);
end;

procedure TVclForm.WMSuivant(var Msg: TWMRegMessage);
begin
   suivantBtn.Enabled := false;
   tPrecedent := mediaPlayer.GetVideoPosInMs;
   MediaPlayer.nextFrame();
   sleep(timeOutSuivant);
   TimerSuivant.Interval := timeOutSuivant;
   TimerSuivant.Enabled := true;
end;

procedure TVclForm.ZoomTBChange(Sender: TObject);
begin
    effectuerZoom;
    if VcldrawForm.Visible then traceData;
end;

procedure TVclForm.WMPrecedent(var Msg: TWMRegMessage);
var position : int64;
begin
   position := mediaPlayer.GetVideoPosInMs;
   mediaPlayer.SetVideoPosInMs(position-vlcfps);
   sleep(timeOutPrecedent);
   trackBar.onChange := nil;
   trackBar.Position := round(correctionRS.Temps[Nmes]/dureeImage);
   trackBar.onChange := trackBarChange;
end;

procedure TVclForm.CurseurClick(Sender: TObject);
var Amenu : TmenuItem;
begin
     Amenu := TmenuItem(sender);
     if Amenu.tag=0
        then crCibleAvi := crCross
        else crCibleAvi := Amenu.tag;
     Amenu.checked := true;
     if (BorneSelect = bsMesure) then if pointCourant=0
        then setCurseur(crOrigine)
        else setCurseur(crCibleAVI);
end;

procedure TVclForm.OrigineItemClick(Sender: TObject);
begin
  correctionRS.withOrigine := origineMobileCB.checked;
  setBoutons;
end;

procedure TVclForm.StopBtnClick(Sender: TObject);
begin
     if (NomFichierVLC<>'') then begin
        MediaPlayer.Pause;
        suivantBtn.Enabled := true;
     end;
end;

procedure TVclForm.CouleurPointsCBChange(Sender: TObject);
begin
   if PointCourant>0
      then couleur[pointCourant] := couleurPointsCB.selected
      else couleur[1] := couleurPointsCB.selected;
   dessine;
end;

procedure TVclForm.GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var s : String;
begin
    TstringGrid(sender).canvas.Font.Color := GetCouleurGrid(acol);
    S := TstringGrid(sender).cells[Acol,Arow];
    with TstringGrid(sender).canvas do
         TextOut(Rect.Left + 2, Rect.Top + 2,S);
end;

function TVclForm.GetCouleurGrid(Acol : integer) : TColor;
begin
if Acol=0
     then result := clBlack
     else result := couleur[(Acol+1) div 2];
case result of
    clMaroon: ;
    clGreen: ;
    clOlive: ;
    clNavy: ;
    clPurple: ;
    clTeal: ;
    clGray: ;
    clBlue: ;
    clFuchsia: ;
    clRed: ;
    clLime,clMoneyGreen: Result := clGreen;
    clAqua,clSkyBlue: Result := clBlue;
    clMedGray: Result := clGray;
    else Result := clBlack;
end; // case
end;

procedure TVclForm.AxesCBChange(Sender: TObject);
begin
  setBoutons;
end;

procedure TVclForm.CouleurAxeCBChange(Sender: TObject);
begin
     dessine
end;

procedure TVclForm.altitudeCBClick(Sender: TObject);
begin
    setBoutons;
    traceGrid;
end;

procedure TVclForm.RazBtnClick(Sender: TObject);
var i,j : integer;
begin
     if MessageDlg('Suppression des donnes',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
         for i := 0 to nmes do
           for j := 0 to pred(grid.ColCount) do
               Grid.cells[j,i+1] := '';
         Nmes := 0;
         traceData;
         setBoutons;
     end;
end;

Function TvclForm.GetBorne(x,y : integer;deplace : boolean) : TstyleDrag;
var i : TstyleDrag;
    aPoint : TPoint;
    a,d : double;
begin
      result := bsNone;
      aPoint := Point(x,y);
      for i in [bsOrigine,bsEchelle1,bsEchelle2,bsaxeX,bsaxeY] do
          if e_PointRepere[i].distance(aPoint) < Magnet
              then begin
                 result := i;
                 exit;
              end;
      if result=bsNone then begin
         d := e_PointRepere[bsOrigine].distance(aPoint);
         if d<100 then exit;
         a := arcTan2(aPoint.y-e_PointRepere[bsOrigine].y,
                      aPoint.x-e_PointRepere[bsOrigine].x);
         if (abs(angleX-a)<0.02)
         then begin
             if deplace then begin
                e_PointRepere[bsAxeX] := aPoint;
                ecranVersImage;
             end;
             result := bsAxeX;
         end
         else if (abs(angleX+signeY*pi/2-a)<0.02) then begin
             if deplace then begin
                e_PointRepere[bsAxeY] := aPoint;
                ecranVersImage;
             end;
             result := bsAxeY;
         end;
      end;
end;
procedure TVclForm.VideRepertoire;
var info : TSearchRec;
begin
  removeBackSlash(tempDirReg);
  if findFirst(tempDirReg+'\*.*',faAnyFile,Info)=0 then begin
     repeat
         if (Info.attr and faDirectory)<>faDirectory then
            deleteFile(Tpath.combine(tempDirReg,Info.Name));
     until FindNext(Info)<>0;
     FindClose(info);
  end;
end;

procedure TVclForm.TimerMajTimer(Sender: TObject);
begin
    if compteurMaj=0
       then MediaPlayer.Pause
       else MediaPlayer.NextFrame;
    inc(compteurMaj);
    timerMaj.Enabled := compteurMaj<3;
    if not timerMaj.enabled then begin
        setBoutons;
        cursor := crDefault;
        MediaPlayer.SetVideoPosInMs(0);
        trackBar.onChange := nil;
        trackBar.Position := 0;
        trackBar.onChange := trackBarChange;
        suivantBtn.Enabled := true;
        attenteLabel.Visible := false;
    end;
end;

procedure TVclForm.TimerMoveTimer(Sender: TObject);
begin
    TimerMove.Enabled := false;
end;

procedure TVclForm.TimerScrollTimer(Sender: TObject);
begin
     if (VclDrawForm.visible) and
        ((ScrollBox.VertScrollBar.position<>PositionV) or
         (ScrollBox.HorzScrollBar.position<>PositionH)) then begin
           positionH := ScrollBox.HorzScrollBar.position;
           positionV := ScrollBox.VertScrollBar.position;
           TraceData;
     end;
end;

procedure TVclForm.TimerSuivantTimer(Sender: TObject);
var tActuel : int64;
begin
    timerSuivant.Enabled := false;
    suivantBtn.Enabled := true;
    tActuel := mediaPlayer.GetVideoPosInMs;
    if tActuel=tPrecedent then begin
       mediaPlayer.SetVideoPosInMs(tPrecedent+vlcfps);
       sleep(timeOutSuivant);
    end
end;

procedure TVclForm.TraceData;
var aPoint : Tpoint;
begin
   apoint.y := PanelVideo.top+scrollBox.top;  // par rapport  la fentre
   apoint.x := PanelVideo.left+scrollBox.left;
   apoint := ClientToScreen(apoint); // par rapport  l'cran
   VclDrawForm.left := apoint.x;
   VclDrawForm.top := apoint.y;
   VclDrawForm.PaintBox.Refresh;
end;

procedure TVclForm.TrackBarChange(Sender: TObject);
begin
    if (csLButtonDown in TrackBar.ControlState) then exit;
    mediaPlayer.SetVideoPosInMs(TrackBar.Position*vlcfps);
    sleep(timeOutPrecedent);
end;

procedure TVclForm.EffectuerZoom;
var zoomX,zoomY : double;
begin
    zoomX := (ScrollBox.width / largeur);
    zoomY := (ScrollBox.height / hauteur);
    if zoomX>zoomY then pasZoom := zoomY else pasZoom := zoomX;
    hauteurAff := round(hauteur*pasZoom);
    largeurAff := round(largeur*pasZoom);
    panelVideo.Width := largeurAff;
    panelVideo.Height := hauteurAff;
    VclDrawForm.width := largeurAff;
    VclDrawForm.height := hauteurAff;
    VclDrawForm.constraints.maxwidth := largeurAff;
    vclDrawForm.constraints.maxheight := hauteurAff;
end;

procedure TVclForm.CorrigeAxes;
var angleLoc : double;
      longueur : integer;
begin  // Angle est l'angle informatique Y vers le bas donc positif=sens horaire
     if borneSelect=bsAxeX then begin // rendre les axes perpendiculaires
           angleLoc := arcTan2(e_pointRepere[bsAxeX].y-e_pointRepere[bsOrigine].y,
                               e_pointRepere[bsAxeX].x-e_pointRepere[bsOrigine].x);
           longueur := round(e_pointRepere[bsAxeY].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x-signeY*round(longueur*sin(angleLoc));
           e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*round(longueur*cos(angleLoc));
     end;
     if borneSelect=bsAxeY then begin // rendre les axes perpendiculaires
           angleLoc := arcTan2(signeY*(-e_pointRepere[bsAxeY].x+e_pointRepere[bsOrigine].x),
                               signeY*(e_pointRepere[bsAxeY].y-e_pointRepere[bsOrigine].y));
           longueur := round(e_pointRepere[bsAxeX].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+round(longueur*cos(angleLoc));
           e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y+round(longueur*sin(angleLoc));
     end;
     if borneSelect=bsOrigine then begin // ne pas changer l'angle
           longueur := round(e_pointRepere[bsAxeX].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+round(longueur*cos(angleX));
           e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y+round(longueur*sin(angleX));
           longueur := round(e_pointRepere[bsAxeY].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x-signeY*round(longueur*sin(angleX));
           e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*round(longueur*cos(angleX));
     end;
end;

procedure TvclForm.RazAxesBtnClick(Sender: TObject);
var longueur : integer;
begin
     longueur := largeurAff div 4;
     angleX := 0;
     e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+longueur;
     e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y;
     e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x;
     e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*longueur;
     ecranVersImage;
     Dessine;
     //	(sender as TtoolButton).checkMenuDropDown;
end;


end.

