unit aviMain;

interface

uses
  System.Types, System.UITypes, System.ImageList, Vcl.Forms,
  Windows, SysUtils, Messages,  Classes, Graphics, Controls,
  Dialogs, StdCtrls,  ExtCtrls, Buttons, math, system.IOUtils,
  Menus, ImgList, Spin, ComCtrls, ToolWin, grids, inifiles,
  vcl.htmlHelpViewer,
  regutil, compile, constreg, grapheU, shellApi,
  clipBrd, mmSystem, Jpeg, Mplayer, OleCtrls,
  rollingShutterCalc;

const
   WM_MajAvi = WM_USER + 16;

type
(*
// Declaration d'un nouvel evenement pour TPanel
  TPaintEvent = procedure(ACanvas: TCanvas) of object;

  { Surcharge de la classe TPanel
    TPanel contient une proprit Canvas protge, il suffit de la publie,
    nous en profitont pour ajouter des evenements et surcharger la methode Paint
    pour appeler ces derniers, afin que TPanel gere seul son dessin et son
    rafraichissement.
    Si l'image "clignote" lors du dessin, surtout si le TPanel recouvre une grande
    partie de l'ecran, il faudrat mettre la proprit DoubleBuffered des TPanel  True.
  }

TPanel = class(ExtCtrls.TPanel)
  private
   fOnAfterPaint: TPaintEvent;  // Dessiner aprs
    fOnBeforePaint: TPaintEvent;  // Dessiner avant
  protected
    procedure Paint; override;   // surcharge de la methode de dessin de TPanel
  public
    property Canvas;             // TPanel contient un canvas qu'il faut publier !
    property OnAfterPaint : TPaintEvent read fOnAfterPaint write fOnAfterPaint;
    property OnBeforePaint : TPaintEvent read fOnAfterPaint write fOnBeforePaint;
  end;

procedure TPanel.Paint;
begin
 // Dclenchement de la methode de dessin "aprs"
  if Assigned(fOnBeforePaint) then fOnBeforePaint(Canvas);

  // Mthode de dessin originale de TPanel
  inherited Paint;

  // Dclenchement de la methode de dessin "aprs"
  if Assigned(fOnAfterPaint) then fOnAfterPaint(Canvas);
end;
*)

  TAviForm = class(TForm)
    PanelMediaPlayer: TPanel;
    MediaPlayer: TMediaPlayer;
    TempsLabel: TLabel;
    OpenDialog: TOpenDialog;
    EditBidon: TEdit;
    ToolBar1: TToolBar;
    OpenBtn: TToolButton;
    ImageList1: TImageList;
    UndoBtn: TToolButton;
    RegressiBtn: TToolButton;
    ExitBtn: TToolButton;
    MesureBtn: TToolButton;
    RefreshBtn: TToolButton;
    ToolBar2: TToolBar;
    LabelNbreSE: TLabel;
    NbreSE: TSpinEdit;
    NbreImagesSE: TSpinEdit;
    Label2: TLabel;
    EchelleEdit: TEdit;
    ImageMenu: TPopupMenu;
    CurseurCroix: TMenuItem;
    CurseurNoir: TMenuItem;
    CurseurBlanc: TMenuItem;
    IncertitudeSE: TSpinEdit;
    LabelIncert: TLabel;
    Label3: TLabel;
    ChronoPhotoBtn: TToolButton;
    SaveDialog: TSaveDialog;
    Splitter1: TSplitter;
    DureeEdit: TEdit;
    Label4: TLabel;
    Status: TStatusBar;
    HelpBtn: TToolButton;
    TrackBar: TTrackBar;
    RazBtn: TToolButton;
    Bitmap1: TMenuItem;
    JPEG1: TMenuItem;
    MesureAutoCB: TCheckBox;
    Grid: TStringGrid;
    ConvertBtn: TToolButton;
    StopBtn: TToolButton;
    CurseurDouble: TMenuItem;
    AxesGB: TGroupBox;
    TraceEchCB: TCheckBox;
    CouleurAxeCB: TColorBox;
    PointsGB: TGroupBox;
    TracePointsCB: TCheckBox;
    CouleurPointsCB: TColorBox;
    EtiquetteCB: TCheckBox;
    ToolButton2: TToolButton;
    altitudeCB: TCheckBox;
    Image: TPanel;
    zoomUD: TSpinEdit;
    OrigineMobileCB: TCheckBox;
    Label1: TLabel;
    RazAxesBtn: TToolButton;
    Label6: TLabel;
    RollingShutterBtn: TSpeedButton;
    RollingShutterSE: TSpinEdit;
    TailleLabel: TLabel;
    CorrigeYRSCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EditBidonKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure MesureBtnClick(Sender: TObject);
    procedure MediaPlayerNotify(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure EchelleEditKeyPress(Sender: TObject; var Key: Char);
    procedure EchelleEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RefreshBtnClick(Sender: TObject);
    procedure MediaPlayerClick(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EchelleEditExit(Sender: TObject);
    procedure CurseurClick(Sender: TObject);
    procedure ChronoPhotoBtnClick(Sender: TObject);
    procedure GridKeyPress(Sender: TObject; var Key: Char);
    procedure CouleurPointsCBChange(Sender: TObject);
    procedure NbreImagesSEChange(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DureeEditExit(Sender: TObject);
    procedure DureeEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CouleurAxeCBChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure Bitmap1Click(Sender: TObject);
    procedure JPEG1Click(Sender: TObject);
    procedure RazAxesBtnClick(Sender: TObject);
    procedure ConvertBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure altitudeCBClick(Sender: TObject);
    procedure ImageResize(Sender: TObject);
    procedure zoomUDChange(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure RollingShutterBtnClick(Sender: TObject);
    procedure OrigineMobileCBClick(Sender: TObject);
    procedure NbreSEChange(Sender: TObject);
    procedure RollingShutterSEChange(Sender: TObject);
  private
    imageCanvas : TCanvas;
    PointRepere : TarrayPoint;
    e_PointRepere : TarrayPoint;
    old_PointRepere : TarrayPoint;
    Couleur : array[0..maxPoints] of Tcolor;
    BlueCibleChrono,RedCibleChrono,GreenCibleChrono : integer;
    xCibleChrono,yCibleChrono : integer;
    BorneSelect : TstyleDrag;
    Largeur,Hauteur : integer;
    PointCourant : integer;
    TempsCourant,dureeTotale : double;
    LongueurEchelle : double;
    AppelRefresh,avanceRefresh : boolean;
    bitmapFin,bitmapInit : TBitmap;
    nomFichierBmp : string;
    NbreImagesParSec : integer;
    DureeImage : double;
    crCibleAvi : integer;
    nomFichier : string;
    premierClick : boolean; // lors du premier setCursorPos, l'image s'efface !
    pasZoom : double;
    largeurAff,hauteurAff : integer;
    angleX : double;
    demiHauteurLoupe : integer;
    Procedure MajVideo;
    Function CouleurGrid(Acol : integer) : Tcolor;
    procedure setBoutons;
    procedure EnregistrePoint;
    procedure SetCurseur(Acursor : Tcursor);
    procedure calcEchelle;
    procedure chronoPhoto;
    procedure InitChronoPhoto;
    procedure SaveChronoPhoto;
    Function GetBitmapFromDC : Tbitmap;
    procedure SauveData;
    procedure Suivant;
    procedure Precedent;
    Function GetBorne(x,y : integer;deplace : boolean) : TstyleDrag;
    function AppartientImage(X, Y: Integer) : boolean;
    procedure CacheLoupe;
    procedure EffectuerZoom;
    procedure EcranVersImage;
    procedure ConvertitXY(Sender: TObject; var X,Y : integer);
    procedure ConvertitCibleXY(Sender: TObject; var X,Y : integer);
    procedure CorrigeAxes;
    Procedure TraceOrigine(old : boolean);
    Procedure TraceLigne(P1,P2 : Tpoint);
  public
      Nmes : integer;
      signeY : integer;
      procedure OuvreFichier(Anom: string);
      procedure Dessine;
  protected
      procedure WMMajAvi(var Message: Tmessage); message WM_MajAvi;
  end;

var
  AviForm: TAviForm;

implementation

uses AideKey, ChronoU, loupeU, regmain, regdde, graphvar, stayOnTopAvi, rollingShutterU;

{$R *.DFM}

procedure TAviForm.FormCreate(Sender: TObject);
var Fichier : TMemIniFile;
    j : integer;
begin
    if aviDrawForm=nil then
       Application.CreateForm(TAviDrawForm, aviDrawForm);
    aviDrawForm.paintBox.onMouseUp := paintBoxMouseUp;
    aviDrawForm.paintBox.onMouseDown := paintBoxMouseDown;
    aviDrawForm.paintBox.onMouseMove := paintBoxMouseMove;
    aviDrawForm.onKeyDown := editBidonKeyDown;
    imageCanvas := aviDrawForm.paintBox.Canvas;
    LongueurEchelle := 1;
    EchelleEdit.text := '1';
    angleX := 0;
    AppelRefresh := false;
    ToolBar2.ButtonHeight := 22;
    EchelleEdit.Height := 22;
    DureeEdit.Height := 22;
    Fichier := TMemIniFile.create(NomFichierIni);
    OpenDialog.filterIndex := Fichier.readInteger(stAVI,'FilterIndex',1);
    TraceEchCB.checked := Fichier.readBool(stAVI,'TraceEchelle',true);
    corrigeYRSCB.checked := Fichier.readBool(stAVI,'CorrigeY',true);
    TracePointsCB.checked := Fichier.readBool(stAVI,'TracePoints',true);
    EtiquetteCB.checked := Fichier.readBool(stAVI,'Etiquette',true);
    couleurAxeCB.selected := Fichier.readInteger(stAVI,'CouleurEchelle',clBlack);
    RollingShutterSE.value := Fichier.readInteger(stAVI,'RollingShutter',0);
    for j := 1 to maxPoints do
        Couleur[j] := Fichier.readInteger(stAVI,'Couleur'+intToStr(j),clBlack);
    CouleurPointsCB.selected := Couleur[1];
    crCibleAvi := Fichier.readInteger(stAVI,'Cible',crCibleNormale);
    tempsLabel.caption := '';
    case crCibleAvi of
        crCibleNoire : curseurNoir.checked := true;
        crCibleBlanche : curseurBlanc.checked := true;
        crCibleDouble : curseurDouble.checked := true;
        else curseurCroix.checked := true;
    end;
    altitudeCB.Checked := Fichier.readBool(stAVI,'Altitude',true);
    IncertitudeSE.value := Fichier.readInteger(stAVI,'PixelIncert',0);
    ZoomUD.value := Fichier.readInteger(stAVI,'Loupe',1);
    Fichier.free;
    Grid.cells[0,0] := 't(s)';
    if LoupeForm=nil then
       Application.CreateForm(TLoupeForm, LoupeForm);
    LoupeForm.paintBox.onMouseUp := paintBoxMouseUp;
    LoupeForm.paintBox.onMouseDown := paintBoxMouseDown;
    LoupeForm.paintBox.onMouseMove := paintBoxMouseMove;
    LoupeForm.onKeyDown := editBidonKeyDown;
    //image.OnAfterPaint := Dessine;
   // image.OnBeforePaint := Dessine;
    CacheLoupe;
    setBoutons;
end; // FormCreate

procedure TAviForm.RegressiBtnClick(Sender: TObject);
begin
    SauveData
end;

procedure TAviForm.RollingShutterBtnClick(Sender: TObject);
begin
    RollingShutterForm := TRollingShutterForm.create(self);
    RollingShutterForm.showModal;
    RollingShutterForm.free;
end;

procedure TAviForm.RollingShutterSEChange(Sender: TObject);
begin
      corrigeYRSCB.Visible := (NbreSE.value>1) and (rollingShutterSE.value>0);
end;

procedure TAviForm.SauveData;
begin
       Screen.Cursor := crHourGlass;
       calcEchelle;
       correctionRS.RSvalue := RollingShutterSE.value;
       correctionRS.Nbre := nmes;
       correctionRS.NPoints := NbreSE.value;
       correctionRS.hauteur := hauteur;
       correctionRS.angleX := angleX;
       correctionRS.signeY := signeY;
       correctionRS.incertXY := IncertitudeSE.value;
       correctionRS.nomFichierVideo := MediaPlayer.FileName;
       correctionRS.sauveData;
       MesureBtn.Down := false;
       setBoutons;
       Screen.Cursor := crDefault;
       Close;
end; // SauveData

procedure TAviForm.MajVideo;

procedure ChercheFreqEch;
var NbreFrames,DureeMS : LongInt;
begin
  MediaPlayer.TimeFormat := tfFrames;
  NbreFrames := MediaPlayer.Length;
  MediaPlayer.TimeFormat := tfMilliseconds;
  DureeMs := MediaPlayer.Length;
  NbreImagesParSec := round(1000*NbreFrames/DureeMs);
  DureeImage := DureeMs/(1000*NbreFrames);
  if NbreImagesParSec=0
     then DureeEdit.text := formatReg(dureeImage)+'s'
     else NbreImagesSE.value := NbreImagesParSec;
  DureeEdit.Visible := NbreImagesParSec=0;
  NbreImagesSE.Visible := NbreImagesParSec>0;
  Label2.Visible := NbreImagesParSec>0;
  Label4.Visible := NbreImagesParSec=0;
  dureeTotale := DureeMs/1000;
end;

var aPoint : TPoint;
begin // MajVideo
     ChercheFreqEch;
     Nmes := 0;
     Largeur := MediaPlayer.DisplayRect.right;
     Hauteur := MediaPlayer.DisplayRect.bottom;
     TailleLabel.Caption := intTostr(largeur)+'x'+intTostr(hauteur);
     apoint.y := image.top;
     apoint.x := image.left;
     apoint := ClientToScreen(apoint);
     aviDrawForm.left := apoint.x;
     aviDrawForm.top := apoint.y;
     PointRepere[bsOrigine] := point(Largeur div 2,Hauteur div 2);
     PointRepere[bsEchelle1] := point(Largeur div 4,Hauteur div 4);
     PointRepere[bsEchelle2] := point(Largeur div 2,Hauteur div 4);
     PointRepere[bsAxeX] := point(3*Largeur div 4,Hauteur div 2);
     if altitudeCB.Checked
        then PointRepere[bsAxeY] := point(Largeur div 2,Hauteur div 4)
        else PointRepere[bsAxeY] := point(Largeur div 2,3*Hauteur div 4);
     BorneSelect := bsNone;
     AppelRefresh := false;
     mesureBtn.down := false;
     MediaPlayer.TimeFormat := tfFrames;
     trackBar.tag := 1;
     trackBar.max := mediaPlayer.length;
     trackBar.position := 0;
     trackBar.tag := 0;
     Caption := CaptionAvi+' ['+ExtractFileName(MediaPlayer.FileName)+']';
     setBoutons;
     EditBidon.setFocus;
     effectuerZoom;
     MediaPlayer.notify := true;
     MediaPlayer.Play;
end; // MajVideo

procedure TAviForm.EffectuerZoom;
var zoomX,zoomY : single;
    i : TStyleDrag;
begin
    zoomX := (Image.Width / largeur);
    zoomY := (Image.Height / hauteur);
    if zoomX>zoomY then pasZoom := zoomY else pasZoom := zoomX;
    if pasZoom>1 then pasZoom := floor(pasZoom); // entier pour viter dformation
    hauteurAff := round(hauteur*pasZoom);
    largeurAff := round(largeur*pasZoom);
    for i := low(TstyleDrag) to High(TstyleDrag) do begin
        e_pointRepere[i].x := round(pointRepere[i].x*pasZoom);
        e_pointRepere[i].y := round(pointRepere[i].y*pasZoom);
    end;
    aviDrawForm.width := largeurAff;
    aviDrawForm.height := hauteurAff;
    aviDrawForm.Constraints.maxHeight := hauteurAff;
    aviDrawForm.Constraints.maxWidth := largeurAff;  // sinon double-clic mets en plein cran
    MediaPlayer.DisplayRect := rect(0,0,largeurAff,hauteurAff);
end;

procedure TAviForm.ExitBtnClick(Sender: TObject);
begin
    Close
end;

procedure TAviForm.PaintBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
convertitCibleXY(sender,x,y);
if (Button<>mbLeft) or not appartientImage(x,y) then exit;
e_pointRepere[BorneSelect].x := x;
e_pointRepere[BorneSelect].y := y;
corrigeAxes;
ecranVersImage;
case BorneSelect of
     bsNone : ;
     bsEchelle1 : begin
         BorneSelect := bsNone;
         calcEchelle;
         setCurseur(crDefault);
         image.hint := hClicDroitAvi;
         aviDrawForm.paintBox.repaint
     end;
     bsEchelle2 : begin
         BorneSelect := bsNone;
         image.hint := hClicDroitAvi;
         setCurseur(crDefault);
         calcEchelle;
         Application.processMessages;
         aviDrawForm.paintBox.repaint
     end;
     bsOrigine : begin
         BorneSelect := bsNone;
         setCurseur(crDefault);
         image.hint := hClicDroitAvi;
         calcEchelle;
         aviDrawForm.paintBox.repaint
     end;
     bsAxeX,bsAxeY : begin
         BorneSelect := bsNone;
         setCurseur(crDefault);
         image.hint := hClicDroitAvi;
         aviDrawForm.paintBox.repaint
     end;
     bsChronoInit : begin
         xCibleChrono := x;
         yCibleChrono := y;
         correctionRS.XY[1,0] := pointRepere[bsChronoInit];
         initChronoPhoto;
     end;
     bsChrono : ;
     bsMesure : EnregistrePoint;
  end;
  aviDrawForm.PaintBox.hint := image.hint;
end; // MouseUp

procedure TAviForm.EnregistrePoint;
begin
         correctionRS.XY[pointCourant,Nmes] := pointRepere[bsMesure];
         if tempsCourant>0
            then correctionRS.Temps[Nmes] := tempsCourant
            else correctionRS.Temps[Nmes] := nmes*dureeImage;
         if (Nmes + 3) > grid.rowCount then
             grid.rowCount := Nmes + 8;
         if pointCourant>0 then if (pointCourant<=NbreSe.value) then begin
               Grid.cells[0,Nmes+1] := floatToStrF(correctionRS.valeurT(Nmes),ffFixed,4,2);
               Grid.cells[pointCourant*2-1,Nmes+1] := correctionRS.strX(pointCourant,Nmes);
               Grid.cells[pointCourant*2,Nmes+1] := correctionRS.strY(pointCourant,Nmes);
         end;
         inc(PointCourant);
         if OrigineMobileCB.checked and (PointCourant=1)
            then begin
               if NbreSE.value>1
                  then image.hint := Format(hMesureAvi1N,[succ(nmes)])
                  else image.hint := Format(hMesureAvi1,[succ(nmes)]);
               setCurseur(crCibleAvi);
            end
            else if NbreSE.value>1 then begin
                image.hint := Format(hMesureAviN,[PointCourant,succ(nmes)]);
                setCurseur(crCibleAvi);
            end;
         UndoBtn.enabled := true;
         if PointCourant>NbreSe.value then begin
             inc(Nmes);
             if OrigineMobileCB.checked
                then begin
                   PointCourant := 0;
                   image.hint := hOrigineI+intToStr(succ(nmes));
                   setCurseur(crOrigine);
                end
                else begin
                    PointCourant := 1;
                    if NbreSE.value>1
                      then image.hint := Format(hMesureAvi1N,[succ(nmes)])
                      else image.hint := Format(hMesureAvi1,[succ(nmes)]);
                    setCurseur(crCibleAvi);
                end;
             RegressiBtn.enabled := nmes>3;
             if mediaPlayer.position<pred(mediaPlayer.length)
                then begin
                   AppelRefresh := false;
                   Suivant;
                end
                else begin
                   BorneSelect := bsNone;
                   image.hint := hClicDroitAvi;
                   MesureBtn.Down := false;
                   setBoutons;
                   dessine;
                end;
         end;
         aviDrawForm.PaintBox.hint := image.Hint;
         correctionRS.Nbre := nmes;
end;

procedure TAviForm.EditBidonKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var P : Tpoint;
    incr : integer;
begin
     if not key in [vk_left,vk_numpad4,vk_right,vk_numpad6,
                    vk_down,vk_numpad2,vk_up,vk_numpad8,vk_prior,
                    vk_next,vk_space,vk_return]
        then exit;
     try
     P := Mouse.CursorPos;
     except
       exit;
     end;
     if ssShift in shift then incr := 8 else incr := 1;
     case key of
          vk_left,vk_numpad4 : dec(P.X,incr);
          vk_right,vk_numpad6 : inc(P.X,incr);
          vk_down,vk_numpad2 : inc(P.Y,incr);
          vk_up,vk_numpad8 : dec(P.Y,incr);
          vk_prior : if ssShift in shift
              then dec(P.X,8)
              else dec(P.Y,8);
          vk_next : if ssShift in shift
              then inc(P.X,8)
              else inc(P.Y,8);
          vk_space,vk_return : if BorneSelect=bsMesure then begin
              e_pointRepere[bsMesure] := AviDrawForm.ScreenToClient(P);
              ecranVersImage;
              enregistrePoint;
              exit;
          end;
          else exit;
     end;
     key := 0;
     Mouse.CursorPos := P; //  setCursorPos(P.X,P.Y);
     if premierClick then begin
        PostMessage(Handle,WM_MajAvi,0,0);
        PremierClick := false;
     end;
end; // editBidonKeyDown

procedure TAviForm.ConvertBtnClick(Sender: TObject);
begin
     screen.cursor := crHourGlass;
     stopBtn.Enabled := true;
     if convertirVideo(nomFichier)
     then begin
          showMessage('Nouveau fichier '+nomFichier);
          MediaPlayer.wait := true;
          MediaPlayer.close;
          MediaPlayer.FileName := nomFichier;
          MediaPlayer.open;
          MediaPlayer.frames := 1;
          MajVideo;
     end
     else begin
        MediaPlayer.FileName := '';
        showMessage('Impossible de convertir le fichier');
     end;
     setBoutons;
     EditBidon.setFocus;
     Screen.Cursor := crDefault;
end;

procedure TAviForm.OuvreFichier(Anom : string);
begin
     screen.cursor := crHourGlass;
     cacheLoupe;
     ANom := AnsiUpperCase(Anom);
     angleX := 0;
     NbreImagesParSec := 25; // par dfaut
     NbreImagesSE.value := NbreImagesParSec;
     DureeImage := 0.04;
     nomFichier := aNom;
     aviDrawForm.Visible := false;
     try
     MediaPlayer.FileName := ANom;
     MediaPlayer.wait := true;
     MediaPlayer.open;
     MediaPlayer.frames := 1;
     MajVideo;
     convertBtn.enabled := nomDecodeur<>'';
     videoDir := extractFilePath(Anom);
     except
        MediaPlayer.FileName := '';
        MediaPlayer.wait := true;
        MediaPlayer.Close;
        if convertBtn.enabled then ShowMessage('Essayez le bouton Convert.');
     end;
     setBoutons;
     premierClick := true;
     traceEchCB.visible := true;
     Screen.Cursor := crDefault;
end; // ouvreFichier

procedure TAviForm.OpenFileBtnClick(Sender: TObject);
begin
   MediaPlayer.Notify := false;
   if MediaPlayer.FileName<>'' then begin
      MediaPlayer.Wait := true;
      MediaPlayer.Stop;
   end;
   if OpenDialog.InitialDir='' then
      OpenDialog.InitialDir := VideoDir;
   if OpenDialog.execute then ouvreFichier(openDialog.fileName)
end;

procedure TAviForm.OrigineMobileCBClick(Sender: TObject);
begin
    correctionRS.withOrigine := origineMobileCB.checked;
end;

procedure TAviForm.setBoutons;
var OK : boolean;
begin
    OK := MediaPlayer.FileName<>'';
    aviDrawForm.Visible := OK;
    EchelleEdit.enabled := OK;
    stopBtn.Enabled := false;
    RegressiBtn.enabled := nmes>3;
    ChronoPhotoBtn.enabled := OK and not MesureBtn.down;
    EchelleEdit.enabled := OK;
    RefreshBtn.enabled := OK;
    RazAxesBtn.enabled := OK and (angleX<>0);
    NbreSE.enabled := OK and not MesureBtn.down;
    MesureBtn.enabled := OK and not ChronoPhotoBtn.down;
    RazBtn.enabled := OK and not MesureBtn.down and (nmes>3);
    if MesureBtn.down
       then begin
          MesureBtn.Hint := hStopMes;
          mesureBtn.Caption := 'Stop'
       end
       else begin
          MesureBtn.Hint := hStartMes;
          mesureBtn.Caption := 'Mesurer';
       end;
    if ChronoPhotoBtn.down
       then ChronoPhotoBtn.Hint := hStopChrono
       else ChronoPhotoBtn.Hint := hChrono;
    UndoBtn.enabled := OK and mesureBtn.Down and (Nmes>0);
    ToolBar2.ButtonHeight := 22;
    EchelleEdit.Height := 22;
    DureeEdit.Height := 22;
    if borneSelect=bsNone then cacheLoupe;
    calcEchelle;
end; // setBoutons

procedure TAviForm.MesureBtnClick(Sender: TObject);
var j : integer;
    pointM : TPoint;
begin
  Grid.ColCount := NbreSE.value*2+1;
  if NbreSE.value=1
     then begin
        Grid.cells[1,0] := 'x(m)';
        Grid.cells[2,0] := 'y(m)';
     end
     else for j := 1 to NbreSE.value do begin
        Grid.cells[2*j-1,0] := 'x'+intToStr(j)+'(m)';
        Grid.cells[2*j,0] := 'y'+intToStr(j)+'(m)';
     end;
  if MesureBtn.Down
  then if MesureAutoCB.checked
     then begin
         nomFichierBmp := Tpath.combine(tempDirReg,'regavi.bmp');
         BorneSelect := bsChronoInit;
         if NbreSE.value>1 then showMessage('Un seul mobile possible');
         NbreSE.value := 1;
         image.hint := hCibleAuto;
         setCurseur(crCibleAvi);
         PointM.x := largeurAff div 4;
         PointM.y := hauteurAff div 4;
         PointM := image.ClientToScreen(PointM);
         showMessagePos(trCibleAuto,PointM.x,PointM.y); // centr sur la video
         PostMessage(Handle,WM_MajAvi,0,0);
     end
     else begin
     BorneSelect := bsMesure;
     if OrigineMobileCB.checked
        then begin
           PointCourant := 0;
           setCurseur(crOrigine);
           image.hint := hOrigine1
        end
        else begin
           PointCourant := 1;
           setCurseur(crCibleAvi);
           if NbreSE.value>1
              then image.hint := Format(hMesureAvi1N,[1])
              else image.hint := Format(hMesureAvi1,[1]);
        end;
     Nmes := 0;
     MesureBtn.Hint := hStopMes;
     MesureBtn.imageIndex := 1;
     MesureBtn.Caption := 'STOP';
     PostMessage(Handle,WM_MajAvi,0,0);
     end
  else begin
     BorneSelect := bsNone;
     image.hint := hClicDroitAvi;
     setCurseur(crDefault);
     MesureBtn.Hint := hStartMes;
     MesureBtn.imageIndex := 8;
     MesureBtn.Caption := 'Mesurer';
  end;
  setBoutons;
  aviDrawForm.PaintBox.hint := image.Hint;
  EditBidon.setFocus;
end;

procedure TAviForm.MediaPlayerNotify(Sender: TObject);
var valeurInt : longInt;
begin
     if MediaPlayer.FileName='' then exit;
     try
     valeurInt := mediaPlayer.position;
     trackBar.tag := 1;
     TrackBar.position := mediaPlayer.position;
     trackBar.tag := 0;
     case mediaPlayer.timeFormat of
          tfMilliseconds : tempsCourant := valeurInt/1000; { millisecondes }
          tfHMS : tempsCourant := MCI_HMS_HOUR(valeurInt)*3600.0+
                    MCI_HMS_MINUTE(valeurInt)*60.0+
                    MCI_HMS_SECOND(valeurInt);
          tfMSF : tempsCourant := MCI_MSF_MINUTE(valeurInt)*60.0+
                    MCI_MSF_SECOND(valeurInt);
          tfFrames,tfBytes,tfSamples : tempsCourant := valeurInt*dureeImage;
          tfSMPTE24,tfSMPTE25,tfSMPTE30,tfSMPTE30Drop :
              tempsCourant := MCI_HMS_HOUR(valeurInt)*3600.0+
                    MCI_HMS_MINUTE(valeurInt)*60.0+
                    MCI_HMS_SECOND(valeurInt);
          tfTMSF : tempsCourant := MCI_TMSF_MINUTE(valeurInt)*60.0+
                    MCI_TMSF_SECOND(valeurInt);
          else tempsCourant := valeurInt;
       end;
     tempsLabel.caption := 't='+
                          FloatToStrF(tempsCourant,ffFixed,5,2)+' s /'+
                          FloatToStrF(dureeTotale,ffFixed,5,2)+' s';
     if AppelRefresh
          then begin
            AppelRefresh := false;
            if avanceRefresh
               then Suivant
               else Precedent
          end
          else begin
            if BorneSelect=bsChrono
               then ChronoPhoto
               else aviDrawForm.paintBox.repaint
         end;
     except
     end;
end;

procedure TAviForm.UndoBtnClick(Sender: TObject);
begin
     if Nmes>0 then dec(nmes);
     UndoBtn.enabled := nmes>0;
     if OrigineMobileCB.checked
          then begin
               PointCourant := 0;
               image.hint := hOrigineI+intToStr(succ(nmes));
               setCurseur(crOrigine);
          end
          else begin
               PointCourant := 1;
               if NbreSE.value>1
                   then image.hint := Format(hMesureAvi1N,[succ(nmes)])
                   else image.hint := Format(hMesureAvi1,[succ(nmes)]);
               setCurseur(crCibleAvi);
          end;
     AppelRefresh := false;
     aviDrawForm.PaintBox.hint := image.Hint;
     Precedent
end;

procedure TAviForm.EchelleEditKeyPress(Sender: TObject; var Key: Char);
begin
    if not CharInSet(key,['0'..'9','.',',','s','m',
                    crSupprArr,crCR,crTab,crGauche,crDroite]) then key := #0
end;

procedure TAviForm.EchelleEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=ord(crCR) then EchelleEditExit(sender)
end;

procedure TAviForm.Dessine;
var magnetCroix : integer;

procedure setCouleurAxe;
begin
     imageCanvas.pen.color := couleurAxeCB.selected;
     imageCanvas.font.color := couleurAxeCB.selected;
     imageCanvas.font.size := 12;
end;

Procedure TraceCroix(Apoint : Tpoint);
begin
       imageCanvas.moveto(Apoint.x-magnetCroix,Apoint.y);
       imageCanvas.lineto(Apoint.x+magnetCroix,Apoint.y);
       imageCanvas.moveto(Apoint.x,Apoint.y-magnetCroix);
       imageCanvas.lineto(Apoint.x,Apoint.y+magnetCroix);
end;

Procedure TraceEchelle;
begin
      imageCanvas.pen.mode := pmNOTXOR;
      TraceLigne(e_PointRepere[bsEchelle1],e_PointRepere[bsechelle2]);
      TraceCroix(e_PointRepere[bsEchelle1]);
      TraceCroix(e_PointRepere[bsechelle2]);
      imageCanvas.TextOut((e_PointRepere[bsEchelle1].X+e_PointRepere[bsEchelle2].X) div 2+magnetCroix,
                          (e_PointRepere[bsEchelle1].Y+e_PointRepere[bsEchelle2].Y) div 2+magnetCroix,
                           echelleEDit.text+' m');
      imageCanvas.pen.mode := pmCOPY;
end;

Procedure TraceCroixData(Apoint : Tpoint);
begin
       Apoint.x := round(apoint.X*pasZoom);
       Apoint.y := round(apoint.Y*pasZoom);
       traceCroix(APoint);
end;

Procedure TraceRepere(i : integer);
var xx,yy : integer;
begin
         xx := round(correctionRS.XY[0,i].X*pasZoom);
         yy := round(correctionRS.XY[0,i].Y*pasZoom);
         SetCouleurAxe;
{axe X}
         imageCanvas.moveto(xx-4*magnetCroix,yy);
         imageCanvas.lineto(xx+4*magnetCroix,yy);
{flche X}
         imageCanvas.moveto(xx+7*magnetCroix div 2,yy-1);
         imageCanvas.lineto(xx+2*magnetCroix,yy);
         imageCanvas.moveto(xx+7*magnetCroix div 2,yy+1);
         imageCanvas.lineto(xx+2*magnetCroix,yy);
{axe Y}
         imageCanvas.moveto(xx,yy-4*magnetCroix);
         imageCanvas.lineto(xx,yy+4*magnetCroix);
{flche Y}
         imageCanvas.moveto(xx-1,yy+7*signeY*magnetCroix div 2);
         imageCanvas.lineto(xx,yy+2*signeY*magnetCroix);
         imageCanvas.moveto(xx+1,yy+7*signeY*magnetCroix div 2);
         imageCanvas.lineto(xx,yy+2*signeY*magnetCroix);
end;

procedure setCouleurPoints(j : integer);
begin
     imageCanvas.pen.Color := couleur[j];
     imageCanvas.font.Color := couleur[j];
     imageCanvas.font.size := 8;
end;

var i,j : integer;
    texte : string;
    PointEcran : TPoint;
    avecTrace : boolean;
begin // Dessine
    if MediaPlayer.FileName='' then exit;
    imageCanvas := aviDrawForm.paintBox.Canvas;
    avecTrace := not(borneSelect in [bsChrono,bsChronoInit]);
    imageCanvas.pen.width := 2;
    magnetCroix := magnet; // ??
    couleurAxeCB.Visible := traceEchCB.checked;
    if traceEchCB.checked and avecTrace then begin
       setCouleurAxe;
       if OrigineMobileCB.checked
          then begin
              for i := 0 to pred(nmes) do TraceRepere(i);
              if PointCourant>0 then TraceRepere(nmes);
          end
          else begin
             TraceOrigine(false);
             imageCanvas.TextOut(e_PointRepere[bsAxeX].X,e_PointRepere[bsaxeX].Y,'X');
             imageCanvas.TextOut(e_PointRepere[bsAxeY].X,e_PointRepere[bsaxeY].Y,'Y');
          end;
       TraceEchelle;
    end;
    avecTrace := tracePointsCB.checked and avecTrace;
(*
R2_BLACK  Pixel is always 0.
R2_COPYPEN Pixel is the pen color.
R2_MASKNOTPEN Pixel is a combination of the colors common to both the screen and the inverse of the pen.
R2_MASKPEN Pixel is a combination of the colors common to both the pen and the screen.
R2_MASKPENNOT Pixel is a combination of the colors common to both the pen and the inverse of the screen.
R2_MERGENOTPEN Pixel is a combination of the screen color and the inverse of the pen color.
R2_MERGEPEN Pixel is a combination of the pen color and the screen color.
R2_MERGEPENNOT Pixel is a combination of the pen color and the inverse of the screen color.
R2_NOP Pixel remains unchanged.
R2_NOT Pixel is the inverse of the screen color.
R2_NOTCOPYPEN Pixel is the inverse of the pen color.
R2_NOTMASKPEN Pixel is the inverse of the R2_MASKPEN color.
R2_NOTMERGEPEN Pixel is the inverse of the R2_MERGEPEN color.
R2_NOTXORPEN Pixel is the inverse of the R2_XORPEN color.
R2_WHITE Pixel is always 1.
R2_XORPEN Pixel is a combination of the colors in the pen and in the screen, but not in both.
*)
    calcEchelle;
    couleurPointsCB.Visible := tracePointsCB.checked;
    if (Nmes+2)>grid.rowCount then grid.rowCount := Nmes+5;
    for i := 0 to pred(nmes) do begin
           Grid.cells[0,i+1] := floatToStrF(correctionRS.valeurT(i),ffFixed,4,2);
           for j := 1 to NbreSE.value do begin
              if avecTrace then begin
                 setCouleurPoints(j);
                 TraceCroixData(correctionRS.XY[j,i]);
                 if EtiquetteCB.checked then begin
                    texte := intToStr(succ(i));
                    imageCanvas.TextOut(round(correctionRS.XY[j,i].x*pasZoom)+2,
                                        round(correctionRS.XY[j,i].y*pasZoom)+2,
                                        texte);
                 end;
              end;
              Grid.cells[j*2-1,i+1] := correctionRS.strX(j,i);
              Grid.cells[j*2,i+1] := correctionRS.strY(j,i);
           end;// for j
       end; // for i
       for i := nmes+1 to pred(grid.rowCount) do
           for j := 0 to pred(grid.colCount) do
               Grid.cells[j,i] := '';
       if avecTrace then
       for j := 1 to pred(PointCourant) do begin
           TraceCroixData(correctionRS.XY[j,nmes]);
           if etiquetteCB.checked then begin
              texte := intToStr(succ(nmes));
              imageCanvas.TextOut(round(correctionRS.XY[j,nmes].x*pasZoom)+2,
                                  round(correctionRS.XY[j,nmes].y*pasZoom)+2,
                                  texte);
           end;
       end; // for j
    if (zoomUD.Value>1) and (borneSelect<>bsNone) and not(loupeForm.Visible) then begin
       PointEcran := Image.ScreenToClient(Mouse.CursorPos);
       if appartientImage(PointEcran.X,PointEcran.Y) then
          PaintBoxMouseMove(loupeForm.paintBox,[], demiHauteurLoupe, demiHauteurLoupe);
    end;
end; // Dessine

procedure TAviForm.RefreshBtnClick(Sender: TObject);
begin
    PostMessage(Handle,WM_MajAvi,0,0)
end;

procedure TAviForm.MediaPlayerClick(Sender: TObject; Button: TMPBtnType;
  var DoDefault: Boolean);
begin
     MediaPlayer.notify := true;
     if button in [btBack,btStep,btNext,btPrev] then begin
         MediaPlayer.wait := true;
         MediaPlayer.notify := true;
     end;
end;

procedure TAviForm.FormActivate(Sender: TObject);
begin
   if mediaPlayer.FileName<>'' then begin
      MediaPlayer.notify := false;
      mediaPlayer.open;
      suivant;
   end;
end;

procedure TAviForm.FormClose(Sender: TObject; var Action: TCloseAction);
var Fichier : TMemIniFile;
    j : integer;
begin
     if VlcChronoForm<>nil then begin
        VlcChronoForm.close;
        VlcChronoForm.free;
        VlcChronoForm := nil;
     end;
     borneSelect := bsNone;
     aviDrawForm.Visible := false;
     try
     Fichier := TMemIniFile.create(NomFichierIni);
     try
     Fichier.writeInteger(stAVI,'RollingShutter',RollingShutterSE.value);
     Fichier.WriteBool(stAVI,'Etiquette',EtiquetteCB.checked);
     Fichier.writeBool(stAVI,'CorrigeY',corrigeYRSCB.checked);
     Fichier.writeInteger(stAVI,'FilterIndex',OpenDialog.filterIndex);
     Fichier.writeBool(stAVI,'TraceEchelle',traceEchCB.checked);
     Fichier.writeBool(stAVI,'TracePoints',tracePointsCB.checked);
     Fichier.writeInteger(stAVI,'CouleurEchelle',couleurAxeCB.selected);
     for j := 0 to maxPoints do
         Fichier.writeInteger(stAVI,'Couleur'+intToStr(j),Couleur[j]);
     Fichier.writeInteger(stAVI,'Cible',crCibleAvi);
     Fichier.writeBool(stAVI,'Altitude',altitudeCB.checked);
     Fichier.writeInteger(stAVI,'PixelIncert',IncertitudeSE.value);
     Fichier.writeInteger(stAVI,'Loupe',zoomUD.value);
     Fichier.UpdateFile;
     finally
     Fichier.free;
     end;
     except
     end;
     if MediaPlayer.FileName<>'' then begin
        try
        MediaPlayer.wait := true;
        MediaPlayer.stop;
        MediaPlayer.wait := true;
        MediaPlayer.close;
        MediaPlayer.FileName := '';
        except
        end;
     end;
     loupeForm.Hide;
     inherited;
end;

procedure TAviForm.RazAxesBtnClick(Sender: TObject);
var longueur : integer;
begin
     longueur := largeurAff div 4;
     angleX := 0;
     e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+longueur;
     e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y;
     e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x;
     e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*longueur;
     ecranVersImage;
     Dessine;
     //	(sender as TtoolButton).checkMenuDropDown;
end;

procedure TAviForm.FormShow(Sender: TObject);
begin
   if mediaPlayer.FileName<>'' then begin
      aviDrawForm.Visible := true;
      appelRefresh := false;
      postMessage(Handle,WM_MajAvi,0,0);
   end
   else aviDrawForm.Visible := false;
end;

procedure TAviForm.FormDestroy(Sender: TObject);

procedure VideRepertoire;
var info : TSearchRec;
begin
  removeBackSlash(tempDirReg);
  if findFirst(tempDirReg+'\*.*',faAnyFile,Info)=0 then begin
     repeat
         if (Info.attr and faDirectory)<>faDirectory then
            deleteFile(Tpath.combine(tempDirReg,Info.Name));
     until FindNext(Info)<>0;
     FindClose(info);
  end;
end;

begin
     videRepertoire;
     if LoupeForm<>nil then begin
        LoupeForm.close;
        LoupeForm.free;
        LoupeForm := nil;
     end;
     aviForm := nil;
end;

procedure TAviForm.FormHide(Sender: TObject);
begin
    aviDrawForm.Visible := false;
end;

procedure TAviForm.SetCurseur(Acursor : Tcursor);
begin
    if (image.cursor<>Acursor) then begin
       Image.cursor := Acursor;
       if MediaPlayer.fileName<>'' then mediaPlayer.Cursor := ACursor;
       aviDrawForm.PaintBox.cursor := Acursor;
       aviDrawForm.cursor := Acursor;
       screen.Cursor := Acursor;
    end;
    if (aCursor=crDefault) then cacheLoupe;
end;

procedure TAviForm.SaveChronoPhoto;
begin
       BorneSelect := bsNone;
       bitmapFin.saveToFile(nomFichierBmp);
       bitmapFin.free;
       bitmapInit.free;
       image.hint := hClicDroitAvi;
       aviDrawForm.PaintBox.hint := hClicDroitAvi;
       mesureBtn.Down := false;
       setBoutons;
       if ChronoPhotoBtn.down  then begin
          if VlcChronoForm=nil then
             Application.createForm(TVlcChronoForm,VlcChronoForm);
          VlcChronoForm.image1.picture.loadFromFile(NomFichierBmp);
          VlcChronoForm.showModal;
          chronoPhotoBtn.Down := false;
       end;
end;

procedure TAviForm.ChronoPhoto;
var x0,y0 : integer;
    bitmap : TBitmap;
    couleur0,couleurInit : TRGBtriple;
    scanLineC,scanLineInit,scanLineFin : pRGBTripleArray;
    margeY,margeX : integer;
    xAttendu,yAttendu : integer;
    xPrec,yPrec : integer;
    ecartMin : integer;

procedure EnregistrePointChrono;
// on affine autour de i0, j0
var xMin,xMax : integer;
    yMin,yMax : integer;
    xb,yb,x1,y1,x2,y2 : integer;
    ecartCible,ecart : integer;
begin
    margeY := hauteurAff div 24;
    margeX := largeurAff div 24;
    xMin := x0+margeX;
    xMax := x0-margeX;
    yMin := y0+margeY;
    yMax := y0-margeY;
    y1 := yMax;y2 := yMin;
    if y1<0 then y1 := 0;
    if y2>=hauteurAff then y2 := pred(hauteurAff);
    x1 := xMax;x2 := xMin;
    if x1<0 then x1 := 0;
    if x2>=largeurAff then x2 := pred(largeurAff);
    for yb := y1 to y2 do begin
        scanLineC := bitmap.scanLine[yb];
        scanLineInit := bitmapInit.scanLine[yb];
        scanLineFin := bitmapFin.scanLine[yb];
        for xb := x1 to x2 do begin
            couleur0 := scanLineC[xb];
            couleurInit := scanLineInit[xb];
            ecart := abs(integer(couleurInit.rgbtBlue)-integer(couleur0.rgbtBlue))+
                     abs(integer(couleurInit.rgbtGreen)-integer(couleur0.rgbtGreen))+
                     abs(integer(couleurInit.rgbtRed)-integer(couleur0.rgbtRed));
            ecartCible := abs(BlueCibleChrono-integer(couleur0.rgbtBlue))+
                     abs(GreenCibleChrono-integer(couleur0.rgbtGreen))+
                     abs(RedCibleChrono-integer(couleur0.rgbtRed));
            if ecartCible<resolutionAcceptee then
                  scanLineFin[xb] := couleur0;
            if (ecart>resolutionAcceptee) and (ecartCible<ecartMin) then begin
            // diffrent de l'tat initial et proche couleur cible
               if xb<xMin then xMin := xb;
               if yb<yMin then yMin := yb;
               if xb>xMax then xMax := xb;
               if yb>yMax then yMax := yb;
            end;
        end;{i}
    end;{j}
    correctionRS.XY[1,Nmes].x := round((xMin+xMax)/(2*pasZoom));
    correctionRS.XY[1,Nmes].y := round((yMin+yMax)/(2*pasZoom));
    if (Nmes + 3) > grid.rowCount then grid.rowCount := Nmes + 8;
    Grid.cells[0,Nmes+1] := FloatToStrF(correctionRS.valeurT(Nmes),ffFixed,5,2);
    Grid.cells[1,Nmes+1] := correctionRS.strX(1,Nmes);
    Grid.cells[2,Nmes+1] := correctionRS.strY(1,Nmes);
    correctionRS.Temps[Nmes] := tempsCourant;
    inc(Nmes);
end; // EnregistrePointChrono

function chercheFixe : boolean;
var xb,yb : integer;
    ecartCible : integer;
    resolutionCible : integer;
begin
    resolutionCible := resolutionCibleMin;
repeat
    EcartMin := resolutionCible;
    for yb := 0 to pred(hauteurAff) do begin
        scanLineC := bitmap.scanLine[yb];
        for xb := 0 to pred(largeurAff) do
           if ((abs(xb-xPrec)<margeX) and (abs(yb-yPrec)<margeY)) then begin
               couleur0 := scanLineC[xb];
               ecartCible := abs(BlueCibleChrono-integer(couleur0.rgbtBlue))+
                             abs(GreenCibleChrono-integer(couleur0.rgbtGreen))+
                             abs(RedCibleChrono-integer(couleur0.rgbtRed));
               if ecartCible<ecartMin then begin // couleur=couleurCible
                     ecartMin := ecartCible;
                     x0 := xb;y0 := yb;
               end;
        end;{i}
    end;{j}
    result := (x0>0) and (y0>0);
    inc(resolutionCible,pasCouleur);
until result or (resolutionCible>resolutionCibleMax);
end;

function chercheMobile : boolean;
var xb,yb : integer;
    ecartCible,ecart : integer;
    resolutionCible : integer;
begin
resolutionCible := resolutionCibleMin;
repeat
    EcartMin := resolutionCible;
    for yb := 0 to pred(hauteurAff) do begin
        scanLineC := bitmap.scanLine[yb];
        scanLineInit := bitmapInit.scanLine[yb];
        for xb := 0 to pred(largeurAff) do begin
            couleur0 := scanLineC[xb];
            couleurInit := scanLineInit[xb];
            ecart := abs(integer(couleurInit.rgbtBlue)-integer(couleur0.rgbtBlue))+
                     abs(integer(couleurInit.rgbtGreen)-integer(couleur0.rgbtGreen))+
                     abs(integer(couleurInit.rgbtRed)-integer(couleur0.rgbtRed));
            if ecart>ResolutionAcceptee  then begin
                 // On cherche l o il y eu changement
                 if ((abs(xb-xAttendu)<margeX) and (abs(yb-yAttendu)<margeY)) or
                    ((abs(xb-xPrec)<margeX) and (abs(yb-yPrec)<margeY))
                 then begin
                    ecartCible := abs(BlueCibleChrono-integer(couleur0.rgbtBlue))+
                                  abs(GreenCibleChrono-integer(couleur0.rgbtGreen))+
                                  abs(RedCibleChrono-integer(couleur0.rgbtRed));
                    if ecartCible<ecartMin then begin // couleur=couleurCible
                       ecartMin := ecartCible;
                       x0 := xb;y0 := yb;
                    end;
                 end;
            end;
        end;{i}
    end;{j}
    result := (x0>0) and (y0>0);
    inc(resolutionCible,pasCouleur);
until result or (resolutionCible>resolutionCibleMax);
end;

var trouve : boolean;
begin // chronoPhoto
    bitmap := GetBitmapFromDC;
    margeY := hauteurAff div 12;
    margeX := largeurAff div 12;
    x0 := 0;y0 := 0;
    yPrec := correctionRS.XY[1,nmes-1].y;
    xPrec := correctionRS.XY[1,nmes-1].x;
    if nmes>1 then begin // Nouvelle position en supposant la vitesse constante
       yAttendu := 2*correctionRS.XY[1,nmes-1].y-correctionRS.XY[1,nmes-2].y;
       xAttendu := 2*correctionRS.XY[1,nmes-1].x-correctionRS.XY[1,nmes-2].x;
    end
    else begin
       yAttendu := correctionRS.XY[1,0].y;
       xAttendu := correctionRS.XY[1,0].x;
    end;
    yAttendu := round(yAttendu*pasZoom);
    xAttendu := round(xAttendu*pasZoom);
    yPrec := round(yPrec*pasZoom);
    xPrec := round(xPrec*pasZoom);
    trouve := chercheMobile;
    if not trouve then chercheFixe;
    ecartMin := ecartMin+16;
    if trouve then enregistrePointChrono;
    if mediaPlayer.position<pred(mediaPlayer.length)
          then begin
               Application.processMessages;
               if ChronoPhotoBtn.down or
                  (MesureBtn.Down and MesureAutoCB.checked) then begin
                  AppelRefresh := false;
                  Suivant;
               end;
          end
          else saveChronoPhoto;
    bitmap.Free;
end; // ChronoPhoto

Function TAviForm.GetBitmapFromDC : Tbitmap;
var imageDC : HDC;
begin
   result := TBitmap.Create;
   with result do begin
      HandleType := bmDIB;
      pixelFormat := pf24bit;
      Width := largeurAff;
      Height := hauteurAff;
      imageDC := GetDC(image.handle);
      BitBlt(Canvas.Handle,0,0,largeurAff,hauteurAff,imageDC,0,0,SrcCopy);
      releaseDC(image.handle,imageDC);
   end;
end;

procedure TAviForm.ImageClick(Sender: TObject);
begin
     if borneSelect=bsNone then PostMessage(Handle,WM_MajAvi,0,0);
end;

procedure TAviForm.ImageResize(Sender: TObject);
begin
  effectuerZoom;
  PostMessage(Handle,WM_MajAvi,0,0)
end;

procedure TAviForm.InitChronoPhoto;

procedure InitMesure;
var couleurCibleChrono : Tcolor;
    R,G,B : integer;
    i,j : integer;
begin
     PointCourant := 1;
     Nmes := 1;
     Grid.ColCount := 3;
     Grid.cells[1,0] := 'x(m)';
     Grid.cells[2,0] := 'y(m)';
     RedCibleChrono := 0;
     BlueCibleChrono := 0;
     GreenCibleChrono := 0;
     for i := xCibleChrono-1 to xCibleChrono+1 do
          for j := yCibleChrono-1 to yCibleChrono+1 do begin
            CouleurCibleChrono := bitmapInit.canvas.pixels[i,j];
            R := (CouleurCibleChrono and $000000FF);
            B := (CouleurCibleChrono and $0000FF00) shr 8;
            G := (CouleurCibleChrono and $00FF0000) shr 16;
            RedCibleChrono := RedCibleChrono+R;
            BlueCibleChrono := BlueCibleChrono+B;
            GreenCibleChrono := GreenCibleChrono+G;
          end;
     RedCibleChrono := RedCibleChrono div 9;
     BlueCibleChrono := BlueCibleChrono div 9;
     GreenCibleChrono := GreenCibleChrono div 9;
     correctionRS.XY[1,0].x := round(xCibleChrono/pasZoom);
     correctionRS.XY[1,0].y := round(yCibleChrono/pasZoom);
     correctionRS.Temps[0] := tempsCourant;
     setBoutons;
end;

begin
     bitmapInit := getBitmapFromDC;
     bitmapFin := getBitmapFromDC;
     BorneSelect := bsChrono;
     AppelRefresh := false;
     initMesure;
     Suivant;
end; // InitChonoPhoto

procedure TAviForm.JPEG1Click(Sender: TObject);
var jp : TJpegImage;
    nomFichier : string;
begin
  bitmapInit := getBitmapFromDC;
  saveDialog.filter := 'JPEG|*.jpg';
  saveDialog.defaultExt := 'JPG';
  if SaveDialog.execute then begin
        nomFichier := saveDialog.FileName;
        jp := TJpegImage.Create;
        jp.Assign(bitmapInit);
        jp.SaveToFile(SaveDialog.fileName);
        jp.free;
        bitmapInit.free;
   end;
   bitmapInit.free;
end;

procedure TAviForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);

procedure Loupe;
var gainLoupe : integer;
    Xleft,Xright,Ytop,Ybottom : integer;

procedure reperage;
begin
    LoupeForm.PaintBox.canvas.pen.color := couleurAxeCB.selected;
    LoupeForm.PaintBox.canvas.brush.Color := couleurAxeCB.selected;
    LoupeForm.PaintBox.canvas.brush.style := bsSolid;

    LoupeForm.PaintBox.canvas.moveto(0,demiHauteurLoupe);
    LoupeForm.PaintBox.canvas.lineto(LoupeForm.width div 3,demiHauteurLoupe);
    LoupeForm.PaintBox.canvas.moveto(2*LoupeForm.width div 3,demiHauteurLoupe);
    LoupeForm.PaintBox.canvas.lineto(LoupeForm.width,demiHauteurLoupe);

    LoupeForm.PaintBox.canvas.moveto(demiHauteurLoupe,0);
    LoupeForm.PaintBox.canvas.lineto(demiHauteurLoupe,LoupeForm.height div 3);
    LoupeForm.PaintBox.canvas.moveto(demiHauteurLoupe,2*LoupeForm.height div 3);
    LoupeForm.PaintBox.canvas.lineto(demiHauteurLoupe,LoupeForm.height);

    LoupeForm.PaintBox.canvas.FillRect(rect(
       demiHauteurLoupe-1,demiHauteurLoupe-1,
       demiHauteurLoupe+1,demiHauteurLoupe+1));
end;

procedure Efface;
begin
     if (Ybottom>0) or (Ytop>0) or  (Xleft>0) or (Xright>0) then begin
        LoupeForm.PaintBox.canvas.brush.Color := LoupeForm.transparentColorValue;
        LoupeForm.PaintBox.canvas.brush.style := bsSolid;
     end;
     if (Ytop>0) or (ybottom>0) then
        LoupeForm.PaintBox.canvas.FillRect(rect(0,ytop,LoupeForm.width,ybottom));
     if (xleft>0) or (xright>0) then
        LoupeForm.PaintBox.canvas.FillRect(rect(xleft,0,xright,LoupeForm.height));
end;

var
   X1,Y1,X2,Y2 : integer;
   decaleX,decaleY : integer;
   bitmapSource,bitmapDest : Tbitmap;
   aPoint : TPoint;
   demiHauteur : integer;
begin
   image.OnMouseMove := nil;
   loupeForm.paintBox.OnMouseMove := nil; // mise  jour longue ...
   aviDrawForm.paintBox.OnMouseMove := nil;
   gainLoupe := zoomUD.value;
   demiHauteur := LoupeForm.height div gainLoupe div 2;
   demiHauteurLoupe := LoupeForm.height div 2;
   X1 := X-demiHauteur;
   Y1 := Y-demiHauteur;
   X2 := X+demiHauteur;
   Y2 := Y+demiHauteur;
   Xleft := 0;Xright := 0;
   Ytop := 0;Ybottom := 0;
   decaleX := 0;decaleY := 0;
   if Y1<0 then begin
      Ybottom := -Y1*gainLoupe;
      Y1 := 0;
      decaleY := Ybottom;
   end;
   if X1<0 then begin
      Xright := -X1*gainLoupe;
      X1 := 0;
      decaleX := Xright;
   end;
   if Y2>hauteurAff then begin
      Ybottom := loupeForm.Height;
      Ytop := loupeForm.Height-(Y2-hauteurAff)*gainLoupe;
      Y2 := hauteurAff;
   end;
   if X2>largeurAff then begin
      Xright := loupeForm.width;
      Xleft := loupeForm.width-(X2-largeurAff)*gainLoupe;
      X2 := largeurAff;
   end;
   bitmapSource := getBitmapFromDC;
   bitmapDest := Tbitmap.Create;
   bitmapDest.Width := (X2-X1);
   bitmapDest.Height := (Y2-Y1);
   bitmapDest.canvas.CopyRect(rect(0,0,X2-X1,Y2-Y1),
            bitmapSource.canvas, rect(X1,Y1,X2,Y2));
   aPoint := image.clientToScreen(Point(x,y));
   LoupeForm.Left := aPoint.X-demiHauteurLoupe;
   LoupeForm.Top := aPoint.Y-demiHauteurLoupe;
   LoupeForm.paintBox.canvas.StretchDraw(
             rect(decaleX,decaleY,
                  decaleX+(X2-X1)*gainLoupe,
                  decaleY+(Y2-Y1)*gainLoupe),bitmapDest);
   Reperage;
   Efface;
   image.OnMouseMove := paintBoxMouseMove;
   loupeForm.paintBox.OnMouseMove := paintBoxMouseMove;
   aviDrawForm.paintBox.OnMouseMove := paintBoxMouseMove;
   bitmapDest.Free;
   bitmapSource.Free;
   if not loupeForm.visible then loupeForm.show;
end; // loupe

var BS : TstyleDrag;
begin  // MouseMove
convertitXY(sender,x,y);
if not appartientImage(x,y) then begin
   cacheLoupe;
   exit;
end;
if chronoPhotoBtn.Down then exit;
old_pointRepere := e_pointRepere;
e_pointRepere[BorneSelect].x := x;
e_pointRepere[BorneSelect].y := y;
corrigeAxes;
ecranVersImage;
case BorneSelect of
     bsEchelle1,bsEchelle2 : begin
         imageCanvas.pen.mode := pmNOTXOR;
         traceLigne(old_PointRepere[bsEchelle1],old_PointRepere[bsEchelle2]); // efface
         traceLigne(e_PointRepere[bsEchelle1],e_PointRepere[bsEchelle2]); // retrace
         imageCanvas.pen.mode := pmCOPY;
     end;
     bsAxeX,bsAxeY,bsOrigine : begin
         traceOrigine(true); // efface
         traceOrigine(false); // retrace
     end;
     bsChronoInit :;
     bsMesure : ;
     bsNone : begin
           image.hint := '';
           BS := GetBorne(x,y,false);
           case BS of
              bsOrigine : setCurseur(crOrigine);
              bsNone : setCurseur(crDefault)
              else setCurseur(crCibleMove);
           end;
           case BS of
               bsOrigine : image.hint := hOrigineMove;
               bsEchelle2 : image.hint := hEchelle2Move;
               bsEchelle1 : image.hint := hEchelle1Move;
               bsAxeX : image.hint := hAxeX;
               bsAxeY : image.hint := hAxeY;
               else image.hint := hClicDroitAvi;
           end;
           Status.panels[2].Text := image.hint;
           aviDrawForm.PaintBox.hint := image.hint;
           exit;
     end;
end;
if (zoomUD.value>1) and (borneSelect in [bsEchelle1,bsEchelle2,bsOrigine,bsMesure,bsChronoInit])
     then loupe
     else cacheLoupe;
end;  // mouseMove

procedure TAviForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    convertitXY(sender,x,y);
    if (Button<>mbLeft) or not appartientImage(x,y) then exit;
    Image.hint := '';
    if borneSelect=bsNone then begin
      BorneSelect := GetBorne(x,y,true);
      case BorneSelect of
           bsNone : setCurseur(crDefault);
           bsOrigine : setCurseur(crOrigine);
           else setCurseur(crCibleMove);
      end;
      case BorneSelect of
           bsOrigine : image.hint := hOrigineMove;
           bsEchelle2 : image.hint := hEchelle2Move;
           bsEchelle1 : image.hint := hEchelle1Move;
           bsAxeX : hint := hAxeX;
           bsAxeY : hint := hAxeY;
           else image.hint := hClicDroitAvi;
      end;
      aviDrawForm.PaintBox.hint := image.hint;
      Status.Panels[2].Text := image.hint;
    end;
    e_pointRepere[BorneSelect].x := x;
    e_pointRepere[BorneSelect].y := y;
    ecranVersImage;
end;

procedure TAviForm.Bitmap1Click(Sender: TObject);
begin
    bitmapInit := getBitmapFromDC;
    saveDialog.filter := 'bitmap|*.bmp';
    saveDialog.defaultExt := 'BMP';
    if saveDialog.Execute then begin
         nomFichierBmp := saveDialog.FileName;
         bitmapInit.saveToFile(nomFichierBmp);
         if VlcChronoForm=nil then
            Application.createForm(TVlcChronoForm,VlcChronoForm);
         VlcChronoForm.image1.picture.loadFromFile(NomFichierBmp);
         VlcChronoForm.showModal;
    end;
    bitmapInit.free;
end;

procedure TAviForm.calcEchelle;
var EchelleEnPixel : double;
    i : integer;
begin
     if MediaPlayer.FileName='' then exit;
     if not OrigineMobileCB.checked then
          for i := 0 to MaxVecteurVideo do
              correctionRS.xy[0,i] := pointRepere[bsOrigine];
     echelleEnPixel := sqrt(sqr(PointRepere[bsEchelle1].x-PointRepere[bsechelle2].x)+
                            sqr(PointRepere[bsEchelle1].y-PointRepere[bsechelle2].y));
     correctionRS.Echelle := LongueurEchelle/EchelleEnPixel;
     if altitudeCB.checked
        then signeY := -1
        else signeY := 1
end;

procedure TAviForm.EchelleEditExit(Sender: TObject);
begin
     try
         LongueurEchelle := StrToFloatWin(EchelleEdit.text);
         calcEchelle;
      except
         showMessage(erEchelle);
         EchelleEdit.text := FormatReg(LongueurEchelle)+'m';
      end;
end;

procedure TAviForm.Suivant;
begin
  if MediaPlayer.fileName='' then exit;
  MediaPlayer.notify := true;
  MediaPlayer.wait := true;
  MediaPlayer.DisplayRect := rect(0,0,largeurAff,hauteurAff);
  if loupeForm.Visible
     then TrackBar.Position := TrackBar.Position+1
     else MediaPlayer.Step;
end;


procedure TAviForm.Precedent;
begin
  if MediaPlayer.fileName='' then exit;
  MediaPlayer.notify := true;
  MediaPlayer.wait := true;
  MediaPlayer.DisplayRect := rect(0,0,largeurAff,hauteurAff);
  if loupeForm.Visible
     then TrackBar.Position := TrackBar.Position-1
     else MediaPlayer.Back;
end;

procedure TAviForm.CurseurClick(Sender: TObject);
var Amenu : TmenuItem;
begin
     Amenu := TmenuItem(sender);
     if Amenu.tag=0
        then crCibleAvi := crCross
        else crCibleAvi := Amenu.tag;
     Amenu.checked := true;
     if BorneSelect=bsMesure then setCurseur(crCibleAvi);
     PostMessage(Handle,WM_MajAvi,0,0);
end;

procedure TAviForm.ChronoPhotoBtnClick(Sender: TObject);
var PointM : TPoint;
begin
  if ChronoPhotoBtn.Down
    then begin
    saveDialog.filter := 'bitmap|*.bmp';
    saveDialog.defaultExt := 'BMP';
    if saveDialog.Execute
       then begin
         nomFichierBmp := saveDialog.FileName;
         if mesureAutoCB.Checked
            then begin
                 BorneSelect := bsChronoInit;
                 if NbreSE.value>1 then showMessage('');
                 NbreSE.value := 1;
                 image.hint := hCibleAuto;
                 aviDrawForm.PaintBox.hint := hCibleAuto;
                 setCurseur(crCibleAvi);
                 PointM.x := largeurAff div 4;
                 PointM.y := hauteurAff div 4;
                 PointM := image.ClientToScreen(PointM);
                 showMessagePos(trCibleAuto,PointM.X,PointM.y);
            end
            else begin
               setCurseur(crHandPoint);
               BorneSelect := bsChronoInit;
            end;
         PostMessage(Handle,WM_MajAvi,0,0);
       end
       else begin
           PostMessage(Handle,WM_MajAvi,0,0);
           ChronoPhotoBtn.Down := false
       end
    end
    else case borneSelect of
         bsChronoInit : borneSelect := bsNone;
         bsChrono : saveChronoPhoto;
         else
    end;
end;

procedure TAviForm.WMMajAvi(var Message: Tmessage);
begin
     if (MediaPlayer.FileName='') or appelRefresh
       then exit; // pas de donnes ou play en cours
     AppelRefresh := true;
     if application.active then EditBidon.setFocus;
// pour rcuprer flches du clavier non interprtes par un autre control
     AvanceRefresh := mediaPlayer.position>(mediaPlayer.length div 2);
     if AvanceRefresh
         then Precedent
         else Suivant;
end;

procedure TAviForm.zoomUDChange(Sender: TObject);
begin
  if zoomUD.value=1 then cacheLoupe;
end;

procedure TAviForm.GridKeyPress(Sender: TObject; var Key: Char);
begin
   key := #0
end;

procedure TAviForm.StopBtnClick(Sender: TObject);
begin
    arretConversionVideo := true;
end;

procedure TAviForm.CouleurPointsCBChange(Sender: TObject);
begin
   couleur[pointCourant] := couleurPointsCB.selected;
   aviDrawForm.paintBox.repaint;
end;

procedure TAviForm.NbreImagesSEChange(Sender: TObject);
var i : integer;
begin
    if MediaPlayer.fileName='' then exit;
    if NbreImagesSE.value<>NbreImagesParSec then
  // donnes temporelles fausses donc on compte
         MediaPlayer.TimeFormat := tfFrames;
    DureeImage := 1/NbreImagesSE.value;
    if MediaPlayer.TimeFormat=tfFrames then begin
         for i := 0 to pred(nmes) do begin
             correctionRS.temps[i] := i*dureeImage;
             Grid.cells[0,i+1] := correctionRS.strT(i);
         end;
         tempsCourant := nmes*dureeImage;
         correctionRS.temps[nmes] := tempsCourant;
    end;
end;

procedure TAviForm.NbreSEChange(Sender: TObject);
begin
    corrigeYRSCB.Visible := (NbreSE.value>1) and (rollingShutterSE.value>0);
end;

Function TAviForm.CouleurGrid(Acol : integer) : Tcolor;
begin
    if Acol=0
       then result := clBlack
       else begin
            Acol := (Acol+1) div 2;
            result := couleur[Acol];
            case result of
               clMaroon: ;
               clGreen: ;
               clOlive: ;
               clNavy: ;
               clPurple: ;
               clTeal: ;
               clGray: ;
               clBlue: ;
               clFuchsia: ;
               clRed: ;
               clLime,clMoneyGreen: Result := clGreen;
               clAqua,clSkyBlue: Result := clBlue;
               clMedGray: Result := clGray;
               else Result := clBlack;
            end; // case
       end;
end;

procedure TAviForm.GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var s : String;
begin
        TstringGrid(sender).canvas.Font.Color := couleurGrid(Acol);
        S := TstringGrid(sender).cells[Acol,Arow];
        with TstringGrid(sender).canvas do
             TextOut(Rect.Left + 2, Rect.Top + 2,S);
end;

procedure TAviForm.DureeEditExit(Sender: TObject);
var i : integer;
begin
         try
         DureeImage := StrToFloatWin(DureeEdit.text);
         if isNan(DureeImage) then begin
            dureeImage := 1/30;
            DureeEdit.text := FormatReg(DureeImage)+'s';
         end;
         if MediaPlayer.fileName='' then exit;
      // donnes temporelles fausses donc on compte
         MediaPlayer.TimeFormat := tfFrames;
         for i := 0 to pred(nmes) do begin
             correctionRS.temps[i] := i*dureeImage;
             Grid.cells[0,i+1] := floatToStrPoint(correctionRS.valeurT(i));
         end;
         tempsCourant := nmes*dureeImage;
         correctionRS.temps[nmes] := tempsCourant;
         except
             DureeEdit.text := FormatReg(DureeImage)+'s';
         end;
end;

procedure TAviForm.DureeEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=ord(crCR) then DureeEditExit(sender)
end;

procedure TAviForm.CouleurAxeCBChange(Sender: TObject);
begin
     aviDrawForm.paintBox.repaint
end;

procedure TAviForm.HelpBtnClick(Sender: TObject);
begin
     Application.helpContext(HELP_MediaPlayer);
end;

procedure TAviForm.TrackBarChange(Sender: TObject);
begin
    if (MediaPlayer.FileName<>'') and
        not AppelRefresh and
       (MediaPlayer.position<>TrackBar.Position) and
       (TrackBar.tag=0) then begin
       try
       MediaPlayer.wait := true;
       MediaPlayer.notify := true;
       MediaPlayer.position := TrackBar.Position;
       except
       end;
    end;   
end;

procedure TAviForm.RazBtnClick(Sender: TObject);
begin
     if MessageDlg('Suppression des donnes',mtConfirmation,[mbYes,mbNo],0)=mrYes then begin
         Nmes := 0;
         setBoutons;
         postMessage(Handle,WM_MajAvi,0,0);
     end;
end;

Function TAviForm.GetBorne(x,y : integer;deplace : boolean) : TstyleDrag;
var i : TstyleDrag;
    aPoint : TPoint;
    a,d : double;
begin
      result := bsNone;
      aPoint := Point(x,y);
      for i in [bsOrigine,bsEchelle1,bsEchelle2,bsaxeX,bsaxeY] do
          if e_PointRepere[i].distance(aPoint) < Magnet
              then begin
                 result := i;
                 exit;
              end;
      if result=bsNone then begin
         d := e_PointRepere[bsOrigine].distance(aPoint);
         if d<100 then exit;
         a := arcTan2(aPoint.y-e_PointRepere[bsOrigine].y,
                      aPoint.x-e_PointRepere[bsOrigine].x);
         if (abs(angleX-a)<0.02)
         then begin
             if deplace then begin
                e_PointRepere[bsAxeX] := aPoint;
                ecranVersImage;
             end;
             result := bsAxeX;
         end
         else if (abs(angleX+signeY*pi/2-a)<0.02) then begin
             if deplace then begin
                e_PointRepere[bsAxeY] := aPoint;
                ecranVersImage;
             end;
             result := bsAxeY;
         end;
      end;
end;

procedure TAviForm.altitudeCBClick(Sender: TObject);
var i,j : integer;
begin
    if nomFichier<>'' then begin
       if altitudeCB.checked
          then signeY := -1
          else signeY := 1;
       e_pointRepere[bsAxeY].x := 2*e_pointRepere[bsOrigine].x-e_pointRepere[bsAxeY].x;
       e_pointRepere[bsAxeY].y := 2*e_pointRepere[bsOrigine].y-e_pointRepere[bsAxeY].y;
       for i := 0 to pred(nmes) do
           for j := 1 to NbreSE.value do
              Grid.cells[j*2,i+1] := correctionRS.strY(j,i);
       aviDrawForm.paintBox.repaint
    end;
end;

function TAviForm.AppartientImage(X, Y: Integer) : boolean;
begin
    result := (x>0) and (y>0) and (x<largeurAff) and (y<hauteurAff)
end;

procedure TAviForm.CacheLoupe;
begin
     if loupeForm.visible then begin
        loupeForm.hide;
        setFocus;
     end;
end;

procedure TAviForm.EcranVersImage;
    var i : TstyleDrag;
    begin
       for i := low(TstyleDrag) to High(TstyleDrag) do begin
           pointRepere[i].x := round(e_pointRepere[i].x/pasZoom);
           pointRepere[i].y := round(e_pointRepere[i].y/pasZoom);
       end;
    end;

procedure TAviForm.ConvertitXY(sender : TObject;var X,Y : integer);
var PointImage,PointLoupe : TPoint;
begin
    if (sender=LoupeForm.paintBox) then begin
        PointImage := image.ClientToScreen(Point(0,0));
        PointLoupe := LoupeForm.ClientToScreen(Point(0,0));
        x := x+pointLoupe.X-PointImage.X;
        y := y+pointLoupe.Y-PointImage.Y;
    end;
end;

procedure TAviForm.ConvertitCibleXY(sender : TObject;var X,Y : integer);
var PointImage,PointLoupe : TPoint;
begin
    if (sender=LoupeForm.paintBox) then begin
        PointImage := image.ClientToScreen(Point(0,0));
        PointLoupe := LoupeForm.ClientToScreen(Point(0,0));
        x := demiHauteurLoupe+pointLoupe.X-PointImage.X;
        y := demiHauteurLoupe+pointLoupe.Y-PointImage.Y;
    end;
end;

 procedure TAviForm.CorrigeAxes;
  var angleLoc : double;
      longueur : integer;
  begin  // Angle est l'angle informatique Y vers le bas donc positif=sens horaire
     if borneSelect=bsAxeX then begin // rendre les axes perpendiculaires
           angleLoc := arcTan2(e_pointRepere[bsAxeX].y-e_pointRepere[bsOrigine].y,
                               e_pointRepere[bsAxeX].x-e_pointRepere[bsOrigine].x);
           longueur := round(e_pointRepere[bsAxeY].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x-signeY*round(longueur*sin(angleLoc));
           e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*round(longueur*cos(angleLoc));
      end;
      if borneSelect=bsAxeY then begin // rendre les axes perpendiculaires
           angleLoc := arcTan2(signeY*(-e_pointRepere[bsAxeY].x+e_pointRepere[bsOrigine].x),
                               signeY*(e_pointRepere[bsAxeY].y-e_pointRepere[bsOrigine].y));
           longueur := round(e_pointRepere[bsAxeX].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+round(longueur*cos(angleLoc));
           e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y+round(longueur*sin(angleLoc));
      end;
      if borneSelect=bsOrigine then begin // ne pas changer l'angle
           longueur := round(e_pointRepere[bsAxeX].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeX].x := e_pointRepere[bsOrigine].x+round(longueur*cos(angleX));
           e_pointRepere[bsAxeX].y := e_pointRepere[bsOrigine].y+round(longueur*sin(angleX));
           longueur := round(e_pointRepere[bsAxeY].Distance(e_pointRepere[bsOrigine]));
           e_pointRepere[bsAxeY].x := e_pointRepere[bsOrigine].x-signeY*round(longueur*sin(angleX));
           e_pointRepere[bsAxeY].y := e_pointRepere[bsOrigine].y+signeY*round(longueur*cos(angleX));
      end;
  end;

Procedure TAviForm.TraceOrigine(old : boolean);
var P : TarrayPoint;

procedure TraceFleche(angle : double);
    var
      PC: TPoint; // centre de la base de la flche
      deltaX, deltaY: integer;
      Points:  array[0..2] of Tpoint; // Flche
      PE : TPoint; // extrmit de l'axe
      rayon,hauteur : integer;
    begin
       rayon := hauteurAff div 2;
       hauteur := screen.Width div 128;
       PE := P[bsOrigine];
       deltaX := round(rayon*cos(angle));
       deltaY := round(rayon*sin(angle));
       PE.offset(deltaX,deltaY);
       TraceLigne(P[bsOrigine],PE);
       deltaX := round(hauteur*cos(angle));
       deltaY := round(hauteur*sin(angle));
       PC := PE;
       PC.Offset(-deltaX,-deltaY);
       deltaX := deltaX div 3;
       deltaY := deltaY div 3;
       Points[0] := PE;
       PC.offset(-deltaY,+deltaX);
       Points[1] := PC;
       PC.offset(+2*deltaY,-2*deltaX);
       Points[2] := PC;
       imageCanvas.Polygon(Points);
    end;

begin // traceOrigine
         imageCanvas.pen.color := couleurAxeCB.selected;
         imageCanvas.pen.mode := pmNOTXOR;
         if old then P := old_PointRepere else P := e_PointRepere;
         angleX := arcTan2(P[bsAxeX].y-P[bsOrigine].y,
                           P[bsAxeX].x-P[bsOrigine].x);
         TraceFleche(angleX);
         imageCanvas.Rectangle(P[bsAxeX].X-(magnet div 2),P[bsAxeX].Y-(magnet div 2),
                               P[bsAxeX].X+(magnet div 2),P[bsAxeX].Y+(magnet div 2));
         TraceFleche(angleX+signeY*pi/2);
         imageCanvas.Rectangle(P[bsAxeY].X-(magnet div 2),P[bsAxeY].Y-(magnet div 2),
                               P[bsAxeY].X+(magnet div 2),P[bsAxeY].Y+(magnet div 2));
         imageCanvas.pen.mode := pmCOPY;
end;

Procedure TAviForm.TraceLigne(P1,P2 : Tpoint);
begin
      with P1 do
          imageCanvas.moveto(x,y);
      with P2 do
          imageCanvas.lineto(x,y);
end;

end.

