unit stayontopU;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  math, grapheU;

type
  TDrawForm = class(TForm)
    PaintBox: TPaintBox;
    procedure PaintBoxPaint(Sender: TObject);
  private
    Procedure Efface;
  public
    zoom : double;
    Procedure Dessine;
  end;

var
  DrawForm: TDrawForm;

implementation

{$R *.dfm}

uses VclMain;


procedure TDrawForm.PaintBoxPaint(Sender: TObject);
begin
     if vclForm.nomFichier<>''
        then Dessine
        else Efface;
end;

procedure TDrawForm.Efface;
begin
     PaintBox.canvas.brush.Color := transparentColorValue;
     PaintBox.canvas.brush.style := bsSolid;
     with PaintBox.clientRect do
          PaintBox.canvas.FillRect(rect(left,top,right,bottom));
end;

Procedure TDrawForm.Dessine;

// Correction de zoom dans TraceLigne

Procedure TraceLigne(x1,y1,x2,y2 : integer);
begin
      PaintBox.canvas.moveto(round(x1*Zoom),round(y1*Zoom));
      PaintBox.canvas.lineto(round(x2*Zoom),round(y2*Zoom));
end;

Procedure TraceRepere(Apoint : TPoint);
begin with Apoint do begin
         PaintBox.canvas.pen.Color := vclForm.couleurAxeCB.selected;
{axe X}
         TraceLigne(x-4*Magnet,y,x+4*Magnet,y);
{flche X}
         TraceLigne(x+2*Magnet,y+2,x+4*Magnet,y);
         TraceLigne(x+2*Magnet,y-2,x+4*Magnet,y);
{axe Y}
         TraceLigne(x,y-4*Magnet,x,y+4*Magnet);
{flche Y}
         if vclForm.altitudeCB.checked
            then begin
                traceLigne(x-2,y-2*Magnet,x,y-4*Magnet);
                traceLigne(x+2,y-2*Magnet,x,y-4*Magnet);
            end
            else begin
                traceLigne(x-2,y+2*Magnet,x,y+4*Magnet);
                traceLigne(x+2,y+2*Magnet,x,y+4*Magnet);
            end
end end;

Procedure TraceCroix(Apoint : Tpoint);
begin
      traceLigne(Apoint.x-Magnet,Apoint.y,Apoint.x+Magnet,Apoint.y);
      traceLigne(Apoint.x,Apoint.y-Magnet,Apoint.x,Apoint.y+Magnet);
end;

Procedure TraceOrigine;
var xmax,ymax : integer;
begin with vclForm.PointRepere[bsOrigine] do begin
         xmax := round(width/Zoom)-2;
         ymax := round(height/Zoom)-2;
         PaintBox.canvas.pen.Color := vclForm.couleurAxeCB.selected;
// axes
         TraceLigne(x,0,x,xmax);
         TraceLigne(0,y,xmax,y);
// flche X
         TraceLigne(xmax-3*Magnet,y+3,xmax,y);
         TraceLigne(xmax-3*Magnet,y-3,xmax,y);
// flche Y
         if vclForm.altitudeCB.checked
            then begin
                traceLigne(x-3,3*Magnet,x,0);
                traceLigne(x+3,3*Magnet,x,0);
            end
            else begin
                traceLigne(x-3,ymax-3*Magnet,x,ymax);
                traceLigne(x+3,ymax-3*Magnet,x,ymax);
            end
end end;

Procedure TraceEchelle;
var angle : integer;
begin
      TraceLigne(vclForm.PointRepere[bsEchelle1].x,
         vclForm.PointRepere[bsEchelle1].y,
         vclForm.PointRepere[bsechelle2].x,
         vclForm.PointRepere[bsEchelle2].y);
      TraceCroix(vclForm.PointRepere[bsEchelle1]);
      TraceCroix(vclForm.PointRepere[bsechelle2]);
      angle := round(arcTan2(vclForm.PointRepere[bsEchelle2].Y-vclForm.PointRepere[bsEchelle1].Y,
                             vclForm.PointRepere[bsEchelle1].X-vclForm.PointRepere[bsEchelle2].X)*180/system.pi);
      if angle>90 then angle := angle-180;
      if angle<-90 then angle := angle+180;
      PaintBox.Canvas.Brush.Style := bsClear; // Set the brush style to transparent.
      PaintBox.Canvas.font.orientation := angle*10;
      PaintBox.canvas.font.size := 12;
      PaintBox.canvas.font.color := vclForm.couleur[0];
      PaintBox.Canvas.TextOut(
                     round((vclForm.PointRepere[bsEchelle1].X+vclForm.PointRepere[bsEchelle2].X)*zoom) div 2,
                     round((vclForm.PointRepere[bsEchelle1].Y+vclForm.PointRepere[bsEchelle2].Y)*zoom) div 2,
                     vclForm.echelleEDit.text+' m');
      PaintBox.Canvas.font.orientation := 0;
      PaintBox.canvas.font.size := 8;
end;

var i,j,jmax : integer;
    texte : string;
begin // Dessine
    Efface;
    vclForm.calcEchelle;
    jmax := vclForm.NbreSE.value;
    if vclForm.traceEchCB.checked then begin
       if vclForm.couleurAxeCB.selected=TransparentColorValue then
          vclForm.couleurAxeCB.selected := clBlack;
       PaintBox.canvas.pen.color := vclForm.couleurAxeCB.selected;
       if vclForm.OrigineMobileCB.checked
          then begin
              for i := 0 to pred(vclForm.nmes) do TraceRepere(vclForm.XY[0,i]);
              if vclForm.PointCourant>0 then TraceRepere(vclForm.XY[0,vclForm.nmes]);
          end
          else TraceOrigine;
       TraceEchelle;
    end;
    for j := 1 to vclForm.NbreSE.value do
        if vclForm.couleur[j]=TransparentColorValue then
           vclForm.couleur[j] := clBlack;
    for i := 0 to pred(vclForm.nmes) do begin
           for j := 1 to jmax do begin
              if vclForm.tracePointsCB.checked then begin
                 PaintBox.canvas.pen.color := vclForm.couleur[j];
                 PaintBox.canvas.Font.Color := vclForm.couleur[j];
                 TraceCroix(vclForm.XY[j,i]);
                 if vclForm.EtiquetteCB.checked then begin
                    texte := intToStr(succ(i));
                    if jmax>1 then texte := intToStr(j)+'-'+texte;
                    PaintBox.canvas.TextOut(round(vclForm.XY[j,i].x*Zoom)+2,
                                            round(vclForm.XY[j,i].y*Zoom)+2,
                                            texte);
                 end;
              end;
           end;{j}
       end; {i}
       if vclForm.tracePointsCB.checked then
       for j := 1 to pred(vclForm.PointCourant) do begin
           TraceCroix(vclForm.XY[j,vclForm.nmes]);
           if vclForm.etiquetteCB.checked then begin
              PaintBox.canvas.pen.color := vclForm.couleur[j];
              PaintBox.canvas.Font.Color := vclForm.couleur[j];
              texte := intToStr(succ(vclForm.nmes));
              if jmax>1 then texte := intToStr(j)+'-'+texte;
              PaintBox.canvas.TextOut(round(vclForm.XY[j,vclForm.nmes].x*Zoom)+2,
                                      round(vclForm.XY[j,vclForm.nmes].y*Zoom)+2,
                                      texte);
           end;
       end;// j
end; // Dessine

end.
