unit stayontopVcl;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  math, grapheU, RollingShutterCalc;

type
  TVclDrawForm = class(TForm)
    PaintBox: TPaintBox;
    procedure PaintBoxPaint(Sender: TObject);
  private
    zoom : double;
    Procedure Efface;
  public
    Procedure Dessine;
  end;

var
  VclDrawForm: TVclDrawForm;

implementation

{$R *.dfm}

uses VclMain;


procedure TVclDrawForm.PaintBoxPaint(Sender: TObject);
begin
     if vclForm.nomFichierVLC<>''
        then Dessine
        else Efface;
end;

procedure TVclDrawForm.Efface;
begin
     PaintBox.canvas.brush.Color := transparentColorValue;
     PaintBox.canvas.brush.style := bsSolid;
     with PaintBox.clientRect do
          PaintBox.canvas.FillRect(rect(left,top,right,bottom));
end;

Procedure TVclDrawForm.Dessine;
var magnetVLC : integer;

// Correction de zoom dans TraceLigne

Procedure TraceLigne(x1,y1,x2,y2 : integer);
begin
      PaintBox.canvas.moveto(round(x1*Zoom),round(y1*Zoom));
      PaintBox.canvas.lineto(round(x2*Zoom),round(y2*Zoom));
end;

Procedure TraceRepere(Apoint : TPoint);
begin with Apoint do begin
         PaintBox.canvas.pen.Color := vclForm.couleurAxeCB.selected;
{axe X}
         TraceLigne(x-4*MagnetVLC,y,x+4*MagnetVLC,y);
{flche X}
         TraceLigne(x+2*MagnetVLC,y+2,x+4*MagnetVLC,y);
         TraceLigne(x+2*MagnetVLC,y-2,x+4*MagnetVLC,y);
{axe Y}
         TraceLigne(x,y-4*MagnetVLC,x,y+4*MagnetVLC);
{flche Y}
         if vclForm.altitudeCB.checked
            then begin
                traceLigne(x-2,y-2*MagnetVLC,x,y-4*MagnetVLC);
                traceLigne(x+2,y-2*MagnetVLC,x,y-4*MagnetVLC);
            end
            else begin
                traceLigne(x-2,y+2*MagnetVLC,x,y+4*MagnetVLC);
                traceLigne(x+2,y+2*MagnetVLC,x,y+4*MagnetVLC);
            end
end end;

Procedure TraceCroix(Apoint : Tpoint);
begin
    traceLigne(Apoint.x-MagnetVLC,Apoint.y,Apoint.x+MagnetVLC,Apoint.y);
    traceLigne(Apoint.x,Apoint.y-MagnetVLC,Apoint.x,Apoint.y+MagnetVLC);
end;

Procedure TraceLigneP(P1,P2 : Tpoint);
begin
      with P1 do
           VcldrawForm.PaintBox.canvas.moveto(x,y);
      with P2 do
           VcldrawForm.PaintBox.canvas.lineto(x,y);
end;


Procedure TraceOrigine;
var P : TarrayPoint;

procedure TraceFleche(angle : double);
    var
      PC: TPoint; // centre de la base de la flche
      deltaX, deltaY: integer;
      Points:  array[0..2] of Tpoint; // Flche
      PE : TPoint; // extrmit de l'axe
      rayon,hauteur : integer;
    begin
       rayon := height div 2;
       hauteur := screen.Width div 128;
       PE := P[bsOrigine];
       deltaX := round(rayon*cos(angle));
       deltaY := round(rayon*sin(angle));
       PE.offset(deltaX,deltaY);
       TraceLigneP(P[bsOrigine],PE);
       deltaX := round(hauteur*cos(angle));
       deltaY := round(hauteur*sin(angle));
       PC := PE;
       PC.Offset(-deltaX,-deltaY);
       deltaX := deltaX div 3;
       deltaY := deltaY div 3;
       Points[0] := PE;
       PC.offset(-deltaY,+deltaX);
       Points[1] := PC;
       PC.offset(+2*deltaY,-2*deltaX);
       Points[2] := PC;
       PaintBox.canvas.Polygon(Points);
    end;

begin // traceOrigine
         PaintBox.canvas.pen.color := vclForm.couleurAxeCB.selected;
         P := vclForm.e_PointRepere;
         vclForm.angleX := arcTan2(P[bsAxeX].y-P[bsOrigine].y,
                                   P[bsAxeX].x-P[bsOrigine].x);
         TraceFleche(vclForm.angleX);
         PaintBox.canvas.Rectangle(P[bsAxeX].X-(magnet div 2),P[bsAxeX].Y-(magnet div 2),
                                   P[bsAxeX].X+(magnet div 2),P[bsAxeX].Y+(magnet div 2));
         TraceFleche(vclForm.angleX+vclForm.signeY*pi/2);
         PaintBox.canvas.Rectangle(P[bsAxeY].X-(magnet div 2),P[bsAxeY].Y-(magnet div 2),
                                   P[bsAxeY].X+(magnet div 2),P[bsAxeY].Y+(magnet div 2));
end;


Procedure TraceEchelle;
var angle : integer;
begin
      TraceLigne(vclForm.PointRepere[bsEchelle1].x,
         vclForm.PointRepere[bsEchelle1].y,
         vclForm.PointRepere[bsechelle2].x,
         vclForm.PointRepere[bsEchelle2].y);
      TraceCroix(vclForm.PointRepere[bsEchelle1]);
      TraceCroix(vclForm.PointRepere[bsechelle2]);
      angle := round(arcTan2(vclForm.PointRepere[bsEchelle2].Y-vclForm.PointRepere[bsEchelle1].Y,
                             vclForm.PointRepere[bsEchelle1].X-vclForm.PointRepere[bsEchelle2].X)*180/system.pi);
      if angle>90 then angle := angle-180;
      if angle<-90 then angle := angle+180;
      PaintBox.Canvas.Brush.Style := bsClear; // Set the brush style to transparent.
      PaintBox.Canvas.font.orientation := angle*10;
      PaintBox.canvas.font.size := 12;
      PaintBox.canvas.font.color := vclForm.couleur[0];
      PaintBox.Canvas.TextOut(
                     round((vclForm.PointRepere[bsEchelle1].X+vclForm.PointRepere[bsEchelle2].X)*zoom) div 2,
                     round((vclForm.PointRepere[bsEchelle1].Y+vclForm.PointRepere[bsEchelle2].Y)*zoom) div 2,
                     vclForm.echelleEDit.text+' m');
      PaintBox.Canvas.font.orientation := 0;
      PaintBox.canvas.font.size := 8;
end;

var i,j,jmax : integer;
    texte : string;
begin // Dessine
    Efface;
    vclForm.calcEchelle;
    zoom := vclForm.pasZoom;
    magnetVLC := round(magnet/zoom);
    if magnetVLC<1 then magnetVLC := 1;
    magnetVLC := 1;
    jmax := vclForm.NbreSE.value;
    if vclForm.traceEchCB.checked then begin
       if vclForm.couleurAxeCB.selected=TransparentColorValue then
          vclForm.couleurAxeCB.selected := clBlack;
       PaintBox.canvas.pen.color := vclForm.couleurAxeCB.selected;
       if vclForm.OrigineMobileCB.checked
          then begin
              for i := 0 to pred(vclForm.nmes) do TraceRepere(correctionRS.XY[0,i]);
              if vclForm.PointCourant>0 then TraceRepere(correctionRS.XY[0,vclForm.nmes]);
          end
          else TraceOrigine;
       TraceEchelle;
    end;
    for j := 1 to vclForm.NbreSE.value do
        if vclForm.couleur[j]=TransparentColorValue then
           vclForm.couleur[j] := clBlack;
    for i := 0 to pred(vclForm.nmes) do begin
           for j := 1 to jmax do begin
              if vclForm.tracePointsCB.checked then begin
                 PaintBox.canvas.pen.color := vclForm.couleur[j];
                 PaintBox.canvas.Font.Color := vclForm.couleur[j];
                 TraceCroix(correctionRS.XY[j,i]);
                 if vclForm.EtiquetteCB.checked then begin
                    texte := intToStr(succ(i));
                    if jmax>1 then texte := intToStr(j)+'-'+texte;
                    PaintBox.canvas.TextOut(round(correctionRS.XY[j,i].x*Zoom)+2,
                                            round(correctionRS.XY[j,i].y*Zoom)+2,
                                            texte);
                 end;
              end;
           end;{j}
       end; {i}
       if vclForm.tracePointsCB.checked then
       for j := 1 to pred(vclForm.PointCourant) do begin
           TraceCroix(correctionRS.XY[j,vclForm.nmes]);
           if vclForm.etiquetteCB.checked then begin
              PaintBox.canvas.pen.color := vclForm.couleur[j];
              PaintBox.canvas.Font.Color := vclForm.couleur[j];
              texte := intToStr(succ(vclForm.nmes));
              if jmax>1 then texte := intToStr(j)+'-'+texte;
              PaintBox.canvas.TextOut(round(correctionRS.XY[j,vclForm.nmes].x*Zoom)+2,
                                      round(correctionRS.XY[j,vclForm.nmes].y*Zoom)+2,
                                      texte);
           end;
       end;// j
end; // Dessine

end.
