unit stayontop_3D;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  grapheU;

type
  Tplan = (Oxz,Oyz);
  TDraw_3DForm = class(TForm)
    PaintBox: TPaintBox;
    procedure PaintBoxPaint(Sender: TObject);
    procedure PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  public
    plan : Tplan;
    Procedure Dessine;
  end;

implementation

{$R *.dfm}

uses VLC_3D;

procedure TDraw_3DForm.PaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    VLC_3DForm.PaintBoxMouseDown(Sender,Button,Shift,X, Y)
end;

procedure TDraw_3DForm.PaintBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
    VLC_3DForm.PaintBoxMouseMove(Sender,Shift,X,Y)
end;

procedure TDraw_3DForm.PaintBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    VLC_3DForm.PaintBoxMouseUp(Sender,Button,Shift,X, Y)
end;

procedure TDraw_3DForm.PaintBoxPaint(Sender: TObject);
begin
     PaintBox.canvas.brush.Color := transparentColorValue;
     PaintBox.canvas.brush.style := bsSolid;
     with PaintBox.clientRect do
          PaintBox.canvas.FillRect(rect(left,top,right,bottom));
     if VLC_3DForm.nomFichier[plan]<>'' then Dessine;
end;

Procedure TDraw_3DForm.Dessine;

Procedure TraceLigne(x1,y1,x2,y2 : integer);
begin
      PaintBox.canvas.moveto(round(x1*VLC_3DForm.pasZoom),round(y1*VLC_3DForm.pasZoom));
      PaintBox.canvas.lineto(round(x2*VLC_3DForm.pasZoom),round(y2*VLC_3DForm.pasZoom));
end;

Procedure TraceRepere(Apoint : TPoint);
begin with Apoint do begin
      TraceLigne(x-4*Magnet,y,x+4*Magnet,y); // axe X
// flche X
      TraceLigne(x+7*Magnet div 2,y-1,x+2*Magnet,y);
      TraceLigne(x+7*Magnet div 2,y+1,x+2*Magnet,y);
      TraceLigne(x,y-4*Magnet,x,y+4*Magnet); // axe Y
// flche Y
      TraceLigne(x-1,y+7*Magnet div 2,x,y+2*Magnet);
      TraceLigne(x+1,y+7*Magnet div 2,x,y+2*Magnet);
end end;

Procedure TraceCroix(Apoint : Tpoint);
begin
      traceLigne(Apoint.x-Magnet,Apoint.y,Apoint.x+Magnet,Apoint.y);
      traceLigne(Apoint.x,Apoint.y-Magnet,Apoint.x,Apoint.y+Magnet);
end;

Procedure TraceTexte(x,y : integer;titre : string);
begin
    canvas.TextOut(round(x*VLC_3DForm.pasZoom),round(y*VLC_3DForm.pasZoom),titre);
end;

Procedure TraceOrigine;
var xMax, yMax : integer;
    titre : string;
begin with VLC_3DForm.PointRepere[plan,bsOrigine] do begin
      xmax := round(width/VLC_3DForm.pasZoom)-2;
      ymax := round(height/VLC_3DForm.pasZoom)-2;
      TraceLigne(x,0,x,ymax); // axe X
      TraceLigne(0,y,xmax,y); // axe Y
// flche X
      TraceLigne(xmax-3*Magnet,y+3,xmax,y);
      TraceLigne(xmax-3*Magnet,y-3,xmax,y);
      PaintBox.canvas.Font.Size := 12;
      TraceTexte(xmax-Magnet,y-2*Magnet,'X');
// flche Y
      TraceLigne(x-3,3*Magnet,x,0);
      TraceLigne(x+3,3*Magnet,x,0);
      if plan=Oxz then titre := 'Z' else titre := 'Y';
      TraceTexte(x+2*Magnet,Magnet,titre);
      PaintBox.canvas.Font.Size := 8;
end end;

Procedure TraceEchelle;
begin
      TraceLigne(vLC_3DForm.PointRepere[plan,bsEchelle1].x,
         vLC_3DForm.PointRepere[plan,bsEchelle1].y,
         vLC_3DForm.PointRepere[plan,bsechelle2].x,
         vLC_3DForm.PointRepere[plan,bsEchelle2].y);
      TraceCroix(vLC_3DForm.PointRepere[plan,bsEchelle1]);
      TraceCroix(vLC_3DForm.PointRepere[plan,bsechelle2]);
end;

procedure TracePoint(i : integer);
begin
        TraceCroix(vLC_3DForm.XY[plan,i]);
        if vLC_3DForm.EtiquetteCB.checked then
               PaintBox.canvas.TextOut(
                        round(vLC_3DForm.XY[plan,i].x*vLC_3DForm.pasZoom)+2,
                        round(vLC_3DForm.XY[plan,i].y*vLC_3DForm.pasZoom)+2,
                        intToStr(succ(i)));
end;

var i : integer;
begin // Dessine
    if vLC_3DForm.couleurAxe=TransparentColorValue then
       vLC_3DForm.couleurAxe := clBlack;
    if VLC_3DForm.couleurPoint=TransparentColorValue then
       vLC_3DForm.couleurPoint := clBlack;
    PaintBox.canvas.pen.color := vLC_3DForm.couleurAxe;
    PaintBox.canvas.Font.Color := vLC_3DForm.couleurAxe;
    vLC_3DForm.calcEchelle;
    if vLC_3DForm.traceEchCB.checked then begin
       TraceOrigine;
       TraceEchelle;
    end;
    PaintBox.canvas.pen.color := vLC_3DForm.couleurPoint;
    PaintBox.canvas.Font.Color := vLC_3DForm.couleurPoint;
    if vLC_3DForm.tracePointsCB.checked then begin
       for i := 0 to pred(vLC_3DForm.nmes) do
           TracePoint(i);
       if vLC_3DForm.PointAcquis[plan] then TracePoint(vLC_3DForm.nmes);
    end;
end; // Dessine

end.
