unit arduinoU;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.ImageList, system.dateUtils,
  Vcl.Graphics, Vcl.Grids, Vcl.ComCtrls, clipbrd, Vcl.ToolWin,  Vcl.ImgList,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  vcl.htmlHelpViewer,
  OOmisc, adport, lnswin32, awuser,
  inifiles, registry,
  regutil, arduinoGraphe, arduinoCfg, compile;

type
  TModeTemporel = (mDeclenche,mRelaxe,mRoll);
  TTrigger = (tMontant,tDescendant,tClavier);
  TArduinoForm = class(TForm)
    grid: TStringGrid;
    GroupBox1: TGroupBox;
    Button1: TButton;
    CommandeEdit: TEdit;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolsBtn: TToolButton;
    StartBtn: TToolButton;
    StopBtn: TToolButton;
    RegressiBtn: TToolButton;
    TimerSauve: TTimer;
    PaintBox: TPaintBox;
    Splitter1: TSplitter;
    TimerGraphe: TTimer;
    PanelVoies: TPanel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    GroupBox5: TGroupBox;
    Label4: TLabel;
    GroupBox6: TGroupBox;
    Label5: TLabel;
    GroupBox7: TGroupBox;
    Label6: TLabel;
    GroupBox8: TGroupBox;
    Label7: TLabel;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    RazBtn: TToolButton;
    TriggerTB: TTrackBar;
    TimerCarac: TTimer;
    ErreurCaracLabel: TLabel;
    VoieSerie: TApdComPort;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure ToolsBtnClick(Sender: TObject);
    procedure RegressiBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure StartBtnClick(Sender: TObject);
    procedure TimerSauveTimer(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure TimerGrapheTimer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure gridGetEditText(Sender: TObject; ACol, ARow: Integer;
      var Value: string);
    procedure Button2Click(Sender: TObject);
    procedure CommandeEditExit(Sender: TObject);
    procedure RazBtnClick(Sender: TObject);
    procedure TriggerTBChange(Sender: TObject);
    procedure TimerCaracTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
    procedure VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);
  private
    indiceCourant : integer;
    chaineLue : ansiString;
    liste : TstringList;
    actif : boolean;
    crTrigger : word;
    graphe : TgrapheArduino;
    indexFichier : integer;
    premiereLigne : boolean; //  sauter car non complte par dfaut de synchro
    NbreColonnes : integer;
    tZero : TTime;
    PremierAppel : boolean;
    dureeMax : integer;
    startCommand : string;
    labelVoie : array[indiceAxes] of Tlabel;
    attenteTrigger : boolean;
    seuilTrigger : double;
    voieTrigger : indiceAxes;
    precedent : double;
    Procedure Sauvegarde;
  public
    sendCommand  : array[0..3] of string;
    SendBtn : array[0..3] of TButton;
    modeTemps : TmodeTemporel;
    trigger : TTrigger;
    monocoup : boolean;
    pointparpoint : boolean;
  end;

var
  ArduinoForm: TArduinoForm;

implementation

{$R *.dfm}

uses regmain, regdde;

procedure TArduinoForm.StopBtnClick(Sender: TObject);
begin
   actif := false;
   razBtn.Enabled := true;
   stopBtn.enabled := false;
   startBtn.Enabled := true;
   timerSauve.Enabled := false;
   timerGraphe.enabled := pointParPoint;
   PanelVoies.Visible := pointParPoint;
   graphe.nbrePointsNew := 0;
   timerGrapheTimer(nil);
   sauvegarde;
end;

procedure TArduinoForm.Button1Click(Sender: TObject);
begin
  voieSerie.Output := AnsiString(commandeEdit.Text);
end;

procedure TArduinoForm.StartBtnClick(Sender: TObject);
var i : integer;
begin
    timerGraphe.enabled := true;
    graphe.indexRoll := 0;
    if pointParPoint
    then begin
      for i := 0 to nbreColonnes do
          graphe.monde[i].valeur[indiceCourant] := graphe.monde[i].valeurC;
      inc(indiceCourant);
      startBtn.Enabled := indiceCourant<MaxvecteurArduino;
      graphe.nbrePoints := indiceCourant;
      regressiBtn.Enabled := indiceCourant>4;
      razBtn.Enabled := regressiBtn.Enabled;
      stopBtn.enabled := false;
      PanelVoies.Visible := true;
    end
    else begin
        indiceCourant := 0;
        graphe.NbrePoints := 0;
        graphe.NbrePointsNew := 0;
        premiereLigne := true;
        stopBtn.enabled := true;
        startBtn.Enabled := False;
        timerSauve.Enabled := true;
        premierAppel := true;
        tZero := getTime;
        if startCommand<>'' then voieSerie.Output := ansiString(startCommand);
        actif := true;
        PanelVoies.Visible := false;
        if (modeTemps=mDeclenche) and (trigger<>tClavier) then begin
            attenteTrigger := true;
            if trigger=tMontant
               then precedent := graphe.monde[voieTrigger].maxi
                else precedent := graphe.monde[voieTrigger].mini
        end;
    end;
end;

procedure TArduinoForm.TimerCaracTimer(Sender: TObject);
begin
    timerCarac.Enabled := false;
    ErreurCaracLabel.visible := false;
end;

procedure TArduinoForm.TimerGrapheTimer(Sender: TObject);
var i : integer;
begin
      for i := 1 to NbreColonnes do
          labelVoie[i].Caption := graphe.monde[i].nom+'='+liste[i-1]+' '+graphe.monde[i].unite;
      if pointParPoint
         then labelVoie[0].Caption := 'index='+intToStr(round(graphe.monde[0].valeurC))
         else labelVoie[0].Caption := 't='+floatToStrF(graphe.monde[0].valeurC,ffFixed,5,3)+' s';
      for i := succ(NbreColonnes) to mondeYmax do
          labelVoie[i].Caption := '';
      for i := 1 to pred(grid.ColCount) do begin
         graphe.monde[i-1].nom := grid.Cells[i,0];
         graphe.monde[i-1].unite := grid.Cells[i,1];
         graphe.monde[i-1].miniStr := grid.Cells[i,2];
         graphe.monde[i-1].maxiStr := grid.Cells[i,3];
      end;
      seuilTrigger := graphe.monde[voieTrigger].mini+
             (triggerTB.max-triggerTB.position)*(graphe.monde[voieTrigger].maxi-graphe.monde[voieTrigger].mini)/triggerTB.max;
      graphe.modePoint := pointParPoint;
      paintBox.Invalidate;
end;

procedure TArduinoForm.TimerSauveTimer(Sender: TObject);
begin
    Sauvegarde;
end;

procedure TArduinoForm.RazBtnClick(Sender: TObject);
begin
    graphe.nbrePoints := 0;
    graphe.nbrePointsNew := 0;
    paintBox.Invalidate;
end;

procedure TArduinoForm.ToolsBtnClick(Sender: TObject);
var j : integer;
begin
     if crTrigger>0 then begin
        voieSerie.RemoveTrigger(crTrigger);
        crTrigger := 0;
     end;
     VoieSerie.Open := False;
     if ArduinoDlg=nil then Application.CreateForm(TArduinoDlg,ArduinoDlg);
     ArduinoDlg.dureeMaxSE.Value := dureeMax;
     ArduinoDlg.startEdit.Text := startCommand;
     ArduinoDlg.ShowModal;
     if arduinoDlg.Comports.items.Count>0 then begin
        VoieSerie.Open := True;
        crTrigger := voieSerie.addDataTrigger(crCR,true);
     end;
     for j := 0 to 3 do begin
         sendBtn[j].visible := sendCommand[j]<>'';
         if (sendBtn[j].caption='') then sendBtn[j].caption := sendCommand[j];
     end;
     dureeMax := arduinoDlg.dureeMaxSE.Value;
     startCommand := ArduinoDlg.startEdit.Text;
     timerGraphe.Enabled := pointParPoint;
     PanelVoies.Visible := pointParPoint;
     triggerTB.visible := not(pointParPoint) and (trigger<>tClavier) and (modeTemps=mDeclenche);
     if pointParPoint then begin
        Grid.Cells[1,0] := 'index';
        Grid.Cells[1,1] := '';
     end
     else begin
        Grid.Cells[1,0] := 'temps';
        Grid.Cells[1,1] := 's';
     end
end;

procedure TArduinoForm.Button2Click(Sender: TObject);
begin
    voieSerie.Output := AnsiString(sendCommand[(sender as TButton).tag]);
end;

procedure TArduinoForm.CommandeEditExit(Sender: TObject);
begin
    sendCommand[0] := commandeEdit.Text;
    sendBtn[0].Visible := sendCommand[0]<>'';
end;

procedure TArduinoForm.FormActivate(Sender: TObject);
begin
    if not voieSerie.Open and IsPortAvailable(VoieSerie.ComNumber) then begin
        voieSerie.Open := True;
        crTrigger := voieSerie.addDataTrigger(crCR,true);
    end;
    NbreColonnes := -1; // pas de donnes
    timerGraphe.Enabled := voieSerie.Open and pointParPoint;
    PanelVoies.Visible := timerGraphe.Enabled;
end;

procedure TArduinoForm.FormClose(Sender: TObject; var Action: TCloseAction);
var Rini : TMemInifile;
    j : integer;
    indexM : integer;
begin
     Rini := TMemIniFile.create(NomFichierIni);
     Rini.WriteInteger('Arduino','Com',voieSerie.comNumber);
     for j := 0 to 3 do begin
         Rini.WriteString('Arduino','Commande'+intToStr(j),sendCommand[j]);
         Rini.WriteString('Arduino','Caption'+intToStr(j),sendBtn[j].caption);
     end;
     Rini.WriteString('Arduino','Start',startCommand);
     Rini.WriteInteger('Arduino','DureeMax',dureeMax);
     Rini.WriteInteger('Arduino','Baud',voieSerie.baud);
     Rini.WriteInteger('Arduino','Mode',ord(modeTemps));
     Rini.WriteInteger('Arduino','Trigger',ord(trigger));
     Rini.WriteBool('Arduino','Monocoup',monocoup);
     Rini.WriteBool('Arduino','PointParPoint',pointParPoint);
     for j := 1 to pred(grid.colCount) do begin
         indexM := j-1;
         if grid.cells[j,0]<>'' then
            Rini.writeString('Arduino','Nom'+intToStr(indexM),grid.cells[j,0]);
         if grid.cells[j,1]<>'' then
            Rini.writeString('Arduino','Unite'+intToStr(indexM),grid.cells[j,1]);
         if grid.cells[j,2]<>'' then
            Rini.writeString('Arduino','Mini'+intToStr(indexM),grid.cells[j,2]);
         if grid.cells[j,3]<>'' then
            Rini.writeString('Arduino','Maxi'+intToStr(indexM),grid.cells[j,3]);
     end;
     Rini.updateFile;
     Rini.Free;
     if crTrigger<>0 then begin
        voieSerie.RemoveTrigger(crTrigger);
        crTrigger := 0;
     end;
     VoieSerie.Open := false;
     timerSauve.Enabled := false;
     actif := false;
     timerGraphe.Enabled := false;
end;

procedure TArduinoForm.FormCreate(Sender: TObject);
const nomDefaut : array[indiceAxes] of string  = ('t','X','Y','Z','aX','aY','aZ');
      uniteDefaut : array[indiceAxes] of string  = ('s','','','','','','');
var j,NbreCom : integer;
    Rini : TMemIniFile;
    baudOK : boolean;
    gbvoie : TGroupBox;
    indexM : integer;
begin
     voieTrigger := mondeY;
     graphe := TgrapheArduino.create;
     graphe.canvas := paintBox.canvas;
     for j := 0 to pred(GroupBox1.ControlCount) do
         if groupBox1.Controls[j] is Tbutton then
            sendBtn[groupBox1.Controls[j].Tag] := Tbutton(groupBox1.Controls[j]);
     indexFichier := 0;
     Rini := TMemIniFile.create(NomFichierIni);
     VoieSerie.ComNumber := Rini.ReadInteger('Arduino','Com',3);
     if IsPortAvailable(VoieSerie.ComNumber)
     then NbreCom := 1
     else begin
        NbreCom := 0;
        for j := 1 to MaxComHandles do
        if IsPortAvailable(j) then begin
            inc(NbreCom);
            VoieSerie.ComNumber := j;
        end;
        if NbreCom=0 then showMessage('Pas de voie srie');
     end;
     VoieSerie.Baud := Rini.ReadInteger('Arduino','Baud',9600);
     for j := 1 to 3 do begin
         sendCommand[j] := Rini.ReadString('Arduino','Commande'+intToStr(j),'');
         sendBtn[j].caption := Rini.ReadString('Arduino','Caption'+intToStr(j),'');
         sendBtn[j].visible := sendCommand[j]<>'';
     end;
     startCommand := Rini.ReadString('Arduino','Start','');
     dureeMax := Rini.ReadInteger('Arduino','DureeMax',15);
     modeTemps := TmodeTemporel(Rini.ReadInteger('Arduino','Mode',0));
     pointParPoint := Rini.ReadBool('Arduino','PointParPoint',true);
     trigger := TTrigger(Rini.ReadInteger('Arduino','Trigger',0));
     monocoup := Rini.ReadBool('Arduino','Monocoup',true);
     baudOK := false;
     if not baudOK then VoieSerie.Baud := 9600;
     {$IFDEF Debug}
     voieSerie.Tracing := tlOn;
     voieSerie.Logging := tlOn;
     {$ELSE}
     voieSerie.Tracing := tlOff;
     voieSerie.Logging := tlOff;
     {$ENDIF}
     liste := TstringList.Create;
     grid.Cells[0,0] := 'Nom';
     grid.Cells[0,1] := 'Unit';
     grid.Cells[0,2] := 'Mini';
     grid.Cells[0,3] := 'Maxi';
     for j := 1 to pred(grid.colCount) do begin
         indexM := j-1;
         grid.Cells[j,0] := Rini.readString('Arduino','Nom'+intToStr(indexM),nomDefaut[indexM]);
         graphe.monde[indexM].nom := grid.Cells[j,0];
         grid.Cells[j,1] := Rini.readString('Arduino','Unite'+intToStr(indexM),uniteDefaut[j-1]);
         graphe.monde[indexM].unite := grid.Cells[j,1];
         grid.Cells[j,2] := Rini.readString('Arduino','Mini'+intToStr(indexM),'');
         graphe.monde[indexM].miniStr := grid.Cells[j,2];
         grid.Cells[j,3] := Rini.readString('Arduino','Maxi'+intToStr(indexM),'');
         graphe.monde[indexM].maxiStr := grid.Cells[j,3];
     end;
     Rini.Free;
     indiceCourant := 0;
     nbreColonnes := -1;
     actif := false;
     if nbreCom>0 then begin
     try
     voieSerie.Open := True;
     crTrigger := voieSerie.AddDataTrigger(crCR,true);
     except
        ShowMessage('Problme voie srie');
     end;
     end;
     with PanelVoies do
     for j := 0 to pred(controlCount) do begin
         GBVoie := TGroupBox(controls[j]);
         LabelVoie[j] := Tlabel(GBvoie.controls[0]);
         LabelVoie[j].Font.color := clWhite;
         LabelVoie[j].tag := j;
         GBVoie.Tag := j;
         GBVoie.Font.color := clWhite;
         GBVoie.color := couleurArduino[j];
     end;
end;

procedure TArduinoForm.FormDestroy(Sender: TObject);
begin
     VoieSerie.Free;
     Graphe.free;
end;

procedure TArduinoForm.FormShow(Sender: TObject);
begin
    if not voieSerie.Open and IsPortAvailable(VoieSerie.ComNumber)then begin
        voieSerie.Open := True;
        crTrigger := voieSerie.addDataTrigger(crCR,true);
    end;
end;

procedure TArduinoForm.gridGetEditText(Sender: TObject; ACol, ARow: Integer;
  var Value: string);
begin
    if Acol=0 then exit;
    case Arow of
        0 : graphe.monde[Acol-1].nom := value;
        1 : graphe.monde[Acol-1].unite := value;
        2 : graphe.monde[Acol-1].miniStr := value;
        3 : graphe.monde[Acol-1].maxiStr := value;
    end;
end;

procedure TArduinoForm.PaintBoxPaint(Sender: TObject);
begin
      graphe.mondeMax := nbreColonnes;
      if not pointParPoint then begin
         graphe.Monde[mondex].miniStr := '0';
         graphe.Monde[mondex].maxiStr := dureeMax.toString;
      end;
      graphe.drawG;
end;

procedure TArduinoForm.RegressiBtnClick(Sender: TObject);
var tampon : TstringList;
    i,k : integer;
    Ligne : String;
    t : double;
begin
     tampon := TstringList.create;
     tampon.add(Application.exeName);
     tampon.add('');
     ligne := '';
     for k := 0 to graphe.mondeMax do begin  // noms
         if grid.Cells[k+1,0]='' then grid.Cells[k+1,0] := 'x'+intToStr(k);
         Ligne := ligne+grid.Cells[k+1,0]+crTab;
     end;
     tampon.add(Ligne);
     ligne := '';
     for k := 0 to graphe.mondeMax do // units
         Ligne := ligne+grid.Cells[k+1,1]+crTab;
     tampon.add(ligne);
     if modeTemps=mRoll then begin
        t := 0;
        for i := graphe.indexRoll to pred(graphe.nbrePoints) do begin // data
           ligne := floatToStrPoint(t);
           t := t + graphe.deltatRoll;
           for k := 1 to graphe.mondeMax do
              Ligne := ligne+floatToStrPoint(graphe.monde[k].valeur[i])+crTab;
           tampon.add(Ligne);
        end;
        for i := 0 to graphe.indexRoll-1  do begin // data
           ligne := floatToStrPoint(t)+crTab;
           t := t + graphe.deltatRoll;
           for k := 1 to graphe.mondeMax do
              Ligne := ligne+floatToStrPoint(graphe.monde[k].valeur[i])+crTab;
           tampon.add(Ligne);
        end;
     end
     else begin
     for i := 0 to pred(indiceCourant) do begin // data
         ligne := '';
         for k := 0 to graphe.mondeMax do
             Ligne := ligne+floatToStrPoint(graphe.monde[k].valeur[i])+crTab;
         tampon.add(Ligne);
     end;
     end;
     ClipBoard.asText := tampon.Text;
     if pageCourante=0
         then with FregressiMain do begin
             grandeursOpen;
             grapheOpen;
             if FormDDE.ImportePressePapier then begin
                ModifConfigAcq := SaveConfigAcq;
                FocusAcquisitionBtn.visible := true;
             end
         end
         else FormDDE.AjoutePressePapier;
     tampon.free;
     modeAcquisition := acqArduino;
     Close;
end; // RegressiBtnClick

procedure TArduinoForm.TriggerTBChange(Sender: TObject);
begin
 seuilTrigger := graphe.monde[voieTrigger].mini+
    (triggerTB.max-triggerTB.position)*(graphe.monde[voieTrigger].maxi-graphe.monde[voieTrigger].mini)/triggerTB.max;
end;

procedure TArduinoForm.VoieSerieTriggerAvail(CP: TObject; Count: Word);
var
   i: word;
   carac: ansiChar;
begin // TriggerAvail
   for i := 1 to Count do begin
      if voieSerie.CharReady then begin
         carac := voieSerie.GetChar;
         if (carac > ' ') then chaineLue := chaineLue + carac;
         if not TimerCarac.enabled  and (ord(carac)>ord(';')) then begin
                 TimerCarac.enabled := true;
                 ErreurCaracLabel.visible := true;
         end;
      end;
    end
end;

procedure TArduinoForm.VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);

procedure TriggerDataTemps;
var i : integer;
    m : indiceAxes;
    seuilAtteint : boolean;
begin
      graphe.monde[mondeX].valeurC := milliSecondsBetween(getTime,tZero)/1000.0;
      if not actif then exit;
      if premiereLigne then begin
         premiereLigne := false;
         tZero := getTime;
         exit;
      end;
      try
      for i := 0 to nbreColonnes do begin
          if (modeTemps=mRelaxe) and not(premierAppel)
             then graphe.monde[i].valeurNew[indiceCourant] := graphe.monde[i].valeurC
             else graphe.monde[i].valeur[indiceCourant] := graphe.monde[i].valeurC;
      end;
      case modeTemps of
          mDeclenche : case trigger of
             tClavier : begin
                inc(indiceCourant);
                graphe.nbrePoints := indiceCourant;
             end;
             tMontant,tDescendant : if attenteTrigger
                 then begin
                      if trigger=tMontant
                         then seuilAtteint := (graphe.monde[voieTrigger].valeurC>=seuilTrigger) and
                                                (precedent<seuilTrigger)
                         else seuilAtteint := (graphe.monde[voieTrigger].valeurC<=seuilTrigger) and
                                                (precedent>seuilTrigger);
                      if seuilAtteint then begin
                         tZero := getTime;
                         graphe.nbrePoints := 1;
                         indiceCourant := 1;
                         attenteTrigger := false;
                      end;
                      Precedent := graphe.monde[voieTrigger].valeurC;
                 end
                 else begin
                   inc(indiceCourant);
                   graphe.nbrePoints := indiceCourant;
                 end;
          end;
          mRelaxe : begin
           inc(indiceCourant);
           if premierAppel
              then graphe.nbrePoints := indiceCourant
              else graphe.NbrePointsNew := indiceCourant;
          end;
          mRoll : begin
           inc(indiceCourant);
           if premierAppel
              then graphe.nbrePoints := indiceCourant
              else graphe.indexRoll := indiceCourant;
          end;
      end;
      except
      end;
      if (indiceCourant>=MaxVecteurArduino) or
         (graphe.monde[mondeX].valeurC>dureeMax) then
      case modeTemps of
         mDeclenche : case trigger of
            tClavier : stopBtnClick(nil);
            tmontant,tdescendant : if monocoup then stopBtnClick(nil)
            else begin
                  indiceCourant := 0;
                  premierAppel := false;
                  graphe.nbrePointsNew := 0;
                  tZero := getTime;
                  attenteTrigger := true;
                  if trigger=tMontant
                      then precedent := graphe.monde[voieTrigger].maxi
                      else precedent := graphe.monde[voieTrigger].mini
            end;
         end;// case
         mRelaxe : begin
             if not premierAppel then begin
                graphe.nbrePoints := graphe.NbrePointsNew;
                for m := mondeX to graphe.mondeMax do
                    for i := 0 to pred(graphe.nbrePoints) do
                        graphe.monde[m].valeur[i] := graphe.monde[m].valeurNew[i];
             end;
             indiceCourant := 0;
             premierAppel := false;
             graphe.nbrePointsNew := 0;
             tZero := getTime;
             if startCommand<>'' then voieSerie.Output := ansiString(startCommand);
         end;
         mRoll : begin
             premierAppel := false;
             graphe.indexRoll := 0;
             tZero := getTime;
             graphe.deltatRoll := (graphe.monde[mondeX].valeur[indiceCourant-1]-
                                   graphe.monde[mondeX].valeur[0])/(indiceCourant-1);
             indiceCourant := 0;
         end;
      end;
end;

var i : integer;
begin
      liste.commaText := string(chaineLue);
      chaineLue := '';
      if liste.Count<1 then exit;
      nbreColonnes := liste.Count; // temps ou index en plus
      for i := 1 to nbreColonnes do
          graphe.monde[i].valeurC := strToFloatWin(liste[i-1]);
      if nbreColonnes>mondeYMax then nbreColonnes := mondeYMax;
      if pointParPoint
        then graphe.monde[mondeX].valeurC := indiceCourant
        else TriggerDataTemps;
      regressiBtn.Enabled := indiceCourant>5;
end;

(*
procedure TArduinoForm.LockGrid;
begin
    Grid.Perform(WM_SETREDRAW, 0, 0);
end;

procedure TArduinoForm.UnLockGrid;
begin
     Grid.Perform(WM_SETREDRAW, 1, 0);
     Grid.Invalidate; // important! to force repaint after all
end;
*)

Procedure TArduinoForm.Sauvegarde;
var nomFichier,ligne : string;
    i,k : integer;
begin
     if not regressiBtn.Enabled then exit;
     NomFichier := MesDocsDir+'RegressiArduino'+intToStr(indexFichier)+'.csv';
     inc(indexFichier);
     if indexFichier>128 then indexFichier := 0;
     AssignFile(fichier,NomFichier);
     Rewrite(fichier);
     for i := 0 to pred(graphe.NbrePoints) do begin
         ligne := '';
         for k := 0 to NbreColonnes do
             Ligne := ligne+FloatToStrPoint(graphe.monde[k].Valeur[i])+',';
         writeln(fichier,Ligne);
     end;
     try
     CloseFile(fichier);
     except
         CloseFile(fichier);
     end;
end;

end.

