unit couleurLambda;

interface

uses Graphics, Windows, Classes,  math;

Function couleurWL(WL : double) : Tcolor;

//     RGB VALUES FOR VISIBLE WAVELENGTHS   by Dan Bruton (astro@tamu.edu)
//     http://www.isc.tamu.edu/~astro/color.html
//     This program will create a ppm (portable pixmap) image of a spectrum.
//     The spectrum is generated using approximate RGB values for visible
//     wavelengths between 380 nm and 780 nm. for GAMMA=1
//     NetPBM Software: ftp://ftp.cs.ubc.ca/ftp/archive/netpbm/

implementation

const GAMMA=0.80;

Function couleurWL(WL : double) : Tcolor;
var R,G,B,sss : double;
    RR,GG,BB : byte;
    WLi : integer;
begin
if WL<1 then WL := 1000*WL; // en micromtre ?
      R := 0;
      G := 0;
      B := 0;
      WLi := round(WL);
      IF ((WLi>=380) AND (WLi<=440)) THEN begin
              R := (WL-440)/(440-380); // <0
              R := abs(R);
              G := 0;
              B := 1;
      END;
      IF ((WLi>=440) AND (WLi<=490)) THEN begin
              R := 0;
              G := (WL-440)/(490-440);
              B := 1;
      END;
      IF ((WLi>=490) AND (WLi<=510)) THEN begin
              R := 0;
              G := 1;
              B := (WL-510)/(510-490); // <0
              B := abs(B);
      END;
      IF ((WLi>=510) AND (WLi<=580)) THEN begin
              R := (WL-510)/(580-510);
              G := 1;
              B := 0;
      END;
      IF ((WLi>=580) AND (WLi<=645)) THEN begin
              R := 1;
              G := (WL-645)/(645-580); // <0
              G := abs(G);
              B := 0;
      END;
      IF ((WLi>=645) AND (WLi<=780)) THEN begin
              R := 1;
              G := 0;
              B := 0;
      END;
//      LET THE INTENSITY SSS FALL OFF NEAR THE VISION LIMITS
      IF (WL>700) THEN
            SSS:=0.3+0.7* (780-WLi)/(780-700)
         ELSE IF (WL<420) THEN
            SSS:=0.3+0.7*(WLi-380)/(420-380)
         ELSE
            SSS:=1;
//      GAMMA ADJUST
      RR:=round(power(SSS*R,GAMMA)*255);
      GG:=round(power(SSS*G,GAMMA)*255);
      BB:=round(power(SSS*B,GAMMA)*255);
      result := RGB(RR,GG,BB);
END;

end.
