// filerwu.pas : fichier include de regmain.pas

procedure TFRegressiMain.EcritFichierUnicode(NomFichier : string);
var donnees : TstringList;

Procedure EcritPage(page : integer);
var i,j : LongInt;
    ivar : integer;
    ligneVide : boolean;
    ligne : string;
begin with pages[page] do begin
    donnees.add(symbReg,'1 PAGE COMMENT');
    donnees.add(commentaireP);
    ligneVide := true;
    while (nmes>0) and ligneVide do begin
       for i := 0 to pred(NbreVariabExp) do
           ligneVide := ligneVide and isNan(valeurVar[indexVariabExp[i],pred(nmes)]);
       if ligneVide then nmes := nmes-1;
    end;
    if nmes>0 then begin
       donnees.add(symbReg2+IntToStr(nmes)+' VALEUR VAR');
       for j := 0 to pred(nmes) do begin
           ligne := '';
           for i := 0 to pred(NbreVariabExp) do
               ligne := ligne + FloatToStrPoint(valeurVar[indexVariabExp[i],j]);
           donnees.add(ligne);
       end; { for j }
       if NbreVariabTexte>0 then begin
          donnees.add(symbReg2+IntToStr(Nmes)+' TEXTE VAR');
          for i := 0 to pred(NbreVariabTexte) do begin
              ivar := indexVariabTexte[i];
              for j := 0 to pred(nmes) do
                    donnees.add(texteVar[iVar,j]);
          end;
       end;
       setChi2;
       if chi2Permis and (nmes<128) then begin
          donnees.add(symbReg2,IntToStr(Nmes),' INCERT VAR');
          for j := 0 to pred(nmes) do begin
             ligne := '';
             for i := 0 to pred(NbreVariabExp) do
                 ligne := ligne + FloatToStrPoint(IncertVar[indexVariabExp[i],j]);
             donnees.add(ligne);
          end; { for j }
       end;
    end;{Nmes>0}
    if NbreConstExp>0 then begin
       donnees.add(symbReg2,IntToStr(NbreConstExp),' VALEUR CONST');
       for i := 0 to pred(NbreConstExp) do
               donnes.add(FloatToStrPoint(ValeurConst[indexConstExp[i]]));
       donnees.add(symbReg2,IntToStr(NbreConstExp),' INCERT CONST');
       for i := 0 to pred(NbreConstExp) do
           donnes.add(FloatToStrPoint(incertConst[indexConstExp[i]]));
    end;
    if NbreConstTexte>0 then begin
       donnees.add(symbReg2,IntToStr(NbreConstTexte),' TEXTE CONST');
       for i := 0 to pred(NbreConstTexte) do
           donnees.add(TexteConst[indexConstTexte[i]]);
    end;
    donnees.add(symbReg2+'2 OPTIONS');
    donnees.add(ord(active));
    donnees.add(ord(experimentale));
    if stat.StatOK then with stat do begin
       donnees.add(symbReg2,IntToStr(Nbre),' VALEUR STAT');
       for i := 0 to pred(Nbre) do
           donnes.add(FloatToStrPoint(Donnees[i]));
    end;
    if ModelePagesIndependantes and
       (TexteModeleP.count>0) then begin
         donnees.add(symbReg2,IntToStr(TexteModeleP.count),' MODELEPAGE');
         for i := 0 to pred(TexteModeleP.count) do
             donnees.add(TexteModeleP[i])
    end;
    if NbreParam[paramFFT]>0 then begin
       donnees.add(symbReg2,IntToStr(NbreParam[paramFFT]),' VALEUR PARAM FFT');
       for i := 1 to NbreParam[paramFFT] do
           donnes.add(FloatToStrPoint(valeurParam[paramFFT,i]));
    end;
    if debutFFT>0 then begin
       donnees.add(symbReg2+'2 BORNES FFT');
       donnees.add(debutFFT);
       donnees.add(finFFT);
    end;
    if NbreParamNormal>0 then begin
       donnees.add(symbReg2,IntToStr(NbreParamNormal),' VALEUR PARAM');
       for i := 1 to NbreParamNormal do
           donnes.add(FloatToStrPoint(valeurParam[paramNormal,i]));
       donnees.add(symbReg2,IntToStr(NbreParamNormal),' INCERT PARAM');
       for i := 1 to NbreParamNormal do
           donnes.add(FloatToStrPoint(incertParam[i]));
       donnees.add(symbReg2,IntToStr(NbreParamNormal),' STDEV PARAM');
       for i := 1 to NbreParamNormal do
           donnes.add(FloatToStrPoint(ecartTypeParam[i]));
    end;
    if NbreModele>0 then begin
       donnees.add(symbReg2,IntToStr(NbreModele),' DEBUT');
       for i := 1 to NbreModele do donnees.add(debut[i]);
       donnees.add(symbReg2,IntToStr(NbreModele),' FIN');
       for i := 1 to NbreModele do donnees.add(fin[i]);
    end;
    if NomFichierBitmap<>'' then begin
       verifNomBitmap(NomFichier);
       donnees.add(symbReg2+'1 BITMAP');
       donnees.add(ExtractFileName(NomFichierBitmap));
    end;
    if (indicateurP<>nil) and (indicateurDlg<>nil) then begin
        donnees.add(symbReg2+'1 INDICATEUR');
        donnees.add(indicateurDlg.indicateurs.indexOf(indicateurP));
    end;
    if FgrapheVariab.graphes[1].Equivalences[page].count>0 then begin
       donnees.add(symbReg2,IntToStr(FgrapheVariab.graphes[1].Equivalences[page].count),' EQUIVALENCE');
       for i := 0 to pred(FgrapheVariab.graphes[1].Equivalences[page].count) do
           with FgrapheVariab.graphes[1].Equivalences[page][i] do begin
           ligne := '';
           writeNombreWin(pente);
           writeNombreWin(ve);
           writeNombreWin(phe);
           writeNombreWin(x1);
           writeNombreWin(y1);
           writeNombreWin(x2);
           writeNombreWin(y2);
           write(fichier,x1i,' ',y1i,' ',x2i,' ',y2i);
           donnes.add(ligne);
      end;
    end;
end end; {ecritPage}

Procedure ecritEnTete;

Procedure EcritMemoExpressions;
var i,posR : integer;
    nom : string;
begin
   if Fvaleurs.Memo.lines.count>0 then begin
      donnees.add(symbReg,IntToStr(Fvaleurs.Memo.lines.count),' MEMO GRANDEURS');
      for i := 0 to pred(Fvaleurs.Memo.lines.count) do begin
          nom := Fvaleurs.Memo.lines[i];
          posR := pos(reperageConstGlb,nom);
          if posR>0 then nom := copy(nom,1,pred(posR));
          donnees.add(nom);
      end;
   end;
end;

Procedure EcritStrList(M : TstringList;nom : string);
var i : integer;
begin
   if M.count>0 then begin
      donnees.add(symbReg,IntToStr(M.count),nom);
      for i := 0 to pred(M.count) do
          donnees.add(M[i])
   end;
end;

Procedure EcritRichEdit(RE : TrichEdit;nom : string);
var i : integer;
begin
   if RE.lines.count>0 then begin
      donnees.add(symbReg,IntToStr(RE.lines.count),nom);
      for i := 0 to pred(RE.lines.count) do
          donnees.add(RE.lines[i])
   end;
end;

var i : integer;
    mecaOK : boolean;
begin // ecritEnTete
   donnees.add('REGRESSI UNICODE 1.0');
   donnees.add(symbReg,IntToStr(NbreVariab),' NOM VAR');
   for i := 0 to pred(NbreVariab) do
       donnees.add(grandeurs[indexVariab[i]].nom);
   donnees.add(symbReg,NbreVariab,' GENRE VAR');
   for i := 0 to pred(NbreVariab) do
       donnees.add(ord(grandeurs[indexVariab[i]].fonct.genreC));
   donnees.add(symbReg,IntToStr(NbreVariab),' UNITE VAR');
   for i := 0 to pred(NbreVariab) do
       if grandeurs[indexVariab[i]].UniteDonnee
          then donnees.add(grandeurs[indexVariab[i]].nomUnite)
          else donnees.add('');
   if indexTri<>0 then begin
      donnees.add(symbReg+'1 GrandeurTri');
      donnees.add(nomGrandeurTri);
   end;
   donnees.add(symbReg,IntToStr(NbreVariab),' FORMAT VAR');
   for i := 0 to pred(NbreVariab) do
       donnees.add(ord(grandeurs[indexVariab[i]].formatU));
   mecaOK := false;
   for i := 0 to pred(NbreVariab) do
       if grandeurs[indexVariab[i]].affSignif then begin
           mecaOK := true;
           break;
       end;
   if mecaOK then begin
      donnees.add(symbReg,IntToStr(NbreVariab),' AFF VAR');
      for i := 0 to pred(NbreVariab) do
          donnees.add(ord(grandeurs[indexVariab[i]].affSignif));
   end;
   if (stoechBecherGlb>1) or (stoechBuretteGlb>1) then begin
      donnees.add(symbReg+'2 DOSAGE');
      donnees.add(stoechBecherGlb);
      donnees.add(stoechBuretteGlb);
   end;
   donnees.add(symbReg,IntToStr(NbreVariab),' PRECISION VAR');
   for i := 0 to pred(NbreVariab) do
       donnees.add(ord(grandeurs[indexVariab[i]].precisionU));
   mecaOK := false;
   for i := 0 to pred(NbreVariab) do with grandeurs[indexVariab[i]] do
       if genreMecanique<>gm_position then begin
              mecaOK := true;
              break;
       end;
   if mecaOK then begin
      donnees.add(symbReg,IntToStr(NbreVariab),' MECA VAR');
      for i := 0 to pred(NbreVariab) do with grandeurs[indexVariab[i]] do
          if genreMecanique=gm_position
             then donnees.add(ord(gm_position))
             else donnees.add(intTostr(ord(genreMecanique))+' '+nomvarPosition);
   end;
   donnees.add(symbReg,IntToStr(NbreVariabExp),' SIGNIF VAR');
   for i := 0 to pred(NbreVariabExp) do
       donnees.add(grandeurs[indexVariab[i]].fonct.expression);
   mecaOK := false;
   for i := 0 to pred(NbreVariabExp) do with grandeurs[indexVariabExp[i]] do
       if grandeurs[indexVariabExp[i]].IncertCalc.expression<>'' then begin
              mecaOK := true;
              break;
       end;
   if mecaOK then begin
      donnees.add(symbReg,IntToStr(NbreVariabExp),' INCERTITUDE');
      for i := 0 to pred(NbreVariabExp) do
          donnees.add(grandeurs[indexVariabExp[i]].IncertCalc.expression);
   end;
   if NbreConstExp>0 then begin
      donnees.add(symbReg,IntToStr(NbreConstExp),' NOM CONST');
      for i := 0 to pred(NbreConstExp) do
          donnees.add(grandeurs[indexConstExp[i]].nom);
      donnees.add(symbReg,IntToStr(NbreConstExp),' UNITE CONST');
      for i := 0 to pred(NbreConstExp) do
          donnees.add(grandeurs[indexConstExp[i]].nomUnite);
      donnees.add(symbReg,IntToStr(NbreConstExp),' SIGNIF CONST');
      for i := 0 to pred(NbreConstExp) do
          ecritChaineRW3(grandeurs[indexConstExp[i]].fonct.expression);
      donnees.add(symbReg,IntToStr(NbreConstExp),' FORMAT CONST');
      for i := 0 to pred(NbreConstExp) do
          donnees.add(ord(grandeurs[indexConstExp[i]].formatU));
      donnees.add(symbReg,IntToStr(NbreConstExp),' PRECISION CONST');
      for i := 0 to pred(NbreConstExp) do
          donnees.add(ord(grandeurs[indexConstExp[i]].precisionU));
      donnees.add(symbReg,NbreConstExp,' AFF CONST');
      for i := 0 to pred(NbreConstExp) do
          donnees.add(ord(grandeurs[indexConstExp[i]].AffSignif));
      if ListeConstAff.count>0 then begin
         donnees.add(symbReg,IntToStr(ListeConstAff.count),' PANEL CONST');
         for i := 0 to pred(ListeConstAff.count) do
             donnees.add(ListeConstAff[i]);
      end;
   end;
   if NbreConstTexte>0 then begin
      donnees.add(symbReg,IntToStr(NbreConstTexte),' NOM TC');
      for i := 0 to pred(NbreConstTexte) do
          donnees.add(grandeurs[indexConstTexte[i]].nom);
      donnees.add(symbReg,NbreConstTexte,' SIGNIF TC');
      for i := 0 to pred(NbreConstTexte) do
          donnees.add(grandeurs[indexConstTexte[i]].fonct.expression);
   end;
   NbreParamNormal := NbreParam[paramNormal];
   if (NbreParamNormal>0) and modelePagesIndependantes then
       while (NbreParamNormal<MaxParametres) and
             (parametres[paramNormal,NbreParamNormal+1].nom<>'')
             do inc(NbreParamNormal);
   if NbreParamNormal>0 then begin
      donnees.add(symbReg,IntToStr(NbreParamNormal),' NOM PARAM');
      for i := 1 to NbreParamNormal do
          donnees.add(parametres[paramNormal,i].nom);
      donnees.add(symbReg,NbreParamNormal,' UNITE PARAM');
      for i := 1 to NbreParamNormal do
          donnees.add(parametres[paramNormal,i].nomUnite);
   end;
   if NbreParam[paramGlb]>0 then begin
       donnees.add(symbReg,IntToStr(NbreParam[paramGlb]),' NOM GLB');
       for i := 1 to NbreParam[paramGlb] do
           donnees.add(parametres[paramGlb,i].nom);
       donnees.add(symbReg,IntToStr(NbreParam[paramGlb]),' VALEUR PARAM GLB');
       for i := 1 to NbreParam[paramGlb] do
           donnes.add(FloatToStrPoint(parametres[paramGlb,i].valeurCourante));
   end;
   donnees.add(symbReg+'1 TRIGO');
   donnes.add(ord(AngleEnDegre));
   donnees.add(symbReg+'1 uniteSI');
   donnees.add(ord(uniteSI));
   if useChi2 then begin
      donnees.add(symbReg+'1 CHI2');
      donnees.add(ord(useChi2));
   end;
   if FichierTrie then begin
      donnees.add(symbReg+'1 TRIDATA');
      donnees.add(ord(FichierTrie));
   end;
   if ModeAcquisition=AcqSimulation then begin
      donnees.add(symbReg+'1 LOGBOX');
      donnees.add(ord(Fvaleurs.logBox.checked));
      donnees.add(symbReg+'1 CBPAGESINDEP');
      donnees.add(ord(Fvaleurs.pagesIndependantesCB.checked));
   end;
   ecritMemoExpressions;
   ecritStrList(TexteModele,' MODELISATION');
   if FgrapheParam<>nil then
      ecritRichEdit(FgrapheParam.MemoModele,' MODELEGLB');
   donnees.add(symbReg,'2 ACQUISITION');
   donnees.add(NomModeAcq[ModeAcquisition]);
   donnees.add(nomExeAcquisition);
end; { ecritEnTete }

Procedure ecritFenetres;
begin
         if FgrapheFFT<>nil then begin
            donnees.add(symbReg+'0 FOURIER');
            FgrapheFFT.ecritConfig;
         end;
         if (Fvaleurs<>nil) and (dispositionFenetre=dNone) then begin
            donnees.add(symbReg+'0 FenetreTxt');
            Fvaleurs.ecritConfig;
         end;
         if FgrapheVariab<>nil then begin
            donnees.add(symbReg+'0 GRAPHE VAR');
            FgrapheVariab.ecritConfig;
         end;
         if FgrapheEuler<>nil then begin
            donnees.add(symbReg+'0 EULER');
            FgrapheEuler.ecritConfig;
         end;
         if FgrapheParam<>nil then begin
            donnees.add(symbReg+'0 GRAPHE CONST');
            FgrapheParam.ecritConfig;
         end;
         if Fstatistique<>nil then begin
            donnees.add(symbReg+'0 STATISTIQUE');
            Fstatistique.ecritConfig;
         end;
end;// ecritFenetres

// EcritFichierUnicode
var page : integer;
begin
     donnees := tstringList.create;
     Screen.cursor := crHourGlass;
     NomFichier := changeFileExt(NomFichier,'.rwu');
     try
     ecritEnTete;
     ecritFenetres;
     for page := 1 to NbrePages do ecritPage(page);
     modifFichier := false;
     donnees.saveToFile(nomfichier);
     except
         AfficheErreur(erWriteFile,0);
     end;
     donnees.free;
     Screen.cursor := crDefault;
end; // ecritFichierUnicode

function TFRegressiMain.LitFichierUnicode : boolean;
var donnees : TstringList;

procedure litPage;
var ligneWinaLire : boolean;

Procedure litValeur(imax : LongInt);
var i,j : LongInt;
begin with pages[pageCourante] do begin
    nmes := imax;
    j := 0;
    try
    while j<nmes do begin
        for i := 0 to pred(NbreVariabExp) do
            read(fichier,valeurVar[i,j]);
        inc(j);
    end;
    except
        nmes := j;
        repeat
           litLigneWin; // trop tard on a dj mang le $2
        until finFichierWin or
              (Length(LigneWin)=0) or
              charinset(ligneWin[1],[symbReg2,symbReg]);
        ligneWinAlire := (Length(LigneWin)>0) and
                         not charInSet(ligneWin[1],[symbReg2,symbReg]);
    end;
    for i := 0 to pred(NbreVariabExp) do
        if isNan(valeurVar[i,pred(nmes)]) then
             nmes := nmes-1;
end end;

Procedure litIncertVariab(imax : integer);
var i,j,jmax : integer;
begin with pages[pageCourante] do begin
    if imax>nmes
       then jmax := nmes
       else jmax := imax;
    try
    for j := 0 to pred(jmax) do begin
        for i := 0 to pred(NbreVariabExp) do
            read(fichier,incertVar[i,j]);
        inc(ligne);
    end;
    inc(ligne,imax-jmax);
    except
    end;
end end;

Procedure litEquivalence(imax : integer);
var i : integer;
    equivalence : Tequivalence;
begin
    for i := 1 to imax do begin
        equivalence := Tequivalence.Create(0,0,0,0,0,0,0,pageCourante);
        with equivalence do begin
           read(fichier,pente,ve,phe);
           read(fichier,x1,y1,x2,y2);
           read(fichier,x1i,y1i,x2i,y2i);
           inc(ligne);
        end;
        if equivalence.pente<>0
           then FgrapheVariab.graphes[1].Equivalences[pageCourante].Add(equivalence)
           else equivalence.Free
    end;
end;

var i,j,imax,choix,iVar : integer;
begin
   if ajoutePage then with pages[pageCourante] do begin
      commentaireP := donnees[ligne];
      inc(ligne);
      while (Length(LigneWin)>0) and (ligneWin[1]=symbReg2) do begin
        imax := NbreLigneWin(ligneWin);
        choix := 0;
        if pos('VALEUR',ligneWin)<>0 then begin
           if pos('VAR',ligneWin)<>0 then choix := 1 else
              if pos('CONST',ligneWin)<>0 then choix := 2 else
              if pos('PARAM',ligneWin)<>0 then choix := 3 else
              if pos('FFT',ligneWin)<>0 then choix := 4 else
              if pos('GLB',ligneWin)<>0 then choix := 5 else
              if pos('STAT',ligneWin)<>0 then choix := 6;
        end else
        if pos('DEBUT',ligneWin)<>0 then choix := 10 else
        if pos('FIN',ligneWin)<>0 then choix := 11 else
        if pos('OPTIONS',ligneWin)<>0 then choix := 13 else
        if pos('INCERT',ligneWin)<>0 then begin
           if pos('VAR',ligneWin)<>0 then choix := 14 else
           if pos('CONST',ligneWin)<>0 then choix := 15 else
           if pos('GLB',ligneWin)<>0 then choix := 23 else
           if pos('PARAM',ligneWin)<>0 then choix := 20;
        end else
        if pos('STDEV',ligneWin)<>0 then begin
           if pos('PARAM',ligneWin)<>0 then choix := 21;
        end else
        if pos('ORIGINE TEMPS',ligneWin)<>0 then choix := 17 else
        if pos('TEXTE',ligneWin)<>0 then begin
           if pos('VAR',ligneWin)<>0 then choix := 18 else
           if pos('CONST',ligneWin)<>0 then choix := 19;
        end else
        if pos('EQUIVALENCE',ligneWin)<>0 then choix := 22 else
        if pos('INDICATEUR',ligneWin)<>0 then choix := 26 else
        if pos('MODELEPAGE',ligneWin)<>0 then choix := 24 else
        if (pos('BORNES FFT',ligneWin)<>0) and (imax=2) then choix := 25 else
        if pos('BITMAP',ligneWin)<>0 then choix := 16;
        ligneWinalire := true;
        case choix of
             0 : for i := 1 to imax do litLigneWin;
             1 : litValeur(imax);
             2 : for i := 0 to pred(imax) do begin
                 j := indexConstExp[i];
                 try
                 if j=grandeurInconnue
                    then inc(ligne)
                    else readlnNombreWin(ValeurConst[j]);
                 except
                     ValeurConst[j] := 0;
                 end;
             end;
             3 : for i := 1 to imax do readlnNombreWin(valeurParam[paramNormal,i]);
             4 : for i := 1 to imax do readlnNombreWin(valeurParam[paramFFT,i]);
             6 : with stat do begin
                 Nbre := imax;
                 StatOK := true;
                 for i := 0 to pred(imax) do
                     readlnNombreWin(Donnees[i]);
             end;
             10 : for i := 1 to imax do readln(fichier,debut[i]);
             11 : for i := 1 to imax do readln(fichier,fin[i]);
             13 : begin
                active := litBooleanWin;
                experimentale := litBooleanWin;
             end;
             14 : litIncertVariab(imax);
             15 : for i := 0 to pred(imax) do begin
                 j := indexConstExp[i];
                 if j=grandeurInconnue
                    then inc(ligne)
                    else readlnNombreWin(incertConst[j]);
             end;
             16 : begin
                  inc(ligne);
                  NomFichierBitmap := ligneWin;
             end;
             17 : inc(ligne);
             18 : for i := 0 to pred(NbreVariabTexte) do begin
                      iVar := indexVariabTexte[i];
                      for j := 0 to pred(nmes) do begin
                          inc(ligne);
                          texteVar[iVar,j] := ligneWin;
                      end;
             end;
             19 : for i := 0 to pred(imax) do begin
                      j := indexConstTexte[i];
                      inc(ligne);
                      if j<>grandeurInconnue then begin
                            texteConst[j] := ligneWin;
                            valeurConst[j] := 0;
                      end;
             end;
             20 : for i := 1 to imax do readlnNombreWin(incertParam[i]);
             21 : for i := 1 to imax do readlnNombreWin(ecartTypeParam[i]);
             22 : litEquivalence(imax);
             23 : for i := 0 to pred(imax) do begin
                      j := indexConstGlb[i];
                      if j=grandeurInconnue
                        then inc(ligne)
                        else readlnNombreWin(grandeurs[j].incertCourante);
             end;
             24 : begin
                 for i := 1 to imax do begin
                     inc(ligne);
                     TexteModeleP.add(ligneWin);
                 end;
                 FGrapheVariab.ModelePagesIndependantesMenu.Checked := true;
                 ModelePagesIndependantes := true;                 
             end;
             25 : begin
                readln(fichier,debutFFT);
                readln(fichier,finFFT);
             end;
             26 : begin
                readln(fichier,iVar);
                try
                if (iVar>=0) and (iVar<indicateurDlg.indicateurs.count)
                   then indicateurP := Tindicateur(indicateurDlg.indicateurs[iVar])
                   else indicateurP := nil;
                except
                indicateurP := nil;
                end;
             end;
        end;
        if ligneWinaLire then inc(ligne);
     end;{while}
     if ModeAcquisition=AcqSimulation then begin
          MiniSimulation := valeurVar[0,0];
          MaxiSimulation := valeurVar[0,pred(nmes)];
          VerifMinMaxReal(MiniSimulation,MaxiSimulation);
          if MiniSimulation=MaxiSimulation then
             MaxiSimulation := MiniSimulation+1;
          valeurVar[0,pred(nmes)] := MaxiSimulation;
          MaxiSimulation := MaxiSimulation+(maxiSimulation-miniSimulation)/pred(nmes);
          valeurVar[0,0] := MiniSimulation;
      end;
   end
   else litLigneWin;
end; { litPage }

procedure litListe;

procedure litMemoGrandeurs(imax : integer);

Procedure VerifBoucle;
var LigneMaj : string;

Function VerifN(strN : string) : boolean;
var posN : integer;
begin
    posN := pos(strN,ligneMaj);
    result := posN>10;
    if result then begin
       delete(ligneWin,posN,length(strN));
       insert(' '+grandeurs[cNombre].nom,ligneWin,posN)
    end;
end;

begin
     LigneMaj := UpperCase(LigneWin);
     if copy(ligneMaj,1,4)='FOR ' then begin
         if verifN(' NOMBRE') then exit;
         if verifN(' NBRE') then exit;
         if verifN(' NPOINTS') then exit;
         if verifN(' N') then exit;
     end;
end;

var i : integer;
begin
     for i := 1 to imax do begin
         VerifBoucle;
         Fvaleurs.Memo.lines.add(ligneWin);
         inc(ligne);
     end;
     Fvaleurs.Memo.lines.Add('');
end;

procedure litNom(Agenre : TgenreGrandeur;imax : integer);
var i : integer;
begin
     for i := 1 to imax do begin
         AjouteExperimentale(ligneWin,Agenre);
         inc(ligne)
     end;
end;

procedure litNomConstTexte(imax : integer);
var i : integer;
    index : integer;
begin
     for i := 1 to imax do begin
         index := AjouteExperimentale(ligneWin,constante);
         grandeurs[index].fonct.genreC := g_texte;
         inc(ligne)
     end;
     construireIndex;
end;

procedure litNomParam(genre : TgenreGrandeur;imax : integer;affecte : boolean);
var i : integer;
begin
     if affecte then NbreParam[genre] := imax;
     for i := 1 to imax do begin
         parametres[genre,i].nom := ligneWin;
         inc(ligne)
     end;
end;

procedure litGenreVariab(Nbrei : integer);
var i : integer;
    genre : TgenreCalcul;
begin
     for i := 0 to pred(Nbrei) do begin
         genre := TgenreCalcul(StrToInt(ligneWin));
         if genre<>g_experimentale then begin
              grandeurs[i].fonct.genreC := genre;
              dec(NbreVariabExp);
         end;
         if genre=g_texte then inc(NbreVariabTexte);
         inc(ligne)
     end;
     construireIndex;
end;

procedure litUnite(iDebut,Nbrei : integer);
var i : integer;
begin
     for i := iDebut to pred(iDebut+Nbrei) do begin
         grandeurs[i].NomUnite := ligneWin;
         inc(ligne)
     end;
end;

procedure litAff(iDebut,Nbrei : integer);
var i : integer;
begin
     for i := iDebut to pred(iDebut+Nbrei) do begin
         grandeurs[i].affSignif := ligneWin<>'0';
         inc(ligne)
     end;
end;

procedure litMeca(Nbre : integer);
var i : integer;
    k : integer;
    nomPos : string;
begin
     for i := 0 to pred(Nbre) do with grandeurs[i] do begin
         k := strToInt(ligneWin[1]);
         genreMecanique := TgenreMecanique(k);
         if genreMecanique>gm_position then begin
            nomVarPosition := copy(ligneWin,3,length(ligneWin));
            k := indexNom(nomPos);
            if k=grandeurInconnue then nomvarPosition := '';
         end;
         inc(ligne)
     end;
end;

procedure litUniteParam(imax : integer);
var i : integer;
begin
     for i := 1 to imax do begin
         parametres[paramNormal,i].NomUnite := ligneWin;
         inc(ligne)
     end;
end;

procedure litValeurParamGlb(imax : integer);
var i : integer;
begin
     for i := 1 to imax do begin
         Parametres[paramGlb,i].valeurCourante := StrToFloatWin(ligneWin);
         inc(ligne)
     end;
end;

procedure litSignif(iDebut,Nbrei : integer);
var i : integer;
begin
     for i := iDebut to pred(iDebut+Nbrei) do begin
         grandeurs[i].fonct.expression := ligneWin;
         inc(ligne)
     end;
end;

procedure litPrecision(iDebut,Nbrei : integer);
var i : integer;
begin
     for i := iDebut to pred(iDebut+Nbrei) do begin
         try
         grandeurs[i].precisionU := strToInt(ligneWin);
         except
         end;
         inc(ligne)
     end;
end;

procedure litFormat(iDebut,Nbrei : integer);
var i : integer;
begin
     for i := iDebut to pred(iDebut+Nbrei) do begin
         grandeurs[i].formatU := TnombreFormat(strToInt(ligneWin));
         inc(ligne)
     end;
end;

procedure litIncertitude(Nbrei : integer);
var i : integer;
    posErreur,LongErreur : integer;
begin
     for i := 0 to pred(Nbrei) do begin
         grandeurs[i].IncertCalc.expression := ligneWin;
         grandeurs[i].compileIncert(i,posErreur,LongErreur);
         inc(ligne)
     end;
end;

Procedure litAcquisition(Nligne : byte);
var i : TmodeAcquisition;
    j : byte;
begin
   ModeAcquisition := AcqCan;
   LigneWin := AnsiUpperCase(ligneWin);
   for i := low(TmodeAcquisition) to high(TmodeAcquisition) do
       if ligneWin=NomModeAcq[i] then begin
          ModeAcquisition := i;
          break;
       end;
   if Nligne>=2 then begin
      litLigneWin;
      nomExeAcquisition := ligneWin;
   end;
   inc(Nligne-2);
end;

procedure litModeleGlb(imax : integer);
var i : integer;
begin
    GrapheConstOpen;
    FgrapheParam.MajModelePermis := false;
    FgrapheParam.MemoModele.Clear;
    for i := 0 to pred(imax) do begin
         FgrapheParam.MemoModele.Lines.Add(ligneWin);
         inc(ligne);
    end;
    FgrapheParam.MajModelePermis := true;
end;

procedure litStrList(T : TstringList;imax : integer);
var i : integer;
begin
     for i := 1 to imax do begin
         T.add(donnees[ligne]);
         inc(ligne);
     end;
end;

Procedure litChoix(choix : integer);
var i : integer;
    Nligne : integer;
begin
    Nligne := NbreLigneWin(ligneWin);
    inc(ligne);
    case choix of
         0 : begin
            for i := 1 to Nligne do litLigneWin;
            while (Length(LigneWin)>0) and (ligneWin[1]=symbReg2) do begin
               Nligne := NbreLigneWin(ligneWin);
               inc(Nligne+1);
            end;
         end;
         1 : litPage;
         2 : FgrapheVariab.litConfig;
         3 : begin
            FourierOpen;
            FgrapheFFT.litConfig;
         end;
         4 : litNom(variable,Nligne);
         5 : litNom(constante,Nligne);
         6 : litUnite(NbreVariab,Nligne);
         7 : litUnite(0,Nligne);
         8 : litIncertitude(Nligne);
         9 : begin
            GrapheConstOpen;
            FgrapheParam.litConfig;
         end;
         10 : LitMemoGrandeurs(Nligne);
         12 : LitStrList(TexteModele,Nligne);
         13 : LitModeleGlb(Nligne);
         14 : LitAcquisition(Nligne);
         15 : begin
            StatistiqueOpen;
            Fstatistique.litConfig;
         end;
         16 : begin
             Fvaleurs.logBox.checked := ligneWin<>'0';
             logSimulation := ligneWin<>'0';
             inc(ligne);
         end;
         17 : begin
             AngleEnDegre := ligneWin<>'0';
             inc(ligne);
         end;
         18 : litGenreVariab(Nligne);
         19 : litSignif(NbreVariab,Nligne);
         20 : litSignif(0,Nligne);
         22 : litFormat(NbreVariab,Nligne);
         23 : litFormat(0,Nligne);
         24 : litPrecision(NbreVariab,Nligne);
         25 : litPrecision(0,Nligne);
         26 : litNomParam(paramNormal,Nligne,true);
         28 : litUniteParam(Nligne);
         29 : begin
             uniteSI := ligneWin<>'0';
             inc(ligne);
         end;
         30 : litNomParam(paramNormal,Nligne,false);
         31 : begin
             inc(ligne,2);
         end;
         32 : litNomParam(paramGlb,Nligne,true);
         33 : litValeurParamGlb(Nligne);
         34 : litAff(NbreVariab,Nligne);
         35 : litAff(0,Nligne);
         36 : litMeca(Nligne);
         38 : begin
             Fvaleurs.PagesIndependantesCB.checked := ligneWin<>'0';
             inc(ligne);
         end;
         39 : litNomConstTexte(Nligne);
         40 : litSignif(NbreVariab+NbreConstExp,Nligne);
         42 : begin
             UseChi2 := ligneWin<>'0';
             inc(ligne);
         end;
         43 : begin
             nomGrandeurTri := ligneWin;
             inc(ligne);
         end;
         44 : begin
             FichierTrie := ligneWin<>'0';
             inc(ligne);
         end;
         45 : Fvaleurs.litConfig;
         46 : begin
            EulerOpen;
            FgrapheEuler.litConfig;
         end;
         47 : begin
              stoechBecherGlb := strToInt(ligneWin);
              inc(ligne);
              stoechBuretteGlb := strToInt(ligneWin);
              inc(ligne);
         end;
         48 : begin
            StatistiqueOpen;
            Fstatistique.litConfig;
         end;
         49 : litNom(constanteGlb,Nligne);
   end;
end;

begin
    if ligneWin='PAGESINDEP' then ligneWin := 'CBPAGESINDEP';
    if Pos('PAGE',ligneWin)=4 then litChoix(1)
    else if Pos('GRAPHE',ligneWin)=4 then begin
       if Pos('CONST',ligneWin)<>0
          then litChoix(9)
          else litChoix(2);
    end
    else if Pos('FOURIER',ligneWin)=4 then litChoix(3)
    else if Pos('STATISTIQUE',ligneWin)=4 then litChoix(48)
    else if Pos('EULER',ligneWin)=4 then litChoix(46)
    else if Pos('NOM',ligneWin)<>0 then begin
        if Pos('CONST',ligneWin)<>0 then litChoix(5)
        else if Pos('VAR',ligneWin)<>0 then litChoix(4)
        else if Pos('PARAM',ligneWin)<>0 then litChoix(26)
        else if Pos('SAUVE',ligneWin)<>0 then litChoix(30)
        else if Pos('GLB',ligneWin)<>0 then litChoix(32)
        else if Pos('TC',ligneWin)<>0 then litChoix(39) { texte const }
        else litChoix(0)
    end
    else if (Pos('MECA',ligneWin)<>0) and
       (Pos('VAR',ligneWin)<>0) then litChoix(36)
    else if (Pos('GENRE',ligneWin)<>0) and
       (Pos('VAR',ligneWin)<>0) then litChoix(18)
    else if Pos('UNITE',ligneWin)<>0 then begin
       if Pos('CONST',ligneWin)<>0 then litChoix(6)
       else if Pos('VAR',ligneWin)<>0 then litChoix(7)
       else if Pos('PARAM',ligneWin)<>0 then litChoix(28);
    end
    else if Pos('FORMAT',ligneWin)<>0 then begin
       if Pos('CONST',ligneWin)<>0 then litChoix(22)
       else if Pos('VAR',ligneWin)<>0 then litChoix(23)
       else litChoix(0)
    end
    else if Pos('AFF',ligneWin)<>0 then begin
       if Pos('CONST',ligneWin)<>0 then litChoix(34)
       else if Pos('VAR',ligneWin)<>0 then litChoix(35)
       else litChoix(0)
    end
    else if Pos('PRECISION',ligneWin)<>0 then begin
       if Pos('CONST',ligneWin)<>0 then litChoix(24)
       else if Pos('VAR',ligneWin)<>0 then litChoix(25)
       else litChoix(0)
    end
    else if Pos('SIGNIF',ligneWin)<>0 then begin
       if Pos('CONST',ligneWin)<>0 then litChoix(19)
       else if Pos('VAR',ligneWin)<>0 then litChoix(20)
       else if Pos('TC',ligneWin)<>0 then litChoix(40) { texte const }
       else litChoix(0)
    end
    else if Pos('INCERTITUDE',ligneWin)<>0 then litChoix(8)
    else if Pos('GRANDEURS',ligneWin)<>0 then begin
       if Pos('MEMO',ligneWin)<>0
          then litChoix(10)
          else litChoix(0)
    end
    else if Pos('MODELISATION',ligneWin)<>0 then litChoix(12)
    else if Pos('TRIGO',ligneWin)<>0 then litChoix(17)
    else if Pos('CHI2',ligneWin)<>0 then litChoix(42)
    else if Pos('TRIDATA',ligneWin)<>0 then litChoix(44)
    else if Pos('MODELEGLB',ligneWin)<>0 then litChoix(13)
    else if Pos('ACQUISITION',ligneWin)<>0 then litChoix(14)
    else if Pos('STATISTIQUE',ligneWin)=4 then litChoix(15)
    else if Pos('LOGBOX',ligneWin)=4 then litChoix(16)
    else if Pos('CBPAGESINDEP',ligneWin)=4 then litChoix(38)
    else if Pos('uniteSI',ligneWin)<>0 then litChoix(29)
    else if Pos('DATETIME',ligneWin)=4 then litChoix(31)
    else if pos('VALEUR PARAM GLB',ligneWin)<>0 then litChoix(33)
    else if pos('GrandeurTri',ligneWin)<>0 then litChoix(43)
    else if pos('FenetreTxt',ligneWin)<>0 then litChoix(45)
    else if pos('DOSAGE',ligneWin)<>0 then litChoix(47)
    else litChoix(0)
end; { litListe }

procedure litFichierRW3;
begin
     inc(ligne);
     FichierTrie := dataTrieGlb;
     while (Length(LigneWin)>0) and (ligneWin[1]=symbReg) do litListe;
     if pageCourante>0 then begin
        LitFichierWin := true;
        pages[pageCourante].affecteConstParam;
        pages[pageCourante].affecteVariableP(false);
     end;
end;

var i,j : integer;
    index : integer;
    trouve : boolean;
    p : codePage;
begin { LitFichierWin }
     LectureFichier := true;
     result := false;
     codeErreurF := erFileData;
     ModeAcquisition := AcqClavier;
     FileMode := fmOpenRead;
     FGrapheVariab.ModelePagesIndependantesMenu.Checked := false;
     ModelePagesIndependantes := false;
     finFichierWin := false;
     try
     if not enTeteRWU then begin
          afficheErreur(erFormat,0);
          lectureFichier := false;
          exit
     end;
     for i := 0 to MaxParamAnim do paramAnimManuelle[i].init;
     litFichierRW3;
     except
         codeErreurF := erReadFile;
         result := false;
     end;
     for i := pred(NbreVariabTexte) downto 0 do begin
         index := indexVariabTexte[i];
         trouve := false;
         for p := 1 to NbrePages do
             trouve := trouve or (pages[p].FtexteVar[index]<>nil);
         if not trouve then begin
            grandeurs[index].fonct.genreC := g_forward;
            for j := succ(i) to pred(NbreVariabTexte) do
                indexVariabTexte[j-1] := indexVariabTexte[j];
            dec(NbreVariabTexte);
         end;
     end;
     LectureFichier := false;
end; // LitFichierUnicode

Procedure TFregressiMain.AjouteFichier(NomFichier : string);
var FichierOK : boolean;
    DecodeVariab,DecodeConst : array[codeGrandeur] of codeGrandeur;
    NomFichierCourt : string;
    NbreVariabFichier,NbreVariabExpFichier : integer;

procedure litGenreVariab(Nbrei : integer);
var i : integer;
    genre : TgenreCalcul;
begin
     NbreVariabExpFichier := 0;
     for i := 0 to pred(Nbrei) do begin
         inc(ligne);
         genre := TgenreCalcul(StrToInt(ligneWin));
         if genre=g_experimentale then begin
            inc(NbreVariabExpFichier);
         end;
     end;
     inc(ligne)
end;

procedure litExpression(imax : integer);
var i,posEgal,k : integer;
    nom : string;
begin
    for i := 0 to pred(imax) do begin
        inc(ligne);
        PosEgal := Pos('=',ligneWin);
        if PosEgal>0 then begin
           nom := copy(ligneWin,1,posEgal-1);
           PosEgal := Pos('[',ligneWin);
           if PosEgal>0 then
              nom := copy(nom,1,posEgal-1);
           PosEgal := Pos('''',ligneWin);
           if PosEgal>0 then
              nom := copy(nom,1,posEgal-1);
           k := indexNom(nom);
           if k=grandeurInconnue then
              Fvaleurs.Memo.lines.add(ligneWin);
        end;
    end;
    inc(ligne);
end;

procedure litModele(imax : integer);

procedure litModeleG;
var i : integer;
begin
    FgrapheVariab.MemoModele.Clear;
    TexteModele.Clear;
    for i := 0 to pred(imax) do begin
         litLigneWin;
         TexteModele.add(ligneWin);
         FgrapheVariab.MemoModele.Lines.Add(ligneWin);
    end;
    inc(ligne);
end;

procedure litModeleP;
var i : integer;
begin with pages[pageCourante] do begin
    TexteModeleP.Clear;
    for i := 0 to pred(imax) do begin
         litLigneWin;
         TexteModeleP.add(ligneWin);
    end;
    inc(ligne);
end end;

var i : integer;
begin
    if ModelePagesIndependantes
       then litModeleP
       else if texteModele.count=0
           then litModeleG
           else inc(ligne,imax+1)
end;


procedure litPage;

Procedure litValeur(imax : integer);
var i,j : integer;
begin with pages[pageCourante] do begin
    if imax>MaxMaxVecteur
       then nmes := MaxMaxVecteur
       else nmes := imax;
    j := 0;
    try
    while j<nmes do begin
        for i := 0 to pred(NbreVariabFichier) do
            read(fichier,valeurVar[decodeVariab[i],j]);
        inc(ligne);
        inc(j);
    end;
    j := nmes;
    while j<imax do begin
        inxc(ligne);
        inc(j);
    end;
    except
        nmes := j;
    end;
end end;

var i,j,imax,choix,iVar : integer;
begin
   if ajoutePage then with pages[pageCourante] do begin
      commentaireP := nomFichierCourt+donnees[ligne];
      inc(ligne);
      while (Length(LigneWin)>0) and (ligneWin[1]=symbReg2) do begin
        imax := NbreLigneWin(ligneWin);
        choix := 0;
        if pos('VALEUR',ligneWin)<>0 then begin
           if pos('VAR',ligneWin)<>0 then choix := 1 else
           if pos('CONST',ligneWin)<>0 then choix := 2 else
           if pos('PARAM',ligneWin)<>0 then choix := 5;
        end else
        if pos('TEXTE',ligneWin)<>0 then begin
           if pos('VAR',ligneWin)<>0 then choix := 3 else
           if pos('CONST',ligneWin)<>0 then choix := 4;
        end;
        case choix of
             0 : inc(ligne,imax);
             1 : litValeur(imax);
             2 : for i := 0 to pred(imax) do begin
                 j := decodeConst[i];
                 if j=grandeurInconnue
                    then inc(ligne)
                    else readlnNombreWin(ValeurConst[j]);
             end;
             3 : for i := 0 to pred(NbreVariabTexte) do begin
                      iVar := indexVariabTexte[i];
                      for j := 0 to pred(imax) do begin
                          inc(ligne);
                          texteVar[iVar,j] := donnees[ligne];
                      end;
             end;
             4 : for i := 0 to pred(imax) do begin
                     j := indexConstTexte[i];
                     inc(ligne);
                     if j<>grandeurInconnue then
                        texteConst[j] := donnees[ligne];
             end;
             5 : for i := 1 to imax do readlnNombreWin(valeurParam[paramNormal,i]);
        end;
        inc(ligne);
     end;
   end
   else inc(ligne)
end; // litPage 

Procedure litListe;

Procedure LitVariab(N : integer);
var i,j,k,kc : integer;
    nomCourant : string;
begin
  NbreVariabFichier := N;
  for i := 0 to pred(NbreVariabFichier) do begin
        inc(ligne);
        nomCourant := copy(ligneWin,1,longNom);
        k := indexNom(nomCourant);
        if (i<NbreVariabExp) and
           (k=grandeurInconnue) then begin
           if FusionDlg=nil then
              Application.CreateForm(TFusionDlg, FusionDlg);
           FusionDlg.nom := nomCourant;
           case FusionDlg.showModal of
               idYes  : begin // nouvelle colonne exprimentale
                   k := AjouteExperimentale(NomCourant,variable);
               end;
               idNo : begin // premire colonne libre
                 k := indexNom(FusionDlg.nomCB.text);
                 if k=grandeurInconnue then begin
                    kc := 0;
                    for j := 0 to pred(i) do
                        if decodeVariab[j]=kc then
                         repeat inc(kc)
                         until (grandeurs[kc].fonct.genreC=g_experimentale) or
                           (grandeurs[kc].genreG=variable) or
                           (kc=NbreGrandeurs);
                    if (grandeurs[kc].fonct.genreC=g_experimentale) or
                       (grandeurs[kc].genreG=variable) then k := kc;
                 end;
             end;// idNo
             idCancel : begin
                 afficheErreur(erFileAdd,0);
                 FichierOK := false;
                 exit;
             end;
           end;// case
        end;
        if (i<NbreVariabExp) and
           ((k=grandeurInconnue) or
            (grandeurs[k].fonct.genreC<>g_experimentale) or
            (grandeurs[k].genreG<>variable)) then begin
              afficheErreur(erFileAdd,0);
              FichierOK := false;
              exit;
        end;
        if (i<NbreVariabExp) then DecodeVariab[i] := k;
  end;
  inc(ligne);
end;

Procedure LitConst(NbreConstFichier : integer);
var i,k : integer;
begin
    for i := 0 to pred(NbreConstFichier) do begin
        inc(ligne);
        k := indexNom(ligneWin);
        if k=grandeurInconnue then
           k := ajouteExperimentale(donnees[ligne], constante);
        decodeConst[i] := k;
        if (i<NbreConstExp) and
           ((k=grandeurInconnue) or
           ((grandeurs[k].fonct.genreC<>g_experimentale) or
            (grandeurs[k].genreG<>constante))) then begin
                 afficheErreur(erFileAdd,0);
                 FichierOK := false;
                 exit;
        end;
  end;
  inc(ligne);
end;

var
    Nligne,i : integer;
begin
    Nligne := NbreLigneWin(ligneWin);
    if pos('NOM CONST',ligneWin)<>0
        then LitConst(Nligne)
        else if pos('NOM VAR',ligneWin)<>0
        then LitVariab(Nligne)
        else if pos('GENRE VAR',ligneWin)<>0
        then LitGenreVariab(Nligne)
        else if pos('MODELISATION',ligneWin)<>0
        then litModele(Nligne)
        else if pos('MEMO GRANDEURS',ligneWin)<>0
        then litExpression(Nligne)
        else if pos('PAGE',ligneWin)<>0
        then begin
            inc(ligne);
            litPage
        end
        else begin
           for i := 0 to Nligne do litLigneWin;
           while (Length(LigneWin)>0) and (ligneWin[1]=symbReg2) do begin
               Nligne := NbreLigneWin(ligneWin);
               inc(ligne,Nligne+1);
            end;
       end;
end; // litListe

begin
     finFichierWin := false;
     Ligne := 0;
     if pos('REGRESSI UNICODE',donnees[0])=0
          then AfficheErreur(erFormat,0)
          else begin
              inc(ligne);
              nomFichierCourt := extractFileName(NomFichier)+' : ';
              FichierOK := true;
              while fichierOK and
                   (ligneWin<>'') and
                   (ligneWin[1]=symbReg) do litListe;
          end;
end; // AjouteFichierU

procedure TFRegressiMain.LitCalculU(FileName : string);

Function LitCalculWin : boolean;

Procedure litListe;

procedure litMemoGrandeurs(imax : integer);
var i : integer;
    posEgal : integer;
    nomAjout : string;
    Ajoute : boolean;
begin
     Fvaleurs.Memo.lines.Add('''Ajout');
     for i := 1 to imax do begin
         inc(ligne);
         posEgal := pos('=',ligneWin);
         Ajoute := posEgal=0;
         if not Ajoute then begin
             nomAjout := copy(ligneWin,1,pred(posEgal));
             Ajoute := indexNom(nomAjout)=grandeurInconnue;
         end;
         if ajoute then Fvaleurs.Memo.lines.add(ligneWin);
     end;
     Fvaleurs.Memo.lines.Add('');
     inc(Ligne);
end;

procedure litModele(imax : integer);
var i : integer;
begin
    FgrapheVariab.MemoModele.Clear;
    TexteModele.Clear;
    for i := 0 to pred(imax) do begin
         inc(ligne);
         TexteModele.add(ligneWin);
         FgrapheVariab.MemoModele.Lines.Add(ligneWin);
    end;
    inc(ligne);
end;

procedure litModeleGlb(imax : integer);
var i : integer;
begin
    GrapheConstOpen;
    FgrapheParam.MemoModele.Clear;
    for i := 0 to pred(imax) do begin
         inc(ligne);
         FgrapheParam.MemoModele.Lines.Add(ligneWin);
    end;
    inc(ligne);
end;

Procedure LitVariab(NbreVariabFichier : integer);
var i,k : integer;
begin
  if NbreVariabFichier<NbreVariabExp then begin
     afficheErreur(erFileCalc,0);
     result := false;
     exit;
  end;
  for i := 0 to pred(NbreVariabFichier) do begin
        inc(ligne);
        k := indexNom(copy(ligneWin,1,longNom));
        if (i<NbreVariabExp) and
           ((k=grandeurInconnue) or
           ((grandeurs[k].fonct.genreC<>g_experimentale) or
            (grandeurs[k].genreG<>variable))) then begin
              afficheErreur(erFileCalc,0);
              result := false;
              exit;
        end;
  end;
  inc(ligne);
end;

Procedure LitConst(NbreConstFichier : integer);
var i,k : integer;
begin
    if NbreConstFichier<NbreConstExp then begin
       afficheErreur(erFileCalc,0);
       result := false;
       exit;
    end;
    for i := 0 to pred(NbreConstFichier) do begin
        inc(ligne);
        k := indexNom(copy(ligneWin,1,longNom));
        if (i<NbreConstExp) and
           ((k=grandeurInconnue) or
           ((grandeurs[k].fonct.genreC<>g_experimentale) or
            (grandeurs[k].genreG<>constante))) then begin
                 afficheErreur(erFileCalc,0);
                 result := false;
                 exit;
        end;
  end;
  inc(ligne);
end;

var
    Nligne,i : integer;
begin
    Nligne := NbreLigneWin(ligneWin);
    if pos('NOM CONST',ligneWin)<>0
        then LitConst(Nligne)
        else if pos('NOM VAR',ligneWin)<>0
        then LitVariab(Nligne)
        else if pos('MEMO GRANDEURS',ligneWin)<>0
        then LitMemoGrandeurs(Nligne)
        else if pos('MODELISATION',ligneWin)<>0
        then LitModele(Nligne)
        else if pos('MODELEGLB',ligneWin)<>0
        then LitModeleGlb(Nligne)
        else begin
           for i := 0 to Nligne do litLigneWin;
           while (Length(LigneWin)>0) and (ligneWin[1]=symbReg2) do begin
               Nligne := NbreLigneWin(ligneWin);
               inc(ligne,Nligne+1);
           end;
       end;
end; { litListe }

begin { LitCalculWin }
     result := false;
     try
     Ligne := 0;
     if pos('REGRESSI WINDOWS',donnees[0])=0
          then AfficheErreur(erFormat,0)
          else begin
              inc(ligne);
              result := true;
              repeat
                 if (length(ligneWin)>0) and (ligneWin[1]=symbReg)
                    then litListe
                    else inc(ligne);
              until (ligneWin=symbReg+'1 PAGE COMMENT') or
                    (ligneWin='') or not result;
          end;
     except
         result := false;
         AfficheErreur(erReadFile,0);
     end;
end;{ LitCalculWin }

begin
if pageCourante=0 then begin
   nomFichierData := FileName;
   FinOuvertureFichier(LitFichierWin);
end
else begin try
if FileExists(FileName)
  then begin
     Screen.cursor := crHourGlass;
     if litCalculWin then begin
          FValeurs.MajBtnClick(nil);
          FgrapheVariab.Perform(WM_Reg_Maj,MajFichier,0);
     end;
  end
  else afficheErreur(erFileNotExist+' : '+FileName,0);
  except
  end;
  Screen.cursor := crDefault;
end end; { LitCalculU }


