unit options;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, sysUtils, ComCtrls, registry, Dialogs,
  ImgList, Mask, inifiles, CheckLst,  shlObj,
  vcl.htmlHelpViewer,
  constreg, maths, regutil, uniteker, compile,
  graphker, coordphys, aidekey;

const
  imFFT = 0; // toujours
  imGrapheConst = 1; // toujours
  imStat = 2;
  imModeleGr = 3;
  imLycee = 4;
  imBornes = 5;
  imAnimation = 6;
  imUnite = 7;
  imTableauImpr = 8;
  imPrinterSetUp = 9;
  imBoutonImpr = 10;
  imAcqFond = 11;
  imCornish = 12;
  imVitesse = 13;
  imOptique = 14;
  imInitiationModele = 15;
  imMRU = 16;
  imEuler = 17;

type
  setMenu = set of 0..31;

  TOptionsDlg = class(TForm)
    PageControl: TPageControl;
    CalculTS: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    DegreRG: TRadioGroup;
    Panel1: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    TestEdit: TEdit;
    TabSheet7: TTabSheet;
    FontSizeImprRG: TRadioGroup;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    AcquisitionTS: TTabSheet;
    AcqListBox: TListBox;
    AddAcqBtn: TBitBtn;
    DelAcqBtn: TBitBtn;
    OpenDialog: TOpenDialog;
    PermuteCB: TCheckBox;
    TabSheet8: TTabSheet;
    ToutModuleBtn: TBitBtn;
    AucunBtn: TBitBtn;
    Label2: TLabel;
    MaxCopiesSE: TSpinEdit;
    MenuPermisCLB: TCheckListBox;
    GroupePathLabel: TLabel;
    GroupePathEdit: TEdit;
    GroupePathBtn: TSpeedButton;
    OptionsFichierCB: TCheckBox;
    UseMilliCB: TCheckBox;
    Label3: TLabel;
    ChiffresSignifSE: TSpinEdit;
    LissageLabel: TLabel;
    OrdreFiltrageSE: TSpinEdit;
    Label1: TLabel;
    NbreEdit: TEdit;
    NbreSpinButton: TSpinButton;
    GridPrintCB: TCheckBox;
    DataCanModifCB: TCheckBox;
    Label16: TLabel;
    TabSheet4: TTabSheet;
    TraceDefautRG: TRadioGroup;
    GrilleCB: TCheckBox;
    IncertitudeCB: TCheckBox;
    Label11: TLabel;
    Label17: TLabel;
    OrdreSplineSE: TSpinEdit;
    DimPointSE: TSpinEdit;
    OptionsBtn: TSpeedButton;
    NomColor: TColorBox;
    NonExpColor: TColorBox;
    ResultatColor: TColorBox;
    UniteColor: TColorBox;
    ExpressionColor: TColorBox;
    CommentaireColor: TColorBox;
    GraduationZeroCB: TCheckBox;
    AngleEnDegreCB: TCheckBox;
    SaveCfgAcqCB: TCheckBox;
    GraduationPiCB: TCheckBox;
    IncertitudeRG: TRadioGroup;
    TriCB: TCheckBox;
    ConstUniversBtn: TBitBtn;
    BiochimieBtn: TBitBtn;
    PhysiqueBtn: TBitBtn;
    GeneralLabel: TLabel;
    Memo1: TMemo;
    CoeffEllipseRG: TRadioGroup;
    GroupBox3: TGroupBox;
    LabelTaille: TLabel;
    SpinEditHauteur: TSpinEdit;
    NbreLabel: TLabel;
    NbreSE: TSpinEdit;
    ExtrapoleDerCB: TCheckBox;
    fontSizeMemoRG: TRadioGroup;
    FenetreRG: TRadioGroup;
    UseItalicCB: TCheckBox;
    UseMPCB: TCheckBox;
    Label12: TLabel;
    grapheClipRG: TRadioGroup;
    ImpMonoCB: TCheckBox;
    UniteParCB: TCheckBox;
    IncertitudeHelpBtn: TSpeedButton;
    GroupBox1: TGroupBox;
    AjustageAutoGrCB: TCheckBox;
    AjustageAutoLinCB: TCheckBox;
    UseChi2CB: TCheckBox;
    LevenbergCB: TCheckBox;
    FontDialog: TFontDialog;
    FontBtn: TSpeedButton;
    UniteSICB: TCheckBox;
    TempPathEdit: TEdit;
    TempDirBtn: TSpeedButton;
    GenerallabelBis: TLabel;
    Label14: TLabel;
    Label18: TLabel;
    DataPathEdit: TEdit;
    RepertoireDataBtn: TSpeedButton;
    RazRepDataBtn: TSpeedButton;
    ClavierAvecGrapheCB: TCheckBox;
    Label13: TLabel;
    VideoPathEdit: TEdit;
    VideoPathBtn: TSpeedButton;
    RazRepVideoBtn: TSpeedButton;
    Label15: TLabel;
    wavpathEdit: TEdit;
    WavPathBtn: TSpeedButton;
    RazRepWavBtn: TSpeedButton;
    procedure NbreSpinButtonDownClick(Sender: TObject);
    procedure NbreSpinButtonUpClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure DegreRGClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure NbreEditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure AddAcqBtnClick(Sender: TObject);
    procedure DelAcqBtnClick(Sender: TObject);
    procedure UniteSICBClick(Sender: TObject);
    procedure ToutModuleBtnClick(Sender: TObject);
    procedure AucunBtnClick(Sender: TObject);
    procedure GroupePathBtnClick(Sender: TObject);
    procedure MenuPermisCLBClickCheck(Sender: TObject);
    procedure MenuPermisCLBClick(Sender: TObject);
    procedure OptionsBtnClick(Sender: TObject);
    procedure ModifGrapheClick(Sender: TObject);
    procedure ConstUniversBtnClick(Sender: TObject);
    procedure BiochimieBtnClick(Sender: TObject);
    procedure PhysiqueBtnClick(Sender: TObject);
    procedure CoeffEllipseRGClick(Sender: TObject);
    procedure SpinEditHauteurChange(Sender: TObject);
    procedure UseMPCBClick(Sender: TObject);
    procedure IncertitudeHelpBtnClick(Sender: TObject);
    procedure UseChi2CBClick(Sender: TObject);
    procedure IncertitudeCBClick(Sender: TObject);
    procedure FontBtnClick(Sender: TObject);
    procedure TempDirBtnClick(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure fontSizeMemoRGClick(Sender: TObject);
    procedure RazRepDataBtnClick(Sender: TObject);
    procedure RepertoireDataBtnClick(Sender: TObject);
    procedure WavPathBtnClick(Sender: TObject);
    procedure VideoPathBtnClick(Sender: TObject);
  private
    configGeneraleChargee,modifConfig : boolean;
    MenuW : LongInt;
    pagePrecedente : TTabSheet;
    procedure setBoutonsAcq;
    function AjouteAcq(nomFichier : string;force : boolean) : boolean;
    Procedure LitConfigGenerale;
    procedure LitConfigUtilisateur;
    procedure initConfig;
    procedure litRepertoire(ini : TMemIniFile;stIdent : string;var repDefaut : string);
  public
    modifPreferences,modifDerivee,modifUniteSI,
    modifPolice,modifGraphe : boolean;
    Procedure ResetConfig;
  end;

var
  OptionsDlg: TOptionsDlg;
  MenuPermis : setMenu;
  OptionsMenuFichier : boolean;

implementation

uses Regmain, fft, optcolordlg, graphvar, valeurs, constante;

const TailleFonte : array[0..2] of integer = (10,12,14);
{$R *.DFM}

function EnumFontsProc(var LogFont: TLogFont; var TextMetric: TTextMetric;
  FontType: Integer; Data: Pointer): Integer; stdcall;
var DC: HDC;
    glyphset : PGlyphset;
    oldFont : hFont;
    taille : dword;
    afontRange : PWCrange;
    i : integer;
    bas : char;
    haut : char;
    grecTrouve : boolean;
    chiffreExpTrouve : boolean;
begin
    Result := 1;
    if LogFont.lfFaceName[0]='@' then exit;
    try
    DC := GetDC(0);
    oldFont := SelectObject(dc,createFontIndirect(LogFont));
    taille := GetFontUnicodeRanges(DC,nil);
    getMem(glyphset,taille);
    glyphset.cbThis := taille;
    GetFontUnicodeRanges(DC,GLYPHSET);
    aFontRange := @(glyphset.ranges[0]);
    grecTrouve := false;
    chiffreExpTrouve := false;
    for i := 0 to pred(glyphset.cRanges) do begin
        bas := afontRange^.wclow;
        haut := char(ord(bas)+afontRange^.cglyphs);
        inc(afontRange);
        if (alpha>=bas) and
           (alpha<=haut) then grecTrouve := true;
        if (MoinsExp>=bas) and
           (MoinsExp<=haut) then chiffreExpTrouve := true;
        if (grecTrouve and chiffreExpTrouve) or
           (haut>MoinsExp) then break;
    end;
    FreeMem(glyphSet);
    if grecTrouve and chiffreExpTrouve then
       TStrings(Data).Add(LogFont.lfFaceName);
    SelectObject(dc, oldFont);
    except
    result := 0;
    end;
end;

procedure TOptionsDlg.litRepertoire(ini : TMemIniFile;stIdent : string;var repDefaut : string);
var repTampon : string;
begin
    repTampon := ini.ReadString(stRepertoire,stIdent,repDefaut);
    if repTampon<>'' then repDefaut := repTampon;
end;

function TOptionsDlg.AjouteAcq(nomFichier : string;force : boolean) : boolean;
var nomCourt,nomCourtBis : string;
    posEgal : integer;
    j : integer;
begin
    result := false;
    if nomFichier='' then exit;
    posEgal := pos('=',nomFichier);
    if posEgal>0 then delete(nomFichier,1,posEgal);
    nomFichier := AnsiUpperCase(nomFichier);
    nomCourt := ChangeFileExt(ExtractFileName(nomFichier),'');
    if not force then begin
       nomCourtBis := '';
       for j := 0 to AcqList.Count - 1 do begin
           nomCourtBis := ChangeFileExt(ExtractFileName(AcqList[j]),'');
           if nomCourt=nomCourtBis then break;
       end;
       if nomCourt=nomCourtBis then exit;
    end;
    result := fileExists(nomFichier) and
        (AcqList.indexOf(nomFichier)<0) and
        (nomCourt<>'CONFIGREGRESSI');
    if result then AcqList.Add(nomFichier);
end;

procedure TOptionsDlg.NbreSpinButtonDownClick(Sender: TObject);
begin
     if NbrePointDerivee>MinPointsDerivee then begin
        dec(NbrePointDerivee,2);
        ModifDerivee := true;
        NbreEdit.text := IntToStr(NbrePointDerivee);
     end;
end;

procedure TOptionsDlg.NbreSpinButtonUpClick(Sender: TObject);
begin
     if NbrePointDerivee<MaxPointsDerivee then begin
        inc(NbrePointDerivee,2);
        ModifDerivee := true;
        NbreEdit.text := IntToStr(NbrePointDerivee);
     end;
end;

procedure TOptionsDlg.FontBtnClick(Sender: TObject);
begin
    FontDialog.font.name := FontName;
    if FontDialog.execute then begin
        testEdit.font.name := FontDialog.font.name;
        FontName := FontDialog.font.name;
    end;
end;

procedure TOptionsDlg.fontSizeMemoRGClick(Sender: TObject);
begin
    ModifPolice := true;
end;

procedure TOptionsDlg.FormActivate(Sender: TObject);
var i : integer;
    nom : string;
begin
       inherited;
       ClavierAvecGrapheCB.checked :=  ClavierAvecGraphe;
       FenetreRG.itemIndex := ord(dispositionFenetre);
       TriCB.Checked := DataTrieGlb;
       IncertitudeRG.itemIndex := ord(TraceIncert);
       uniteParCB.checked := UniteParenthese;
       LevenbergCB.checked := LevenbergMarquardt;
       ExtrapoleDerCB.checked := ExtrapoleDerivee;
       GridPrintCB.checked := GridPrint;
       DataCanModifCB.checked := DataCanModifiable;
       SaveCfgAcqCB.checked := SaveConfigAcq;       
       OptionsFichierCB.checked := OptionsMenuFichier;
       GraduationPiCB.checked := GraduationPi;
       NbreEdit.text := IntToStr(NbrePointDerivee);
       DegreRG.itemIndex := DegreDerivee-1;
       MaxCopiesSE.value := MaxCopiesPrinter;
       TraceDefautRG.itemIndex := ord(TraceDefaut);
       GrilleCB.checked := OgQuadrillage in OptionGrapheDefault;
       grapheClipRG.ItemIndex := ord(grapheClip);
       OrdreSplineSE.Value := OrdreLissage;
       OrdreFiltrageSE.Value := OrdreFiltrage;
       DimPointSE.Value := DimPointVGA;
       IncertitudeCB.checked := avecEllipse;
       UseChi2CB.checked := avecChi2;
       UniteSICB.checked := uniteSIglb;
       impmonocb.checked := imprimanteMonochrome;
       ModifDerivee := false;
       ModifPolice := false;
       ModifUniteSI := false;
       ModifPreferences := false;
       ModifGraphe := false;
       PermuteCB.checked := permuteColRow;
       OrdreSplineSE.Value := OrdreLissage;
       OrdreFiltrageSE.Value := OrdreFiltrage;
       UseItalicCB.checked := useItalic;
       AngleEnDegreCB.checked := angleEnDegre;       
       UseMPCB.checked := useMathPlayer;
       ChiffresSignifSE.value := precision;
       if coeffEllipse<1.1
          then CoeffEllipseRG.ItemIndex := 0
          else if coeffEllipse<2
              then CoeffEllipseRG.ItemIndex := 1
              else CoeffEllipseRG.ItemIndex := 2;
       spinEditHauteur.Value := texteGrapheSize;
       NbreSE.Value := NbreTexteMax;              
       case fontSizeMemo of
            10 : FontSizeMemoRG.itemIndex := 0;
            12 : FontSizeMemoRG.itemIndex := 1;
            14 : FontSizeMemoRG.itemIndex := 2;
            else FontSizeMemoRG.itemIndex := 1;
       end;
       case fontSizeImpr of
            10 : FontSizeImprRG.itemIndex := 0;
            12 : FontSizeImprRG.itemIndex := 1;
            else FontSizeImprRG.itemIndex := 0;
       end;
       for i := 0 to pred(menuPermisCLB.items.count) do
           menuPermisCLB.checked[i] := i in menuPermis;
       NonExpColor.selected := couleurNonExp;
       ExpressionColor.selected := couleurExp;
       GroupePathEdit.text := GroupeDir;
       tempPathEdit.text := TempDirReg;
       DataPathEdit.text := DataDir;
       WavPathEdit.text := WavDir;
//       ImagesPathEdit.text := ImagesDir;
       VideoPathEdit.text := VideoDir;
       AcqListBox.clear;
       for i := 0 to pred(AcqList.count) do begin
           Nom := ChangeFileExt(ExtractFileName(AcqList[i]),'');
           AcqListBox.items.Add(Nom);
       end;
       AcquisitionTS.Visible := true;
       AcquisitionTS.Enabled := true;
       GraduationZeroCB.checked := OgZeroGradue in optionGrapheDefault;
       pageControl.activePage := calculTS;
       pagePrecedente := calculTS;
end;

procedure TOptionsDlg.DegreRGClick(Sender: TObject);
begin
      DegreDerivee := 1+DegreRG.itemIndex;
      if (degreDerivee=3) and (NbrePointDerivee<5)
         then begin
              NbrePointDerivee := 5;
              NbreEdit.Text := '5';
         end;
      ModifDerivee := true;
end;

procedure TOptionsDlg.OKBtnClick(Sender: TObject);

procedure SauveOptions;
var i : integer;
    Rini : TMemIniFile;
begin
    try
    Rini := TMemIniFile.create(NomFichierIni);
    try
    if dispositionFenetre<>dNone then
       Rini.WriteInteger('Fenetre','Disposition',ord(dispositionFenetre));
    RIni.writeInteger('Graphe','Clip',ord(grapheClip));
    RIni.writeString('Graphe','Font',FontName);
    Rini.WriteInteger('PenStyle','Tangente',ord(PstyleTangente));
    Rini.WriteInteger('Color','Tangente',pcolorTangente);
    Rini.WriteInteger('Color','MethTangente',CouleurMethodeTangente);
    Rini.WriteInteger('PenStyle','Reticule',ord(PstyleReticule));
    Rini.WriteInteger('Color','Reticule',pcolorReticule);
    Rini.WriteInteger('Color','FondReticule',FondReticule);
    Rini.writeInteger('Drive','Nombre',NbrePointDerivee);
    Rini.writeBool('Drive','Extrapole',ExtrapoleDerivee);
    Rini.WriteBool('Graphe','Grille',OgQuadrillage in OptionGrapheDefault);
    Rini.WriteBool('Graphe','ZeroIdem',OgMemeZero in OptionGrapheDefault);
    Rini.writeInteger('Calcul','OrdreFiltrage',OrdreFiltrage);
    Rini.WriteBool('Calcul','UniteSI',UniteSIglb);
    Rini.writeBool('Calcul','Cosinus',ModeleCosinus);
    Rini.writeBool('Graphe','Clavier',ClavierAvecGraphe);
    Rini.writeInteger('Point','Taille',dimPointVGA);
    Rini.writeInteger('Color','Axe',couleurGrille);
    Rini.writeInteger('Drive','Degr',DegreDerivee);
    Rini.writeInteger('Graphe','ReperePage',ord(reperePage));
    Rini.writeInteger('Format','Chiffres',Precision);
    Rini.writeInteger('Fonte','TailleMemo',FontSizeMemo);
    Rini.writeInteger('Fonte','TexteGraphe',TexteGrapheSize);
    Rini.writeInteger('Graphe','NbreTexte',NbreTexteMax);
    Rini.writeBool('Graphe','ZeroGradue',OgZeroGradue in OptionGrapheDefault);
    Rini.writeBool('Calcul','ModelePourCent',ModelePourCent);
    Rini.writeBool('CoeffCorrel','Affiche',WithCoeffCorrel);
    Rini.writeBool('Graphe','Pvaleur',WithPvaleur);
    Rini.writeInteger('Graphe','AffIncertParam',ord(AffIncertParam));
    Rini.writeBool('Graphe','BandeConfiance',WithBandeConfiance);
    Rini.writeBool('FFT','Optimise',NbreHarmoniqueOptimise);
    Rini.writeBool('FFT','HarmAff',HarmoniqueAff);
    Rini.writeInteger('FFT','Precision',round(precisionFFT*1000));
    Rini.writeBool('Graphe','VisuAjuste',VisualisationAjustement);
    Rini.writeBool('Graphe','Ellipse',avecEllipse);
    Rini.writeBool('Regressi','Chi2',avecChi2);
    Rini.WriteBool('Regressi','AjusteAutoLin',AjustageAutoLinCB.checked);
    Rini.WriteBool('Regressi','Levenberg',LevenbergMarquardt);
    Rini.WriteBool('Regressi','AjusteAutoGr',AjustageAutoGrCB.checked);
    Rini.WriteBool('Regressi','Permute',PermuteColRow);
    Rini.WriteBool('Regressi','DataTrie',DataTrieGlb);
    Rini.WriteBool('Regressi','UnitePar',UniteParenthese);
    Rini.WriteInteger('Regressi','IncertRect',ord(TraceIncert));
    Rini.WriteBool('Regressi','GraduationPi',GraduationPi);
    Rini.WriteInteger('Graphe','CoeffEllipse',CoeffEllipseRG.itemIndex);
    Rini.WriteBool('Graphe','Rappel3',RappelTroisGraphes);   
    Rini.WriteBool('Calcul','Degre',AngleEnDegre);
    Rini.WriteBool('Calcul','Decibel',ModeleDecibel);
    Rini.WriteBool('Calcul','Qualite',ModeleFacteurQualite);
    Rini.writeBool('Calcul','Cosinus',ModeleCosinus);
    Rini.WriteBool('Regressi','Italique',UseItalic);
    Rini.WriteBool('Regressi','MathPlayer',UseMathPlayer);
    Rini.writeInteger('Impression','Fonte',FontSizeImpr);
    Rini.writeInteger('Graphe','WidthEcran',penWidthVGA);
    Rini.writeInteger('Graphe','WidthGrid',penWidthGrid);
    Rini.writeInteger('Graphe','TailleTick',tailleTick);
    Rini.DeleteKey('Impression','Bold');
    Rini.writeBool('Regressi','DataModif',DataCanModifiable);
    Rini.writeBool('Regressi','SaveCfgAcq',SaveConfigAcq);
    Rini.EraseSection('Acquisition');
    for i := 0 to pred(AcqList.count) do
        Rini.writeString('Acquisition',IntToStr(i),AcqList[i]);
    Rini.WriteInteger('Regressi','Menus',LongInt(MenuPermis));
    Rini.WriteString(stRepertoire,'Groupe',GroupeDir);
    Rini.WriteString(stRepertoire,'Temp',TempDirReg);
    Rini.WriteString(stRepertoire,'ffmpeg',ffMpegExe);
    Rini.WriteString(stRepertoire,'Data',DataDir);
    Rini.WriteString(stRepertoire,'Images',ImagesDir);
    Rini.WriteString(stRepertoire,'AVI',VideoDir);
    Rini.WriteString(stRepertoire,'WAV',WavDir);
    Rini.WriteString('Fonte','Name',FontName);
    Rini.WriteInteger('Graphe','TracePoint',ord(traceDefaut));
    for i := 0 to pred(NbreCouleur) do begin
        Rini.writeInteger('Color','C'+IntToStr(i),couleurPages[i]);
        Rini.writeInteger('PenStyle','C'+IntToStr(i),ord(stylePages[i]));
        Rini.writeInteger('PointStyle','C'+IntToStr(i),ord(MotifPages[i]));
    end;
    for i := 1 to MaxOrdonnee do begin
       Rini.writeInteger('Color','O'+IntToStr(i),couleurInit[i]);
       Rini.writeInteger('PointStyle','O'+IntToStr(i),ord(MotifInit[i]));
    end;
    Rini.UpdateFile;
    finally
    Rini.free;
    end;
    except
    end;
end;

begin // OKBtnClick
     modifConfig := true;
     UniteParenthese := uniteParCB.checked;
     DataTrieGlb := TriCB.Checked;
     ClavierAvecGraphe := ClavierAvecGrapheCB.checked;
     FichierTrie := DataTrieGlb;
     dispositionFenetre := TdispositionFenetre(FenetreRG.itemIndex);
     TraceDefaut := TtraceDefaut(TraceDefautRG.itemIndex);
     if GraduationZeroCB.checked
        then include(optionGrapheDefault,OgZeroGradue)
        else exclude(optionGrapheDefault,OgZeroGradue);
     avecEllipse := IncertitudeCB.checked;
     DimPointVGA := DimPointSE.value;
     imprimanteMonochrome := impmonocb.checked;
     grapheClip := TgrapheClipBoard(grapheClipRG.itemIndex);
     OrdreLissage := OrdreSplineSE.Value;
     OrdreFiltrage := OrdreFiltrageSE.Value;     
     ModifDerivee := ModifDerivee or (ExtrapoleDerivee<>ExtrapoleDerCB.checked);
     ExtrapoleDerivee := ExtrapoleDerCB.checked;
     LevenbergMarquardt := LevenbergCB.checked;
     if GrilleCB.checked
         then include(OptionGrapheDefault,OgQuadrillage)
         else exclude(OptionGrapheDefault,OgQuadrillage);
     MaxCopiesPrinter := MaxCopiesSE.value;
     GraduationPi := GraduationPiCB.checked;
     DataCanModifiable := DataCanModifCB.checked;
     SaveConfigAcq := SaveCfgAcqCB.checked;
     GridPrint := GridPrintCB.checked;
     fontSizeMemo := tailleFonte[FontSizeMemoRG.itemIndex];
     TexteGrapheSize := spinEditHauteur.value;
     NbreTexteMax := NbreSE.value;
     fontSizeImpr := tailleFonte[FontSizeImprRG.itemIndex];
     precision := chiffresSignifSE.value;
     permuteColRow := PermuteCB.checked;
     UseItalic := UseItalicCB.checked;
     AngleEnDegre := AngleEnDegreCB.checked;
     UniteSIglb := UniteSICB.checked;
     UseMathPlayer := UseMPCB.checked;
     avecChi2 := UseChi2CB.checked;
     if avecChi2 then avecEllipse := true;
     couleurNonExp := NonExpColor.selected;
     couleurExp := ExpressionColor.selected;
     OrdreLissage := OrdreSplineSE.Value;
     OrdreFiltrage := OrdreFiltrageSE.Value;
     TraceIncert := Tincertitude(IncertitudeRG.itemIndex);
     tempDirReg := tempPathEdit.text;
     DataDir := DataPathEdit.text;
   // ImagesDir := ImagesPathEdit.text;
     WavDir := WavPathEdit.text;
     VideoDir := VideoPathEdit.text;
     if not SysUtils.DirectoryExists(TempDirReg) then TempDirReg := 'c:\Temp';
     groupeDir := groupePathEdit.text;
     removeBackSlash(groupeDir);
     case CoeffEllipseRG.ItemIndex of
         0 : coeffEllipse := 1; // 68 %
         1 : coeffEllipse := 1.96; // 95 %
         2 : coeffEllipse := 2.58; // 99 %
     end;
     try
     SauveOptions;
     except
     end;
end; // OKBtnClick

procedure TOptionsDlg.NbreEditChange(Sender: TObject);
begin
     ModifDerivee := true
end;

procedure TOptionsDlg.FormCreate(Sender: TObject);
var cheminReg : string;
    cheminReg1,cheminReg2 : string;

procedure ChercheAcq(nom : string);
var nomFichier : string;
begin
     if AcqList.count<=MaxAcq then begin
         nom := Nom+'.exe';
         nomFichier := cheminReg+Nom;
         if AjouteAcq(nomFichier,false) then exit;
         if cheminReg1<>cheminReg then begin
            nomFichier := cheminReg1+Nom;
            if AjouteAcq(nomFichier,false) then exit;
         end;
         if cheminReg2<>cheminReg then  begin
            nomFichier := cheminReg2+Nom;
            if AjouteAcq(nomFichier,false) then exit;
         end;
     end;
end;

begin
  OptionsMenuFichier := false;
  ModifConfig := false;
  MenuW := High(LongInt);
  MenuPermis := SetMenu(MenuW);
  exclude(MenuPermis,imCornish);
  exclude(MenuPermis,imEuler);
  ConfigGeneraleChargee := false;
  cheminReg := extractFilePath(paramstr(0));
  cheminReg1 := ProgramDir+'Evariste\Regressi\';
  cheminReg2 := ProgramDir+'Regressi\';
  initConfig;
  try
  litConfigUtilisateur;
  except
  end;
  try
  litConfigGenerale;  // prdomine
  except
// Erreur lecture regressi.ini
  end;
// vrification de l'existence du rpertoire
  if (VideoDir<>'') and
     not(SysUtils.DirectoryExists(VideoDir))
        then VideoDir := '';
  if not(ConfigGeneraleChargee) or (AcqList.count=0) then begin
  // Orphy
       ChercheAcq('GTI2_GTS2');ChercheAcq('GTI2_Oscillo');
       ChercheAcq('Portab2');ChercheAcq('OrphyLab');ChercheAcq('ECaptoo');
  // autres
       ChercheAcq('RS232');ChercheAcq('Regavi');
       ChercheAcq('Candibus');ChercheAcq('CandiPCI');
       ChercheAcq('ESAO3');ChercheAcq('Table');
  // spectro
       ChercheAcq('S250');ChercheAcq('CECIL');ChercheAcq('Biochrom');
       ChercheAcq('JENWAY6300');ChercheAcq('JENWAY6500');ChercheAcq('JENWAY7300');
       ChercheAcq('EasySpec');ChercheAcq('SpectroCCD');ChercheAcq('shimadzu');
 // oscillo
       ChercheAcq('Metrix');
       ChercheAcq('HM407');ChercheAcq('HM305');
       ChercheAcq('TDS200');ChercheAcq('TDS2000');
       ChercheAcq('AgilentDSO');ChercheAcq('HP54600');
 // Descartes
       ChercheAcq('WebcamIntensite');
       ChercheAcq('PhidgetForce');ChercheAcq('ieOrphy');
  end;
  GeneralLabel.Visible := ConfigGeneraleChargee;
  GeneralLabelBis.Visible := ConfigGeneraleChargee;
  ChiffresSignifSE.minValue := precisionMin;
  ChiffresSignifSE.maxValue := precisionMax;
end; // FormCreate

procedure TOptionsDlg.HelpBtnClick(Sender: TObject);
begin
     Application.HelpContext(HELP_Options)
end;

procedure TOptionsDlg.IncertitudeCBClick(Sender: TObject);
begin
    ModifGraphe := true;
    usechi2CB.checked := incertitudeCB.checked;
end;

procedure TOptionsDlg.IncertitudeHelpBtnClick(Sender: TObject);
begin
(*
 if AideIncertitudeForm=nil then
     Application.CreateForm(TAideIncertitudeForm, AideIncertitudeForm);
  AideIncertitudeForm.pageControl1.activePage := AideIncertitudeForm.tabSheet3;
  AideIncertitudeForm.show;
  *)
      Application.helpContext(HELP_Incertitudes);
end;

procedure TOptionsDlg.UseChi2CBClick(Sender: TObject);
begin
    incertitudeCB.Checked := usechi2CB.checked;
end;

procedure TOptionsDlg.UseMPCBClick(Sender: TObject);
begin
  inherited;
  modifPreferences := true;
end;

procedure TOptionsDlg.VideoPathBtnClick(Sender: TObject);
begin
     if SelectDir(VideoDir)
        then VideoPathEdit.text := videoDir;
end;

procedure TOptionsDlg.WavPathBtnClick(Sender: TObject);
begin
     if SelectDir(WavDir)
        then WavPathEdit.text := wavDir;
end;

procedure TOptionsDlg.AddAcqBtnClick(Sender: TObject);
var NomFichier : String;
    i : integer;
begin
     if OpenDialog.execute then begin
        NomFichier := AnsiUpperCase(OpenDialog.FileName);
        i := AcqList.indexOf(NomFichier);
        if i<0 then begin
             if AcqList.count=MaxAcq+1 then AcqList.delete(MaxAcq);
             AcqList.Add(NomFichier);
             AcqListBox.Items.Add(ChangeFileExt(ExtractFileName(NomFichier),''));
        end;
        setBoutonsAcq;
     end;
end;

procedure TOptionsDlg.DelAcqBtnClick(Sender: TObject);
var numero : integer;
begin
     Numero := AcqListBox.itemIndex;
     if Numero>=0 then begin
        AcqListBox.Items.Delete(Numero);
        AcqList.Delete(Numero);
        SetBoutonsAcq;
     end;
end;

procedure TOptionsDlg.SetBoutonsAcq;
begin
    AddAcqBtn.enabled := AcqList.count<=MaxAcq;
    DelAcqBtn.enabled := AcqList.count>0;
end;

procedure TOptionsDlg.UniteSICBClick(Sender: TObject);
begin
    ModifUniteSI := true
end;

procedure TOptionsDlg.TempDirBtnClick(Sender: TObject);
begin
     if SelectDir(TempDirReg)
        then TempPathEdit.text := tempDirReg;
end;

procedure TOptionsDlg.ToutModuleBtnClick(Sender: TObject);
var i : integer;
begin
     MenuW := High(LongInt);
     MenuPermis := setMenu(MenuW);
     for i := 0 to pred(MenuPermisCLB.items.Count) do
           MenuPermisCLB.checked[I] := true;
end;

procedure TOptionsDlg.AucunBtnClick(Sender: TObject);
var i : integer;
begin
     MenuPermis := [];
     for i := 0 to pred(MenuPermisCLB.items.Count) do
            MenuPermisCLB.checked[i] := false;
end;

procedure TOptionsDlg.GroupePathBtnClick(Sender: TObject);
begin
     if SelectDir(GroupeDir)
        then GroupePathEdit.text := groupedir;
end;

procedure TOptionsDlg.MenuPermisCLBClickCheck(Sender: TObject);
var i : integer;
begin
     for i := 0 to pred(menuPermisCLB.items.count) do
         if menuPermisCLB.checked[i]
            then include(MenuPermis,i)
            else exclude(MenuPermis,i)
end;

procedure TOptionsDlg.MenuPermisCLBClick(Sender: TObject);
begin
     modifPreferences := true
end;

procedure TOptionsDlg.OptionsBtnClick(Sender: TObject);
begin
   OptionCouleurDlg := TOptionCouleurDlg.create(self);
   OptionCouleurDlg.DlgGraphique := nil;
   OptionCouleurDlg.ShowModal;
   OptionCouleurDlg.free;
   ModifGraphe := true;
end;

procedure TOptionsDlg.ModifGrapheClick(Sender: TObject);
begin
    ModifGraphe := true;
end;

Procedure TOptionsDlg.LitConfigGenerale;
var i,z : integer;
    ini : TMemIniFile;
    nomFichier : string;
begin
  nomFichier := changeFileExt(application.exeName,'.ini');
  ConfigGeneraleChargee := FileExists(NomFichier);
  if not ConfigGeneraleChargee then exit;
  ini := TMemIniFile.create(NomFichier);
  try
  SauvegardePermise := Ini.ReadBool('Sauvegarde','Active',true);
  AvecModeleManuel := Ini.ReadBool('Modele','Manuel',AvecModeleManuel);
  ClavierAvecGraphe := ini.readBool('Graphe','Clavier',true);
  GraduationZeroCB.checked := Ini.ReadBool('Graphe','ZeroGradue',false);
  if GraduationZeroCB.checked then include(OptionGrapheDefault,ogZeroGradue);
  ModeleCosinus := ini.ReadBool('Calcul','Cosinus',ModeleCosinus);
  PstyleTangente := TpenStyle(ini.ReadInteger('PenStyle','Tangente',ord(PstyleTangente)));
  grapheClip := TgrapheClipBoard(ini.ReadInteger('Graphe','Clip',0));
  OrdreFiltrage := ini.ReadInteger('Calcul','OrdreFiltrage',OrdreFiltrage);
  CoeffEllipseRG.itemIndex := ini.ReadInteger('Graphe','CoeffEllipse',0);
  PcolorTangente := ini.ReadInteger('Color','Tangente',PcolorTangente);
  CouleurMethodeTangente := ini.ReadInteger('Color','MethTangente',CouleurMethodeTangente);
  PstyleReticule := TpenStyle(ini.ReadInteger('PenStyle','Reticule',ord(PstyleReticule)));
  PcolorReticule := ini.ReadInteger('Color','Reticule',PcolorReticule);
  FondReticule := ini.ReadInteger('Color','FondReticule',FondReticule);
  precision := ini.ReadInteger('Format','Chiffres',precision);
  modelePourCent := ini.ReadBool('Calcul','ModelePourCent',false);
  UniteSIglb := ini.ReadBool('Calcul','UniteSI',UniteSIglb);
  //option sauve aussi dans le fichier de donnes
  if precision<precisionMin then precision := precisionMin;
  if precision>precisionMax then precision := precisionMax;
  LevenbergMarquardt := ini.ReadBool('Regressi','Levenberg',LevenbergMarquardt);
  AngleEnDegre := ini.ReadBool('Calcul','Degre',AngleEnDegre);
  ModeleDecibel := ini.ReadBool('Calcul','Decibel',ModeleDecibel);
  ModeleFacteurQualite := ini.ReadBool('Calcul','Qualite',ModeleFacteurQualite);
  NbreHarmoniqueOptimise := ini.ReadBool('FFT','Optimise',NbreHarmoniqueOptimise);
  HarmoniqueAff := ini.ReadBool('FFT','HarmAff',HarmoniqueAff);
  z := ini.readInteger('FFT','Precision',5);
  if z<3 then z := 3; if z>100 then z := 100;
  precisionFFT := z/1000;
  litRepertoire(ini,'Temp',TempDirReg);
  litRepertoire(ini,'Groupe',GroupeDir);
  litRepertoire(ini,'Data',DataDir);
  litRepertoire(ini,'WAV',WavDir);
  litRepertoire(ini,'AVI',VideoDir);
  litRepertoire(ini,'Images',ImagesDir);
  litRepertoire(ini,'fffmpeg',ffmpegexe);
  FontName := ini.ReadString('Fonte','Name',FontName);
  FontName := Ini.ReadString('Graphe','Font',FontName);
  DispositionFenetre := TDispositionFenetre(ini.ReadInteger('Fenetre','Disposition',ord(DispositionFenetre)));
  NbrePointDerivee := ini.ReadInteger('Drive','Nombre',NbrePointDerivee);
  ExtrapoleDerivee := ini.ReadBool('Drive','Extrapole',true);
  DegreDerivee := ini.ReadInteger('Drive','Degr',DegreDerivee);
  if degreDerivee<1 then degreDerivee := 1;
  if degreDerivee>3 then degreDerivee := 3;
  TraceDefaut := TtraceDefaut(ini.ReadInteger('Graphe','TracePoint',ord(TraceDefaut)));
  if ini.ReadBool('Graphe','Grille',true)
      then include(OptionGrapheDefault,OgQuadrillage)
      else exclude(OptionGrapheDefault,OgQuadrillage);
  if ini.ReadBool('Graphe','ZeroIdem',true)
      then include(OptionGrapheDefault,OgMemeZero)
      else exclude(OptionGrapheDefault,OgMemeZero);
  VisualisationAjustement := ini.ReadBool('Graphe','VisuAjuste',VisualisationAjustement);
  avecEllipse := ini.ReadBool('Graphe','Ellipse',avecEllipse);
  MaxCopiesPrinter := ini.ReadInteger('Impression','Copies',MaxCopiesPrinter);
  GridPrint := ini.ReadBool('Impression','Grid',GridPrint);
  fontSizeMemo := ini.ReadInteger('Fonte','TailleMemo',fontSizeMemo);
  TexteGrapheSize := ini.ReadInteger('Fonte','TexteGraphe',TexteGrapheSize);
  if texteGrapheSize>8 then texteGrapheSize := 5;
  NbreTexteMax := ini.ReadInteger('Graphe','NbreTexte',NbreTexteMax);
  DimPointVGA := ini.ReadInteger('Point','Taille',3);
  penWidthVGA := 1;
  penWidthGrid := ini.readInteger('Graphe','WidthGrid',penWidthGrid);
  tailleTick := ini.readInteger('Graphe','TailleTick',tailleTick);
  fontSizeImpr := ini.ReadInteger('Impression','Fonte',fontSizeImpr);
  DataCanModifiable := ini.ReadBool('Regressi','DataModif',DataCanModifiable);
  SaveConfigAcq := ini.ReadBool('Regressi','SaveCfgAcq',SaveConfigAcq);
  avecChi2 := ini.ReadBool('Regressi','Chi2',avecChi2);
  avecEllipse := ini.ReadBool('Graphe','Ellipse',avecEllipse);
  if avecChi2 then avecEllipse := true;
  TraceIncert := Tincertitude(ini.ReadInteger('Regressi','IncertRect',ord(TraceIncert)));
  UniteParenthese := ini.ReadBool('Regressi','UnitePar',UniteParenthese);
  DataTrieGlb := ini.ReadBool('Regressi','DataTrie',DataTrieGlb);
  GraduationPi := ini.ReadBool('Regressi','GraduationPi',GraduationPi);
  UseItalic := ini.ReadBool('Regressi','Italique',UseItalic);
  UseMathPlayer := ini.ReadBool('Regressi','MathPlayer',UseMathPlayer);
  RappelTroisGraphes := ini.ReadBool('Graphe','Rappel3',RappelTroisGraphes);
  couleurExp := Ini.ReadInteger('Color','Exp.',couleurExp);
  WithCoeffCorrel := Ini.ReadBool('CoeffCorrel','Affiche',WithCoeffCorrel);
  WithPvaleur := Ini.ReadBool('Graphe','Pvaleur',WithPvaleur);
  AffIncertParam := TAffIncertParam(Ini.readInteger('Graphe','AffIncertParam',ord(i95)));
  ReperePage := TreperePage(Ini.ReadInteger('Graphe','ReperePage',ord(SPcouleur)));
  WithBandeConfiance := Ini.ReadBool('Graphe','BandeConfiance',WithBandeConfiance);
  couleurNonExp :=  Ini.ReadInteger('Color','NonExp',couleurNonExp);
  TraceDefaut := TTraceDefaut(Ini.ReadInteger('Graphe','TracePoint',ord(traceDefaut)));
  for i := 0 to pred(NbreCouleur) do begin
      couleurPages[i] := Ini.ReadInteger('Color','C'+IntToStr(i),couleurPages[i]);
      stylePages[i] := TpenStyle(Ini.ReadInteger('PenStyle','C'+IntToStr(i),ord(stylePages[i])));
      MotifPages[i] := Tmotif(Ini.ReadInteger('PointStyle','C'+IntToStr(i),ord(MotifPages[i])));
  end;
  for i := 1 to MaxOrdonnee do begin
      couleurInit[i] := Ini.ReadInteger('Color','O'+IntToStr(i),couleurInit[i]);
      MotifInit[i] := Tmotif(Ini.ReadInteger('PointStyle','O'+IntToStr(i),ord(MotifInit[i])));
  end;
  for i := 1 to MaxIntervalles do begin
      couleurModele[i] := Ini.ReadInteger('Color','M'+IntToStr(i),couleurModele[i]);
      couleurModele[-i] := Ini.ReadInteger('Color','S'+IntToStr(i),couleurModele[-i]);
  end;
  couleurGrille := Ini.ReadInteger('Color','Axe',couleurGrille);
  finally
  ini.free;
  end;
end; // litConfigGenerale

procedure TOptionsDlg.LitConfigUtilisateur;
var Rini : TMemIniFile;
    z : integer;
begin
  try
  Rini := TMemIniFile.create(NomFichierIni);
  try
  grapheClip := TgrapheClipBoard(Rini.ReadInteger('Graphe','Clip',0));
  ModeleCosinus := Rini.ReadBool('Calcul','Cosinus',ModeleCosinus);
  ClavierAvecGraphe := Rini.readBool('Graphe','Clavier',ClavierAvecGraphe);
  PstyleTangente := TpenStyle(Rini.ReadInteger('PenStyle','Tangente',ps_Dot));
  PcolorTangente := Rini.ReadInteger('Color','Tangente',clBlack);
  PstyleReticule := TpenStyle(Rini.ReadInteger('PenStyle','Reticule',ps_Dot));
  PcolorReticule := Rini.ReadInteger('Color','Reticule',clBlack);
  FondReticule := Rini.ReadInteger('Color','FondReticule',clInfoBk);
  OrdreFiltrage := Rini.ReadInteger('Calcul','OrdreFiltrage',OrdreFiltrage);
  CoeffEllipseRG.itemIndex := Rini.ReadInteger('Graphe','CoeffEllipse',0);
  ModelePourCent := Rini.readBool('Calcul','ModelePourCent',ModelePourCent);
  UniteSIglb := Rini.ReadBool('Calcul','UniteSI',UniteSIglb);
  GraduationZeroCB.checked := Rini.ReadBool('Graphe','ZeroGradue',ogZeroGradue in OptionGrapheDefault);
  if GraduationZeroCB.checked then
     include(OptionGrapheDefault,ogZeroGradue);
  LevenbergMarquardt := Rini.ReadBool('Regressi','Levenberg',false);
  if Rini.ReadBool('Graphe','Grille',true)
      then include(OptionGrapheDefault,OgQuadrillage)
      else exclude(OptionGrapheDefault,OgQuadrillage);
  if Rini.ReadBool('Graphe','ZeroIdem',true)
      then include(OptionGrapheDefault,OgMemeZero)
      else exclude(OptionGrapheDefault,OgMemeZero);
  DispositionFenetre := TDispositionFenetre(Rini.ReadInteger('Fenetre',
                  'Disposition',ord(DispositionFenetre)));
  AngleEnDegre := Rini.ReadBool('Calcul','Degre',true);
  ModeleDecibel := Rini.ReadBool('Calcul','Decibel',false);
  ModeleFacteurQualite := Rini.ReadBool('Calcul','Qualite',true);
  ExtrapoleDerivee := Rini.ReadBool('Drive','Extrapole',true);
  NbreHarmoniqueOptimise := Rini.ReadBool('FFT','Optimise',false);
  HarmoniqueAff := Rini.ReadBool('FFT','HarmAff',HarmoniqueAff);
  z := Rini.readInteger('FFT','Precision',5);
  if z<3 then z := 3; if z>100 then z := 100;
  precisionFFT := z/1000;
  DimPointVGA := Rini.ReadInteger('Point','Taille',3);
  DataTrieGlb := Rini.ReadBool('Regressi','DataTrie',false);
  TraceIncert := Tincertitude(Rini.ReadInteger('Regressi','IncertRect',ord(TraceIncert)));
  UniteParenthese := Rini.ReadBool('Regressi','UnitePar',UniteParenthese);
  VisualisationAjustement := Rini.ReadBool('Graphe','VisuAjuste',false);
  fontSizeImpr := Rini.ReadInteger('Impression','Fonte',10);
  couleurExp := Rini.ReadInteger('Color','Exp.',couleurExp);
  fontSizeImpr := 2*(fontSizeImpr div 2);
  penWidthVGA := 1;
  penWidthGrid := Rini.readInteger('Graphe','WidthGrid',1);
  tailleTick := Rini.readInteger('Graphe','TailleTick',1);
  if (fontSizeImpr<8) or (fontSizeImpr>12) then fontSizeImpr := 10;
  Precision := Rini.ReadInteger('Format','Chiffres',4);
  if precision<precisionMin then precision := precisionMin;
  if precision>precisionMax then precision := precisionMax;
  NbrePointDerivee := Rini.ReadInteger('Drive','Nombre',5);
  DegreDerivee := Rini.ReadInteger('Drive','Degr',2);
  if degreDerivee<1 then degreDerivee := 1;
  if degreDerivee>3 then degreDerivee := 3;
  TraceDefaut := TTraceDefaut(Rini.ReadInteger('Graphe','TracePoint',ord(tdPoint)));
  AjustageAutoLinCB.checked := Rini.ReadBool('Regressi','AjusteAutoLin',true);
  AjustageAutoGrCB.checked := Rini.ReadBool('Regressi','AjusteAutoGr',false);
  GraduationPi := Rini.ReadBool('Regressi','GraduationPi',true);
  WithCoeffCorrel := Rini.ReadBool('CoeffCorrel','Affiche',false);
  WithPvaleur := Rini.ReadBool('Graphe','Pvaleur',false);
  AffIncertParam := TAffIncertParam(Rini.readInteger('Graphe','AffIncertParam',ord(i95)));
  WithBandeConfiance := Rini.ReadBool('Graphe','BandeConfiance',false);
  DataCanModifiable := Rini.ReadBool('Regressi','DataModif',false);
  SaveConfigAcq := Rini.ReadBool('Regressi','SaveCfgAcq',true);
  PermuteColRow := Rini.ReadBool('Regressi','Permute',false);
  avecEllipse := Rini.ReadBool('Graphe','Ellipse',false);
  UseItalic := Rini.ReadBool('Regressi','Italique',false);
  UseMathPlayer := Rini.ReadBool('Regressi','MathPlayer',true);
  RappelTroisGraphes := Rini.ReadBool('Graphe','Rappel3',false);
  FontName := RIni.ReadString('Graphe','Font',FontName);
  avecChi2 := Rini.ReadBool('Regressi','Chi2',false);
  if avecChi2 then avecEllipse := true;
  fontSizeMemo := Rini.ReadInteger('Fonte','TailleMemo',12);
  reperePage := TreperePage(Rini.ReadInteger('graphe','ReperePage',ord(SPcouleur)));
  TexteGrapheSize := Rini.ReadInteger('Fonte','TexteGraphe',5);
  NbreTexteMax := Rini.ReadInteger('Graphe','NbreTexte',NbreTexteMax);
  MaxCopiesPrinter := Rini.ReadInteger('Impression','Copies',1);
  GridPrint := Rini.ReadBool('Impression','Grid',false);
  litRepertoire(Rini,'Temp',TempDirReg);
  litRepertoire(Rini,'Data',DataDir);
  litRepertoire(Rini,'WAV',WavDir);
  litRepertoire(Rini,'Images',ImagesDir);
  litRepertoire(Rini,'AVI',VideoDir);
  litRepertoire(Rini,'Groupe',GroupeDir);
  litRepertoire(Rini,'fffmpeg',ffmpegexe);
  FontName := Rini.ReadString('Fonte','Name',FontName);
  couleurNonExp := Rini.ReadInteger('Color','NonExp',couleurNonExp);
  finally
  Rini.Free;
  end;
  except
  end;
end; // LitConfigUtilisateur

procedure TOptionsDlg.InitConfig;
var Rini : TIniFile;
    i : integer;
    acqGene : Tstrings;
    nomFichier  : string;
begin
  nomFichier := changeFileExt(application.exeName,'.ini');
  ConfigGeneraleChargee := FileExists(NomFichier);
  if ConfigGeneraleChargee
     then Rini := TIniFile.create(NomFichier)
     else Rini := TIniFile.create(NomFichierIni);
  try
     MenuW := High(LongInt);
     MenuW := Rini.ReadInteger('Regressi','Menus',MenuW);
     MenuPermis := SetMenu(menuW);
     AcqList.clear;
     acqGene := TstringList.Create;
     Rini.ReadSectionValues('Acquisition',AcqGene);
     for i := 0 to pred(AcqGene.count) do
         AjouteAcq(acqGene.Strings[i],true);
     acqGene.free;
  finally
  Rini.Free;
  end;
end; // InitConfig

procedure TOptionsDlg.RazRepDataBtnClick(Sender: TObject);
begin
     if sender=RazRepDataBtn then begin
        DataDir := MesDocsDir;
        DataPathEdit.Text := dataDir;
     end;
     if sender=RazRepWavBtn then begin
        WavDir := GetFolder(CSIDL_MYMUSIC);
        WavPathEdit.Text := WavDir;
     end;
     if sender=RazRepVideoBtn then begin
        VideoDir := GetFolder(CSIDL_MYVIDEO);
        VideoPathEdit.Text := VideoDir;
     end;
end;

procedure TOptionsDlg.RepertoireDataBtnClick(Sender: TObject);
begin
     if SelectDir(DataDir)
        then DataPathEdit.text := dataDir;
end;

Procedure TOptionsDlg.ResetConfig;
begin
    if not ModifConfig then if configGeneraleChargee
       then litConfigGenerale
       else litConfigUtilisateur;
end;

procedure TOptionsDlg.ConstUniversBtnClick(Sender: TObject);
begin
  ConstanteUnivDlg.showModal
end;

procedure TOptionsDlg.BiochimieBtnClick(Sender: TObject);
var i : integer;
begin
    ToutModuleBtnClick(Sender);
    exclude(MenuPermis,imFFT);
    exclude(MenuPermis,imAcqFond);
    exclude(MenuPermis,imVitesse);
    exclude(MenuPermis,imOptique);
    for i := 0 to pred(menuPermisCLB.items.count) do
        menuPermisCLB.checked[i] := i in menuPermis;
end;

procedure TOptionsDlg.PhysiqueBtnClick(Sender: TObject);
var i : integer;
begin
  ToutModuleBtnClick(Sender);
  exclude(MenuPermis,imCornish);
  for i := 0 to pred(menuPermisCLB.items.count) do
      menuPermisCLB.checked[i] := i in menuPermis;
end;

procedure TOptionsDlg.PageControlChange(Sender: TObject);
begin
       PagePrecedente := Pagecontrol.ActivePage;
end;

procedure TOptionsDlg.CoeffEllipseRGClick(Sender: TObject);
begin
     case CoeffEllipseRG.ItemIndex of
         0 : coeffEllipse := 1; // 68 %
         1 : coeffEllipse := 1.96; // 95 %
         2 : coeffEllipse := 2.58; // 99 %
     end;
end;

procedure TOptionsDlg.SpinEditHauteurChange(Sender: TObject);
begin
  modifGraphe := true;
end;

end.


