﻿unit regutil;

interface

uses
  system.SysUtils, System.UITypes, System.Types, system.IOutils, System.StrUtils,
  system.Inifiles,
  Windows, Messages, Classes, Dialogs,
  Graphics, printers, controls, grids, clipBrd, forms,
  Math, StdCtrls, comctrls, richedit, registry, shlObj,
  Vcl.FileCtrl,  // pour SelectDirectory
  Vcl.graphUtil,
  Xml.xmldom, Xml.XMLIntf, Xml.XMLDoc,
  constreg, maths,
  OOmisc, adport, lnswin32, awuser;

var
  fichier : textFile;
  ReseauDir,ExemplesDir,DataDir,VideoDir,ImagesDir,wavDir,ffmpegExe,arduinoExe : String;
  DocRegPdf,DocRegWord,DocIncertitudes,DocModelisation : string;
  GroupeDir : String;
  finFichierWin : boolean;
  autoIncrementation : boolean;
  ligneWin,userName : string;
  mesDocsDir : string;
  TempDirReg,programDir : string;
  ModifFichier : boolean;
  AcqList : TStringList;
  TexteModele : TstringList;
  NbreParamAnim : integer;
  SauvegardePermise : boolean = true;
  nomDecodeur : string;
  nomFichierIni : string;

// Les caractères au-delà de 7 bits sont différents selon l'encodage...
// £ encodé en UTF-8 donne (194)(163) ce qui, lu en latin-1, fait Â£.
// &                            (167)

const
        longNombre = 10;
        maxPages = 32;
        IntervalleSauvegarde = 1/(24*6); // 1 jour=1 donc 10 minutes
        RegistreReg = 'Software\Regressi';
        HautGrapheTxt = 0.32; { Hauteur graphe avec texte }
        HautGrapheGr = 0.43; { Hauteur graphe seul }
        HautGraphePaysage = 0.90; { Hauteur graphe seul pleine page }
        MargeImprimante = 21;
        MargeImprimantePaysage = 30; // soit 1 cm
        PrecisionMin = 3;
        PrecisionMax = 15; // Precision double pour FloatToStrF
        PrecisionMaxIncert = 6; // Precision double pour FloatToStrF
        PrecisionFichier = 15;
        LongNom = 32;
        SymbReg : char = '£';
        SymbReg2 : char = '&';
        MaxPasAnim = 8192;
        MaxPasAnimTemps = 128;
        MinPasAnimTemps = 16;
        NbreItemParamAnim = 7;
        DetectUnicode = #194;

        UneHeure = 3600; // secondes
        UnJour = 24*UneHeure;
        UnMois = UnJour*365.25/12;
        QuartdHeure = 15*60;
        UneMinute = 60;

        UneHeureWin = 1/24; { 1 jour = 1.000 }
        QuartdHeureWin = 1/(24*4);
        UneMinuteWin = 1/(24*60);
        UneSecondeWin = 1/(24*60*60);
        UnMoisWin = 365.25/12;
        unAnWin = 365.25;

        crLettre = 1;
        crGomme = 2;
        crPencil = 3;
        crZoom = 4;
        crCible = 5;
        crCibleNoire = 6;
        crCibleBlanche = 7;
        crCibleNormale = 8;
        crCibleDouble = 9;
        crCibleMove = 10;
        crOrigine = 11;
        crRectangle = 12;
        crCible1 = 13;
        crCible2 = 14;
        crCible3 = 15;
        crCible4 = 16;
        crCible5 = 17;
        crOrigineTemps = 18;

        MaxAcq = 12;
        MaxParamAnim = 12;

        WM_Reg_Maj = WM_USER + 0;
        WM_Reg_Calcul = WM_USER + 1;
        WM_Reg_Origine = WM_USER + 2;
        WM_Reg_Fichier = WM_USER + 3;
        WM_Reg_InitMagnum = WM_USER + 4;
        WM_Reg_Modele = WM_USER + 6;
        WM_Reg_Animation = WM_USER + 7;
        WM_Reg_Paint = WM_USER + 8;
        WM_Maj_AVI = WM_USER + 9;
        WM_AVI_Suivant = WM_USER + 10;
        WM_AVI_Precedent = WM_USER + 11;
        WM_AVI_Chrono = WM_USER + 12;
        WM_AVI_Chrono_Init = WM_USER + 13;
        WM_Maj_Wav = WM_USER + 14;
 //       WM_Maj_Directory = WM_User + 15;

{
    protected
    procedure WMRegMaj(var Message: TWMRegMAj); message WM_reg_Maj;

    procedure TMyComponent.WMRegMaj(var Message: TWMRegMaj);
    begin
       ...
      inherited;
    end;
}

        MajModele = 0; { modification de l'expresssion du modèle }
        MajGrandeur = 1; { modification de l'expression des grandeurs }
        MajValeur = 2;{ modification des valeurs expérimentales dans tableur }
        MajFichier = 3; { général après chargement de fichier ... }
        MajChangePage = 4; { changement de page }
        MajAjoutPage = 5; { ajout de page }
        MajSupprPage = 6; { suppression de page }
        MajVide = 7; { nettoyage }
        MajFFT = 8; { options Fenêtre et période }
        MajTri = 9; { modif de l'ordre }
        MajIncertitude = 12;
        MajPolice = 10;
        MajSuperposition = 13;
        MajNumeroMesure = 14;
        MajUnites = 15;
        MajValeurAcq = 16;{ modification des valeurs expérimentales par acquisition }
        MajLangue = 17;
        MajModeleGlb = 18;{ modification du modèle des paramètres }
        MajUnitesParam = 19;
        MajSupprPoints = 20;
        MajNom = 22; { Modif d'un nom }
        MajAjoutValeur = 23; { ajout d'un point en mode clavier }
        MajSelectPage = 24; { changement de sélection des pages }
        MajPreferences = 25; { préférences de couleurs ... }
        MajGroupePage = 26; { groupement de pages }
        MajOptionsGraphe = 27; { groupement de pages }
        MajValeurGr = 28;{ modification des valeurs expérimentales dans le graphe }
        MajSauvePage = 29; { avant de changer de page }
        MajValeurConst = 30;{ modification des valeurs des paramètres dans tableur }
        MajEquivalence = 31; {modification calcul dérivée donc équivalences à revoir}

        CalculCompile = 1;
        CalculRemplit = 2;
        CalculAjuste = 3;
        CalculModele = 4;

        alphaR =  AnsiChar(128);
        betaR = AnsiChar(129);
        chiR = AnsiChar(130);
        deltaR = AnsiChar(131); deltaMajR = AnsiChar(150);
        epsilonR = AnsiChar(132);
        phiR = AnsiChar(133); phiMajR = AnsiChar(151);
        gammaR = AnsiChar(134); gammaMajR = AnsiChar(152);
        etaR = AnsiChar(135);
        lambdaR = AnsiChar(136); lambdaMajR = AnsiChar(153);
        nuR = AnsiChar(138);
        piR = AnsiChar(139);piMajR = AnsiChar(154);
        thetaR = AnsiChar(140);thetaMajR = AnsiChar(155);
        rhoR = AnsiChar(141);
        sigmaR = AnsiChar(142);sigmaMajR = AnsiChar(156);
        tauR = AnsiChar(143);
        omegaR = AnsiChar(144);omegaMajR = AnsiChar(157);
        xiR = AnsiChar(147);xiMajR = AnsiChar(158);
        psiR = AnsiChar(148);psiMajR = AnsiChar(159);
        zetaR = AnsiChar(149);
        muR = AnsiChar(181);

        alpha=WideChar($03B1);alphaMaj=WideChar($0391);
        beta=WideChar($03B2);betaMaj=WideChar($0392);
        gammaMin=WideChar($03B3);gammaMaj=WideChar($0393);
        deltaMin=WideChar($03B4);deltaMaj = WideChar($0394);
        chi=WideChar($03C7);chiMaj=WideChar($03A7);
        epsilon=WideChar($03B5);epsilonMaj=WideChar($0395);
        upsilon=WideChar($03C5);upsilonMaj=WideChar($03A5);
        iota=WideChar($03B9);iotaMaj=WideChar($0399);
        phiMin=WideChar($03C6);phiMaj=WideChar($03A6);
        eta=WideChar($03B7);etaMaj=WideChar($0397);
        lambdaMaj=WideChar($039B);lambdaMin=WideChar($03BB);
        nu=WideChar($03BD);nuMaj=WideChar($039D);
        xiMaj=WideChar($039E);xi=WideChar($03BE);
        piMin=WideChar($03C0);piMaj=WideChar($03A0);
        thetaMaj=WideChar($0398);theta=WideChar($03B8);
        rho=WideChar($03C1);rhomaj=WideChar($03A1);
        sigmaMin=WideChar($03C3);sigmaMaj=WideChar($03A3);
        tau=WideChar($03C4); tauMaj=WideChar($03A4);
        omegaMin=WideChar($03C9);omegaMaj=WideChar($03A9);
        psi=WideChar($03C8);psiMaj=WideChar($03A8);
        zeta=WideChar($03B6);zetaMaj=WideChar($0396);
        mu=WideChar($03BC);muMaj=WideChar($039C);
        kappa=WideChar($03BA);kappaMaj=WideChar($039A);
        omicron=WideChar($03Bf);omicronMaj=WideChar($039F);
        pourMille=WideChar(8240);cdot=WideChar($22C5);// inconnu de Segoe
        pointMedian=WideChar($00B7);puce=WideChar($2219);
        SymbRegUnicode=WideChar(163);


        ChiffreExp : array[0..9] of wideChar =
  (WideChar($2070),WideChar($00B9),WideChar($00B2),WideChar($00B3),
   WideChar($2074),WideChar($2075),WideChar($2076),WideChar($2077),
   WideChar($2078),WideChar($2079)); // Tahoma 1 2 3 uniquement

        ChiffreExpR : array[0..9] of ansiChar =
  (AnsiChar(186),AnsiChar(185),AnsiChar(178),AnsiChar(179),
   AnsiChar(165),AnsiChar(169),AnsiChar(172),AnsiChar(173),
   AnsiChar(174),AnsiChar(188));

       MoinsExp = WideChar($207B); // pas Tahoma
       PlusExp = WideChar($207A);
       supEgal = WideChar($2265);
       infEgal = WideChar($2264);

       MoinsExpR = AnsiChar(170); // idem pour Regressi fontes
       PlusExpR = AnsiChar(184);
       infEgalR = AnsiChar(250);
       supEgalR = AnsiChar(249);

       RepereConst = 'Cte:';
       SeparateurConst =  '________________';

type
    Tincertitude = (iEllipse,iCroix,iRectangle);
   // TetatVLC = (vlcnone,vlc32,vlc64);
    TAffIncertParam = (iType,i95,iBoth);
    EGetFloatError = class(Exception);
    EIncertitudeError = class(Exception);
    TdispositionFenetre = (dMaxi,dCascade,dMosaicVert,dMosaicHoriz,dNone);
    TgrapheClipBoard = (gcEMF,gcJpeg,gcBitmap,gcPng,gcEps);
    TformeActive = (mainActif,grapheActif,statActif,texteActif,FFTactif);
    TnombreFormat = (fDefaut,fExponent,fFixed,
       fLongueDuree,fDateTime,fDate,fTime,fDegreMinute,
       fBinary,fHexa);
    TligneRappel = (lrEquivalence,lrTangente,lrXdeY,lrReticule,lrEquivalenceManuelle,lrX,lrY,lrPente);
    Tgraduation = (gLin,gLog,gInv,gdB,gBits);
    ChaineAzt = array[0..512] of char;
    vecteurNombre = array[0..16] of double;

    (*
    TThreadSurveillance = class(TThread)
    private
       HandleDirectory        : THandle;
       OverLapped             : TOverlapped;
       CheminEnCours          : String;
  //     FOnDirectoryChange     : TDirectoryChange;
       Procedure MiseAJourListe;
  //     Property OnDirectoryChange : TDirectoryChange Read FOnDirectoryChange Write FOnDirectoryChange;
    public
       HandleFenetre          : HWND;
       FichierAjoute          : string;
       ListeAjouts            : TStrings;
    protected
       procedure Execute; override;
    end;
    *)

    TstrListe = class(TstringList)
         public
             function MyIndexOf(Item : string) : Integer;
    end;
    TWMRegMessage = record
       Msg: Uint;
       case Boolean of
          false: (WParam: WParam;LParam: LParam;Result: LResult);
          true: (TypeMaJ: WParam;CodeMaj : LParam;ResultR: LResult);
    end;

    TPrinterRecord = record
        Cur: TPoint;
        MargeTexte : integer;
        Finish: TPoint;  { End of the printable area }
        Height: Integer; { Height of the current line }
        sauveOrientation : TprinterOrientation;
        PageH,PageW : integer;
    end;

        CoefUnite = (zero,yocto,zepto,atto,femto,pico,nano,micro,milli,
               nulle,kilo,mega,giga,tera,peta,exa,zetta,yotta,infini);
        TmodeAcquisition = (AcqClavier,AcqFichier,AcqCan,AcqClipBoard,
                            AcqBitMap,AcqSimulation,AcqVideo,AcqSon,AcqChrono,
                            AcqCourbes,AcqArduino,AcqOscilloArduino);

        TparamAnimation = class
           groupBoxA : TgroupBox;
           sliderA : TtrackBar;
           nomA : string;
           codeA : integer;
           ValeurA,DebutA,FinA,PasA : reel;
         //  SauveValeurA : reel;
           Active,VariationLog,Ainitialiser : boolean;
           constructor create;
           procedure init;
           procedure litFichier(NbreItem : integer);
           procedure ecritFichier;
           function sliderMaxValue : integer;
        end;

const
        MaxLogicielAcq = 9;
        couleurCalc = clGrayText;
        crSupprArr = char(vk_back);
        crHaut = char(vk_up);
        crBas = char(vk_down);
        crGauche = char(vk_left);
        crDroite = char(vk_right);
        crHome = char(vk_home);
        crEnd = char(vk_end);
        crCR = #13; // WideChar(13);
        crLF = #10;
        crESC = #27;
        crTab = char(vk_tab);
        Separateur : tSysCharSet = [' ',crTab,',',';'];
        NomModeAcq : array[TmodeAcquisition] of string =
            ('CLAVIER','FICHIER','EXTERNE','PRESSE-PAPIER','RS232',
             'SIMULATION','VIDEO','SON','CHRONOPHOTO','COURBES','ARDUINO','OSCILLOARDUINO');
        Majuscule   : tSysCharSet = ['A'..'Z'];
        Minuscule   : tSysCharSet = ['a'..'z'];
        Grecque = alpha+beta+gammaMin+gammaMaj+deltaMin+deltaMaj+
              epsilon+chi+zeta+eta+theta+thetaMaj+kappa+
              lambdaMin+lambdaMaj+mu+nu+xi+xiMaj+
              piMin+piMaj+rho+sigmaMin+sigmaMaj+tau+
              phiMin+phiMaj+chi+psi+psiMaj+omegaMin+omegaMaj;
        LettreAccent = 'éèêëàâùïüô';

        Chiffre     : tSysCharSet = ['0'..'9'];
        ChiffreEtc : tSysCharSet = ['0'..'9','+','-','e','E','.'];
        ChiffreWin : tSysCharSet = ['0'..'9','+','-','e','E','.',','];
        CaracNombre : tSysCharSet = ['0'..'9','+','-','e','E','.',',','/',':'];
        CaracDateTime : tSysCharSet = ['0'..'9','/',':',' ',crSupprArr,crTab,crCR];
        CaracDate : tSysCharSet = ['0'..'9','/',crSupprArr,crTab,crCR];
        CaracTime : tSysCharSet = ['0'..'9',':',crSupprArr,crTab,crCR];
        CaracDegre : tSysCharSet = ['0'..'9','+','-',':','°','''','"',crSupprArr,crTab,crCR];
        CharGetFloat : tSysCharSet = ['0'..'9','+','-','e','E','.',',','*','/','^',
            'P','p','I','i',piMin,piMaj,'m','µ','n','f','k','M','G','T',
            '(',')',crSupprArr,crTab,crCR];
        CharGetInt : tSysCharSet = ['0'..'9',crGauche,crDroite,crSupprArr,crTab,crCR];
        ChiffreExpStr = WideChar($2070)+WideChar($00B9)+WideChar($00B2)+
               WideChar($00B3)+WideChar($2074)+WideChar($2075)+WideChar($2076)+
               WideChar($2077)+WideChar($2078)+WideChar($2079);
        ChiffrePuiss = WideChar($2070)+WideChar($00B9)+WideChar($00B2)+
               WideChar($00B3)+WideChar($2074)+WideChar($2075)+WideChar($2076)+
               WideChar($2077)+WideChar($2078)+WideChar($2079)+MoinsExp+PlusExp;

        NChiffreSignif = 5;
        caracPrefixe : tSysCharSet = ['y','z','a','f','p','n','µ','m','k','M','G','T','P','E','Z','Y'];
        prefixeUnite : array[coefUnite] of char =
              ('0','y','z','a','f','p','n','µ','m',
               ' ','k','M','G','T','P','E','Z','Y','ì');
        valUnite : array[coefUnite] of reel =
              (1E-27,1E-24,1E-21,1E-18,1E-15,1E-12,1E-9,1E-6,1E-3,
               1,1E+3,1E+6,1E+9,1E+12,1E+15,1E+18,1E+21,1E+24,1E+27);
        expUnite : array[coefUnite] of string =
              ('E-27','E-24','E-21','E-18','E-15','E-12','E-9','E-6','E-3',
                '','E+3','E+6','E+9','E+12','E+15','E+18','E+21','E+24','E+27');
        puissanceUnite : array[coefUnite] of shortInt =
              (-27,-24,-21,-18,-15,-12,-9,-6,-3,
                0,+3,+6,+9,+12,+15,+18,+21,+24,+27);
        NomLigneRappel : array[TligneRappel] of string =
            ('Equivalences','Tangentes','Valeurs du modèle','Réticules','Equivalences','Delta X','Delta Y','Pente');

var
        fontName : string = 'Segoe UI';
        crCibleVideo : integer = crCibleDouble;
        AffIncertParam : TAffIncertParam = i95;
        FontSizeMemo : integer = 12;
        grapheClip : TgrapheClipBoard;
        TexteGrapheSize : integer = 5;
        RappelTroisGraphes : boolean = true;
        postScriptExiste : boolean = false;
        CoeffEllipse : double = 1.0;
        ModeleFacteurQualite : boolean = true; // sinon facteur d'amortissement Q=1/2m
        ModeleDecibel : boolean = false;
        FichierTrie : boolean = false;
        DataTrieGlb : boolean = false;
        Recuit : boolean = false;
        recuitFaible : boolean = true;
        modeleCosinus : boolean = true;
        VisualisationAjustement : boolean = false;
        DispositionFenetre : TDispositionFenetre = dMaxi; 
        GridPrint : boolean = false;
        StoechBecherGlb : integer = 1;
        StoechBuretteGlb : integer = 1;
        OrdreBruit : integer = 3;
        DataCanModifiable : boolean = false;
        SaveConfigAcq : boolean = true;
        withCoeffCorrel : boolean = true;
        withPvaleur : boolean = false;
        withBandeConfiance : boolean = false;
        avecModeleManuel : boolean = true;
        ajusteOrigine : boolean = false;
        PrecisionCorrel : integer = 5;
        LevenbergMarquardt : boolean = false;
        MaxCopiesPrinter : integer = 1;
        couleurIncertitude : Tcolor = clBlue;
        couleurNonExp : Tcolor = clGray;
        couleurExp : Tcolor = clBlack;
        ChercheUniteParam : boolean = true;
        avecTableau : boolean = true;
        uniteParenthese : boolean = false;
        TraceIncert : Tincertitude = iEllipse;
        ClavierAvecGraphe : boolean = true;
        modelePourCent : boolean = false;
        arretConversionVideo : boolean = false;

Function OKReg(const strOk : string;const helpCtx : LongInt) : boolean;
Function OKformat(const strOk : string;args : array of const) : boolean;
Procedure afficheErreur(const strErreur : string;const HelpCtx : LongInt);
Procedure ValidateReel(Sender : Tedit;var z : double);
Function ToucheValidation(key : word) : boolean;
Procedure VerifKeyGetFloat(var key : char);
Procedure VerifKeyGetInt(var key : char);
Procedure TrimComplet(var S : String);
Procedure TrimAscii127(var S : String);
Function Pad(S : String;Len : integer) : String;
Function ConvertitChaine(nombre : string;var valeur : double) : boolean;
Procedure ConvertitPrefixe(var nombre : string);
Procedure ConvertitPrefixeExpression(var Texte : string);
Function FormatIncert(const nombre : double) : string;
Function FormatGeneral(const nombre : double;const Nchiffres : integer) : string;
Function FormatIngenieur(Nombre : double;PrecisionU : integer) : string;
Function FormatRadian(nombre : reel) : string;
Function FormatReg(const nombre : double) : string;
Function FormatCourt(const nombre : double) : string;
Function FormatLongueDureeAxe(const nombre : double) : string;
//Function FormatPrec(valeur,sigma : reel) : String;
Function ChainePrec(const prec : double) : String;
function Compte(chaine,sousChaine : string) : integer;
function litLigneWinU : string;
function litLigneWin : string;
function EnTeteRW3 : boolean;
function litBooleanWin : boolean;
procedure ecritChaineRW3(s : String);
procedure readLnNombreWin(var z : reel);
procedure extraitNombre(const chaine : string;var valeur : vecteurNombre);
Function NbreLigneWin(const s : String) : LongInt;
Function PuissToStr(const puiss : integer) : string;
Function IsLigneComment(const ligneCourante : String) : boolean;
Function FloatToStrPoint(const valeur : double) : string;
Function FloatToStrLatex(const valeur : double) : string;
Function StrToFloatWin(nombre : String) : reel;
Function StrToFloatSex(degStr,minStr,secStr : string) : double;
function IniReadFloat(const Ini : TMemIniFile;const Section, Name: string; Default: Double): Double;
Function EncodeDuree(duree : LongInt) : TdateTime;
Function DureeEcoulee(const InstantDebut : TdateTime) : reel;
Function existeOption(opt : char;const defaut : boolean) : boolean;
Function CaracToChiffre(carac : char) : integer;
Function GetFloat(Nombre : String) : reel;
Function GetFloatDate(Nombre : String;Aformat : TnombreFormat) : reel;
Function LigneDeChiffres(const s : String) : boolean;
//function litDate(strValeur : string) : reel;
function HeightLinePrinter : Word;
Procedure ImprimerGrid(g : TstringGrid;var debut : integer);
Procedure VerifOrpheline(count : integer;var debut : integer);
Procedure DebutImpressionTexte(var haut : integer);
Function FinImpressionTexte : integer;
Procedure DebutImpressionGr(Orientation : TprinterOrientation;var bas : integer);
Procedure FinImpressionGr;
Procedure NewLine;
Function SetFileEPS(const NomFichier : string) : boolean;
Procedure ResetPrinter;
Procedure ImprimerLigne(const TextStr : String;var debut : integer);
function valeur125(valInt : integer;down : boolean) : integer;
function getNomCoord(nom : string) : string;
procedure AffecteStatusPanel(var Astatus : TstatusBar;i : integer;Atext : string);
procedure VideStatusPanel(var Astatus : TstatusBar;i : integer);
function FichierGroupe : String;
Procedure AddBackSlash(var aPath : String);
Procedure RemoveBackSlash(var aPath : String);
procedure VerifMemo(memo: TRichEdit);
Function isCaracGrandeur(carac : char) : boolean;
Function isLettre(carac : char) : boolean;
function litColor(couleurDefaut : TColor) : Tcolor;
function TailleFichier(const nomFichier : string) : Int64;
function SelectDir(var aDirectory : string) : boolean;
function IsPortAvailable(ComNum: cardinal): boolean;
function ConvertirVideo(var Anom : string) : boolean;
Function couleurComplementaire(abitmap : Tbitmap) : Tcolor;

function writeStringXML(ANode : IXMLNOde;Nom,valeur : string) : IXMLNode;
function writeIntegerXML(ANode : IXMLNOde;Nom : string;valeur : integer) : IXMLNode;
function writeBoolXML(ANode : IXMLNOde;Nom : string;valeur : boolean) : IXMLNode;
function writeFloatXML(ANode : IXMLNOde;Nom : string;valeur : double) : IXMLNode;
function writeDateTimeXML(ANode : IXMLNOde;Nom : string;valeur : TDateTime) : IXMLNode;

Function GetBoolXML(ANode : IXMLNOde) : boolean;
Function GetIntegerXML(ANode : IXMLNOde) : integer;
Function GetFloatXML(ANode : IXMLNOde) : double;
Function GetColorXML(ANode : IXMLNOde) : Tcolor;

Function GetFolder(CSIDLValue: integer): String;

{$IFDEF Debug}
procedure ecritDebug(reponse : string);
procedure initDebug;
{$ENDIF}

var
     precision : integer;
     erreurDetectee : boolean;
     avecOptionsXY : boolean;
     ModeAcquisition : TModeAcquisition;
     NomExeAcquisition : String;
     LigneRappelCourante : TligneRappel;
     LigneRappelTangente : TligneRappel;
     avecEllipse,avecChi2,ReticuleComplet,PermuteColRow,
     UseItalic,UseMathPlayer : boolean;
     FontSizeImpr : integer;
     GraduationPi : boolean;
     MyCF_RTF : word;
     LectureFichier,LecturePage : boolean;
     ParamAnimManuelle : array[0..MaxParamAnim] of TparamAnimation;
     PrinterParam : TprinterRecord;
{$IFDEF Debug}
     ecritVLCCreate : boolean = true;
     compteurVLCShow : integer = 0;
{$ENDIF}

// graphique pour configRegressi
const
    MaxOrdonnee   = 6;
    MaxIntervalles = 4;
type
    indiceOrdonnee  = 1..MaxOrdonnee;
    Tmotif = (mCroix, mCroixDiag, mCercle, mCarre, mLosange,
    mCerclePlein, mCarrePlein, mIncert, mEchantillon, mHisto,
    mSpectre, mPixel, mReticule, mBarreD, mBarreG, mLigneH, mLigneEuler);
    // etoile, triangle, pentagone, asterisque, losangePlein, pentagonePlein, trianglePlein

var
    CouleurPages: array[0..MaxPages] of
    Tcolor = (clGray, clBlue, clRed, clOlive, clNavy, clPurple, clTeal, clBlack,
      clMaroon, clFuchsia, clBlue, clGray, clAqua, clTeal, clBlue, clRed,
      clGray, clBlue, clRed, clOlive, clNavy, clPurple, clTeal, clBlack,
      clMaroon, clFuchsia, clBlue, clGray, clAqua, clTeal, clBlue, clRed,
      clGreen);
    StylePages: array[0..MaxPages] of
    TpenStyle = (psSolid, psDash, psDot, psDashDot, psDashDotDot,
      psSolid, psDash, psDot, psDashDot, psDashDotDot,
      psSolid, psDash, psDot, psDashDot, psDashDotDot,
      psSolid, psDash, psDot, psDashDot, psDashDotDot,
      psSolid, psDash, psDot, psDashDot, psDashDotDot,
      psSolid, psDash, psDot, psDashDot, psDashDotDot,
      psSolid, psDash, psDot);
    MotifPages: array[0..MaxPages] of
    Tmotif = (mCroix, mCroixDiag, mCercle, mCarre, mLosange,mCerclePlein, mCarrePlein,
      mCroix, mCroixDiag, mCercle, mCarre, mLosange, mCerclePlein, mCarrePlein,
      mCroix, mCroixDiag, mCercle, mCarre, mLosange, mCerclePlein, mCarrePlein,
      mCroix, mCroixDiag, mCercle, mCarre, mLosange, mCerclePlein, mCarrePlein,
      mCroix, mCroixDiag, mCercle, mCarre, mLosange);
    CouleurModele: array[-MaxIntervalles..MaxIntervalles] of
    Tcolor = (clTeal, clMaroon, clFuchsia, clNavy, clWhite, clBlue, clRed, clPurple, clGreen);
    CouleurInit: array[indiceOrdonnee] of Tcolor =
         (clBlack, clBlue, clRed, clPurple, clGreen, clNavy);
    MotifInit: array[indiceOrdonnee] of Tmotif =
         (mCroix, mCroixDiag, mCercle, mCarre, mLosange, mCerclePlein);


implementation

Function couleurComplementaire(abitmap : Tbitmap) : Tcolor;
type
  TRGBTripleArray = ARRAY[Word] of TRGBTriple;
  pRGBTripleArray = ^TRGBTripleArray; // Use a PByteArray for pf8bit color.
var zz : TRGBtriple;
    i,j : integer;
    scanLine : pRGBTripleArray;
    rouge,vert,bleu : integer;
    pasY,pasX : integer;
    H,L,S : word;
    aColor : TcolorRef;
    rr,gg,bb :  byte;
begin
       rouge := 0;
       vert := 0;
       bleu := 0;
       pasY := abitmap.height div 9;
       pasX := abitmap.width div 9;
       for i := 1 to 8 do begin
         scanLine := abitmap.scanLine[i*pasY];
         for j := 1 to 8 do begin
             zz := scanLine[j*pasX];
             rouge := rouge+(zz.rgbtRed);
             vert := vert+(zz.rgbtGreen);
             bleu := bleu+(zz.rgbtBlue);
         end;
       end;
       acolor := RGB(rouge div 64,vert div 64,bleu div 64);
       ColorRGBToHLS(aColor,H,L,S); // 0..240 pour H
       if H>120
          then H := H-120
          else H := H+120; // couleur complémentaire
       if S<127 // non saturé, il faut jouer sur l'intensité : clair sur foncé et réciproquement
          then if L<127
             then L := 255
             else L := 0;
       S := 255; // saturation maxi
       result := ColorHLSToRGB(H,L,S);
       rr := 64*(GetRvalue(result) div 64);
       gg := 64*(GetGvalue(result) div 64);
       bb := 64*(GetBvalue(result) div 64);
       result := RGB(rr,gg,bb);
end;

(**** XML *****)

function writeStringXML(ANode : IXMLNOde;Nom,valeur : string) : IXMLNode;
var newNode : IXMLNode;
begin
    newNode := Anode.AddChild(Nom);
    newNode.nodeValue := valeur;
    result := newNode;
end;

function writeIntegerXML(ANode : IXMLNOde;Nom : string;valeur : integer) : IXMLNode;
var newNode : IXMLNode;
begin
    newNode := Anode.AddChild(Nom);
    newNode.nodeValue := intToStr(valeur);
    result := newNode;
end;

function writeFloatXML(ANode : IXMLNOde;Nom : string;valeur : double) : IXMLNode;
var newNode : IXMLNode;
begin
    newNode := Anode.AddChild(Nom);
    newNode.nodeValue := FloatToStrPoint(valeur);
    result := newNode;
end;

function writeDateTimeXML(ANode : IXMLNOde;Nom : string;valeur : TDateTime) : IXMLNode;
var newNode : IXMLNode;
begin
    newNode := Anode.AddChild(Nom);
    newNode.nodeValue := valeur;
    result := newNode;
end;

function writeBoolXML(ANode : IXMLNOde;Nom : string;valeur : boolean) : IXMLNode;
var newNode : IXMLNode;
begin
    newNode := Anode.AddChild(Nom);
    newNode.nodeValue := ord(valeur);
    result := newNode;
end;

Function GetBoolXML(ANode : IXMLNOde) : boolean;
var s : string;
begin
     s := ANode.NodeValue;
     result := s<>'0';
end;

Function GetIntegerXML(ANode : IXMLNOde) : integer;
begin
     try
     result := StrToInt(ANode.text);
     except
        result := 0;
     end;
end;

Function GetFloatXML(ANode : IXMLNOde) : double;
var s : string;
begin
     try
     s := ANode.NodeValue;
     result := StrToFloatWin(s);
     except
       result := Nan
     end;
end;

Function GetColorXML(ANode : IXMLNOde) : Tcolor;
var zword : word;
begin
    zWord := strToInt(ANode.Text);
    result := TColor(zWord);
end;

(**** fin XML *****)

var
     SuiteCaracGrandeur : TsysCharSet; // carac permis à l'interieur d'un nom de grandeur
     Lettres : TsysCharSet;
     RW3Unicode : boolean;

const
      Digits : array[0..$F] of Char = '0123456789ABCDEF';

function IsPortAvailable(ComNum: cardinal): boolean;

   function MakeComName(const Dest: PChar; const ComNum: cardinal): PChar;
   begin
      StrFmt(Dest, '\\.\COM%d', [ComNum]);
      MakeComName := Dest;
   end;

var
   ComName: array[0..12] of char;
   Res: integer;
   DeviceLayer: TApdBaseDispatcher;
begin
   DeviceLayer := TApdWin32Dispatcher.Create(nil);
   try
      Res := DeviceLayer.OpenCom(MakeComName(ComName, ComNum), 64, 64);
      Result := (Res >= 0) or (GetLastError = DWORD(Abs(ecAccessDenied)));
      if Result then
         DeviceLayer.CloseCom;
   finally
      DeviceLayer.Free;
   end;
end;

Function StrToFloatSex(degStr,minStr,secStr : string) : double;
var deg,minute,seconde,valeur : double;
    negatif : boolean;
begin
   negatif := degStr[1]='-';
   if negatif then delete(degStr,1,1);
   deg := StrToInt(degStr);
   minute := StrToInt(minStr);
   seconde := StrToFloatWin(secStr);
   valeur := deg+minute/60+seconde/3600;
   if negatif then valeur := -valeur;
   result := valeur;
end;

Procedure TrimComplet(var s : string);
var longueur,posCourant : integer;
begin
	longueur := Length(s);
	posCourant := 1;
	while (posCourant<=longueur) do
		if ord(s[posCourant])<=32
			then begin
			   Delete(s,posCourant,1);
			   dec(longueur);
			end
			else inc(posCourant);
end;

(*
Procedure TrimBlanc(var s : string);
var posCourant : integer;
begin
	posCourant := pos(' ',s);
	while (posCourant>0) do begin
	   Delete(s,posCourant,1);
     posCourant := pos(' ',s);
  end
end;
*)

Procedure TrimAscii127(var s : String);
var longueur,posCourant : integer;
begin
	longueur := Length(s);
  posCourant := 1;
	while (posCourant<=longueur) do
		if ((s[posCourant]<=' ') or (s[posCourant]>'z'))
			then begin
			   Delete(s,posCourant,1);
			   dec(longueur);
			end
			else inc(posCourant);
end;

Function GetFloat(Nombre : String) : reel;
Const
    MaxPile = 10;
    CaracCte : tSysCharSet = [piMin,piMaj,'P','I','p','i'];
type
    IndicePile  = 1..MaxPile;
Var
    Pile : Array[IndicePile] of reel;
    IndicePileCourant : 0..MaxPile;
    CaracCourant   : char;
    PointeurExp : integer;

Procedure suivant;
// Lit le prochain caractère et l'assigne à caracCourant
// Le caracCourant est toujours extrait avant appel d'un analyseur
begin
    inc(pointeurExp);
    if pointeurExp<=length(Nombre)
       then begin
          caracCourant := Nombre[pointeurExp];
          if charInSet(caracCourant,[cDot,pointMedian,puce]) then caracCourant := '*';
       end
       else caracCourant := #0;
end;

Procedure InitFonctor;
Begin
  pointeurExp := 0;
  indicePileCourant := 0;
  suivant;
end;

// Les procédures LireXXX extraient un XXX de la chaine Nombre à partir du pointeur courant

Function LireNombre : reel;
    Var PointeurChiffre : integer;
        Valeur : reel;
        NombreLoc : String;

    Procedure lireEntier;
    begin
       While charinset(caracCourant,chiffre) do suivant
    end;

    Begin
        PointeurChiffre := PointeurExp; // pointe le premier chiffre du nombre
        If charinset(caracCourant,['-','+']) then suivant; // saute le signe
        lireEntier;
        If caracCourant=FormatSettings.decimalSeparator // C'est un nombre décimal
           Then begin
              suivant; // on saute le .
              lireEntier
           end;
        If ( upcase(caracCourant) = 'E' ) // puissance de 10
           then begin
              suivant; // on saute le E
              if (caracCourant='+') or (caracCourant='-')  then suivant;
              lireEntier
           end
           else if charInSet(caracCourant,caracPrefixe) then suivant; // coeff unité
        NombreLoc := copy(nombre,pointeurChiffre,pointeurExp-PointeurChiffre);
        if not ConvertitChaine(nombreLoc,valeur)
           then raise EGetFloatError.Create(erNombre);
        LireNombre := valeur;
   end; // lireNombre

Function LireIdEnt : String;
Var PointeurIdent : integer;
Begin
  PointeurIdent := pointeurExp;
  While charinset(caracCourant,CaracCte) do suivant;
  if (pointeurExp-pointeurIdent)>longNom then raise EGetFloatError.Create(erTropLong);
  LireIdent := copy(nombre,pointeurIdent,pointeurExp-pointeurIdent)
End;  // LireIdEnt

Procedure Depile(Var P : reel);
Begin
  if indicePileCourant=0
    then raise EGetFloatError.Create(Erinterne)
    else begin
      P := Pile[indicePileCourant];
      dec(indicePileCourant);
   end;
End;

Procedure Empile(P : reel);
Begin
  if indicePileCourant=MaxPile
    then raise EGetFloatError.Create(erTropcomplexe)
    else begin
      inc(indicePileCourant);
      Pile[indicePileCourant] := P;
   end;
End;

Function CalcOperateur(C : char;PG,PD : reel) : reel;
begin
   case C of
         '+'  : calcOperateur := PG+PD;
         '-'  : calcOperateur := PG-PD;
         '/'  : calcOperateur := PG/PD;
         '*'  : calcOperateur := PG*PD;
         '^'  : calcOperateur := Power(PG,PD);
         else CalcOperateur := 0;
   end;
end;

Procedure AnalyseExpression;Forward;

Procedure E; // E=(.Expression.)
Begin
  If caracCourant='('
    Then Begin
        suivant;
        AnalyseExpression;
        case caracCourant of
             ')'  : suivant;
             #0 : ; // fin => on ajoute ) manquante
             else raise EGetFloatError.Create('Erreur )');
        end;{case}
    End
    Else raise EGetFloatError.Create('Erreur (')
End;{E}

Procedure AnalyseElement; // Element = E/nombre
Var
  U : String;
Begin
  If charInSet(caracCourant,['P','p']) or (caracCourant=piMin) or (caracCourant=piMaj)
    Then Begin
        U := LireIdent;
        U := AnsiUpperCase(U);
        if (U=piMin) or (U='PI')or (U=piMaj)
           then Empile(pi)
           else raise EGetFloatError.Create('Erreur nombre')
    End // then
    Else If charinset(caracCourant,Chiffre+['-','+','.'])
        Then Empile(LireNombre)
        Else E
End; // analyseElement

Procedure AnalyseFacteur; // facteur = Element.^.element
Var  T1,T2 : reel;
Begin
  AnalyseElement;
  While (caracCourant='^') do Begin
     suivant;
     AnalyseElement;
     depile(T2);
     depile(T1);
     Empile(CalcOperateur('^',T1,T2));
  End {while}
End; // AnalyseFacteur

Procedure AnalyseTerme; // terme = facteur.[* ou /].facteur
Var
  C        : Char;
  T1,T2    : reel;
Begin
  AnalyseFacteur;
  While (caracCourant='*') or (caracCourant='/') do Begin
       C:=caracCourant;
       suivant;
       AnalyseFacteur;
       depile(T2);
       depile(T1);
       Empile(CalcOperateur(C,T1,T2));
    End {while}
End; // AnalyseTerme

Procedure AnalyseExpression;// Expression = [+ ou - ou rien].Terme.[+ ou -].terme
Var
  C      : Char;
  T1,T2  : reel;
Begin
  If (caracCourant='+') or (caracCourant='-')
     Then Begin
        C:=caracCourant;
        suivant
     end
     Else C:='+';
  AnalyseTerme;
  If C='-' Then begin
         depile(T1);
         Empile(-T1)
  end;
  While (caracCourant='+') or (caracCourant='-') do Begin
      C:=caracCourant;
      suivant;
      AnalyseTerme;
      depile(T2);
      depile(T1);
      Empile(CalcOperateur(C,T1,T2));
  End // while
End; // AnalyseExpression

procedure VerifExposant;
var i,j : integer;
    acarac : char;
    ExpInsere : boolean;
begin
    i := 1;
    expInsere := false;
    while (i<=length(nombre)) do begin
        acarac := nombre[i];
        if pos(acarac,chiffrePuiss)>0
            then begin
                 for j := 0 to 9 do
                 if acarac=ChiffreExp[j] then begin
                    if expInsere
                    then begin
                       nombre[i] := char(ord('0')+j);
                       inc(i);
                    end
                    else begin
                       nombre.Insert(i-1,'^');
                       expInsere := true;
                       nombre[i+1] := char(ord('0')+j);
                       inc(i,2);
                    end;
                    break;
                 end;
                 if aCarac=moinsExp then begin
                       nombre.Insert(i-1,'^');
                       expInsere := true;
                       nombre[i+1] := '-';
                       inc(i,2);
                 end;
                 if aCarac=plusExp then begin
                       nombre.Insert(i-1,'^');
                       expInsere := true;
                       nombre[i+1] := '+';
                       inc(i,2);
                 end;
            end
            else inc(i);
    end;
end;

var posVirgule : integer;
    virgule : char;
Begin // getFloat
  trimComplet(Nombre);
  verifExposant;
  if nombre='' then raise EGetFloatError.Create('chaine vide');
  if FormatSettings.decimalSeparator='.' then virgule := ',' else virgule := '.';
  posVirgule := pos(virgule,nombre);
  while posVirgule>0 do begin
        Nombre[posVirgule] := FormatSettings.decimalSeparator;
        posVirgule := pos(virgule,nombre);
  end;
  InitFonctor;
  AnalyseExpression;
  if pred(pointeurExp)<>length(nombre) then
     raise EGetFloatError.Create('Erreur nombre');
  result := Pile[1];
  if isInfinite(result) then result := Nan;
end; // getFloat

Function StrLongueDureeToSecond(zz : string) : reel;

function Extrait : integer;
var posSepar : integer;
begin
       posSepar := pos(':',zz);
       if posSepar=0
          then if zz=''
             then result := 0
             else begin
                result := strToInt(zz);
                zz := '';
             end
             else begin
                 result := strToInt(copy(zz,1,posSepar-1));
                 delete(zz,1,posSepar);
             end;   
end;

//  conversion d hh:mm:ss en secondes
var posJour,sec,min,hour,day : integer;
begin
    posJour := pos('j',zz);
    if posJour>0
       then begin
         try
         day := strToInt(copy(zz,1,posJour-1));
         except
         day := 0;
         end;
         delete(zz,1,posJour);
       end
       else day := 0;
    if (day=0) and (pos(':',zz)=0)
       then result := strToFloat(zz)  { donnée en seconde }
       else begin
          sec := 0;
          for min := 1 to length(zz) do
              if zz[min]=':' then inc(sec);
          if (day>0) or (sec>1)
             then begin
                hour := extrait;
                min := extrait;
                sec := extrait;
             end
             else begin
                min := extrait;
                sec := extrait;
                hour := 0;
             end;
          result := ((day*24+hour)*60+min)*60+sec;
      end;    
end;

Function GetFloatDate(Nombre : String;Aformat : TnombreFormat) : reel;
var posDegre,posSeconde,posMinute,i : integer;
    degre,minute,seconde : integer;
    z : string;
begin
  case Aformat of
     fDateTime : result := StrToDateTime(nombre);
     fDate : result := StrToDate(nombre);
     fTime : result := StrToTime(nombre);     
     fLongueDuree : result := StrLongueDureeToSecond(nombre);
     else begin
        posDegre := pos(':',nombre);
        if posDegre>0 then begin
           nombre[posDegre] := '°';
           posDegre := pos(':',nombre);
           if posDegre>0 then nombre[posDegre] := '''';
        end;
        posDegre := pos('°',nombre);
        posMinute := pos('''',nombre);
        posSeconde := pos('"',nombre);
        if posSeconde=0 then begin
           posSeconde := pos('''''',nombre);
           if posSeconde>0 then begin
              nombre[posSeconde] := '"';
              delete(nombre,posSeconde+1,1);
           end;
        end;
        if (posDegre>0) or (posMinute>0) or (posSeconde>0)
             then begin
                  minute := 0;
                  seconde := 0;
                  degre := 0;
                  z := '';
                  i := 1;
                  while i<=length(nombre) do begin
                        try
                        case nombre[i] of
                             '0'..'9' : z := z+nombre[i];
                             '°' : begin
                                 degre := strToInt(z);
                                 z := '';
                              end;
                             '''' : begin
                                 minute := strToInt(z);
                                 z := '';
                              end;
                             '"' : begin
                                 seconde := strToInt(z);
                                 z := '';
                              end;
                        end;
                        except
                        end;
                        inc(i);
                  end;
                  if z<>'' then
                     if posMinute=0
                        then minute := strToInt(z)
                        else if posSeconde=0
                             then seconde := strToInt(z);
                  if degre<0
                    then result := degre-minute/60-seconde/60/60
                    else result := degre+minute/60+seconde/60/60;
              end // posDegre <> 0
              else result := getFloat(nombre);
     end { else }
  end;{ case }
end; // GetFloatDate

Function OKReg(const strOk : string;const helpCtx : LongInt) : boolean;
var SauveCursor : Tcursor;
begin
     SauveCursor := Screen.cursor;
     Screen.cursor := crDefault;
     result := MessageDlg(strOK,mtConfirmation,[mbYes,mbNo,mbHelp],HelpCtx) = idYes;
     Screen.cursor := SauveCursor;
// TMsgDlgType = ( mtWarning, mtError,  mtInformation,  mtConfirmation,  mtCustom);
// TMsgDlgBtn = (mbYes,mbNo,mbOK,mbCancel,mbAbort,mbRetry,mbIgnore,mbAll,mbNoToAll,mbYesToAll,mbHelp,mbClose);
end;

Function OKformat(const strOk : string;args : array of const) : boolean;
begin
     result := MessageDlg(format(strOK,args),mtConfirmation,[mbYes,mbNo,mbHelp],0)=idYes;
end;

Function StrToFloatWin(nombre : String) : reel;
var posSeparator : integer;
begin
   if FormatSettings.decimalSeparator='.'
   then begin
      posSeparator := pos(',',nombre);
      if posSeparator>0
         then Nombre[posSeparator] := '.';
   end
   else begin
      posSeparator := pos('.',nombre);
      if posSeparator>0
         then Nombre[posSeparator] := ',';
   end;
   try
       result := strToFloat(nombre);
   except
       result := Nan
   end;
end;

Function FloatToStrPoint(const valeur : reel) : string;
var posSeparator : integer;
begin
   result := FloatToStr(valeur);
   if FormatSettings.decimalSeparator<>'.' then begin
      posSeparator := pos(FormatSettings.decimalSeparator,result);
      if posSeparator>0 then result[posSeparator] := '.';
   end;
end;

Function FloatToStrLatex(const valeur : double) : string;
var posSeparator : integer;
begin
   if isNan(valeur) or isInfinite(valeur)
   then result := ''
   else begin
      result := FloatToStrF(valeur,ffGeneral,4,2);
      if FormatSettings.decimalSeparator<>'.' then begin
         posSeparator := pos(FormatSettings.decimalSeparator,result);
         if posSeparator>0 then result[posSeparator] := '.';
      end;
   end;
end;

Function ConvertitChaine(nombre : string;var valeur : reel) : boolean;
begin
   convertitChaine := false;
   TrimComplet(nombre);
   valeur := Nan;
   if Length(nombre)=0 then exit;
   case nombre[1] of
        'e','E' : nombre := '1'+nombre;
        '.',',' : begin
           nombre[1] := FormatSettings.decimalSeparator;
           nombre := '0'+nombre
        end;
        '0'..'9','+','-' : ;
        else exit;
   end;
   convertitChaine := true;
   convertitPrefixe(nombre);
   try
   valeur := StrToFloat(nombre);
   except
      convertitChaine := false;
   end;
end;

Procedure ConvertitPrefixe(var nombre : string);
var u : coefUnite;
    c : char;
begin
   c := nombre[length(nombre)];
   if charInSet(c,caracPrefixe) then begin
      if c=mu
         then u := micro
         else begin
         u := zero;
         repeat inc(u) until (c=prefixeUnite[u]);
      end;
      delete(nombre,length(nombre),1);
      nombre := nombre+expUnite[u];
   end;
end;

Procedure ConvertitPrefixeExpression(var Texte : string);
var u : coefUnite;
    c : char;
    long : integer;
begin
   long := length(texte);
   if (long>1) and charInSet(texte[long-1],['0'..'9']) then begin
      c := texte[long];
      if c=mu then begin
         u := micro;
         delete(texte,length(texte),1);
         texte := texte+expUnite[u];
      end
      else if charInSet(c,caracPrefixe) then begin
         u := zero;
         repeat inc(u) until (c=prefixeUnite[u]);
         delete(texte,length(texte),1);
         texte := texte+expUnite[u];
      end;
   end
end;

Function FormatIngenieur(Nombre : reel;PrecisionU : integer) : string;

Function FormatZero : string;
var i : integer;
begin
     result := '0.';
     for i := 1 to precisionU do result := result+'0';
end;

var
   tampon  : string;
   unite   : coefUnite;
   PuissanceDix : reel;
   Longueur : integer;
   AbsNombre : reel;
   negatif : boolean;
begin
     if isNan(Nombre) or isInfinite(nombre) then begin
        result := '';
        exit;
     end;
     if isZero(Nombre,1e-24) then begin
        result := formatZero;
        exit;
     end;
     absNombre := abs(Nombre);
     negatif := nombre<0;
     try
     PuissanceDix := Dix(ceil(log10(absNombre))-precisionU);
     except
       result := '?';
       exit;
     end;
     AbsNombre := round(AbsNombre/PuissanceDix)*PuissanceDix;
     unite := nulle;
     while ( AbsNombre>=999 ) and (unite<infini) do begin
          AbsNombre := AbsNombre/1000;
          inc(unite)
     end; // abs(nombre)<1000 ou infini
     if unite=infini then begin // ne devrait pas arriver
        result := 'INF';
        exit
     end;
     while ( AbsNombre<0.999 ) and (unite>zero) do begin
          AbsNombre := AbsNombre*1000;
          Dec(unite)
     end; // abs(nombre)>=1 ou zero
     if unite=zero then begin // ne devrait pas arriver
        result := FormatZero;
        exit
     end;
     longueur := succ(PrecisionU); // succ pour le point
     if AbsNombre<10
       then tampon := FloatToStrF(AbsNombre,ffGeneral,longueur,longueur-2)
// 2 = un chiffre avant la virgule + virgule
       else if AbsNombre<100
            then tampon := FloatToStrF(AbsNombre,ffGeneral,longueur,longueur-3)
// 3 =  deux chiffres avant la virgule + virgule
            else tampon := FloatToStrF(AbsNombre,ffGeneral,longueur,longueur-4);
// 4 =  trois chiffres avant la virgule + virgule
      while tampon[1]=' ' do delete(tampon,1,1);
      longueur := pos(FormatSettings.decimalSeparator,tampon);
      if longueur<=PrecisionU
         then tampon := copy(tampon,1,PrecisionU+1)
         else tampon := copy(tampon,1,PrecisionU);
   if negatif then tampon := '-' + tampon;
   if unite<>nulle then tampon := tampon+expUnite[unite];
   result := tampon;
end; // FormatIngenieur

(*
Function FormatPrec(valeur,sigma : reel) : String;
var puissValeur : shortInt;
    CoeffValeur,valeurDix : reel;
    PrecisionLoc,Decimales : integer;
begin
   try
   PrecisionLoc := floor(log10(abs(valeur))-floor(log10(sigma)))+2;
   if PrecisionLoc<=2
      then PrecisionLoc := 3
      else if PrecisionLoc>PrecisionMax
           then PrecisionLoc := PrecisionMax;
      PuissValeur := 3*floor(log10(abs(valeur))/3);
      CoeffValeur := dix(-puissValeur);
   except
     PrecisionLoc := PrecisionMax div 2;
     PuissValeur := 0;
     CoeffValeur := 1;
   end;
   Decimales := PrecisionLoc-1;
   valeurDix := valeur*CoeffValeur;
   if valeurDix>=10 then dec(Decimales);
   if valeurDix>=100 then dec(Decimales);
   result := FloatToStrF(valeurDix,ffFixed,PrecisionLoc,Decimales);
   if puissValeur<>0 then
      result := result+pintMedian+'10'+puissToStr(puissValeur);
end; // FormatPrec
*)

Function FormatMilli(Nombre : reel;PrecisionU : integer) : string;
var
   Longueur : integer;
   i : integer;
begin
     if isNan(Nombre) or isInfinite(Nombre) then result := ''
     else begin
     result := FormatGeneral(Nombre,PrecisionU);
     longueur := precisionU-length(result)+1;// +1=decimalSeparator
     if (longueur>0) and
          (pos(FormatSettings.decimalSeparator,result)>0) and
          (pos('E',result)<=0) then begin
           for i := 1 to longueur do
               result := result+'0';
     end;
     end;
end; // FormatMilli

(*
Function FormatIncert(const nombre : reel) : string;
var longueur,i : integer;
begin
     result := FloatToStrF(nombre,ffFixed,2,18);
     longueur := length(result);
     i := 0;
     repeat
        inc(i);
     until charinset(result[i],['1'..'9']) or (i=longueur);
     if result[i]='1'
        then case result[i+1] of
           '0'..'2' : ; // tel quel
           '3'..'7' : i := i+1; // on garde deux chiffres
           '8'..'9' : result[i] := '2'; // on arrondit
        end;
     result := copy(result,1,i)
end;
*)

Function FormatIncert(const nombre : reel) : string;
var longueur,i,posE : integer;
    puiss : string;
begin
     result := FloatToStrF(nombre,ffFixed,2,18);
     posE := pos('E',result);
     longueur := length(result);
     if pos('E',result)>0 then begin
        puiss := copy(result,posE+1,longueur-posE);
        i := strToInt(puiss);
        puiss := pointMedian+'10'+puissToStr(i);
        result := copy(result,1,posE-1);
        longueur := length(result);
     end
     else puiss := '';
     i := 0;
     repeat inc(i);
     until charinset(result[i],['1'..'9']) or (i=longueur);
     if i<longueur then begin
        i := i+1; // on garde deux chiffres
        if Result[i]=formatSettings.DecimalSeparator
           then i := i+1;// on saute la virgule
     end;
     result := copy(result,1,i)+puiss;
end;

Function FormatGeneral(const Nombre : reel;const Nchiffres : integer) : string;
var Nexp,posV,posE,i : integer;
    exposant : string;
begin
   if isNan(Nombre) or isInfinite(Nombre)
      then FormatGeneral := ''
      else begin
           result := FloatToStrF(nombre,ffGeneral,Nchiffres,2);
           posV := pos(FormatSettings.decimalSeparator,result);
           if posV=0
        then begin
           posE := pos('E',result);
           if posE>0
              then begin
                 exposant := copy(result,posE+1,length(result)-posE);
                 result := copy(result,1,posE-1);
                 Nexp := Nchiffres-posE+1;
              end
              else begin
                 exposant := '';
                 Nexp := Nchiffres-length(result);
              end;
           if Nexp>0 then begin
              result := result+FormatSettings.decimalSeparator;
              for i := 1 to Nexp do result := result+'0';
           end;
        end
        else begin
           posE := pos('E',result);
           if posE>0
              then begin
                 exposant := copy(result,posE+1,length(result)-posE);
                 result := copy(result,1,posE-1);
                 Nexp := Nchiffres-posE+2;
              end
              else begin
                 exposant := '';
                 Nexp := Nchiffres-length(result)+1;
              end;
           if result[1]='-' then begin
             inc(Nexp);
             if result[2]='0' then inc(Nexp);
           end
           else if result[1]='0' then inc(Nexp);
           for i := 1 to Nexp do result := result+'0';
        end;
     end;
     if exposant<>'' then begin
         Nexp := strToInt(exposant);
         result := result+pointMedian+'10'+puissToStr(Nexp);
     end;
end; // FormatGeneral

Function FormatRadian(Nombre : reel) : string;
var num,denom : integer;
    strNum,strDenom : string;
begin
   if nombre<0 then strNum := '-' else strNum := '';
   nombre := abs(nombre);
   AngleEnRadian(nombre);
   if nombre<pi/12
      then result := '0'
      else begin
          denom := 12;
          num := round(nombre*12/pi);
          if num mod 2 = 0 then begin
             num := num div 2;
             denom := denom div 2;
          end;
          if num mod 2 = 0 then begin
             num := num div 2;
             denom := denom div 2;
          end;
          if num mod 3 = 0 then begin
             num := num div 3;
             denom := denom div 3;
          end;
          if AngleEnDegre
             then result := StrNum+IntToStr(180*num div denom)
             else begin
                if denom=1 then strDenom := '' else strDenom := '/'+intToStr(Denom);
                if num<>1 then strNum := strNum + intToStr(Num);
                result := strNum+piMin+strDenom;
             end;
     end;
end; // FormatRadian

Function FormatReg(const Nombre : reel) : string;
begin
       result := FormatMilli(Nombre,Precision)
end;

Function FormatCourt(const Nombre : reel) : string;
begin
       result := FormatMilli(Nombre,PrecisionMin)
end;

Function ChainePrec(const Prec : reel) : String;
begin
   if prec>=1
       then result := '???'
       else if prec>1e-3
          then result := FloatToStrF(prec*100,ffGeneral,1,0)+' %'
          else result := '<0,1%';
    result := ' '+result;
end;

function TailleFichier(const nomFichier : string) : Int64;
var sr: TSearchRec;
begin
      if findFirst(nomFichier,faAnyFile,Sr)= 0
      then begin
      try
      result := Int64(Sr.Size);
      finally
        system.sysutils.FindClose(Sr);
      end
      end
      else result := -1;
end;

Function NbreLigneWin(const s : String) : LongInt;
var fin : integer;
    StValeur : string;
begin
     fin := 2;
     while (s[fin]>='0') and
     	   (s[fin]<='9') do inc(fin);
     stValeur := copy(s,2,fin-2);
     try
     NbreLigneWin := StrToInt(stValeur)
     except
        on EConvertError do NbreLigneWin := 0
     end
end;

function litColor(couleurDefaut : Tcolor) : TColor;
var couleurStr : string;
    couleurInt : longWord;
begin
    try
    readln(fichier,couleurStr);
    couleurInt := round(strToFloat(couleurStr));
    couleurInt := couleurInt mod 16777216; // 2^24
    result := Tcolor(couleurInt);
    except
        result := couleurDefaut
    end;
end;

procedure afficheErreur(const strErreur : string;const HelpCtx : LongInt);
var  Boutons : TMsgDlgButtons;
     SauveCursor : Tcursor;
begin
     if HelpCtx=0
        then boutons := [mbOK]
        else boutons := [mbOK,mbHelp];
     SauveCursor := Screen.cursor;
     Screen.cursor := crDefault;
     MessageDlg(strErreur,mtError,boutons,HelpCtx);
     Screen.cursor := SauveCursor;
end;

Function PuissToStr(const puiss : integer) : string;
var tampon,dest : string;
    i : integer;
    numero : integer;
begin
      if puiss=0
         then tampon := ''
         else tampon := IntToStr(puiss);
      dest := '';
      for i := 1 to length(tampon) do
          case tampon[i] of
               '0'..'9' : begin
                  numero := strToInt(tampon[i]);
                  dest := dest+chiffreExp[numero];
               end;
               '+' : dest := dest+PlusExp;
               '-' : dest := dest+MoinsExp;
          end;
      PuissToStr := dest
end;

function Compte(chaine,sousChaine : string) : integer;
var index : integer;
begin
     index := System.StrUtils.PosEx(sousChaine,chaine,1);
     result := 0;
     while index>0 do begin
           inc(result);
           index := System.StrUtils.PosEx(sousChaine,chaine,index+length(sousChaine));
     end;
end;

Function IsLigneComment(const ligneCourante : String) : boolean;
// ligne vide ou ligne de commentaire
var PosBlanc : integer;
begin
    posBlanc := 1;
    while (posBlanc<=length(ligneCourante)) and
          (ligneCourante[posBlanc]=' ') do inc(posBlanc);
    IsLigneComment :=
        (posBlanc>length(ligneCourante)) or
        charInSet(ligneCourante[posBlanc],['''',';'] )
end;

function EnTeteRW3 : boolean;
begin
   result := false;
   ligneWin := '';
   try
   readln(fichier,ligneWin);
   result := Pos('REGRESSI WINDOWS',ligneWin)>0;
   except
        FinFichierWin := true;
   end;
   finFichierWin := finFichierWin or eof(fichier);
   RW3Unicode := false;
end;

function litLigneWinU : string;
var ligneShort : shortString;

Procedure RW3versUnicode;
const
  NouveauCode : array[123..188] of Char =
    ('a','b',sigmaMin,'c','d',
     alpha,beta,
     chi,deltaMin,epsilon,phiMin,gammaMin,eta,lambdaMin,#137,nu,piMin,
     theta,rho,sigmaMin,tau,omegaMin,#145,#146,xi,psi,zeta,
     deltaMaj,phiMaj,gammaMaj,lambdaMaj,piMaj,thetaMaj,sigmaMaj,omegaMaj,xiMaj,psiMaj,
     #160,#161,#162,#163,WideChar($00B3),#165,#166,#167,#168,WideChar($2074),
     MoinsExp,#171,WideChar($2076),WideChar($2077),WideChar($2078),#175,#176,#177,WideChar($00B2),WideChar($00B3),
     #180,mu,#182,#183,PlusExp,WideChar($00B9),WideChar($2070),#187,WideChar($0079));

// 200-209 » … Ã   Õ Œ  œ –   —
// 210 219 “ ”  ‘  ’÷ ◊ ÿ Ÿ  ⁄ €

var i : integer;
    numero : integer;
begin
     ligneWin := '';
     for i := 1 to length(ligneShort) do begin
         numero := ord(ligneShort[i]);
         if (numero=194) then continue;
// Les caractères au-delà de 7 bits sont différents selon l'encodage...
// £ encodé en UTF-8 donne (194)(163) ce qui, lu en latin-1, fait Â£.
         if (numero<123) or (numero>188)
            then ligneWin := ligneWin+char(numero)
            else ligneWin := ligneWin+NouveauCode[numero]
     end;
end;

begin
   try
   finFichierWin := finFichierWin or eof(fichier);
   if finFichierWin
      then begin
        ligneWin := '';
        result := '';
      end
      else begin
      readln(fichier,ligneShort);
      RW3versUnicode;
      result := ligneWin;
   end;
   except
       FinFichierWin := true;
       ligneWin := '';
       result := '';
   end;
end;

function litLigneWin : string;
begin
   try
   finFichierWin := finFichierWin or eof(fichier);
   if finFichierWin
      then ligneWin := ''
      else readln(fichier,ligneWin);
   if (length(ligneWin)>1) and (ligneWin[1]='Â') then delete(ligneWin,1,1);
   result := ligneWin;
   except
       FinFichierWin := true;
       ligneWin := '';
       result := '';
   end;
end;

procedure readLnNombreWin(var z : reel);
begin
    try
    readln(fichier,z);
    if z=1e-26 then z := nan;
    except
        z := nan;
    end;                                end;

function litBooleanWin : boolean;
begin
   litLigneWin;
   litBooleanWin := (length(ligneWin)>0) and (ligneWin[1]<>'0')
end;

Function ToucheValidation(key : word) : boolean;
begin
    ToucheValidation := key in [vk_tab,vk_left,vk_right,vk_down,vk_up,vk_return]
end;

Procedure VerifKeyGetFloat(var key : char);
begin
     if charinset(key,[',','.'])
        then key := FormatSettings.decimalSeparator
        else if not charinset(key,CharGetFloat) then key := #0
end;

Procedure VerifKeyGetInt(var key : char);
begin
     if not charinset(key,CharGetInt) then key := #0
end;

Procedure ValidateReel(Sender : Tedit;var z : reel);
begin
     try
         z := StrToFloatWin(sender.text)
     except
         sender.text := FloatToStr(z);
         raise EGetFloatError.Create(erNombre)
     end;
end;

function PadChar(S : String;Len : integer;Achar : char) : String;
// Return a string right-padded to length len with Achar
var i,Slen : integer;
begin
   SLen := length(S); 
   if SLen>=Len
      then result := copy(S,1,Len)
      else begin
         result := S;
         for i := Slen+1 to len do
             result := result + Achar;
      end;
end;

function Pad(S : String;Len : integer) : String;
// Return a string right-padded to length len with ' '
begin
     result := PadChar(S,len,' ')
end;

Function EncodeDuree(duree : LongInt) : TdateTime;
var h,m,s,ms : word;
begin
    h := duree div 3600;
    duree := duree-h*3600;
    m := duree div 60;
    duree := duree-m*60;
    s := duree;
    ms := 0;
    EncodeDuree := EncodeTime(h,m,s,ms);
end;

Function DureeEcoulee(const InstantDebut : TdateTime) : reel;
var h,m,s,ms : word;
begin
      decodeTime(time-instantDebut,h,m,s,ms);
      DureeEcoulee := h*3600.0+m*60.0+s*1.0+ms*0.001;
end;

Function existeOption(opt : char;const defaut : boolean) : boolean;
var str : String;
    i : integer;
begin
    result := defaut;
    for i := 1 to ParamCount do begin
       str := ParamStr(i);
       if (length(str)>1) and (str[1]='/') and (upcase(str[2])=opt) then begin
          if length(str)=2
             then result := true
             else result := (str[3]='+');
          exit;
       end;
     end;
end;

Function CaracToChiffre(carac : char) : integer;
var i : integer;
begin
      if charInSet(carac,chiffre)
         then result := ord(carac)-ord('0')
         else begin
            result := 0;
            for i := 0 to 9 do
                if carac=ChiffreExp[i] then begin
                   result := i;
                   break;
                end;
         end
end;

procedure NewPage;
begin with PrinterParam do begin
    Cur.X := MargeTexte;
    Cur.Y := MargeTexte;
    Printer.NewPage;
end end;

Procedure VerifOrpheline(count : integer;var debut : integer);
var hauteur : integer;
begin
    Hauteur := succ(count)*HeightLinePrinter;
    PrinterParam.PageH := GetDeviceCaps (Printer.Handle,PHYSICALHEIGHT); //??
    if (debut+hauteur)>PrinterParam.PageH
        then begin
             Printer.NewPage;
             debut := 0;
             DebutImpressionTexte(debut);
        end
        else begin
             DebutImpressionTexte(debut);
             ImprimerLigne('',debut);
        end;
end;

function HeightLinePrinter : Word;
begin
    Result := abs(Printer.Canvas.Font.Height)
end;

// Start a new line on the current page, if no more lines left start a new page
procedure NewLine;
begin with printerParam do begin
    Cur.X := MargeTexte;
    if Height = 0
       then Inc(Cur.Y,HeightLinePrinter)
       else Inc(Cur.Y,Height);
    if Cur.Y > (Finish.Y - Height) then NewPage;
    Height := 0;
end end;

// Print a string to the printer without regard to special characters
procedure ImprimerTexte(const TextStr: string);
var L : integer;
begin with PrinterParam do begin
    L := Printer.Canvas.TextWidth(TextStr);
    Printer.Canvas.TextOut(Cur.X,Cur.Y,TextStr);
    Inc(Cur.X,L);
end end;

procedure ImprimerColonne(const TextStr: string;const largeurCol,NumCol : integer);
var XX : integer;
begin with PrinterParam do begin
    Cur.X := margeTexte+numCol*largeurCol;
    if GridPrint then begin
       XX := Cur.X+largeurCol-3; // ligne en fin de colonne
       Printer.Canvas.MoveTo(XX,Cur.Y-1);
       Printer.Canvas.LineTo(XX,Cur.Y+height-1);
    end;
    ImprimerTexte(textStr);
end end;

procedure ImprimerLigne(const TextStr : string;var debut : integer);
begin
    ImprimerTexte(textStr);
    debut := finImpressionTexte;
end;

Procedure DebutImpressionTexte(var haut : integer);
var limite : Trect;
begin with printerParam do begin
     limite := Printer.Canvas.ClipRect;
     with limite do begin
        PageW := right-left;
        PageH := bottom-top;
     end;
     if printer.Orientation=poPortrait
        then MargeTexte := PageW div MargeImprimante
        else MargeTexte := PageW div MargeImprimantePaysage;
     Finish.X := PageW-margeTexte;
     Finish.Y := PageH-margeTexte;
     Cur.X := MargeTexte;
     if haut<margeTexte then haut := MargeTexte;
     if haut>Finish.Y
       then NewPage
       else Cur.Y := haut;
     Height := 0;
     Printer.title := 'Regressi';
     Printer.Canvas.Font.Name := FontName;
     Printer.Canvas.Font.Size := FontSizeImpr;
     Printer.Canvas.Font.Color := clBlack;
     Printer.Canvas.TextFlags := 0;
     Printer.canvas.Brush.Style := bsClear;
end end;

Function FinImpressionTexte : integer;
begin
     NewLine;
     result := printerParam.Cur.Y
end;
                                                       
Procedure FinImpressionGr;
begin
     printer.endDoc;
     printer.orientation := printerParam.sauveOrientation
end;

Procedure DebutImpressionGr(Orientation : TprinterOrientation;var bas : integer);
begin
     printerParam.sauveOrientation := printer.orientation;
     printer.Orientation := Orientation;
     printer.title := 'Regressi';
     PrinterParam.PageW := GetDeviceCaps (Printer.Handle,PHYSICALWIDTH); //??
     PrinterParam.PageH := GetDeviceCaps (Printer.Handle,PHYSICALHEIGHT); //??
     with printerParam do begin
        MargeTexte := PageW div MargeImprimante;
        Finish.X := PageW-margeTexte;
        Finish.Y := PageH-margeTexte;
        Cur.X := MargeTexte;
        Cur.Y := MargeTexte;
        Height := 0;
     end;
     Printer.Canvas.Font.Name := FontName;
     Printer.Canvas.Font.Size := FontSizeImpr;
     Printer.Canvas.Font.Color := clBlack;
     bas := 0;
     printer.beginDoc;
     ImprimerLigne(userName,bas);
end;

procedure ImprimerGrid(g : TstringGrid;var debut : integer);

var colMax,LargeurColonne,Longueur : integer;

procedure PrintPermute;
var r,c : integer;
    rdebut,rfin,bloc : integer;
    texte : string;
begin with G do begin
      if rowCount>64 then begin
          afficheErreur(erGrandTableau,0);
          exit;
      end;
      if GridPrint then with PrinterParam do begin
           Printer.Canvas.MoveTo(margeTexte,Cur.Y-1);
           Printer.Canvas.LineTo(Finish.X,Cur.Y-1);
      end;
      for bloc := 0 to rowCount div (colMax-1) do begin
          rdebut := bloc*(colMax-1)+2; // -1 = nom(unité)
          rfin := rdebut+(colMax-1);
          if rfin>rowCount then rfin := rowCount;
          for c := 0 to pred(colCount) do begin
             texte := cells[c,0];
             if cells[c,1]<>'' then texte := texte+'('+cells[c,1]+')';
             ImprimerColonne(texte,largeurColonne,0);
             for r := rdebut to pred(rfin) do
                 ImprimerColonne(cells[c,r],largeurColonne,(r-rdebut) + 1);
             newLine;
             if GridPrint then with PrinterParam do begin
                  Printer.Canvas.MoveTo(margeTexte,Cur.Y-1);
                  Printer.Canvas.LineTo(Finish.X,Cur.Y-1);
             end;
          end;
      end;
end end;

Procedure PrintNormal;
var r,c,colDebut,colFin,pas,XX,oldY : integer;
begin with G do begin
      colDebut := 0;
      if GridPrint then with PrinterParam do begin // ligne horizontale
           Printer.Canvas.MoveTo(margeTexte,Cur.Y-1);
           Printer.Canvas.LineTo(Finish.X,Cur.Y-1);
      end;
      pas := succ(rowCount div 64);
      repeat
         colFin := pred(ColCount);
         if (colFin-colDebut)>=colMax
            then colFin := colDebut+pred(colMax);
         oldY := 0; // pour le compilateur
         for r := 0 to pred(RowCount) do begin
             if (r<3) or (((r-2) mod pas)=0) then begin
                if GridPrint then begin // ligne verticale au début
                   XX := printerParam.Cur.X+largeurColonne-3;
                   Printer.Canvas.MoveTo(XX,printerParam.Cur.Y-1);
                   Printer.Canvas.LineTo(XX,printerParam.Cur.Y+printerParam.Height-1);
                end;
                for c := colDebut to colFin do
                    ImprimerColonne(cells[c,r],largeurColonne,c-colDebut);
                if r=0 then oldY := PrinterParam.Cur.Y-1;
                NewLine;
                if GridPrint then with PrinterParam do begin // ligne horizontale
                   if r=0 then begin
                      Printer.Canvas.MoveTo(margeTexte,oldY);
                      Printer.Canvas.LineTo(margeTexte+(colFin-colDebut+1)*largeurColonne,oldY);
                   end;
                   Printer.Canvas.MoveTo(margeTexte,cur.Y-1);
                   Printer.Canvas.LineTo(margeTexte+(colFin-colDebut+1)*largeurColonne,cur.Y-1);
                end;
             end;
         end;
         colDebut := colFin+1;
      until colDebut>pred(colCount);
end end;

begin with G do begin // ImprimerGrid
      Printer.Canvas.TextFlags := 0;
      Longueur := Precision+6; // blanc signe . Exx
      DebutImpressionTexte(debut);
      NewLine;
      LargeurColonne := Printer.Canvas.TextWidth(PadChar('',longueur,'A'));
      colMax := (printerParam.PageW-2*printerParam.MargeTexte) div largeurColonne;
      if permuteColRow and (rowCount>colCount)
         then printPermute
         else printNormal;
      NewLine;
      debut := FinImpressionTexte;
end end; // ImprimerGrid

Function LitBool : boolean;
var m : integer;
begin
      readln(fichier,m);
      result := boolean(m);
end;

constructor TparamAnimation.create;
begin
    inherited create;
    init;
end;

function TparamAnimation.sliderMaxValue : integer;
begin
     if variationLog
        then begin
           try
           result := round(log10(finA/debutA)/log10(pasA));
           except
               result := 16;
               try
               pasA := power(10,log10(finA/debutA)/16);
               except
                   debutA := 1;
                   finA := 10;
                   pasA := power(10,1/16);
               end;
           end;
           if result>MaxPasAnim then begin
               result := MaxPasAnim;
               pasA := power(10,log10(finA/debutA)/MaxPasAnim);
           end;
        end
        else begin
           try
           result := round((finA-debutA)/pasA);
           except
              result := 16;
              pasA := (finA-debutA)/16;
              if pasA=0 then begin
                 finA := debutA+1;
                 pasA := 1/16;
              end;
           end;
           if result<2 then begin
               result := 2;
               if abs(DebutA)<1E-9 then debutA := 1E-9;
               pasA := abs(debutA);
               finA := debutA+pasA;
           end;
           if result>MaxPasAnim then begin
               result := MaxPasAnim;
               pasA := (finA-debutA)/MaxPasAnim;
           end;
        end;
end;

procedure TparamAnimation.init;
begin
     nomA := '';
     codeA := 255;
     ValeurA := Nan;
     DebutA := Nan;
     FinA := Nan;
     PasA := Nan;
     active := false;
     variationLog := false;
     aInitialiser := false;
end;

Procedure TparamAnimation.litFichier(NbreItem : integer);
var i,intZut : integer;

function getReel(defaut: reel) : reel;
var texte : string;
begin
     readln(fichier,texte);
     texte := Trim(texte);
     if (texte='NAN') or (texte='INF') or (texte='-INF')
        then result := defaut
        else result := strToFloatWin(texte);
end;

begin
     PasA := getReel(1);{1}
     readln(fichier,NomA);{2}
     DebutA := getReel(0);{3}
     FinA := getReel(debutA+16*pasA);{4}
     readln(fichier,intZut);{5}
     active := intZut>0;
     readln(fichier,intZut);{6}
     variationLog := intZut>0;
     verifMinMaxReal(debutA,finA);
     if NbreItem>6
        then valeurA := getReel(debutA) {7}
        else valeurA := debutA;
     pasA := abs(pasA);
     for i := 8 to NbreItem do readln(fichier);
end;

Function FormatLongueDureeAxe(const nombre : reel) : string;
var t : longInt;
    min,hour,day : integer;
begin
    result := '';
    t := round(nombre);
    day := t div UnJour;
    if day>0 then result := intToStr(day)+'j';
    t := t-day*UnJour;
    hour := t div UneHeure;
    if hour>0 then result := result+IntToStr(hour)+'h';
    if day=0 then begin
       t := t-hour*UneHeure;
       min := t div UneMinute;
       result := result+IntToStr(min);
    end;
end;

Procedure TparamAnimation.ecritFichier;
begin
      writeln(fichier,PasA);   {1}
      writeln(fichier,nomA);   {2}
      writeln(fichier,debutA);   {3}
      writeln(fichier,finA); {4}
      writeln(fichier,ord(active)); {5}
      writeln(fichier,ord(variationLog)); {6}
      writeln(fichier,valeurA); {7}
end;

procedure VerifMemo(memo: TRichEdit);
var oldSelStart : integer;
begin
     oldSelStart := memo.SelStart;
     memo.SelectAll;
     memo.selAttributes.size := fontSizeMemo;
     memo.selAttributes.style := [];
     memo.selLength := 0;
     memo.DefAttributes := memo.SelAttributes;
     memo.font.size := fontSizeMemo;
     memo.SelStart := oldSelStart;
end;

function valeur125(valInt : integer;down : boolean) : integer;
var mantisse,exposant,coeff : reel;
    valeur : reel;
begin
     if down
        then Valeur := ValInt/2.15
        else Valeur := ValInt*2.15;
     exposant := log10(valeur);
     coeff := Int(exposant);
     if (exposant<0) and (coeff<>exposant) then coeff := coeff-1;
     coeff := power(10,coeff);
     mantisse := Int(valeur/coeff);
     if mantisse>2 then if mantisse<6
           then mantisse := 5
           else mantisse := 10;
     result := round(mantisse*coeff);
end;

procedure AffecteStatusPanel(var Astatus : TstatusBar;i : integer;Atext : string);
begin with Astatus.panels[i] do begin
     text := ' '+Atext+' ';
     width := Length(text)*8;
end end;

procedure VideStatusPanel(var Astatus : TstatusBar;i : integer);
begin with Astatus.panels[i] do begin
     text := '';
     width := 16;
end end;

    function TstrListe.MyIndexOf(Item : string) : Integer;
    var i : integer;
        zut : string;
    begin
        result := -1;
        for i := 0 to pred(count) do begin
            zut := strings[i];
            if pos(RepereConst,zut)>0 then
               system.delete(zut,1,length(RepereConst));
            if Item=zut then begin
               if Item=SeparateurConst
                  then result := i-1
                  else result := i;
               exit;
            end;
        end;
    end;

    function getNomCoord(nom : string) : string;
    begin
       if pos(RepereConst,nom)>0 then
          system.delete(nom,1,length(RepereConst));
       result := nom;
    end;

    function FichierGroupe : String;
    begin
        result := GroupeDir+'\Regressi.RW3'
    end;

Procedure AddBackSlash(var aPath : String);
Begin
  If (aPath <> '') and
     (aPath[Length(aPath)] <> '\') Then
         aPath := aPath + '\';
End;

Procedure RemoveBackSlash(var aPath : String);
var long : integer;
Begin
  Long := Length(aPath);
  If (aPath <> '') and
     (aPath[Long] = '\') Then
         delete(aPath,Long-1,1);
End;

// permet de retrouver un repertoire d'après sa valeur CSIDL
Function GetFolder(CSIDLValue: integer): String;
Var
  IdList    : PItemIdList;
  Folder    : Array[0..MAX_PATH] Of Char;
Begin
  if Failed(SHGetFolderLocation(0, CSIDLValue, 0, 0, IdList))
  then result := ''
  else begin
      SHGetPathFromIDList(IdList, Folder);
      result := folder;
      AddBackSlash(result);
  end;
End;

Function LigneDeChiffres(const s : String) : boolean;
var j : integer;
    AvecChiffres : boolean;
begin
    Result := false;
    AvecChiffres := false;
    for j := 1 to length(s) do
        if charinset(s[j],caracNombre) or
           (charinset(s[j],caracPrefixe) and (j>1) and
           charinset(s[j-1],chiffre))
           then avecChiffres := true
           else if not charinset(s[j],separateur) then exit;
    result := avecChiffres;
end;

Procedure WindowsVersXML(var s : String);
const
  NouveauCode : array[128..160] of Char =
    (alpha,beta,chi,deltaMin,epsilon,phiMin,gammaMin,eta,lambdaMin,#137,
     nu,pimin,theta,rho,sigmaMin,tau,omegaMin,#145,#146,xi,
     psi,zeta,deltaMaj,phiMaj,gammaMaj,lambdaMaj,piMaj,thetaMaj,sigmaMaj,omegaMaj,
     xiMaj,psiMaj,#160);

var i,numero : integer;
    resu : string;
begin
     resu := '';
     for i := 1 to length(s) do begin
         numero := ord(s[i]);
         if (numero<127) or (numero>160)
            then resu := resu+s[i]
            else resu := resu+NouveauCode[numero]
     end;
     s := resu;
end;

Function isLettre(carac : char) : boolean;
begin
    result := charInSet(carac,Lettres);
    if not result then result := pos(carac,grecque)>0;
end;

Function isCaracGrandeur(carac : char) : boolean;
begin
    result := isLettre(carac);
    if not result then result :=
         charInset(carac,SuiteCaracGrandeur);
end;

procedure ecritChaineRW3(s : string);
var sRW3 : shortString;

Procedure UnicodeVersRW3;
var i,j : integer;
    carac : char;
    caracR : AnsiChar;
begin
     sRW3 := '';
     for i := 1 to length(s) do begin
         carac := s[i];
         if (pos(carac,grecque)>0) or
            (pos(carac,lettreAccent)>0) or
            (pos(carac,chiffrePuiss)>0)
            then case carac of
                      alpha : caracR := alphaR;
                      beta : caracR := betaR;
                      gammaMin: caracR := gammaR;
                      gammaMaj: caracR := gammaMajR;
                      deltaMin: caracR := deltaR;
                      deltaMaj: caracR := deltaMajR;
                      epsilon: caracR := epsilonR;
                      zeta: caracR := zetaR;
                      eta: caracR := etaR;
                      kappa: caracR := 'k';
                      lambdaMin: caracR := lambdaR;
                      lambdaMaj: caracR := lambdaMajR;
                      mu: caracR := muR;
                      nu: caracR := nuR;
                      xi: caracR := xiR;
                      xiMaj: caracR := xiMajR;
                      pimin: caracR := piR;
                      piMaj: caracR := piMajR;
                      rho: caracR := rhoR;
                      sigmaMin: caracR := sigmaR;
                      sigmaMaj: caracR := sigmaMajR;
                      tau: caracR := tauR;
                      theta: caracR := thetaR;
                      thetaMaj: caracR := thetaMajR;
                      phiMin: caracR := phiR;
                      phiMaj: caracR := phiMajR;
                      chi: caracR := chiR;
                      psi: caracR := psiR;
                      psiMaj: caracR := psiMajR;
                      omegaMin: caracR := omegaR;
                      omegaMaj: caracR := omegaMajR;
                      'é' : caracR := AnsiChar(233);
                      'è' : caracR := AnsiChar(232);
                      'ê' : caracR := AnsiChar(234);
                      'ë' : caracR := AnsiChar(235);
                      'ï' : caracR := AnsiChar(239);
                      'à' : caracR := AnsiChar(224);
                      'â' : caracR := AnsiChar(226);
                      'ù' : caracR := AnsiChar(249);
                      'û' : caracR := AnsiChar(251);
                      'ü' : caracR := AnsiChar(252);
                      'ô' : caracR := AnsiChar(252);
                      MoinsExp : caracR := moinsExpR;
                      PlusExp : caracR := plusExpR;
                      InfEgal : caracR := infEgalR;
                      SupEgal : caracR := supEgalR;
                      else begin
                         caracR := '?';
                         for j := 0 to 9 do
                            if carac=ChiffreExp[j] then begin
                               caracR := ChiffreExpR[j];
                               break;
                            end;
                      end;
                 end
            else caracR := AnsiChar(carac);
            sRW3 := sRW3+caracR;
     end;
end;

begin
    UnicodeVersRW3;
    writeln(fichier,sRW3);
end;

procedure extraitNombre(const chaine : string;var valeur : vecteurNombre);
var
  cars : TStringList;            // Define our string list variable
  i    : Integer;
begin
  // Define a string list object, and point our variable at it
  cars := TStringList.Create;
  // Now add some cars to our list - using the DelimitedText property
  // with overriden control variables
  cars.Delimiter := ' ';        // Each list item will be blank separated
//  cars.QuoteChar := '|';        // And each item will be quoted with |'s
  cars.DelimitedText := chaine;

  for i := 0 to cars.Count-1 do
      valeur[i] := strToInt(cars[i]);

  // Free up the list object
  cars.Free;
end;

function ConvertirVideo(var Anom : string) : boolean;
const ratio = 1;
var parametres : string;
    StartInfo : TStartupInfo;
    ProcessInfo : TProcessInformation;
    destination : string;
    repertoire : string;
    extension : string;
    position : integer;
    OK : boolean;
begin
  screen.cursor := crHourGlass;
  result := false;
  repertoire := extractFilePath(Anom);
  (*
  if pos('prism',nomDecodeur)>0 then begin
     parametres :=
       '-convert "'+Anom+'"'+
       ' -format .avi'+
       ' -overwrite ALWAYS'+
       ' -settings .avi MPEG4 768 1000 0.0 44100 2 128'+
       ' -outfolder '+'"'+repertoire+'"'+
       ' -exit';
     destination := System.IOUtils.Tpath.combine(tempDirReg,extractFileName(Anom));
     destination := changeFileExt(destination,'.avi');
  end;
  *)
// .avi [ENCODEUR_VIDÉO] [VITESSE_TRANSMISSION_MOYENNE] [VITESSE_TRANSMISSION_MAXIMALE]
//      [FACTEUR DE TAUX QUALITÉ] [TAUX_ÉCHANTILLONNAGE] [CANAUX] [VITESSE_TRANSMISSION_SON]
  if pos('mencoder',nomDecodeur)>0  then begin
     destination := Anom;
     position := pos('.',destination);
     destination := copy(destination,1,position-1)+'MPEG.AVI';
     parametres := '"'+Anom+'"'+' -o '+'"'+destination+'"'+' -ovc x264 -of avi -nosound';
  //  parametres := '"'+Anom+'"'+' -o '+destination+' -ovc raw -of avi -nosound';
  //  parametres := '"'+Anom+'"'+' -o '+'"'+destination+'"'+' -ovc lavc -of avi -nosound';
  end;
  if pos('ffmpeg',nomDecodeur)>0  then begin
     extension := AnsiUpperCase(extractFileExt(Anom));
     if extension='.AVI'
        then destination := changeFileExt(Anom,'.mpg')
        else destination := changeFileExt(Anom,'.avi');
     parametres := ' -i "'+Anom+'"'+' '+'"'+destination+'"';
  end;
  if fileExists(destination) then System.SysUtils.DeleteFile(destination);
// Mise à zéro de la structure StartInfo
// FillChar(StartInfo,SizeOf(StartInfo),#0);
 ZeroMemory(@StartInfo, SizeOf(StartInfo)); // remplit de 0 StartInfo
 StartInfo.cb  := SizeOf(StartInfo);
 OK := CreateProcess(Nil, Pchar('"'+nomDecodeur+'" '+parametres),
              Nil, Nil, False, 0, Nil, Nil, StartInfo,ProcessInfo);
 if OK then begin
       arretConversionVideo := false;
       repeat
       OK := WaitForSingleObject(ProcessInfo.hProcess, 500)=WAIT_OBJECT_0;
       if not OK then
          application.processMessages; // non terminé, pour que StopBtn puisse réagir
       until OK or arretConversionVideo;
       Anom := destination;
       result := true;
  end;
  screen.cursor := crDefault;
end;


function IniReadFloat(const Ini : TMemIniFile;const Section, Name: string; Default: Double): Double;

var
  FloatStr: string;
begin
  FloatStr := Ini.ReadString(Section, Name, '');
  Result := Default;
  if FloatStr <> '' then
  try
    Result := StrToFloatWin(FloatStr);
  except
    on EConvertError do
      // Ignore EConvertError exceptions
    else
      raise;
  end;
end;


var OldPrinter : integer;

Function SetFileEPS(const NomFichier : string) : boolean;
var j : integer;
    ADevice, ADriver, APort : chaineAzt;
    ADeviceMode: THandle;
begin with Printer do begin
     oldPrinter := PrinterIndex;
     result := false;
     for j := 0 to pred(Printers.count) do
         if (pos('PostScript',Printers[j])>0) or
            (pos('PS',Printers[j])>0)
         then begin // imprimante PS trouvée
           PrinterIndex := j; // installe
           Printer.GetPrinter(ADevice, ADriver, APort, ADeviceMode);
           StrPcopy(Aport,NomFichier); // sur fichier
           Printer.SetPrinter(ADevice, ADriver, APort, ADeviceMode);
           result := true;
           break;
         end;
end end;

Procedure ResetPrinter;
begin
     Printer.PrinterIndex := oldPrinter
end;

function GetUserName: string;
 var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  Reg.RootKey := HKEY_CURRENT_USER;
  Reg.OpenKey('\Volatile Environment', True);
  Result := Reg.ReadString('UserName');
end;

function SelectDir(var aDirectory : string) : boolean;
begin
    result := SelectDirectory(aDirectory,[sdAllowCreate,sdPerformCreate,sdPrompt],0)
end;

function setDecodeur(decodeur : string) : boolean;
begin
     result := true;
     if FileExists(decodeur)
        then begin
          nomDecodeur := decodeur;
          result := false;
          if pos('ffmpeg',decodeur)>0 then ffmpegExe := decodeur;
        end;
end;

(*
procedure ChercheDirHDFgroup;
var  dirProgram : string;
     info : TSearchRec;
     sousRep : boolean;
begin
      dirProgram := GetFolder(CSIDL_Program_Files);
      dirProgram := dirProgram+'\HDF_Group\HDF5\';
      if findFirst(dirProgram+'*.*',faDirectory,Info)=0 then begin
         sousRep := (info.Name='.') or (info.Name='..') or (info.Name='') or
             ((info.Attr and faDirectory)<>faDirectory) ;
         while sousRep do begin
            FindNext(Info);
            sousRep := (info.Name='.') or (info.Name='..') or (info.Name='') or
                       ((info.Attr and faDirectory)<>faDirectory);
         end;
      end;
      NomHdfdll := dirProgram+info.Name+'\bin\hdf5.dll';
      if not fileExists(NomhdfDll) then NomHdfDll := '';
end;
*)

// Surveillance chemin

Const FILE_LIST_DIRECTORY=$0001;

(*
procedure TThreadSurveillance.Execute;
Var Buffer   : Array[0..9999]Of Byte;
    Retour   : DWord;
    i        : DWord;
    Suivant  : DWord;
    Action   : DWord;
    Long     : DWord;
    Chaine   : WideString;
    Fin      : Boolean;
    ajoutFichier : boolean;
begin
  // Initialisation ds données du Thread
  ListeAjouts           := TStringList.Create;
  // La structure OverLapped permet à Windows de garder une trace
  // de la fonctione en cours. hEvent permet de tester si la fonction
  // est finie ou non
  FillChar(Overlapped,SizeOf(OverLapped),#0);
  OverLapped.hEvent:=CreateEvent(Nil,False,False,Nil);

  HandleDirectory    := INVALID_HANDLE_VALUE;
  CheminEnCours      := '';

  // Boucle pincipale du Thread
  While Not Terminated Do Begin
    // Le chemin demandé à changé => On change la surveillance
    If CheminASurveiller<>CheminEnCours Then Begin
      ListeAjouts.Clear;

      // Une demande est en cours, on libère le Handle
      If HandleDirectory<>INVALID_HANDLE_VALUE
      Then Begin
        CloseHandle(HandleDirectory);
        HandleDirectory:=INVALID_HANDLE_VALUE;
        ListeAjouts.Add('<FIN>');
      End;

      // Prise en compte de la nouvelle demande
      CheminEnCours:=CheminASurveiller;
      If CheminEnCours<>'' Then Begin
        // Suppression du '\' final
        CheminEnCours := ExcludeTrailingPathDelimiter(CheminEnCours);
        // Création du Handle sur le répertoire à surveiller
        HandleDirectory:=CreateFile (
          PChar(CheminEnCours),       // Chemin a surveiller
          FILE_LIST_DIRECTORY,        // C'est un chemin qu'il faut ouvrir
          FILE_SHARE_READ   Or        // Mode de partage, l'exemple donné dans le SDK est
          FILE_SHARE_DELETE Or        // faux, du moins avec Xp car il manque le partage
          FILE_SHARE_WRITE,           // en écriture
          Nil,                        // sécurité par défaut
          OPEN_EXISTING,              // Le chemin doit exister
          FILE_FLAG_BACKUP_SEMANTICS  // Attribut de surcharge des droits liés au dossier
            Or FILE_FLAG_OVERLAPPED,  // Attribut de fonction effectuée après coup
          0);                         // Pas d'attributs à copier

        ListeAjouts.Add('<DEBUT:'+CheminEnCours+'>');
      End;

    //  Synchronize(MiseAJourListe);
    End;

    // Une demande de notification est en cours
    If HandleDirectory<>INVALID_HANDLE_VALUE  Then Begin
      // Appel de la fonction de test des changements dans le répertoire
      If ReadDirectoryChangesW(
          HandleDirectory,                  // Handle du chemin à surveiller
          @Buffer,                          // Adresse du buffer qui contiendra la
                                            // description des modifications
          SizeOf(Buffer),                   // Taille du buffer
          True,                             // On surveille aussi les sous-répertoires
             FILE_NOTIFY_CHANGE_FILE_NAME   // Tous les changement de nom et modification
      //    Or FILE_NOTIFY_CHANGE_DIR_NAME    // sont signalés
          Or FILE_NOTIFY_CHANGE_LAST_WRITE, //
          @Retour,                          // Adresse de la longueur retournée dans buffer
          @OverLapped,                      // Structure de réponse différée
          Nil)                              // Pas de fonction de rappel
      Then Begin
        // Maintenant on attend une modification
        Repeat
          Fin:=GetOverLappedResult(HandleDirectory,OverLapped,Retour,False);
        Until  Fin
            Or(GetLastError<>ERROR_IO_INCOMPLETE)
            Or Terminated
            Or(CheminASurveiller<>CheminEnCours);
        // Si la fonction a fini correctement
        // et que l'on ne doit pas terminer le thread
        If Fin And Not Terminated And (CheminASurveiller=CheminEnCours) Then Begin
          // il faut alors décoder le buffer reçu
          ListeAjouts.Clear;
          i:=0;
          ajoutFichier := false;
          Repeat
            // Le premier DWord contient le décalage vers l'information suivante
            Move(Buffer[i  ],Suivant,4);
            // Le deuxième DWord contient le type de changement détecté
            Move(Buffer[i+4],Action ,4);
            // Le troisième DWord contient la longueur en octets du nom concerné
            Move(Buffer[i+8],Long   ,4);
            // Le nom du fichier suit
            SetLength(Chaine,Long Div 2);
            Move(Buffer[i+12],Chaine[1],Long);
            If Action=FILE_ACTION_ADDED            Then begin
               ListeAjouts.Add('FILE_ACTION_ADDED');
               FichierAjoute := CheminEnCours+'\'+Chaine;
               ajoutFichier := true;
            end;
            If Action=FILE_ACTION_MODIFIED Then begin
               ListeAjouts.Add('FILE_ACTION_MODIFIED');
               FichierAjoute := CheminEnCours+'\'+Chaine;
               ajoutFichier := true;
            end;
            If Action=FILE_ACTION_REMOVED          Then ListeAjouts.Add('FILE_ACTION_REMOVED');
            If Action=FILE_ACTION_RENAMED_OLD_NAME Then ListeAjouts.Add('FILE_ACTION_RENAMED_OLD_NAME');
            If Action=FILE_ACTION_RENAMED_NEW_NAME Then ListeAjouts.Add('FILE_ACTION_RENAMED_NEW_NAME');
            ListeAjouts.Add(CheminEnCours+'\'+Chaine);
            // On passe à la donnée suivante
            i:=i+Suivant;
          Until (i>=Retour)Or(Suivant=0);
          // Ajout des fichiers modifiés dans le Memo
          // Comme c'est un Thread, il n'est pas possible de modifier directement Memo1
          if ajoutFichier then Synchronize(MiseAJourListe);
        End;
      End;
    End;
  End;

  // Libération du Handle en cas de besoin
  If HandleDirectory<>INVALID_HANDLE_VALUE Then CloseHandle(HandleDirectory);
  HandleDirectory:=INVALID_HANDLE_VALUE;

  // Libération des objets
  ListeAjouts.Free;
  CloseHandle(OverLapped.hEvent);
end;
*)

(*
// Cette procédure ne doit être appelée que par l'intermédiaire de Synchronize
procedure TThreadSurveillance.MiseAJOurListe;
Begin
  PostMessage(handleFenetre,wm_Maj_directory,0,0);
 // If Assigned(FOnDirectoryChange) then FOnDirectoryChange(Self,TranslateActions[Msg.wParam], String(Pchar(Msg.LParam)));
End;
*)

{$IFDEF Debug}
var fichierDebug : textFile;

procedure ecritDebug(reponse : string);
begin
   append(fichierDebug);
   writeln(fichierDebug,reponse);
   closeFile(fichierDebug);
end;

procedure initDebug;
begin
    assignFile(fichierDebug,mesDocsDir+'RegressiDebug.txt');
    rewrite(fichierDebug);
    writeln(fichierDebug,'Test Regressi VLC 18/05/2018');
    closeFile(fichierDebug);
end;
{$ENDIF}

var j : integer;
Initialization
     ExemplesDir := extractFilePath(application.ExeName)+'Exemples\';
     DocRegPdf := changeFileExt(application.ExeName,'.pdf');
     DocRegWord := changeFileExt(application.ExeName,'.odt');
     DocIncertitudes := extractFilePath(application.ExeName)+'Regressi-incertitudes.pdf';
     DocModelisation := extractFilePath(application.ExeName)+'Regressi-modelisation.pdf';
     ReseauDir := GetFolder(CSIDL_NETHOOD);
     //fontesDir := GetFolder(CSIDL_FONTS);
     mesDocsDir := GetFolder(CSIDL_Personal)+'Regressi';
     dataDir := mesDocsDir;
     videoDir := GetFolder(CSIDL_MyVideo); // GetFolder(CSIDL_Common_Video);
     imagesDir := GetFolder(CSIDL_MYPICTURES);
     wavDir := GetFolder(CSIDL_MYMUSIC);
     ProgramDir := GetFolder(CSIDL_Program_Files);
     system.sysUtils.forceDirectories(MesDocsDir);
     addBackSlash(mesDocsDir);
     arduinoExe := ProgramDir;
     addBackSlash(arduinoExe);
     arduinoExe := arduinoExe+'arduino\arduino.exe';
     nomFichierIni := mesDocsDir+'Regressi.ini';
     tempDirReg := GetEnvironmentVariable('TEMP');   // path of temporary files folder
     if tempDirReg='' then tempDirReg := GetEnvironmentVariable('TMP');   // directory to store temporary file
        // temp Protégé sur certains réseaux ?
     if tempDirReg='' then tempDirReg := 'C:\Temp';
     system.sysUtils.ForceDirectories(tempDirReg);
   // appDataDir := GetFolder(CSIDL_AppData)+'Regressi';
   // system.sysUtils.forceDirectories(appDataDir);
     userName := GetUserName;
     precision := 4;
     autoIncrementation := false;
     ReticuleComplet := true;
     LigneRappelCourante := lrEquivalence;
     LigneRappelTangente := lrEquivalence;
     AcqList := TStringList.Create;
     AcqList.sorted := true;
     AcqList.Duplicates := dupIgnore;
     GraduationPi := false;
     MyCF_RTF := RegisterClipBoardFormat(CF_RTF);
     Lettres := ['a'..'z','A'..'Z'];
     SuiteCaracGrandeur := ['''','%','"','0'..'9']; // '_' utilisé pour unité
     avecOptionsXY := true;
     if setDecodeur(extractFilePath(paramstr(0))+'ffmpeg.exe')
        then if setDecodeur(ProgramDir+'ffmpeg\ffmpeg.exe')
        then if setDecodeur('c:\ffmpeg\bin\ffmpeg.exe')
        then if setDecodeur(extractFilePath(paramstr(0))+'mencoder.exe')
        then if setDecodeur(ProgramDir+'mencoder\mencoder.exe') then nomDecodeur := '';
     with Printer do
     for j := 0 to pred(Printers.count) do
         if (pos('PostScript',Printers[j])>0) or
            (pos('PS',Printers[j])>0) then begin
           postScriptExiste := true;
           break;
         end;
{$IFDEF Debug}
     initDebug;
{$ENDIF}

Finalization
   AcqList.Free;
   TexteModele.free;
end.

